/* eslint-disable import/no-duplicates */
declare module '@sage/x3-sales-project-management-api-partial' {
    import type { Package as SageX3FinanceData$Package } from '@sage/x3-finance-data-api';
    import type { Package as SageX3InvoicingData$Package, PaymentTerm, TaxRule } from '@sage/x3-invoicing-data-api';
    import type { Package as SageX3ManufacturingData$Package } from '@sage/x3-manufacturing-data-api';
    import type {
        Address,
        BusinessPartner,
        Currency,
        Customer,
        Package as SageX3MasterData$Package,
        Product,
        UnitOfMeasure,
    } from '@sage/x3-master-data-api';
    import type { Package as SageX3PhysicalFlowsData$Package } from '@sage/x3-physical-flows-data-api';
    import type {
        Budget,
        Package as SageX3ProjectManagement$Package,
        SaleableProductInput,
        Task,
        TimeEntryLineInput,
    } from '@sage/x3-project-management-api';
    import type {
        Package as SageX3ProjectManagementData$Package,
        ProjectLink,
    } from '@sage/x3-project-management-data-api';
    import type { Package as SageX3PurchasingData$Package } from '@sage/x3-purchasing-data-api';
    import type {
        Package as SageX3Sales$Package,
        SalesInvoice,
        SalesInvoiceLine,
        SalesInvoiceLineInput,
        SalesOrder,
        SalesOrderLineInput,
        SalesOrderQuantityLineInput,
    } from '@sage/x3-sales-api';
    import type {
        Package as SageX3SalesData$Package,
        SalesInvoiceType,
        SalesOrderType,
        SalesQuoteType,
    } from '@sage/x3-sales-data-api';
    import type { Package as SageX3Stock$Package } from '@sage/x3-stock-api';
    import type { MajorVersionStatus, Package as SageX3StockData$Package } from '@sage/x3-stock-data-api';
    import type { Package as SageX3Structure$Package } from '@sage/x3-structure-api';
    import type { Package as SageX3System$Package, Site, User } from '@sage/x3-system-api';
    import type { Package as SageXtremX3SystemUtils$Package, SysUser } from '@sage/xtrem-x3-system-utils-api';
    import type {
        AggregateQueryOperation,
        AggregateReadOperation,
        ClientCollection,
        ClientNode,
        ClientNodeInput,
        decimal,
        GetDefaultsOperation,
        integer,
        QueryOperation,
        ReadOperation,
    } from '@sage/xtrem-client';
    export interface ProjectBillingPlanLine extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        billingPlan: ProjectBillingPlan;
        lineNumber: integer;
        documentType: Origin;
        status: ProgressBillingLineStatus;
        isValidated: boolean;
        isRefreshRequested: boolean;
        localizedDescription: string;
        periodStart: string;
        periodEnd: string;
        nextInvoiceDate: string;
        currency: Currency;
        unit: UnitOfMeasure;
        estimationDate: string;
        estimatedProgress: string;
        estimatedQuantity: string;
        estimatedAmount: string;
        billedProgress: string;
        billedQuantity: string;
        billedAmount: string;
        cumulatedQuantity: string;
        cumulatedAmount: string;
        remainingQuantity: string;
        remainingAmount: string;
        createdOn: string;
        createdBy: User;
        updatedOn: string;
        updatedBy: User;
        validatedOn: string;
        validatedBy: User;
        adjustedOn: string;
        adjustedBy: User;
        adjustedValue: AdjustedValue;
        salesInvoice: SalesInvoice;
        salesInvoiceLine: SalesInvoiceLine;
    }
    export interface ProjectBillingPlanLineInput extends ClientNodeInput {
        billingPlan?: string;
        lineNumber?: integer | string;
        documentType?: Origin;
        status?: ProgressBillingLineStatus;
        isValidated?: boolean | string;
        isRefreshRequested?: boolean | string;
        localizedDescription?: string;
        periodStart?: string;
        periodEnd?: string;
        nextInvoiceDate?: string;
        currency?: string;
        unit?: string;
        estimationDate?: string;
        estimatedProgress?: decimal | string;
        estimatedQuantity?: decimal | string;
        estimatedAmount?: decimal | string;
        billedProgress?: decimal | string;
        billedQuantity?: decimal | string;
        billedAmount?: decimal | string;
        cumulatedQuantity?: decimal | string;
        cumulatedAmount?: decimal | string;
        remainingQuantity?: decimal | string;
        remainingAmount?: decimal | string;
        createdOn?: string;
        createdBy?: string;
        updatedOn?: string;
        updatedBy?: string;
        validatedOn?: string;
        validatedBy?: string;
        adjustedOn?: string;
        adjustedBy?: string;
        adjustedValue?: AdjustedValue;
        salesInvoice?: string;
        salesInvoiceLine?: integer | string;
    }
    export interface ProjectBillingPlanLineBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        billingPlan: ProjectBillingPlan;
        lineNumber: integer;
        documentType: Origin;
        status: ProgressBillingLineStatus;
        isValidated: boolean;
        isRefreshRequested: boolean;
        localizedDescription: string;
        periodStart: string;
        periodEnd: string;
        nextInvoiceDate: string;
        currency: Currency;
        unit: UnitOfMeasure;
        estimationDate: string;
        estimatedProgress: string;
        estimatedQuantity: string;
        estimatedAmount: string;
        billedProgress: string;
        billedQuantity: string;
        billedAmount: string;
        cumulatedQuantity: string;
        cumulatedAmount: string;
        remainingQuantity: string;
        remainingAmount: string;
        createdOn: string;
        createdBy: User;
        updatedOn: string;
        updatedBy: User;
        validatedOn: string;
        validatedBy: User;
        adjustedOn: string;
        adjustedBy: User;
        adjustedValue: AdjustedValue;
        salesInvoice: SalesInvoice;
        salesInvoiceLine: SalesInvoiceLine;
    }
    export interface ProjectBillingPlanLine$Lookups {
        billingPlan: QueryOperation<ProjectBillingPlan>;
        currency: QueryOperation<Currency>;
        unit: QueryOperation<UnitOfMeasure>;
        createdBy: QueryOperation<User>;
        updatedBy: QueryOperation<User>;
        validatedBy: QueryOperation<User>;
        adjustedBy: QueryOperation<User>;
        salesInvoice: QueryOperation<SalesInvoice>;
        salesInvoiceLine: QueryOperation<SalesInvoiceLine>;
    }
    export interface ProjectBillingPlanLine$Operations {
        query: QueryOperation<ProjectBillingPlanLine>;
        read: ReadOperation<ProjectBillingPlanLine>;
        aggregate: {
            read: AggregateReadOperation<ProjectBillingPlanLine>;
            query: AggregateQueryOperation<ProjectBillingPlanLine>;
        };
        lookups(dataOrId: string | { data: ProjectBillingPlanLineInput }): ProjectBillingPlanLine$Lookups;
        getDefaults: GetDefaultsOperation<ProjectBillingPlanLine>;
    }
    export interface ProjectBillingPlan extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        localizedDescription: string;
        site: Site;
        billingMode: BillingMode;
        project: ProjectLink;
        salesOrderNumber: SalesOrder;
        salesOrderLineNumber: integer;
        salesOrderSequenceNumber: integer;
        currency: Currency;
        unit: UnitOfMeasure;
        projectLink: ProjectLink;
        task: Task;
        budget: Budget;
        periodStart: string;
        periodEnd: string;
        lines: ClientCollection<ProjectBillingPlanLine>;
    }
    export interface ProjectBillingPlanInput extends ClientNodeInput {
        id?: string;
        localizedDescription?: string;
        site?: string;
        billingMode?: BillingMode;
        project?: string;
        salesOrderNumber?: string;
        salesOrderLineNumber?: integer | string;
        salesOrderSequenceNumber?: integer | string;
        currency?: string;
        unit?: string;
        projectLink?: string;
        task?: string;
        budget?: string;
        periodStart?: string;
        periodEnd?: string;
    }
    export interface ProjectBillingPlanBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        localizedDescription: string;
        site: Site;
        billingMode: BillingMode;
        project: ProjectLink;
        salesOrderNumber: SalesOrder;
        salesOrderLineNumber: integer;
        salesOrderSequenceNumber: integer;
        currency: Currency;
        unit: UnitOfMeasure;
        projectLink: ProjectLink;
        task: Task;
        budget: Budget;
        periodStart: string;
        periodEnd: string;
        lines: ClientCollection<ProjectBillingPlanLine>;
    }
    export interface ProjectBillingPlan$Lookups {
        site: QueryOperation<Site>;
        project: QueryOperation<ProjectLink>;
        salesOrderNumber: QueryOperation<SalesOrder>;
        currency: QueryOperation<Currency>;
        unit: QueryOperation<UnitOfMeasure>;
        projectLink: QueryOperation<ProjectLink>;
        task: QueryOperation<Task>;
        budget: QueryOperation<Budget>;
    }
    export interface ProjectBillingPlan$Operations {
        query: QueryOperation<ProjectBillingPlan>;
        read: ReadOperation<ProjectBillingPlan>;
        aggregate: {
            read: AggregateReadOperation<ProjectBillingPlan>;
            query: AggregateQueryOperation<ProjectBillingPlan>;
        };
        lookups(dataOrId: string | { data: ProjectBillingPlanInput }): ProjectBillingPlan$Lookups;
        getDefaults: GetDefaultsOperation<ProjectBillingPlan>;
    }
    export interface SalesDocumentLine extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        projectDocument: string;
        lineNumber: integer;
        documentLineNumber: integer;
        project: ProjectLink;
        revisionNumber: integer;
        budget: string;
        product: Product;
        productDescription: string;
        majorProductVersion: MajorVersionStatus;
        minorProductVersion: string;
        plannedQuantity: string;
        plannedUnit: UnitOfMeasure;
        documentQuantity: string;
        salesUnit: UnitOfMeasure;
        quantityInStockUnit: string;
        stockUnit: UnitOfMeasure;
        currency: Currency;
        basePrice: string;
        doApplyBasePrice: boolean;
        task: Task;
        customer: BusinessPartner;
        documentType: SoldProductsDocumentType;
        documentNumber: string;
        projectLink: ProjectLink;
    }
    export interface SalesDocumentLineInput extends ClientNodeInput {
        projectDocument?: string;
        lineNumber?: integer | string;
        documentLineNumber?: integer | string;
        project?: string;
        revisionNumber?: integer | string;
        budget?: string;
        product?: string;
        productDescription?: string;
        majorProductVersion?: string;
        minorProductVersion?: string;
        plannedQuantity?: decimal | string;
        plannedUnit?: string;
        documentQuantity?: decimal | string;
        salesUnit?: string;
        quantityInStockUnit?: decimal | string;
        stockUnit?: string;
        currency?: string;
        basePrice?: decimal | string;
        doApplyBasePrice?: boolean | string;
        task?: string;
        customer?: string;
        documentType?: SoldProductsDocumentType;
        documentNumber?: string;
        projectLink?: string;
    }
    export interface SalesDocumentLineBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        projectDocument: string;
        lineNumber: integer;
        documentLineNumber: integer;
        project: ProjectLink;
        revisionNumber: integer;
        budget: string;
        product: Product;
        productDescription: string;
        majorProductVersion: MajorVersionStatus;
        minorProductVersion: string;
        plannedQuantity: string;
        plannedUnit: UnitOfMeasure;
        documentQuantity: string;
        salesUnit: UnitOfMeasure;
        quantityInStockUnit: string;
        stockUnit: UnitOfMeasure;
        currency: Currency;
        basePrice: string;
        doApplyBasePrice: boolean;
        task: Task;
        customer: BusinessPartner;
        documentType: SoldProductsDocumentType;
        documentNumber: string;
        projectLink: ProjectLink;
    }
    export interface SalesDocumentLine$Lookups {
        project: QueryOperation<ProjectLink>;
        product: QueryOperation<Product>;
        majorProductVersion: QueryOperation<MajorVersionStatus>;
        plannedUnit: QueryOperation<UnitOfMeasure>;
        salesUnit: QueryOperation<UnitOfMeasure>;
        stockUnit: QueryOperation<UnitOfMeasure>;
        currency: QueryOperation<Currency>;
        task: QueryOperation<Task>;
        customer: QueryOperation<BusinessPartner>;
        projectLink: QueryOperation<ProjectLink>;
    }
    export interface SalesDocumentLine$Operations {
        query: QueryOperation<SalesDocumentLine>;
        read: ReadOperation<SalesDocumentLine>;
        aggregate: {
            read: AggregateReadOperation<SalesDocumentLine>;
            query: AggregateQueryOperation<SalesDocumentLine>;
        };
        lookups(dataOrId: string | { data: SalesDocumentLineInput }): SalesDocumentLine$Lookups;
        getDefaults: GetDefaultsOperation<SalesDocumentLine>;
    }
    export interface SalesDocument extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        project: ProjectLink;
        revisionNumber: integer;
        documentType: SoldProductsDocumentType;
        soldToCustomer: Customer;
        date: string;
        site: Site;
        customerReference: string;
        currency: Currency;
        rateType: ExchangeRateType;
        reverse: string;
        divisor: string;
        taxRule: TaxRule;
        priceIncludingOrExcludingTax: PriceAmountTaxTax;
        shippingSite: Site;
        paymentTerm: PaymentTerm;
        documentNumber: string;
        allocationType: AllocationType;
        shipToCustomerAddress: Address;
        billToCustomer: BusinessPartner;
        payByBusinessPartner: BusinessPartner;
        requestedDeliveryDate: string;
        shipmentDate: string;
        salesInvoiceType: SalesInvoiceType;
        salesOrderType: SalesOrderType;
        salesQuoteType: SalesQuoteType;
        dueDateCalculationStartDate: string;
        validityDate: string;
        lines: ClientCollection<SalesDocumentLine>;
    }
    export interface SalesDocumentInput extends ClientNodeInput {
        id?: string;
        project?: string;
        revisionNumber?: integer | string;
        documentType?: SoldProductsDocumentType;
        soldToCustomer?: string;
        date?: string;
        site?: string;
        customerReference?: string;
        currency?: string;
        rateType?: ExchangeRateType;
        reverse?: decimal | string;
        divisor?: decimal | string;
        taxRule?: string;
        priceIncludingOrExcludingTax?: PriceAmountTaxTax;
        shippingSite?: string;
        paymentTerm?: string;
        documentNumber?: string;
        allocationType?: AllocationType;
        shipToCustomerAddress?: string;
        billToCustomer?: string;
        payByBusinessPartner?: string;
        requestedDeliveryDate?: string;
        shipmentDate?: string;
        salesInvoiceType?: string;
        salesOrderType?: string;
        salesQuoteType?: string;
        dueDateCalculationStartDate?: string;
        validityDate?: string;
    }
    export interface SalesDocumentBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        project: ProjectLink;
        revisionNumber: integer;
        documentType: SoldProductsDocumentType;
        soldToCustomer: Customer;
        date: string;
        site: Site;
        customerReference: string;
        currency: Currency;
        rateType: ExchangeRateType;
        reverse: string;
        divisor: string;
        taxRule: TaxRule;
        priceIncludingOrExcludingTax: PriceAmountTaxTax;
        shippingSite: Site;
        paymentTerm: PaymentTerm;
        documentNumber: string;
        allocationType: AllocationType;
        shipToCustomerAddress: Address;
        billToCustomer: BusinessPartner;
        payByBusinessPartner: BusinessPartner;
        requestedDeliveryDate: string;
        shipmentDate: string;
        salesInvoiceType: SalesInvoiceType;
        salesOrderType: SalesOrderType;
        salesQuoteType: SalesQuoteType;
        dueDateCalculationStartDate: string;
        validityDate: string;
        lines: ClientCollection<SalesDocumentLine>;
    }
    export interface SalesDocument$Lookups {
        project: QueryOperation<ProjectLink>;
        soldToCustomer: QueryOperation<Customer>;
        site: QueryOperation<Site>;
        currency: QueryOperation<Currency>;
        taxRule: QueryOperation<TaxRule>;
        shippingSite: QueryOperation<Site>;
        paymentTerm: QueryOperation<PaymentTerm>;
        shipToCustomerAddress: QueryOperation<Address>;
        billToCustomer: QueryOperation<BusinessPartner>;
        payByBusinessPartner: QueryOperation<BusinessPartner>;
        salesInvoiceType: QueryOperation<SalesInvoiceType>;
        salesOrderType: QueryOperation<SalesOrderType>;
        salesQuoteType: QueryOperation<SalesQuoteType>;
    }
    export interface SalesDocument$Operations {
        query: QueryOperation<SalesDocument>;
        read: ReadOperation<SalesDocument>;
        aggregate: {
            read: AggregateReadOperation<SalesDocument>;
            query: AggregateQueryOperation<SalesDocument>;
        };
        lookups(dataOrId: string | { data: SalesDocumentInput }): SalesDocument$Lookups;
        getDefaults: GetDefaultsOperation<SalesDocument>;
    }
    export interface SaleableProductExtension {
        salesDocument: SalesDocument;
        salesDocumentLine: SalesDocumentLine;
    }
    export interface SaleableProductInputExtension {
        salesDocument?: string;
        salesDocumentLine?: integer | string;
    }
    export interface SaleableProductBindingExtension {
        salesDocument: SalesDocument;
        salesDocumentLine: SalesDocumentLine;
    }
    export interface SaleableProductExtension$Lookups {
        salesDocument: QueryOperation<SalesDocument>;
        salesDocumentLine: QueryOperation<SalesDocumentLine>;
    }
    export interface SaleableProductExtension$Operations {
        lookups(dataOrId: string | { data: SaleableProductInput }): SaleableProductExtension$Lookups;
    }
    export interface SalesInvoiceLineExtension {
        projectSalesDocument: SalesDocument;
        projectSalesDocumentLineNumber: integer;
    }
    export interface SalesInvoiceLineInputExtension {
        projectSalesDocument?: string;
        projectSalesDocumentLineNumber?: integer | string;
    }
    export interface SalesInvoiceLineBindingExtension {
        projectSalesDocument: SalesDocument;
        projectSalesDocumentLineNumber: integer;
    }
    export interface SalesInvoiceLineExtension$Lookups {
        projectSalesDocument: QueryOperation<SalesDocument>;
    }
    export interface SalesInvoiceLineExtension$Operations {
        lookups(dataOrId: string | { data: SalesInvoiceLineInput }): SalesInvoiceLineExtension$Lookups;
    }
    export interface SalesOrderLineExtension {
        projectBillingPlan: ProjectBillingPlan;
        projectSalesDocument: SalesDocument;
        projectSalesDocumentLine: integer;
    }
    export interface SalesOrderLineInputExtension {
        projectBillingPlan?: string;
        projectSalesDocument?: string;
        projectSalesDocumentLine?: integer | string;
    }
    export interface SalesOrderLineBindingExtension {
        projectBillingPlan: ProjectBillingPlan;
        projectSalesDocument: SalesDocument;
        projectSalesDocumentLine: integer;
    }
    export interface SalesOrderLineExtension$Lookups {
        projectBillingPlan: QueryOperation<ProjectBillingPlan>;
        projectSalesDocument: QueryOperation<SalesDocument>;
    }
    export interface SalesOrderLineExtension$Operations {
        lookups(dataOrId: string | { data: SalesOrderLineInput }): SalesOrderLineExtension$Lookups;
    }
    export interface SalesOrderQuantityLineExtension {
        projectSalesDocument: SalesDocument;
        projectSalesDocumentLine: integer;
        projectBillingPlan: ProjectBillingPlan;
    }
    export interface SalesOrderQuantityLineInputExtension {
        projectSalesDocument?: string;
        projectSalesDocumentLine?: integer | string;
        projectBillingPlan?: string;
    }
    export interface SalesOrderQuantityLineBindingExtension {
        projectSalesDocument: SalesDocument;
        projectSalesDocumentLine: integer;
        projectBillingPlan: ProjectBillingPlan;
    }
    export interface SalesOrderQuantityLineExtension$Lookups {
        projectSalesDocument: QueryOperation<SalesDocument>;
        projectBillingPlan: QueryOperation<ProjectBillingPlan>;
    }
    export interface SalesOrderQuantityLineExtension$Operations {
        lookups(dataOrId: string | { data: SalesOrderQuantityLineInput }): SalesOrderQuantityLineExtension$Lookups;
    }
    export interface TimeEntryLineExtension {
        billingPlan: ProjectBillingPlan;
        billingPlanLine: ProjectBillingPlanLine;
    }
    export interface TimeEntryLineInputExtension {
        billingPlan?: string;
        billingPlanLine?: integer | string;
    }
    export interface TimeEntryLineBindingExtension {
        billingPlan: ProjectBillingPlan;
        billingPlanLine: ProjectBillingPlanLine;
    }
    export interface TimeEntryLineExtension$Lookups {
        billingPlan: QueryOperation<ProjectBillingPlan>;
        billingPlanLine: QueryOperation<ProjectBillingPlanLine>;
    }
    export interface TimeEntryLineExtension$Operations {
        lookups(dataOrId: string | { data: TimeEntryLineInput }): TimeEntryLineExtension$Lookups;
    }
    export interface Package {
        '@sage/x3-sales-project-management/ProjectBillingPlanLine': ProjectBillingPlanLine$Operations;
        '@sage/x3-sales-project-management/ProjectBillingPlan': ProjectBillingPlan$Operations;
        '@sage/x3-sales-project-management/SalesDocumentLine': SalesDocumentLine$Operations;
        '@sage/x3-sales-project-management/SalesDocument': SalesDocument$Operations;
    }
    export interface GraphApi
        extends Package,
            SageX3FinanceData$Package,
            SageX3InvoicingData$Package,
            SageX3ManufacturingData$Package,
            SageX3MasterData$Package,
            SageX3PhysicalFlowsData$Package,
            SageX3ProjectManagement$Package,
            SageX3ProjectManagementData$Package,
            SageX3PurchasingData$Package,
            SageX3Sales$Package,
            SageX3SalesData$Package,
            SageX3Stock$Package,
            SageX3StockData$Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-sales-project-management-api' {
    export type * from '@sage/x3-sales-project-management-api-partial';
}
declare module '@sage/x3-finance-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-manufacturing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-physical-flows-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-purchasing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-sales-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-sales-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-project-management-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-api-partial' {
    import type {
        SaleableProductBindingExtension,
        SaleableProductExtension,
        SaleableProductExtension$Lookups,
        SaleableProductExtension$Operations,
        SaleableProductInputExtension,
        TimeEntryLineBindingExtension,
        TimeEntryLineExtension,
        TimeEntryLineExtension$Lookups,
        TimeEntryLineExtension$Operations,
        TimeEntryLineInputExtension,
    } from '@sage/x3-sales-project-management-api';
    export interface SaleableProduct extends SaleableProductExtension {}
    export interface SaleableProductBinding extends SaleableProductBindingExtension {}
    export interface SaleableProductInput extends SaleableProductInputExtension {}
    export interface SaleableProduct$Lookups extends SaleableProductExtension$Lookups {}
    export interface SaleableProduct$Operations extends SaleableProductExtension$Operations {}
    export interface TimeEntryLine extends TimeEntryLineExtension {}
    export interface TimeEntryLineBinding extends TimeEntryLineBindingExtension {}
    export interface TimeEntryLineInput extends TimeEntryLineInputExtension {}
    export interface TimeEntryLine$Lookups extends TimeEntryLineExtension$Lookups {}
    export interface TimeEntryLine$Operations extends TimeEntryLineExtension$Operations {}
}
declare module '@sage/x3-sales-api-partial' {
    import type {
        SalesInvoiceLineBindingExtension,
        SalesInvoiceLineExtension,
        SalesInvoiceLineExtension$Lookups,
        SalesInvoiceLineExtension$Operations,
        SalesInvoiceLineInputExtension,
        SalesOrderLineBindingExtension,
        SalesOrderLineExtension,
        SalesOrderLineExtension$Lookups,
        SalesOrderLineExtension$Operations,
        SalesOrderLineInputExtension,
        SalesOrderQuantityLineBindingExtension,
        SalesOrderQuantityLineExtension,
        SalesOrderQuantityLineExtension$Lookups,
        SalesOrderQuantityLineExtension$Operations,
        SalesOrderQuantityLineInputExtension,
    } from '@sage/x3-sales-project-management-api';
    export interface SalesInvoiceLine extends SalesInvoiceLineExtension {}
    export interface SalesInvoiceLineBinding extends SalesInvoiceLineBindingExtension {}
    export interface SalesInvoiceLineInput extends SalesInvoiceLineInputExtension {}
    export interface SalesInvoiceLine$Lookups extends SalesInvoiceLineExtension$Lookups {}
    export interface SalesInvoiceLine$Operations extends SalesInvoiceLineExtension$Operations {}
    export interface SalesOrderLine extends SalesOrderLineExtension {}
    export interface SalesOrderLineBinding extends SalesOrderLineBindingExtension {}
    export interface SalesOrderLineInput extends SalesOrderLineInputExtension {}
    export interface SalesOrderLine$Lookups extends SalesOrderLineExtension$Lookups {}
    export interface SalesOrderLine$Operations extends SalesOrderLineExtension$Operations {}
    export interface SalesOrderQuantityLine extends SalesOrderQuantityLineExtension {}
    export interface SalesOrderQuantityLineBinding extends SalesOrderQuantityLineBindingExtension {}
    export interface SalesOrderQuantityLineInput extends SalesOrderQuantityLineInputExtension {}
    export interface SalesOrderQuantityLine$Lookups extends SalesOrderQuantityLineExtension$Lookups {}
    export interface SalesOrderQuantityLine$Operations extends SalesOrderQuantityLineExtension$Operations {}
}
