/* eslint-disable import/no-duplicates */
declare module '@sage/x3-sales-finance-api-partial' {
    import type { Package as SageX3Finance$Package, PrepaymentInvoice } from '@sage/x3-finance-api';
    import type { Package as SageX3FinanceData$Package } from '@sage/x3-finance-data-api';
    import type { Package as SageX3InvoicingData$Package } from '@sage/x3-invoicing-data-api';
    import type { Package as SageX3ManufacturingData$Package } from '@sage/x3-manufacturing-data-api';
    import type { Package as SageX3MasterData$Package } from '@sage/x3-master-data-api';
    import type { Package as SageX3PhysicalFlowsData$Package } from '@sage/x3-physical-flows-data-api';
    import type { Package as SageX3ProjectManagementData$Package } from '@sage/x3-project-management-data-api';
    import type { Package as SageX3PurchasingData$Package } from '@sage/x3-purchasing-data-api';
    import type { Package as SageX3Sales$Package, SalesOrderLineInput } from '@sage/x3-sales-api';
    import type { Package as SageX3SalesData$Package } from '@sage/x3-sales-data-api';
    import type { Package as SageX3Stock$Package } from '@sage/x3-stock-api';
    import type { Package as SageX3StockData$Package } from '@sage/x3-stock-data-api';
    import type { Package as SageX3Structure$Package } from '@sage/x3-structure-api';
    import type { Package as SageX3System$Package } from '@sage/x3-system-api';
    import type { Package as SageXtremX3SystemUtils$Package } from '@sage/xtrem-x3-system-utils-api';
    import type { QueryOperation } from '@sage/xtrem-client';
    export interface SalesOrderLineExtension {
        prepaymentContract: PrepaymentInvoice;
    }
    export interface SalesOrderLineInputExtension {
        prepaymentContract?: string;
    }
    export interface SalesOrderLineBindingExtension {
        prepaymentContract: PrepaymentInvoice;
    }
    export interface SalesOrderLineExtension$Lookups {
        prepaymentContract: QueryOperation<PrepaymentInvoice>;
    }
    export interface SalesOrderLineExtension$Operations {
        lookups(dataOrId: string | { data: SalesOrderLineInput }): SalesOrderLineExtension$Lookups;
    }
    export interface Package {}
    export interface GraphApi
        extends Package,
            SageX3Finance$Package,
            SageX3FinanceData$Package,
            SageX3InvoicingData$Package,
            SageX3ManufacturingData$Package,
            SageX3MasterData$Package,
            SageX3PhysicalFlowsData$Package,
            SageX3ProjectManagementData$Package,
            SageX3PurchasingData$Package,
            SageX3Sales$Package,
            SageX3SalesData$Package,
            SageX3Stock$Package,
            SageX3StockData$Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-sales-finance-api' {
    export type * from '@sage/x3-sales-finance-api-partial';
}
declare module '@sage/x3-finance-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-finance-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-manufacturing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-physical-flows-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-purchasing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-sales-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-sales-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-sales-api-partial' {
    import type {
        SalesOrderLineBindingExtension,
        SalesOrderLineExtension,
        SalesOrderLineExtension$Lookups,
        SalesOrderLineExtension$Operations,
        SalesOrderLineInputExtension,
    } from '@sage/x3-sales-finance-api';
    export interface SalesOrderLine extends SalesOrderLineExtension {}
    export interface SalesOrderLineBinding extends SalesOrderLineBindingExtension {}
    export interface SalesOrderLineInput extends SalesOrderLineInputExtension {}
    export interface SalesOrderLine$Lookups extends SalesOrderLineExtension$Lookups {}
    export interface SalesOrderLine$Operations extends SalesOrderLineExtension$Operations {}
}
