/* eslint-disable import/no-duplicates */
declare module '@sage/xtrem-x3-system-api-partial' {
    import type { Package as SageXtremX3SystemUtils$Package, SysUser } from '@sage/xtrem-x3-system-utils-api';
    import type {
        AggregateQueryOperation,
        AggregateReadOperation,
        BinaryStream,
        ClientCollection,
        ClientNode,
        ClientNodeInput,
        GetDefaultsOperation,
        integer,
        Operation,
        QueryOperation,
        ReadOperation,
        VitalClientNode,
        VitalClientNodeInput,
    } from '@sage/xtrem-client';
    export interface AmountConversionIntoLetters$Enum {
        noConversion: 1;
        french: 2;
        english: 3;
        german: 4;
        italian: 5;
        spanish: 6;
        portuguese: 7;
        turkish: 8;
    }
    export type AmountConversionIntoLetters = keyof AmountConversionIntoLetters$Enum;
    export interface AuthorizationsBetweenFolders$Enum {
        none: 1;
        read: 2;
        all: 3;
    }
    export type AuthorizationsBetweenFolders = keyof AuthorizationsBetweenFolders$Enum;
    export interface CodingOfTheBase$Enum {
        ascii: 1;
        unicode: 2;
    }
    export type CodingOfTheBase = keyof CodingOfTheBase$Enum;
    export interface DatabaseType$Enum {
        oracle: 1;
        sqlServer: 2;
    }
    export type DatabaseType = keyof DatabaseType$Enum;
    export interface DefinitionLevel3$Enum {
        folder: 1;
        company: 2;
        site: 3;
        user: 4;
        legislation: 5;
    }
    export type DefinitionLevel3 = keyof DefinitionLevel3$Enum;
    export interface DestinationType$Enum {
        preview: 1;
        printer: 2;
        message: 3;
        file: 4;
        printerFile: 5;
        ZPL_printer: 6;
        archiving: 7;
    }
    export type DestinationType = keyof DestinationType$Enum;
    export interface EntityType$Enum {
        businessPartner: 1;
        company: 2;
        site: 3;
        user: 4;
        accounts: 5;
        leads: 6;
        building: 7;
        place: 8;
    }
    export type EntityType = keyof EntityType$Enum;
    export interface EntryDisplay$Enum {
        entered: 1;
        displayed: 2;
        hidden: 3;
    }
    export type EntryDisplay = keyof EntryDisplay$Enum;
    export interface FieldType1$Enum {
        alphanumeric: 1;
        numeric: 2;
        date: 3;
        localMenu: 4;
    }
    export type FieldType1 = keyof FieldType1$Enum;
    export interface FirstDayOfWeek$Enum {
        monday: 1;
        tuesday: 2;
        wednesday: 3;
        thursday: 4;
        friday: 5;
        saturday: 6;
        sunday: 7;
    }
    export type FirstDayOfWeek = keyof FirstDayOfWeek$Enum;
    export interface ManagerType$Enum {
        supervisor: 1;
        departmentHead: 2;
        director: 3;
        hrManager: 4;
        expenseNoteManager: 5;
        assistant: 6;
        payrollManager: 7;
        operatingManager: 8;
        trainingManager: 9;
        interviewManager: 10;
        employee: 11;
    }
    export type ManagerType = keyof ManagerType$Enum;
    export interface ModuleTable$Enum {
        supervisor: 1;
        financials: 2;
        aparAccounting: 3;
        external: 4;
        sales: 5;
        purchasing: 6;
        stock: 7;
        manufacturing: 8;
        commonData: 9;
        development: 10;
        sageX3Internals: 11;
        helpDesk: 12;
        crmActivities: 13;
        fixedAssets: 14;
        humanResourcesAdministration: 15;
        moduleSpe1: 16;
        moduleSpe2: 17;
        moduleSpe3: 18;
        moduleSpe4: 19;
        humanCapitalManagement: 20;
    }
    export type ModuleTable = keyof ModuleTable$Enum;
    export interface PageOrientation$Enum {
        portrait: 1;
        landscape: 2;
    }
    export type PageOrientation = keyof PageOrientation$Enum;
    export interface PrinterType$Enum {
        normal: 1;
        fax: 2;
        thermal: 3;
        color: 4;
    }
    export type PrinterType = keyof PrinterType$Enum;
    export interface ProfileTypeFunction$Enum {
        normal: 1;
        administrator: 2;
        developer: 3;
    }
    export type ProfileTypeFunction = keyof ProfileTypeFunction$Enum;
    export interface ReportGroup$Enum {
        supervisor: 1;
        masterData: 2;
        generalAccounting: 3;
        analyticalAccounting: 4;
        arAndAp: 5;
        legalReports: 6;
        vat: 7;
        treasury: 8;
        openItems: 9;
        payments: 10;
        customerReminders: 11;
        salesExternalDocuments: 12;
        salesInternalDocuments: 13;
        salesPrices: 14;
        salesAnalysis: 15;
        salesListings: 16;
        purchaseParameters: 17;
        purchaseExternalDocuments: 18;
        purchaseInternalDocuments: 19;
        purchasePrices: 20;
        purchaseAnalysis: 21;
        purchaseListings: 22;
        helpDesk: 23;
        commercialActivity: 24;
        stockCounts: 25;
        stockReordering: 26;
        listOfStockToMove: 27;
        stockAnalysis: 28;
        stockInternalDocuments: 29;
        manufacturingWeighing: 30;
        manufacturingReordering: 31;
        manufacturingWorkOrderDocuments: 32;
        manufacturingTechnicalData: 33;
        manufacturingValuation: 34;
        manufacturingAnalysis: 35;
        v1099: 36;
        iasReports: 37;
        fixedAssets: 38;
        specific: 39;
        fixedAssetsSetupAndCoreData: 40;
        fixedAssetsFixedAssets: 41;
        fixedAssetsMiscellaneous: 42;
        fixedAssetsPhysicalManagement: 43;
        fixedAssetsFunding: 44;
        operatingBudgets: 45;
        stockExternalDocuments: 46;
        hrPayrollManagement: 47;
        hrCharges: 48;
        hrHistorical: 49;
        notUsed: 50;
        hrDadsU: 51;
        hrMiscellaneous: 52;
        hrProfitSharing: 53;
        hrTraining: 54;
        hrCareers: 55;
        hrTotalPayroll: 56;
        hrTimeManagement: 57;
        hrPayments: 58;
        hrStaffManagement: 59;
        vatOthers: 60;
        vatGermany: 61;
        vatSpain: 62;
        vatPortugal: 63;
        feesFrance: 64;
        feesBelgium: 65;
        feesUnitedStates: 66;
        vatAustria: 67;
        feesOthers: 68;
        vatBelgium: 69;
        assetManagementGermanyAndAustria: 70;
        assetManagementPortugal: 71;
        assetManagementItaly: 72;
        assetManagementUki: 73;
        assetManagementFrance: 74;
        notUsed1: 75;
        vatFrance: 76;
        employee: 77;
        vatBoxesManagement: 78;
    }
    export type ReportGroup = keyof ReportGroup$Enum;
    export interface SequenceNumberType$Enum {
        alphanumeric: 1;
        numeric: 2;
    }
    export type SequenceNumberType = keyof SequenceNumberType$Enum;
    export interface TypeOfDependency$Enum {
        none: 1;
        reverse: 2;
        sizing: 3;
        formula: 4;
    }
    export type TypeOfDependency = keyof TypeOfDependency$Enum;
    export interface TypesOfActivityCode$Enum {
        functional: 1;
        sizing: 2;
        localization: 3;
    }
    export type TypesOfActivityCode = keyof TypesOfActivityCode$Enum;
    export interface UserFunctions$Enum {
        salesEngineer: 1;
        teleSales: 2;
        salesDirector: 3;
        customerSupport: 4;
        other: 5;
    }
    export type UserFunctions = keyof UserFunctions$Enum;
    export interface UserStatus$Enum {
        permanent: 1;
        temporary: 2;
        partTime: 3;
    }
    export type UserStatus = keyof UserStatus$Enum;
    export interface Access extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface AccessInput extends ClientNodeInput {}
    export interface AccessBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface Access$Operations {
        query: QueryOperation<Access>;
        read: ReadOperation<Access>;
        aggregate: {
            read: AggregateReadOperation<Access>;
            query: AggregateQueryOperation<Access>;
        };
        getDefaults: GetDefaultsOperation<Access>;
    }
    export interface ActivityCode extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface ActivityCodeInput extends ClientNodeInput {}
    export interface ActivityCodeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface ActivityCode$Operations {
        query: QueryOperation<ActivityCode>;
        read: ReadOperation<ActivityCode>;
        aggregate: {
            read: AggregateReadOperation<ActivityCode>;
            query: AggregateQueryOperation<ActivityCode>;
        };
        getDefaults: GetDefaultsOperation<ActivityCode>;
    }
    export interface Company extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        isLegalCompany: boolean;
        legislation: MiscellaneousTable;
        name: string;
        shortDescription: string;
    }
    export interface CompanyInput extends ClientNodeInput {
        code?: string;
        isLegalCompany?: boolean | string;
        legislation?: string;
        name?: string;
        shortDescription?: string;
    }
    export interface CompanyBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        isLegalCompany: boolean;
        legislation: MiscellaneousTable;
        name: string;
        shortDescription: string;
    }
    export interface Company$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface Company$Operations {
        query: QueryOperation<Company>;
        read: ReadOperation<Company>;
        aggregate: {
            read: AggregateReadOperation<Company>;
            query: AggregateQueryOperation<Company>;
        };
        lookups(dataOrId: string | { data: CompanyInput }): Company$Lookups;
        getDefaults: GetDefaultsOperation<Company>;
    }
    export interface Destination extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
        accessCode: Access;
        isActive: boolean;
        isAssembledCopies: boolean;
        numberOfCopies: integer;
        destination: DestinationType;
        driver: string;
        printerName: string;
        printerType: PrinterType;
        orientation: integer;
        port: string;
        server: string;
        pageOrientation: PageOrientation;
        destinationFile: string;
    }
    export interface DestinationInput extends ClientNodeInput {
        code?: string;
        description?: string;
        shortDescription?: string;
        accessCode?: string;
        isActive?: boolean | string;
        isAssembledCopies?: boolean | string;
        numberOfCopies?: integer | string;
        destination?: DestinationType;
        driver?: string;
        printerName?: string;
        printerType?: PrinterType;
        orientation?: integer | string;
        port?: string;
        server?: string;
        pageOrientation?: PageOrientation;
        destinationFile?: string;
    }
    export interface DestinationBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
        accessCode: Access;
        isActive: boolean;
        isAssembledCopies: boolean;
        numberOfCopies: integer;
        destination: DestinationType;
        driver: string;
        printerName: string;
        printerType: PrinterType;
        orientation: integer;
        port: string;
        server: string;
        pageOrientation: PageOrientation;
        destinationFile: string;
    }
    export interface Destination$Lookups {
        accessCode: QueryOperation<Access>;
    }
    export interface Destination$Operations {
        query: QueryOperation<Destination>;
        read: ReadOperation<Destination>;
        aggregate: {
            read: AggregateReadOperation<Destination>;
            query: AggregateQueryOperation<Destination>;
        };
        lookups(dataOrId: string | { data: DestinationInput }): Destination$Lookups;
        getDefaults: GetDefaultsOperation<Destination>;
    }
    export interface Function extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface FunctionInput extends ClientNodeInput {}
    export interface FunctionBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface Function$Operations {
        query: QueryOperation<Function>;
        read: ReadOperation<Function>;
        aggregate: {
            read: AggregateReadOperation<Function>;
            query: AggregateQueryOperation<Function>;
        };
        getDefaults: GetDefaultsOperation<Function>;
    }
    export interface FunctionalProfile extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface FunctionalProfileInput extends ClientNodeInput {}
    export interface FunctionalProfileBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface FunctionalProfile$Operations {
        query: QueryOperation<FunctionalProfile>;
        read: ReadOperation<FunctionalProfile>;
        aggregate: {
            read: AggregateReadOperation<FunctionalProfile>;
            query: AggregateQueryOperation<FunctionalProfile>;
        };
        getDefaults: GetDefaultsOperation<FunctionalProfile>;
    }
    export interface FunctionalProfilePerSite extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface FunctionalProfilePerSiteInput extends ClientNodeInput {}
    export interface FunctionalProfilePerSiteBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface FunctionalProfilePerSite$Operations {
        query: QueryOperation<FunctionalProfilePerSite>;
        read: ReadOperation<FunctionalProfilePerSite>;
        aggregate: {
            read: AggregateReadOperation<FunctionalProfilePerSite>;
            query: AggregateQueryOperation<FunctionalProfilePerSite>;
        };
        getDefaults: GetDefaultsOperation<FunctionalProfilePerSite>;
    }
    export interface GeneralParameter extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        definitionLevel: DefinitionLevel3;
    }
    export interface GeneralParameterInput extends ClientNodeInput {
        code?: string;
        definitionLevel?: DefinitionLevel3;
    }
    export interface GeneralParameterBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        definitionLevel: DefinitionLevel3;
    }
    export interface GeneralParameter$Queries {
        getGeneralParameterValue: Operation<
            {
                code: string | null;
                parameter: string;
            },
            string
        >;
        getGeneralParameterUserValue: Operation<
            {
                user: string;
                site: string;
                parameter: string | null;
            },
            string
        >;
    }
    export interface GeneralParameter$Operations {
        query: QueryOperation<GeneralParameter>;
        read: ReadOperation<GeneralParameter>;
        aggregate: {
            read: AggregateReadOperation<GeneralParameter>;
            query: AggregateQueryOperation<GeneralParameter>;
        };
        queries: GeneralParameter$Queries;
        getDefaults: GetDefaultsOperation<GeneralParameter>;
    }
    export interface GeneralParametersData extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface GeneralParametersDataInput extends ClientNodeInput {}
    export interface GeneralParametersDataBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface GeneralParametersData$Operations {
        query: QueryOperation<GeneralParametersData>;
        read: ReadOperation<GeneralParametersData>;
        aggregate: {
            read: AggregateReadOperation<GeneralParametersData>;
            query: AggregateQueryOperation<GeneralParametersData>;
        };
        getDefaults: GetDefaultsOperation<GeneralParametersData>;
    }
    export interface Image extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface ImageInput extends ClientNodeInput {}
    export interface ImageBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface Image$Operations {
        query: QueryOperation<Image>;
        read: ReadOperation<Image>;
        aggregate: {
            read: AggregateReadOperation<Image>;
            query: AggregateQueryOperation<Image>;
        };
        getDefaults: GetDefaultsOperation<Image>;
    }
    export interface Language extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
    }
    export interface LanguageInput extends ClientNodeInput {
        code?: string;
    }
    export interface LanguageBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
    }
    export interface Language$Operations {
        query: QueryOperation<Language>;
        read: ReadOperation<Language>;
        aggregate: {
            read: AggregateReadOperation<Language>;
            query: AggregateQueryOperation<Language>;
        };
        getDefaults: GetDefaultsOperation<Language>;
    }
    export interface MiscellaneousTable extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
        defaultValue: boolean;
        dependency: MiscellaneousTable;
    }
    export interface MiscellaneousTableInput extends ClientNodeInput {
        code?: string;
        description?: string;
        shortDescription?: string;
        defaultValue?: boolean | string;
        dependency?: string;
    }
    export interface MiscellaneousTableBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
        defaultValue: boolean;
        dependency: MiscellaneousTable;
    }
    export interface MiscellaneousTable$Lookups {
        dependency: QueryOperation<MiscellaneousTable>;
    }
    export interface MiscellaneousTable$Operations {
        query: QueryOperation<MiscellaneousTable>;
        read: ReadOperation<MiscellaneousTable>;
        aggregate: {
            read: AggregateReadOperation<MiscellaneousTable>;
            query: AggregateQueryOperation<MiscellaneousTable>;
        };
        lookups(dataOrId: string | { data: MiscellaneousTableInput }): MiscellaneousTable$Lookups;
        getDefaults: GetDefaultsOperation<MiscellaneousTable>;
    }
    export interface MiscellaneousTables extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface MiscellaneousTablesInput extends ClientNodeInput {}
    export interface MiscellaneousTablesBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface MiscellaneousTables$Operations {
        query: QueryOperation<MiscellaneousTables>;
        read: ReadOperation<MiscellaneousTables>;
        aggregate: {
            read: AggregateReadOperation<MiscellaneousTables>;
            query: AggregateQueryOperation<MiscellaneousTables>;
        };
        getDefaults: GetDefaultsOperation<MiscellaneousTables>;
    }
    export interface MiscellaneousTablesColumns extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
    }
    export interface MiscellaneousTablesColumnsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
    }
    export interface MiscellaneousTablesColumnsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
    }
    export interface MiscellaneousTablesColumns$Operations {
        query: QueryOperation<MiscellaneousTablesColumns>;
        read: ReadOperation<MiscellaneousTablesColumns>;
        aggregate: {
            read: AggregateReadOperation<MiscellaneousTablesColumns>;
            query: AggregateQueryOperation<MiscellaneousTablesColumns>;
        };
        getDefaults: GetDefaultsOperation<MiscellaneousTablesColumns>;
    }
    export interface Site extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        name: string;
        isStockSite: boolean;
        legalCompany: Company;
        unavailablePeriodsCode: string;
    }
    export interface SiteInput extends ClientNodeInput {
        code?: string;
        name?: string;
        isStockSite?: boolean | string;
        legalCompany?: string;
        unavailablePeriodsCode?: string;
    }
    export interface SiteBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        name: string;
        isStockSite: boolean;
        legalCompany: Company;
        unavailablePeriodsCode: string;
    }
    export interface Site$Queries {
        getDefaultSiteFromModule: Operation<
            {
                module: ModuleTable;
            },
            Site
        >;
    }
    export interface Site$Lookups {
        legalCompany: QueryOperation<Company>;
    }
    export interface Site$Operations {
        query: QueryOperation<Site>;
        read: ReadOperation<Site>;
        aggregate: {
            read: AggregateReadOperation<Site>;
            query: AggregateQueryOperation<Site>;
        };
        queries: Site$Queries;
        lookups(dataOrId: string | { data: SiteInput }): Site$Lookups;
        getDefaults: GetDefaultsOperation<Site>;
    }
    export interface SyracusMethod extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface SyracusMethodInput extends ClientNodeInput {}
    export interface SyracusMethodBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface SyracusMethod$Operations {
        query: QueryOperation<SyracusMethod>;
        read: ReadOperation<SyracusMethod>;
        aggregate: {
            read: AggregateReadOperation<SyracusMethod>;
            query: AggregateQueryOperation<SyracusMethod>;
        };
        getDefaults: GetDefaultsOperation<SyracusMethod>;
    }
    export interface User extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        name: string;
        nameDescription: string;
        code: string;
        picture: BinaryStream;
        functionProfile: UserFunctionProfile;
        destinations: ClientCollection<UserDestinations>;
    }
    export interface UserInput extends ClientNodeInput {
        name?: string;
        nameDescription?: string;
        code?: string;
        functionProfile?: string;
    }
    export interface UserBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        name: string;
        nameDescription: string;
        code: string;
        picture: BinaryStream;
        functionProfile: UserFunctionProfile;
        destinations: ClientCollection<UserDestinations>;
    }
    export interface User$Lookups {
        functionProfile: QueryOperation<UserFunctionProfile>;
    }
    export interface User$Operations {
        query: QueryOperation<User>;
        read: ReadOperation<User>;
        aggregate: {
            read: AggregateReadOperation<User>;
            query: AggregateQueryOperation<User>;
        };
        lookups(dataOrId: string | { data: UserInput }): User$Lookups;
        getDefaults: GetDefaultsOperation<User>;
    }
    export interface UserAccess extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface UserAccessInput extends ClientNodeInput {}
    export interface UserAccessBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface UserAccess$Operations {
        query: QueryOperation<UserAccess>;
        read: ReadOperation<UserAccess>;
        aggregate: {
            read: AggregateReadOperation<UserAccess>;
            query: AggregateQueryOperation<UserAccess>;
        };
        getDefaults: GetDefaultsOperation<UserAccess>;
    }
    export interface UserDestinations extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        denormalizedIndex: integer;
        destination: string;
    }
    export interface UserDestinationsInput extends VitalClientNodeInput {
        code?: string;
        denormalizedIndex?: integer | string;
        destination?: string;
    }
    export interface UserDestinationsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        denormalizedIndex: integer;
        destination: string;
    }
    export interface UserDestinations$Queries {
        getDefaultDestinations: Operation<{}, UserDestinations[]>;
    }
    export interface UserDestinations$Operations {
        query: QueryOperation<UserDestinations>;
        read: ReadOperation<UserDestinations>;
        aggregate: {
            read: AggregateReadOperation<UserDestinations>;
            query: AggregateQueryOperation<UserDestinations>;
        };
        queries: UserDestinations$Queries;
        getDefaults: GetDefaultsOperation<UserDestinations>;
    }
    export interface UserFunctionProfile extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        profile: string;
        defaultSites: ClientCollection<UserFunctionProfileDefaultSite>;
        reports: ClientCollection<UserFunctionProfileReport>;
    }
    export interface UserFunctionProfileInput extends ClientNodeInput {
        profile?: string;
    }
    export interface UserFunctionProfileBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        profile: string;
        defaultSites: ClientCollection<UserFunctionProfileDefaultSite>;
        reports: ClientCollection<UserFunctionProfileReport>;
    }
    export interface UserFunctionProfile$Operations {
        query: QueryOperation<UserFunctionProfile>;
        read: ReadOperation<UserFunctionProfile>;
        aggregate: {
            read: AggregateReadOperation<UserFunctionProfile>;
            query: AggregateQueryOperation<UserFunctionProfile>;
        };
        getDefaults: GetDefaultsOperation<UserFunctionProfile>;
    }
    export interface UserFunctionProfileDefaultSite extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        defaultSite: Site;
        denormalizedIndex: integer;
    }
    export interface UserFunctionProfileDefaultSiteInput extends VitalClientNodeInput {
        defaultSite?: string;
        denormalizedIndex?: integer | string;
    }
    export interface UserFunctionProfileDefaultSiteBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        defaultSite: Site;
        denormalizedIndex: integer;
    }
    export interface UserFunctionProfileDefaultSite$Lookups {
        defaultSite: QueryOperation<Site>;
    }
    export interface UserFunctionProfileDefaultSite$Operations {
        query: QueryOperation<UserFunctionProfileDefaultSite>;
        read: ReadOperation<UserFunctionProfileDefaultSite>;
        aggregate: {
            read: AggregateReadOperation<UserFunctionProfileDefaultSite>;
            query: AggregateQueryOperation<UserFunctionProfileDefaultSite>;
        };
        lookups(
            dataOrId: string | { data: UserFunctionProfileDefaultSiteInput },
        ): UserFunctionProfileDefaultSite$Lookups;
        getDefaults: GetDefaultsOperation<UserFunctionProfileDefaultSite>;
    }
    export interface UserFunctionProfileReport extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
    }
    export interface UserFunctionProfileReportInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
    }
    export interface UserFunctionProfileReportBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
    }
    export interface UserFunctionProfileReport$Operations {
        query: QueryOperation<UserFunctionProfileReport>;
        read: ReadOperation<UserFunctionProfileReport>;
        aggregate: {
            read: AggregateReadOperation<UserFunctionProfileReport>;
            query: AggregateQueryOperation<UserFunctionProfileReport>;
        };
        getDefaults: GetDefaultsOperation<UserFunctionProfileReport>;
    }
    export interface UserParameterValue extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface UserParameterValueInput extends ClientNodeInput {}
    export interface UserParameterValueBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface UserParameterValue$Operations {
        query: QueryOperation<UserParameterValue>;
        read: ReadOperation<UserParameterValue>;
        aggregate: {
            read: AggregateReadOperation<UserParameterValue>;
            query: AggregateQueryOperation<UserParameterValue>;
        };
        getDefaults: GetDefaultsOperation<UserParameterValue>;
    }
    export interface UserProfileMenu extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface UserProfileMenuInput extends ClientNodeInput {}
    export interface UserProfileMenuBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
    }
    export interface UserProfileMenu$Operations {
        query: QueryOperation<UserProfileMenu>;
        read: ReadOperation<UserProfileMenu>;
        aggregate: {
            read: AggregateReadOperation<UserProfileMenu>;
            query: AggregateQueryOperation<UserProfileMenu>;
        };
        getDefaults: GetDefaultsOperation<UserProfileMenu>;
    }
    export interface Package {
        '@sage/xtrem-x3-system/Access': Access$Operations;
        '@sage/xtrem-x3-system/ActivityCode': ActivityCode$Operations;
        '@sage/xtrem-x3-system/Company': Company$Operations;
        '@sage/xtrem-x3-system/Destination': Destination$Operations;
        '@sage/xtrem-x3-system/Function': Function$Operations;
        '@sage/xtrem-x3-system/FunctionalProfile': FunctionalProfile$Operations;
        '@sage/xtrem-x3-system/FunctionalProfilePerSite': FunctionalProfilePerSite$Operations;
        '@sage/xtrem-x3-system/GeneralParameter': GeneralParameter$Operations;
        '@sage/xtrem-x3-system/GeneralParametersData': GeneralParametersData$Operations;
        '@sage/xtrem-x3-system/Image': Image$Operations;
        '@sage/xtrem-x3-system/Language': Language$Operations;
        '@sage/xtrem-x3-system/MiscellaneousTable': MiscellaneousTable$Operations;
        '@sage/xtrem-x3-system/MiscellaneousTables': MiscellaneousTables$Operations;
        '@sage/xtrem-x3-system/MiscellaneousTablesColumns': MiscellaneousTablesColumns$Operations;
        '@sage/xtrem-x3-system/Site': Site$Operations;
        '@sage/xtrem-x3-system/SyracusMethod': SyracusMethod$Operations;
        '@sage/xtrem-x3-system/User': User$Operations;
        '@sage/xtrem-x3-system/UserAccess': UserAccess$Operations;
        '@sage/xtrem-x3-system/UserDestinations': UserDestinations$Operations;
        '@sage/xtrem-x3-system/UserFunctionProfile': UserFunctionProfile$Operations;
        '@sage/xtrem-x3-system/UserFunctionProfileDefaultSite': UserFunctionProfileDefaultSite$Operations;
        '@sage/xtrem-x3-system/UserFunctionProfileReport': UserFunctionProfileReport$Operations;
        '@sage/xtrem-x3-system/UserParameterValue': UserParameterValue$Operations;
        '@sage/xtrem-x3-system/UserProfileMenu': UserProfileMenu$Operations;
    }
    export interface GraphApi extends Package, SageXtremX3SystemUtils$Package {}
}
declare module '@sage/xtrem-x3-system-api' {
    export type * from '@sage/xtrem-x3-system-api-partial';
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/xtrem-x3-system-api';
    export interface GraphApi extends GraphApiExtension {}
}
