/* eslint-disable import/no-duplicates */
declare module '@sage/x3-finance-data-api-partial' {
    import type {
        CustomerInvoiceHeaderInput,
        EarlyDiscountLateCharge,
        Package as SageX3InvoicingData$Package,
        PaymentMethod,
        SupplierInvoiceHeaderInput,
    } from '@sage/x3-invoicing-data-api';
    import type {
        BusinessPartner,
        BusinessPartnerInput,
        Currency,
        CustomerInput,
        Package as SageX3MasterData$Package,
    } from '@sage/x3-master-data-api';
    import type { Package as SageX3ProjectManagementData$Package } from '@sage/x3-project-management-data-api';
    import type { Package as SageX3StockData$Package } from '@sage/x3-stock-data-api';
    import type { Package as SageX3Structure$Package } from '@sage/x3-structure-api';
    import type { Company, MiscellaneousTable, Package as SageX3System$Package, Site } from '@sage/x3-system-api';
    import type { Package as SageXtremX3SystemUtils$Package, SysUser } from '@sage/xtrem-x3-system-utils-api';
    import type {
        AggregateQueryOperation,
        AggregateReadOperation,
        ClientCollection,
        ClientNode,
        ClientNodeInput,
        decimal,
        GetDefaultsOperation,
        integer,
        QueryOperation,
        ReadOperation,
        VitalClientNode,
        VitalClientNodeInput,
    } from '@sage/xtrem-client';
    export interface AccountScheme extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface AccountSchemeInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface AccountSchemeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface AccountScheme$Operations {
        query: QueryOperation<AccountScheme>;
        read: ReadOperation<AccountScheme>;
        aggregate: {
            read: AggregateReadOperation<AccountScheme>;
            query: AggregateQueryOperation<AccountScheme>;
        };
        getDefaults: GetDefaultsOperation<AccountScheme>;
    }
    export interface Account extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        chartOfAccounts: ChartOfAccounts;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface AccountInput extends ClientNodeInput {
        chartOfAccounts?: string;
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface AccountBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        chartOfAccounts: ChartOfAccounts;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface Account$Lookups {
        chartOfAccounts: QueryOperation<ChartOfAccounts>;
    }
    export interface Account$Operations {
        query: QueryOperation<Account>;
        read: ReadOperation<Account>;
        aggregate: {
            read: AggregateReadOperation<Account>;
            query: AggregateQueryOperation<Account>;
        };
        lookups(dataOrId: string | { data: AccountInput }): Account$Lookups;
        getDefaults: GetDefaultsOperation<Account>;
    }
    export interface AccountingCode extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        type: AccountingCodeType;
        accountingCode: string;
        chartOfAccounts: ChartOfAccounts;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface AccountingCodeInput extends ClientNodeInput {
        type?: AccountingCodeType;
        accountingCode?: string;
        chartOfAccounts?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface AccountingCodeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        type: AccountingCodeType;
        accountingCode: string;
        chartOfAccounts: ChartOfAccounts;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface AccountingCode$Lookups {
        chartOfAccounts: QueryOperation<ChartOfAccounts>;
    }
    export interface AccountingCode$Operations {
        query: QueryOperation<AccountingCode>;
        read: ReadOperation<AccountingCode>;
        aggregate: {
            read: AggregateReadOperation<AccountingCode>;
            query: AggregateQueryOperation<AccountingCode>;
        };
        lookups(dataOrId: string | { data: AccountingCodeInput }): AccountingCode$Lookups;
        getDefaults: GetDefaultsOperation<AccountingCode>;
    }
    export interface AutomaticJournal extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
    }
    export interface AutomaticJournalInput extends ClientNodeInput {
        code?: string;
        description?: string;
        shortDescription?: string;
    }
    export interface AutomaticJournalBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
    }
    export interface AutomaticJournal$Operations {
        query: QueryOperation<AutomaticJournal>;
        read: ReadOperation<AutomaticJournal>;
        aggregate: {
            read: AggregateReadOperation<AutomaticJournal>;
            query: AggregateQueryOperation<AutomaticJournal>;
        };
        getDefaults: GetDefaultsOperation<AutomaticJournal>;
    }
    export interface BankAccount extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        bank: string;
        description: string;
        shortDescription: string;
    }
    export interface BankAccountInput extends ClientNodeInput {
        bank?: string;
        description?: string;
        shortDescription?: string;
    }
    export interface BankAccountBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        bank: string;
        description: string;
        shortDescription: string;
    }
    export interface BankAccount$Operations {
        query: QueryOperation<BankAccount>;
        read: ReadOperation<BankAccount>;
        aggregate: {
            read: AggregateReadOperation<BankAccount>;
            query: AggregateQueryOperation<BankAccount>;
        };
        getDefaults: GetDefaultsOperation<BankAccount>;
    }
    export interface BillOfLanding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        site: Site;
    }
    export interface BillOfLandingInput extends ClientNodeInput {
        code?: string;
        site?: string;
    }
    export interface BillOfLandingBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        site: Site;
    }
    export interface BillOfLanding$Lookups {
        site: QueryOperation<Site>;
    }
    export interface BillOfLanding$Operations {
        query: QueryOperation<BillOfLanding>;
        read: ReadOperation<BillOfLanding>;
        aggregate: {
            read: AggregateReadOperation<BillOfLanding>;
            query: AggregateQueryOperation<BillOfLanding>;
        };
        lookups(dataOrId: string | { data: BillOfLandingInput }): BillOfLanding$Lookups;
        getDefaults: GetDefaultsOperation<BillOfLanding>;
    }
    export interface ChartOfAccounts extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface ChartOfAccountsInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface ChartOfAccountsBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface ChartOfAccounts$Operations {
        query: QueryOperation<ChartOfAccounts>;
        read: ReadOperation<ChartOfAccounts>;
        aggregate: {
            read: AggregateReadOperation<ChartOfAccounts>;
            query: AggregateQueryOperation<ChartOfAccounts>;
        };
        getDefaults: GetDefaultsOperation<ChartOfAccounts>;
    }
    export interface CostTypeDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CostTypeDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface CostTypeDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CostTypeDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface CostTypeDimensions$Operations {
        query: QueryOperation<CostTypeDimensions>;
        read: ReadOperation<CostTypeDimensions>;
        aggregate: {
            read: AggregateReadOperation<CostTypeDimensions>;
            query: AggregateQueryOperation<CostTypeDimensions>;
        };
        lookups(dataOrId: string | { data: CostTypeDimensionsInput }): CostTypeDimensions$Lookups;
        getDefaults: GetDefaultsOperation<CostTypeDimensions>;
    }
    export interface CustomerDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CustomerDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface CustomerDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CustomerDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface CustomerDimensions$Operations {
        query: QueryOperation<CustomerDimensions>;
        read: ReadOperation<CustomerDimensions>;
        aggregate: {
            read: AggregateReadOperation<CustomerDimensions>;
            query: AggregateQueryOperation<CustomerDimensions>;
        };
        lookups(dataOrId: string | { data: CustomerDimensionsInput }): CustomerDimensions$Lookups;
        getDefaults: GetDefaultsOperation<CustomerDimensions>;
    }
    export interface CustomerInvoiceHeaderCurrencyRates extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        ledger: Ledger;
        ledgerCurrency: Currency;
        multiplyingRate: string;
        dividingRate: string;
    }
    export interface CustomerInvoiceHeaderCurrencyRatesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        ledger?: string;
        ledgerCurrency?: string;
        multiplyingRate?: decimal | string;
        dividingRate?: decimal | string;
    }
    export interface CustomerInvoiceHeaderCurrencyRatesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        ledger: Ledger;
        ledgerCurrency: Currency;
        multiplyingRate: string;
        dividingRate: string;
    }
    export interface CustomerInvoiceHeaderCurrencyRates$Lookups {
        ledger: QueryOperation<Ledger>;
        ledgerCurrency: QueryOperation<Currency>;
    }
    export interface CustomerInvoiceHeaderCurrencyRates$Operations {
        query: QueryOperation<CustomerInvoiceHeaderCurrencyRates>;
        read: ReadOperation<CustomerInvoiceHeaderCurrencyRates>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoiceHeaderCurrencyRates>;
            query: AggregateQueryOperation<CustomerInvoiceHeaderCurrencyRates>;
        };
        lookups(
            dataOrId: string | { data: CustomerInvoiceHeaderCurrencyRatesInput },
        ): CustomerInvoiceHeaderCurrencyRates$Lookups;
        getDefaults: GetDefaultsOperation<CustomerInvoiceHeaderCurrencyRates>;
    }
    export interface CustomerInvoiceHeaderDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CustomerInvoiceHeaderDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface CustomerInvoiceHeaderDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface CustomerInvoiceHeaderDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface CustomerInvoiceHeaderDimensions$Operations {
        query: QueryOperation<CustomerInvoiceHeaderDimensions>;
        read: ReadOperation<CustomerInvoiceHeaderDimensions>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoiceHeaderDimensions>;
            query: AggregateQueryOperation<CustomerInvoiceHeaderDimensions>;
        };
        lookups(
            dataOrId: string | { data: CustomerInvoiceHeaderDimensionsInput },
        ): CustomerInvoiceHeaderDimensions$Lookups;
        getDefaults: GetDefaultsOperation<CustomerInvoiceHeaderDimensions>;
    }
    export interface DimensionType extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        dimensionType: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DimensionTypeInput extends ClientNodeInput {
        dimensionType?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface DimensionTypeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        dimensionType: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DimensionType$Operations {
        query: QueryOperation<DimensionType>;
        read: ReadOperation<DimensionType>;
        aggregate: {
            read: AggregateReadOperation<DimensionType>;
            query: AggregateQueryOperation<DimensionType>;
        };
        getDefaults: GetDefaultsOperation<DimensionType>;
    }
    export interface Dimension extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        dimensionType: DimensionType;
        dimension: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DimensionInput extends ClientNodeInput {
        dimensionType?: string;
        dimension?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface DimensionBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        dimensionType: DimensionType;
        dimension: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface Dimension$Lookups {
        dimensionType: QueryOperation<DimensionType>;
    }
    export interface Dimension$Operations {
        query: QueryOperation<Dimension>;
        read: ReadOperation<Dimension>;
        aggregate: {
            read: AggregateReadOperation<Dimension>;
            query: AggregateQueryOperation<Dimension>;
        };
        lookups(dataOrId: string | { data: DimensionInput }): Dimension$Lookups;
        getDefaults: GetDefaultsOperation<Dimension>;
    }
    export interface DistributionKey extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        numberOfLines: integer;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DistributionKeyInput extends ClientNodeInput {
        code?: string;
        numberOfLines?: integer | string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface DistributionKeyBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        numberOfLines: integer;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DistributionKey$Operations {
        query: QueryOperation<DistributionKey>;
        read: ReadOperation<DistributionKey>;
        aggregate: {
            read: AggregateReadOperation<DistributionKey>;
            query: AggregateQueryOperation<DistributionKey>;
        };
        getDefaults: GetDefaultsOperation<DistributionKey>;
    }
    export interface EntryType extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface EntryTypeInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface EntryTypeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface EntryType$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface EntryType$Operations {
        query: QueryOperation<EntryType>;
        read: ReadOperation<EntryType>;
        aggregate: {
            read: AggregateReadOperation<EntryType>;
            query: AggregateQueryOperation<EntryType>;
        };
        lookups(dataOrId: string | { data: EntryTypeInput }): EntryType$Lookups;
        getDefaults: GetDefaultsOperation<EntryType>;
    }
    export interface Factor extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        companyName: string;
    }
    export interface FactorInput extends ClientNodeInput {
        code?: string;
        companyName?: string;
    }
    export interface FactorBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        companyName: string;
    }
    export interface Factor$Operations {
        query: QueryOperation<Factor>;
        read: ReadOperation<Factor>;
        aggregate: {
            read: AggregateReadOperation<Factor>;
            query: AggregateQueryOperation<Factor>;
        };
        getDefaults: GetDefaultsOperation<Factor>;
    }
    export interface FiscalYear extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        ledgerTypeNumber: GeneralLedgerTypes;
        code: integer;
        description: string;
        shortDescription: string;
        startDate: string;
        endDate: string;
        closingDate: string;
        isAutoLedger: boolean;
        periods: ClientCollection<Period>;
    }
    export interface FiscalYearInput extends ClientNodeInput {
        company?: string;
        ledgerTypeNumber?: GeneralLedgerTypes;
        code?: integer | string;
        description?: string;
        shortDescription?: string;
        startDate?: string;
        endDate?: string;
        closingDate?: string;
        isAutoLedger?: boolean | string;
    }
    export interface FiscalYearBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        ledgerTypeNumber: GeneralLedgerTypes;
        code: integer;
        description: string;
        shortDescription: string;
        startDate: string;
        endDate: string;
        closingDate: string;
        isAutoLedger: boolean;
        periods: ClientCollection<Period>;
    }
    export interface FiscalYear$Lookups {
        company: QueryOperation<Company>;
    }
    export interface FiscalYear$Operations {
        query: QueryOperation<FiscalYear>;
        read: ReadOperation<FiscalYear>;
        aggregate: {
            read: AggregateReadOperation<FiscalYear>;
            query: AggregateQueryOperation<FiscalYear>;
        };
        lookups(dataOrId: string | { data: FiscalYearInput }): FiscalYear$Lookups;
        getDefaults: GetDefaultsOperation<FiscalYear>;
    }
    export interface JournalEntryTransaction extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface JournalEntryTransactionInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface JournalEntryTransactionBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface JournalEntryTransaction$Operations {
        query: QueryOperation<JournalEntryTransaction>;
        read: ReadOperation<JournalEntryTransaction>;
        aggregate: {
            read: AggregateReadOperation<JournalEntryTransaction>;
            query: AggregateQueryOperation<JournalEntryTransaction>;
        };
        getDefaults: GetDefaultsOperation<JournalEntryTransaction>;
    }
    export interface Journal extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface JournalInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface JournalBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface Journal$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface Journal$Operations {
        query: QueryOperation<Journal>;
        read: ReadOperation<Journal>;
        aggregate: {
            read: AggregateReadOperation<Journal>;
            query: AggregateQueryOperation<Journal>;
        };
        lookups(dataOrId: string | { data: JournalInput }): Journal$Lookups;
        getDefaults: GetDefaultsOperation<Journal>;
    }
    export interface Ledger extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface LedgerInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface LedgerBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface Ledger$Operations {
        query: QueryOperation<Ledger>;
        read: ReadOperation<Ledger>;
        aggregate: {
            read: AggregateReadOperation<Ledger>;
            query: AggregateQueryOperation<Ledger>;
        };
        getDefaults: GetDefaultsOperation<Ledger>;
    }
    export interface OpenItem extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        documentType: EntryType;
        documentNumber: string;
        lineNumber: integer;
        openItemLineNumber: integer;
        journalEntryLineInternalNumber: integer;
        company: Company;
        site: Site;
        currency: Currency;
        controlAccount: string;
        businessPartner: BusinessPartner;
        payToOrPayByBusinessPartner: BusinessPartner;
        dueDate: string;
        paymentMethod: PaymentMethod;
        paymentType: OpenItemType;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        sign: integer;
        amountInCurrency: string;
        amountInCompanyCurrency: string;
        paidAmountInCurrency: string;
        paidAmountInCompanyCurrency: string;
        provisionalPaidAmountInCurrency: string;
        provisionalPaidAmountInCompanyCurrency: string;
        canBeReminded: boolean;
        reminderLevel: integer;
        reminderDate: string;
        dispute: MiscellaneousTable;
        paymentApprovalLevel: PaymentApprovalType;
        canBeIncludedInStatement: boolean;
        postedStatus: integer;
        deductedPrepaymentAmount: string;
        prepaymentAmountToDeduct: string;
        fiscalYear: integer;
        period: integer;
        prepaymentInvoiceIssueDate: string;
        isPrepaymentIssued: boolean;
        closedStatus: integer;
        paymentDate: string;
        uniqueNumber: string;
    }
    export interface OpenItemInput extends ClientNodeInput {
        documentType?: string;
        documentNumber?: string;
        lineNumber?: integer | string;
        openItemLineNumber?: integer | string;
        journalEntryLineInternalNumber?: integer | string;
        company?: string;
        site?: string;
        currency?: string;
        controlAccount?: string;
        businessPartner?: string;
        payToOrPayByBusinessPartner?: string;
        dueDate?: string;
        paymentMethod?: string;
        paymentType?: OpenItemType;
        earlyDiscountOrLateCharge?: string;
        sign?: integer | string;
        amountInCurrency?: decimal | string;
        amountInCompanyCurrency?: decimal | string;
        paidAmountInCurrency?: decimal | string;
        paidAmountInCompanyCurrency?: decimal | string;
        provisionalPaidAmountInCurrency?: decimal | string;
        provisionalPaidAmountInCompanyCurrency?: decimal | string;
        canBeReminded?: boolean | string;
        reminderLevel?: integer | string;
        reminderDate?: string;
        dispute?: string;
        paymentApprovalLevel?: PaymentApprovalType;
        canBeIncludedInStatement?: boolean | string;
        postedStatus?: integer | string;
        deductedPrepaymentAmount?: decimal | string;
        prepaymentAmountToDeduct?: decimal | string;
        fiscalYear?: integer | string;
        period?: integer | string;
        prepaymentInvoiceIssueDate?: string;
        isPrepaymentIssued?: boolean | string;
        closedStatus?: integer | string;
        paymentDate?: string;
        uniqueNumber?: string;
    }
    export interface OpenItemBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        documentType: EntryType;
        documentNumber: string;
        lineNumber: integer;
        openItemLineNumber: integer;
        journalEntryLineInternalNumber: integer;
        company: Company;
        site: Site;
        currency: Currency;
        controlAccount: string;
        businessPartner: BusinessPartner;
        payToOrPayByBusinessPartner: BusinessPartner;
        dueDate: string;
        paymentMethod: PaymentMethod;
        paymentType: OpenItemType;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        sign: integer;
        amountInCurrency: string;
        amountInCompanyCurrency: string;
        paidAmountInCurrency: string;
        paidAmountInCompanyCurrency: string;
        provisionalPaidAmountInCurrency: string;
        provisionalPaidAmountInCompanyCurrency: string;
        canBeReminded: boolean;
        reminderLevel: integer;
        reminderDate: string;
        dispute: MiscellaneousTable;
        paymentApprovalLevel: PaymentApprovalType;
        canBeIncludedInStatement: boolean;
        postedStatus: integer;
        deductedPrepaymentAmount: string;
        prepaymentAmountToDeduct: string;
        fiscalYear: integer;
        period: integer;
        prepaymentInvoiceIssueDate: string;
        isPrepaymentIssued: boolean;
        closedStatus: integer;
        paymentDate: string;
        uniqueNumber: string;
    }
    export interface OpenItem$Lookups {
        documentType: QueryOperation<EntryType>;
        company: QueryOperation<Company>;
        site: QueryOperation<Site>;
        currency: QueryOperation<Currency>;
        businessPartner: QueryOperation<BusinessPartner>;
        payToOrPayByBusinessPartner: QueryOperation<BusinessPartner>;
        paymentMethod: QueryOperation<PaymentMethod>;
        earlyDiscountOrLateCharge: QueryOperation<EarlyDiscountLateCharge>;
        dispute: QueryOperation<MiscellaneousTable>;
    }
    export interface OpenItem$Operations {
        query: QueryOperation<OpenItem>;
        read: ReadOperation<OpenItem>;
        aggregate: {
            read: AggregateReadOperation<OpenItem>;
            query: AggregateQueryOperation<OpenItem>;
        };
        lookups(dataOrId: string | { data: OpenItemInput }): OpenItem$Lookups;
        getDefaults: GetDefaultsOperation<OpenItem>;
    }
    export interface Period extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        ledgerTypeNumber: GeneralLedgerTypes;
        fiscalYear: integer;
        code: integer;
        startDate: string;
        endDate: string;
        status: FiscalYearPeriodStatus;
        closingDate: string;
        isAutoLedger: boolean;
    }
    export interface PeriodInput extends ClientNodeInput {
        company?: string;
        ledgerTypeNumber?: GeneralLedgerTypes;
        fiscalYear?: integer | string;
        code?: integer | string;
        startDate?: string;
        endDate?: string;
        status?: FiscalYearPeriodStatus;
        closingDate?: string;
        isAutoLedger?: boolean | string;
    }
    export interface PeriodBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        ledgerTypeNumber: GeneralLedgerTypes;
        fiscalYear: integer;
        code: integer;
        startDate: string;
        endDate: string;
        status: FiscalYearPeriodStatus;
        closingDate: string;
        isAutoLedger: boolean;
    }
    export interface Period$Lookups {
        company: QueryOperation<Company>;
    }
    export interface Period$Operations {
        query: QueryOperation<Period>;
        read: ReadOperation<Period>;
        aggregate: {
            read: AggregateReadOperation<Period>;
            query: AggregateQueryOperation<Period>;
        };
        lookups(dataOrId: string | { data: PeriodInput }): Period$Lookups;
        getDefaults: GetDefaultsOperation<Period>;
    }
    export interface ReminderGroup extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface ReminderGroupInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface ReminderGroupBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface ReminderGroup$Operations {
        query: QueryOperation<ReminderGroup>;
        read: ReadOperation<ReminderGroup>;
        aggregate: {
            read: AggregateReadOperation<ReminderGroup>;
            query: AggregateQueryOperation<ReminderGroup>;
        };
        getDefaults: GetDefaultsOperation<ReminderGroup>;
    }
    export interface SupplierInvoiceHeaderCurrencyRates extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        ledger: Ledger;
        ledgerCurrency: Currency;
        multiplyingRate: string;
        dividingRate: string;
    }
    export interface SupplierInvoiceHeaderCurrencyRatesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        ledger?: string;
        ledgerCurrency?: string;
        multiplyingRate?: decimal | string;
        dividingRate?: decimal | string;
    }
    export interface SupplierInvoiceHeaderCurrencyRatesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        ledger: Ledger;
        ledgerCurrency: Currency;
        multiplyingRate: string;
        dividingRate: string;
    }
    export interface SupplierInvoiceHeaderCurrencyRates$Lookups {
        ledger: QueryOperation<Ledger>;
        ledgerCurrency: QueryOperation<Currency>;
    }
    export interface SupplierInvoiceHeaderCurrencyRates$Operations {
        query: QueryOperation<SupplierInvoiceHeaderCurrencyRates>;
        read: ReadOperation<SupplierInvoiceHeaderCurrencyRates>;
        aggregate: {
            read: AggregateReadOperation<SupplierInvoiceHeaderCurrencyRates>;
            query: AggregateQueryOperation<SupplierInvoiceHeaderCurrencyRates>;
        };
        lookups(
            dataOrId: string | { data: SupplierInvoiceHeaderCurrencyRatesInput },
        ): SupplierInvoiceHeaderCurrencyRates$Lookups;
        getDefaults: GetDefaultsOperation<SupplierInvoiceHeaderCurrencyRates>;
    }
    export interface SupplierInvoiceHeaderDimensions extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface SupplierInvoiceHeaderDimensionsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        dimensionType?: string;
        dimension?: string;
    }
    export interface SupplierInvoiceHeaderDimensionsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        dimensionType: DimensionType;
        dimension: Dimension;
    }
    export interface SupplierInvoiceHeaderDimensions$Lookups {
        dimensionType: QueryOperation<DimensionType>;
        dimension: QueryOperation<Dimension>;
    }
    export interface SupplierInvoiceHeaderDimensions$Operations {
        query: QueryOperation<SupplierInvoiceHeaderDimensions>;
        read: ReadOperation<SupplierInvoiceHeaderDimensions>;
        aggregate: {
            read: AggregateReadOperation<SupplierInvoiceHeaderDimensions>;
            query: AggregateQueryOperation<SupplierInvoiceHeaderDimensions>;
        };
        lookups(
            dataOrId: string | { data: SupplierInvoiceHeaderDimensionsInput },
        ): SupplierInvoiceHeaderDimensions$Lookups;
        getDefaults: GetDefaultsOperation<SupplierInvoiceHeaderDimensions>;
    }
    export interface BusinessPartnerExtension {
        accountingCode: string;
        expenseEntryType: EntryType;
    }
    export interface BusinessPartnerInputExtension {
        accountingCode?: string;
        expenseEntryType?: string;
    }
    export interface BusinessPartnerBindingExtension {
        accountingCode: string;
        expenseEntryType: EntryType;
    }
    export interface BusinessPartnerExtension$Lookups {
        expenseEntryType: QueryOperation<EntryType>;
    }
    export interface BusinessPartnerExtension$Operations {
        lookups(dataOrId: string | { data: BusinessPartnerInput }): BusinessPartnerExtension$Lookups;
    }
    export interface CostTypeExtension {
        dimensions: ClientCollection<CostTypeDimensions>;
    }
    export interface CostTypeInputExtension {
        dimensions?: Partial<CostTypeDimensionsInput>[];
    }
    export interface CostTypeBindingExtension {
        dimensions: ClientCollection<CostTypeDimensionsBinding>;
    }
    export interface CustomerExtension {
        reminderGroup: ReminderGroup;
        factor: Factor;
        paymentBank: BankAccount;
        _accountingCode: string;
        accountStructure: AccountScheme;
        dimensions: ClientCollection<CustomerDimensions>;
    }
    export interface CustomerInputExtension {
        reminderGroup?: string;
        factor?: string;
        paymentBank?: string;
        _accountingCode?: string;
        accountStructure?: string;
        dimensions?: Partial<CustomerDimensionsInput>[];
    }
    export interface CustomerBindingExtension {
        reminderGroup: ReminderGroup;
        factor: Factor;
        paymentBank: BankAccount;
        _accountingCode: string;
        accountStructure: AccountScheme;
        dimensions: ClientCollection<CustomerDimensionsBinding>;
    }
    export interface CustomerExtension$Lookups {
        reminderGroup: QueryOperation<ReminderGroup>;
        factor: QueryOperation<Factor>;
        paymentBank: QueryOperation<BankAccount>;
        accountStructure: QueryOperation<AccountScheme>;
    }
    export interface CustomerExtension$Operations {
        lookups(dataOrId: string | { data: CustomerInput }): CustomerExtension$Lookups;
    }
    export interface CustomerInvoiceHeaderExtension {
        entryType: EntryType;
        journal: Journal;
        paymentBank: BankAccount;
        currencyRates: ClientCollection<CustomerInvoiceHeaderCurrencyRates>;
        dimensions: ClientCollection<CustomerInvoiceHeaderDimensions>;
    }
    export interface CustomerInvoiceHeaderInputExtension {
        entryType?: string;
        journal?: string;
        paymentBank?: string;
        currencyRates?: Partial<CustomerInvoiceHeaderCurrencyRatesInput>[];
        dimensions?: Partial<CustomerInvoiceHeaderDimensionsInput>[];
    }
    export interface CustomerInvoiceHeaderBindingExtension {
        entryType: EntryType;
        journal: Journal;
        paymentBank: BankAccount;
        currencyRates: ClientCollection<CustomerInvoiceHeaderCurrencyRatesBinding>;
        dimensions: ClientCollection<CustomerInvoiceHeaderDimensionsBinding>;
    }
    export interface CustomerInvoiceHeaderExtension$Lookups {
        entryType: QueryOperation<EntryType>;
        journal: QueryOperation<Journal>;
        paymentBank: QueryOperation<BankAccount>;
    }
    export interface CustomerInvoiceHeaderExtension$Operations {
        lookups(dataOrId: string | { data: CustomerInvoiceHeaderInput }): CustomerInvoiceHeaderExtension$Lookups;
    }
    export interface ProductCategoryExtension {
        accountingCode: string;
    }
    export interface ProductCategoryInputExtension {
        accountingCode?: string;
    }
    export interface ProductCategoryBindingExtension {
        accountingCode: string;
    }
    export interface ProductExtension {
        accountingCode: string;
    }
    export interface ProductInputExtension {
        accountingCode?: string;
    }
    export interface ProductBindingExtension {
        accountingCode: string;
    }
    export interface SupplierInvoiceHeaderExtension {
        entryType: EntryType;
        journal: Journal;
        currencyRates: ClientCollection<SupplierInvoiceHeaderCurrencyRates>;
        dimensions: ClientCollection<SupplierInvoiceHeaderDimensions>;
    }
    export interface SupplierInvoiceHeaderInputExtension {
        entryType?: string;
        journal?: string;
        currencyRates?: Partial<SupplierInvoiceHeaderCurrencyRatesInput>[];
        dimensions?: Partial<SupplierInvoiceHeaderDimensionsInput>[];
    }
    export interface SupplierInvoiceHeaderBindingExtension {
        entryType: EntryType;
        journal: Journal;
        currencyRates: ClientCollection<SupplierInvoiceHeaderCurrencyRatesBinding>;
        dimensions: ClientCollection<SupplierInvoiceHeaderDimensionsBinding>;
    }
    export interface SupplierInvoiceHeaderExtension$Lookups {
        entryType: QueryOperation<EntryType>;
        journal: QueryOperation<Journal>;
    }
    export interface SupplierInvoiceHeaderExtension$Operations {
        lookups(dataOrId: string | { data: SupplierInvoiceHeaderInput }): SupplierInvoiceHeaderExtension$Lookups;
    }
    export interface Package {
        '@sage/x3-finance-data/AccountScheme': AccountScheme$Operations;
        '@sage/x3-finance-data/Account': Account$Operations;
        '@sage/x3-finance-data/AccountingCode': AccountingCode$Operations;
        '@sage/x3-finance-data/AutomaticJournal': AutomaticJournal$Operations;
        '@sage/x3-finance-data/BankAccount': BankAccount$Operations;
        '@sage/x3-finance-data/BillOfLanding': BillOfLanding$Operations;
        '@sage/x3-finance-data/ChartOfAccounts': ChartOfAccounts$Operations;
        '@sage/x3-finance-data/CostTypeDimensions': CostTypeDimensions$Operations;
        '@sage/x3-finance-data/CustomerDimensions': CustomerDimensions$Operations;
        '@sage/x3-finance-data/CustomerInvoiceHeaderCurrencyRates': CustomerInvoiceHeaderCurrencyRates$Operations;
        '@sage/x3-finance-data/CustomerInvoiceHeaderDimensions': CustomerInvoiceHeaderDimensions$Operations;
        '@sage/x3-finance-data/DimensionType': DimensionType$Operations;
        '@sage/x3-finance-data/Dimension': Dimension$Operations;
        '@sage/x3-finance-data/DistributionKey': DistributionKey$Operations;
        '@sage/x3-finance-data/EntryType': EntryType$Operations;
        '@sage/x3-finance-data/Factor': Factor$Operations;
        '@sage/x3-finance-data/FiscalYear': FiscalYear$Operations;
        '@sage/x3-finance-data/JournalEntryTransaction': JournalEntryTransaction$Operations;
        '@sage/x3-finance-data/Journal': Journal$Operations;
        '@sage/x3-finance-data/Ledger': Ledger$Operations;
        '@sage/x3-finance-data/OpenItem': OpenItem$Operations;
        '@sage/x3-finance-data/Period': Period$Operations;
        '@sage/x3-finance-data/ReminderGroup': ReminderGroup$Operations;
        '@sage/x3-finance-data/SupplierInvoiceHeaderCurrencyRates': SupplierInvoiceHeaderCurrencyRates$Operations;
        '@sage/x3-finance-data/SupplierInvoiceHeaderDimensions': SupplierInvoiceHeaderDimensions$Operations;
    }
    export interface GraphApi
        extends Package,
            SageX3InvoicingData$Package,
            SageX3MasterData$Package,
            SageX3ProjectManagementData$Package,
            SageX3StockData$Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-finance-data-api' {
    export type * from '@sage/x3-finance-data-api-partial';
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-finance-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type {
        BusinessPartnerBindingExtension,
        BusinessPartnerExtension,
        BusinessPartnerExtension$Lookups,
        BusinessPartnerExtension$Operations,
        BusinessPartnerInputExtension,
        CustomerBindingExtension,
        CustomerExtension,
        CustomerExtension$Lookups,
        CustomerExtension$Operations,
        CustomerInputExtension,
        ProductBindingExtension,
        ProductCategoryBindingExtension,
        ProductCategoryExtension,
        ProductCategoryInputExtension,
        ProductExtension,
        ProductInputExtension,
    } from '@sage/x3-finance-data-api';
    export interface BusinessPartner extends BusinessPartnerExtension {}
    export interface BusinessPartnerBinding extends BusinessPartnerBindingExtension {}
    export interface BusinessPartnerInput extends BusinessPartnerInputExtension {}
    export interface BusinessPartner$Lookups extends BusinessPartnerExtension$Lookups {}
    export interface BusinessPartner$Operations extends BusinessPartnerExtension$Operations {}
    export interface Customer extends CustomerExtension {}
    export interface CustomerBinding extends CustomerBindingExtension {}
    export interface CustomerInput extends CustomerInputExtension {}
    export interface Customer$Lookups extends CustomerExtension$Lookups {}
    export interface Customer$Operations extends CustomerExtension$Operations {}
    export interface ProductCategory extends ProductCategoryExtension {}
    export interface ProductCategoryBinding extends ProductCategoryBindingExtension {}
    export interface ProductCategoryInput extends ProductCategoryInputExtension {}
    export interface Product extends ProductExtension {}
    export interface ProductBinding extends ProductBindingExtension {}
    export interface ProductInput extends ProductInputExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type {
        CostTypeBindingExtension,
        CostTypeExtension,
        CostTypeInputExtension,
    } from '@sage/x3-finance-data-api';
    export interface CostType extends CostTypeExtension {}
    export interface CostTypeBinding extends CostTypeBindingExtension {}
    export interface CostTypeInput extends CostTypeInputExtension {}
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type {
        CustomerInvoiceHeaderBindingExtension,
        CustomerInvoiceHeaderExtension,
        CustomerInvoiceHeaderExtension$Lookups,
        CustomerInvoiceHeaderExtension$Operations,
        CustomerInvoiceHeaderInputExtension,
        SupplierInvoiceHeaderBindingExtension,
        SupplierInvoiceHeaderExtension,
        SupplierInvoiceHeaderExtension$Lookups,
        SupplierInvoiceHeaderExtension$Operations,
        SupplierInvoiceHeaderInputExtension,
    } from '@sage/x3-finance-data-api';
    export interface CustomerInvoiceHeader extends CustomerInvoiceHeaderExtension {}
    export interface CustomerInvoiceHeaderBinding extends CustomerInvoiceHeaderBindingExtension {}
    export interface CustomerInvoiceHeaderInput extends CustomerInvoiceHeaderInputExtension {}
    export interface CustomerInvoiceHeader$Lookups extends CustomerInvoiceHeaderExtension$Lookups {}
    export interface CustomerInvoiceHeader$Operations extends CustomerInvoiceHeaderExtension$Operations {}
    export interface SupplierInvoiceHeader extends SupplierInvoiceHeaderExtension {}
    export interface SupplierInvoiceHeaderBinding extends SupplierInvoiceHeaderBindingExtension {}
    export interface SupplierInvoiceHeaderInput extends SupplierInvoiceHeaderInputExtension {}
    export interface SupplierInvoiceHeader$Lookups extends SupplierInvoiceHeaderExtension$Lookups {}
    export interface SupplierInvoiceHeader$Operations extends SupplierInvoiceHeaderExtension$Operations {}
}
