/* eslint-disable import/no-duplicates */
declare module '@sage/x3-purchasing-finance-api-partial' {
    import type { FinancialCommitment, Package as SageX3Finance$Package } from '@sage/x3-finance-api';
    import type { Package as SageX3FinanceData$Package } from '@sage/x3-finance-data-api';
    import type { Package as SageX3InvoicingData$Package } from '@sage/x3-invoicing-data-api';
    import type { Package as SageX3ManufacturingData$Package } from '@sage/x3-manufacturing-data-api';
    import type { Package as SageX3MasterData$Package } from '@sage/x3-master-data-api';
    import type { Package as SageX3PhysicalFlowsData$Package } from '@sage/x3-physical-flows-data-api';
    import type { Package as SageX3ProjectManagementData$Package } from '@sage/x3-project-management-data-api';
    import type {
        Package as SageX3Purchasing$Package,
        PurchaseOrderLineInput,
        PurchaseOrderQuantityLineInput,
    } from '@sage/x3-purchasing-api';
    import type { Package as SageX3PurchasingData$Package } from '@sage/x3-purchasing-data-api';
    import type { Package as SageX3StockData$Package } from '@sage/x3-stock-data-api';
    import type { Package as SageX3Structure$Package } from '@sage/x3-structure-api';
    import type { Package as SageX3System$Package } from '@sage/x3-system-api';
    import type { Package as SageXtremX3SystemUtils$Package } from '@sage/xtrem-x3-system-utils-api';
    import type { QueryOperation } from '@sage/xtrem-client';
    export interface PurchaseOrderLineExtension {
        commitment: FinancialCommitment;
    }
    export interface PurchaseOrderLineInputExtension {
        commitment?: string;
    }
    export interface PurchaseOrderLineBindingExtension {
        commitment: FinancialCommitment;
    }
    export interface PurchaseOrderLineExtension$Lookups {
        commitment: QueryOperation<FinancialCommitment>;
    }
    export interface PurchaseOrderLineExtension$Operations {
        lookups(dataOrId: string | { data: PurchaseOrderLineInput }): PurchaseOrderLineExtension$Lookups;
    }
    export interface PurchaseOrderQuantityLineExtension {
        commitment: FinancialCommitment;
    }
    export interface PurchaseOrderQuantityLineInputExtension {
        commitment?: string;
    }
    export interface PurchaseOrderQuantityLineBindingExtension {
        commitment: FinancialCommitment;
    }
    export interface PurchaseOrderQuantityLineExtension$Lookups {
        commitment: QueryOperation<FinancialCommitment>;
    }
    export interface PurchaseOrderQuantityLineExtension$Operations {
        lookups(
            dataOrId: string | { data: PurchaseOrderQuantityLineInput },
        ): PurchaseOrderQuantityLineExtension$Lookups;
    }
    export interface Package {}
    export interface GraphApi
        extends Package,
            SageX3Finance$Package,
            SageX3FinanceData$Package,
            SageX3InvoicingData$Package,
            SageX3ManufacturingData$Package,
            SageX3MasterData$Package,
            SageX3PhysicalFlowsData$Package,
            SageX3ProjectManagementData$Package,
            SageX3Purchasing$Package,
            SageX3PurchasingData$Package,
            SageX3StockData$Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-purchasing-finance-api' {
    export type * from '@sage/x3-purchasing-finance-api-partial';
}
declare module '@sage/x3-finance-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-finance-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-manufacturing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-physical-flows-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-purchasing-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-purchasing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-finance-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-purchasing-api-partial' {
    import type {
        PurchaseOrderLineBindingExtension,
        PurchaseOrderLineExtension,
        PurchaseOrderLineExtension$Lookups,
        PurchaseOrderLineExtension$Operations,
        PurchaseOrderLineInputExtension,
        PurchaseOrderQuantityLineBindingExtension,
        PurchaseOrderQuantityLineExtension,
        PurchaseOrderQuantityLineExtension$Lookups,
        PurchaseOrderQuantityLineExtension$Operations,
        PurchaseOrderQuantityLineInputExtension,
    } from '@sage/x3-purchasing-finance-api';
    export interface PurchaseOrderLine extends PurchaseOrderLineExtension {}
    export interface PurchaseOrderLineBinding extends PurchaseOrderLineBindingExtension {}
    export interface PurchaseOrderLineInput extends PurchaseOrderLineInputExtension {}
    export interface PurchaseOrderLine$Lookups extends PurchaseOrderLineExtension$Lookups {}
    export interface PurchaseOrderLine$Operations extends PurchaseOrderLineExtension$Operations {}
    export interface PurchaseOrderQuantityLine extends PurchaseOrderQuantityLineExtension {}
    export interface PurchaseOrderQuantityLineBinding extends PurchaseOrderQuantityLineBindingExtension {}
    export interface PurchaseOrderQuantityLineInput extends PurchaseOrderQuantityLineInputExtension {}
    export interface PurchaseOrderQuantityLine$Lookups extends PurchaseOrderQuantityLineExtension$Lookups {}
    export interface PurchaseOrderQuantityLine$Operations extends PurchaseOrderQuantityLineExtension$Operations {}
}
