/* eslint-disable import/no-duplicates */
declare module '@sage/x3-sales-data-api-partial' {
    import type {
        CustomerInvoiceHeaderInput,
        Package as SageX3InvoicingData$Package,
    } from '@sage/x3-invoicing-data-api';
    import type { Package as SageX3MasterData$Package } from '@sage/x3-master-data-api';
    import type { Package as SageX3ProjectManagementData$Package } from '@sage/x3-project-management-data-api';
    import type { Package as SageX3StockData$Package } from '@sage/x3-stock-data-api';
    import type { Package as SageX3Structure$Package } from '@sage/x3-structure-api';
    import type { MiscellaneousTable, Package as SageX3System$Package } from '@sage/x3-system-api';
    import type { Package as SageXtremX3SystemUtils$Package, SysUser } from '@sage/xtrem-x3-system-utils-api';
    import type {
        AggregateQueryOperation,
        AggregateReadOperation,
        ClientNode,
        ClientNodeInput,
        GetDefaultsOperation,
        integer,
        QueryOperation,
        ReadOperation,
    } from '@sage/xtrem-client';
    export interface DeliveryPriority$Enum {
        normal: 1;
        urgent: 2;
        critical: 3;
    }
    export type DeliveryPriority = keyof DeliveryPriority$Enum;
    export interface LineType$Enum {
        normal: 1;
        fixedKit: 2;
        kitComponent: 3;
        kitOption: 4;
        kitVariant: 5;
        flexKit: 6;
        bomComponent: 7;
        bomOption: 8;
        bomVariant: 9;
        subcontracted: 10;
        service: 11;
        suppliedMaterial: 12;
        fixedAmountService: 13;
    }
    export type LineType = keyof LineType$Enum;
    export interface RouteCode$Enum {
        routeCode1: 1;
        routeCode2: 2;
        routeCode3: 3;
        routeCode4: 4;
    }
    export type RouteCode = keyof RouteCode$Enum;
    export interface SalesDeliveryType extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface SalesDeliveryTypeInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface SalesDeliveryTypeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface SalesDeliveryType$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface SalesDeliveryType$Operations {
        query: QueryOperation<SalesDeliveryType>;
        read: ReadOperation<SalesDeliveryType>;
        aggregate: {
            read: AggregateReadOperation<SalesDeliveryType>;
            query: AggregateQueryOperation<SalesDeliveryType>;
        };
        lookups(dataOrId: string | { data: SalesDeliveryTypeInput }): SalesDeliveryType$Lookups;
        getDefaults: GetDefaultsOperation<SalesDeliveryType>;
    }
    export interface SalesInvoiceType extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
        invoiceCategory: InvoiceType;
    }
    export interface SalesInvoiceTypeInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
        invoiceCategory?: InvoiceType;
    }
    export interface SalesInvoiceTypeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
        invoiceCategory: InvoiceType;
    }
    export interface SalesInvoiceType$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface SalesInvoiceType$Operations {
        query: QueryOperation<SalesInvoiceType>;
        read: ReadOperation<SalesInvoiceType>;
        aggregate: {
            read: AggregateReadOperation<SalesInvoiceType>;
            query: AggregateQueryOperation<SalesInvoiceType>;
        };
        lookups(dataOrId: string | { data: SalesInvoiceTypeInput }): SalesInvoiceType$Lookups;
        getDefaults: GetDefaultsOperation<SalesInvoiceType>;
    }
    export interface SalesOrderType extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface SalesOrderTypeInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface SalesOrderTypeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface SalesOrderType$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface SalesOrderType$Operations {
        query: QueryOperation<SalesOrderType>;
        read: ReadOperation<SalesOrderType>;
        aggregate: {
            read: AggregateReadOperation<SalesOrderType>;
            query: AggregateQueryOperation<SalesOrderType>;
        };
        lookups(dataOrId: string | { data: SalesOrderTypeInput }): SalesOrderType$Lookups;
        getDefaults: GetDefaultsOperation<SalesOrderType>;
    }
    export interface SalesPriceReason extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: integer;
        localizedDescription: string;
    }
    export interface SalesPriceReasonInput extends ClientNodeInput {
        code?: integer | string;
        localizedDescription?: string;
    }
    export interface SalesPriceReasonBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: integer;
        localizedDescription: string;
    }
    export interface SalesPriceReason$Operations {
        query: QueryOperation<SalesPriceReason>;
        read: ReadOperation<SalesPriceReason>;
        aggregate: {
            read: AggregateReadOperation<SalesPriceReason>;
            query: AggregateQueryOperation<SalesPriceReason>;
        };
        getDefaults: GetDefaultsOperation<SalesPriceReason>;
    }
    export interface SalesQuoteType extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface SalesQuoteTypeInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface SalesQuoteTypeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface SalesQuoteType$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface SalesQuoteType$Operations {
        query: QueryOperation<SalesQuoteType>;
        read: ReadOperation<SalesQuoteType>;
        aggregate: {
            read: AggregateReadOperation<SalesQuoteType>;
            query: AggregateQueryOperation<SalesQuoteType>;
        };
        lookups(dataOrId: string | { data: SalesQuoteTypeInput }): SalesQuoteType$Lookups;
        getDefaults: GetDefaultsOperation<SalesQuoteType>;
    }
    export interface SalesReturnType extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface SalesReturnTypeInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface SalesReturnTypeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface SalesReturnType$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface SalesReturnType$Operations {
        query: QueryOperation<SalesReturnType>;
        read: ReadOperation<SalesReturnType>;
        aggregate: {
            read: AggregateReadOperation<SalesReturnType>;
            query: AggregateQueryOperation<SalesReturnType>;
        };
        lookups(dataOrId: string | { data: SalesReturnTypeInput }): SalesReturnType$Lookups;
        getDefaults: GetDefaultsOperation<SalesReturnType>;
    }
    export interface CustomerInvoiceHeaderExtension {
        invoiceType: SalesInvoiceType;
    }
    export interface CustomerInvoiceHeaderInputExtension {
        invoiceType?: string;
    }
    export interface CustomerInvoiceHeaderBindingExtension {
        invoiceType: SalesInvoiceType;
    }
    export interface CustomerInvoiceHeaderExtension$Lookups {
        invoiceType: QueryOperation<SalesInvoiceType>;
    }
    export interface CustomerInvoiceHeaderExtension$Operations {
        lookups(dataOrId: string | { data: CustomerInvoiceHeaderInput }): CustomerInvoiceHeaderExtension$Lookups;
    }
    export interface ShipToCustomerAddressExtension {
        routeCode: RouteCode;
        deliveryPriority: DeliveryPriority;
    }
    export interface ShipToCustomerAddressInputExtension {
        routeCode?: RouteCode;
        deliveryPriority?: DeliveryPriority;
    }
    export interface ShipToCustomerAddressBindingExtension {
        routeCode: RouteCode;
        deliveryPriority: DeliveryPriority;
    }
    export interface Package {
        '@sage/x3-sales-data/SalesDeliveryType': SalesDeliveryType$Operations;
        '@sage/x3-sales-data/SalesInvoiceType': SalesInvoiceType$Operations;
        '@sage/x3-sales-data/SalesOrderType': SalesOrderType$Operations;
        '@sage/x3-sales-data/SalesPriceReason': SalesPriceReason$Operations;
        '@sage/x3-sales-data/SalesQuoteType': SalesQuoteType$Operations;
        '@sage/x3-sales-data/SalesReturnType': SalesReturnType$Operations;
    }
    export interface GraphApi
        extends Package,
            SageX3InvoicingData$Package,
            SageX3MasterData$Package,
            SageX3ProjectManagementData$Package,
            SageX3StockData$Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-sales-data-api' {
    export type * from '@sage/x3-sales-data-api-partial';
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-sales-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type {
        CustomerInvoiceHeaderBindingExtension,
        CustomerInvoiceHeaderExtension,
        CustomerInvoiceHeaderExtension$Lookups,
        CustomerInvoiceHeaderExtension$Operations,
        CustomerInvoiceHeaderInputExtension,
    } from '@sage/x3-sales-data-api';
    export interface CustomerInvoiceHeader extends CustomerInvoiceHeaderExtension {}
    export interface CustomerInvoiceHeaderBinding extends CustomerInvoiceHeaderBindingExtension {}
    export interface CustomerInvoiceHeaderInput extends CustomerInvoiceHeaderInputExtension {}
    export interface CustomerInvoiceHeader$Lookups extends CustomerInvoiceHeaderExtension$Lookups {}
    export interface CustomerInvoiceHeader$Operations extends CustomerInvoiceHeaderExtension$Operations {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type {
        ShipToCustomerAddressBindingExtension,
        ShipToCustomerAddressExtension,
        ShipToCustomerAddressInputExtension,
    } from '@sage/x3-sales-data-api';
    export interface ShipToCustomerAddress extends ShipToCustomerAddressExtension {}
    export interface ShipToCustomerAddressBinding extends ShipToCustomerAddressBindingExtension {}
    export interface ShipToCustomerAddressInput extends ShipToCustomerAddressInputExtension {}
}
