/* eslint-disable import/no-duplicates */
declare module '@sage/x3-stock-data-api-partial' {
    import type {
        Customer,
        Package as SageX3MasterData$Package,
        Product,
        ProductCategory,
        ProductSite,
        ProductSiteInput,
        ProductVersion,
        Supplier,
        UnitOfMeasure,
    } from '@sage/x3-master-data-api';
    import type {
        Package as SageX3ProjectManagementData$Package,
        ProjectLink,
    } from '@sage/x3-project-management-data-api';
    import type { Package as SageX3Structure$Package } from '@sage/x3-structure-api';
    import type {
        GenericPrintReport,
        MiscellaneousTable,
        Package as SageX3System$Package,
        Site,
    } from '@sage/x3-system-api';
    import type { Package as SageXtremX3SystemUtils$Package, SysUser } from '@sage/xtrem-x3-system-utils-api';
    import type {
        AggregateQueryOperation,
        AggregateReadOperation,
        ClientCollection,
        ClientNode,
        ClientNodeInput,
        decimal,
        GetDefaultsOperation,
        integer,
        QueryOperation,
        ReadOperation,
        VitalClientNode,
        VitalClientNodeInput,
    } from '@sage/xtrem-client';
    export interface AdcFlowType$Enum {
        issueFlow: 1;
        stockChange: 2;
        containerOperation: 3;
    }
    export type AdcFlowType = keyof AdcFlowType$Enum;
    export interface ContainerStatus$Enum {
        free: 1;
        inStock: 2;
    }
    export type ContainerStatus = keyof ContainerStatus$Enum;
    export interface CostSource$Enum {
        entered: 1;
        standardCost: 2;
        revisedStandardCost: 3;
        lastCost: 4;
        historicalAuc: 5;
        fifoCost: 6;
        lotAverageCost: 7;
        orderCost: 8;
        lifoCost: 9;
        lastPurchasePrice: 10;
    }
    export type CostSource = keyof CostSource$Enum;
    export interface DefaultLot$Enum {
        none: 1;
        supplierLot: 2;
        documentNumber: 3;
    }
    export type DefaultLot = keyof DefaultLot$Enum;
    export interface DimensionCostGroup$Enum {
        subtotal1: 1;
        subtotal2: 2;
        subtotal3: 3;
        subtotal4: 4;
        subtotal5: 5;
        subtotal6: 6;
        subtotal7: 7;
        subtotal8: 8;
        subtotal9: 9;
        subtotal10: 10;
        subtotal11: 11;
        subtotal12: 12;
        subtotal13: 13;
        subtotal14: 14;
        subtotal15: 15;
    }
    export type DimensionCostGroup = keyof DimensionCostGroup$Enum;
    export interface EntryTypeEnum$Enum {
        customer: 1;
        salesOrder: 2;
        picking: 3;
        delivery: 4;
        salesInvoice: 5;
        receipt: 6;
        transferInactive: 7;
        supplierReturn: 8;
        count: 9;
        workOrder: 10;
        suggestion: 11;
        productionTracking: 12;
        customerReturn: 13;
        purchaseOrder: 14;
        productionDeclaration: 15;
        miscellaneousStockInactive: 16;
        supplierInvoice: 17;
        salesCredit: 18;
        miscellaneousReceipt: 19;
        miscellaneousIssue: 20;
        locationChangeInactive: 21;
        intersiteTransferInactive: 22;
        intersiteTransferReceiptInactive: 23;
        transferForSubcontractingInactive: 24;
        receiptForSubcontractingInactive: 25;
        returnToStockInactive: 26;
        putawayPlan: 27;
        qualityControl: 28;
        stockChange: 29;
        valueChange: 30;
        assembly: 31;
        disassembly: 32;
        serviceRequest: 33;
        reorderPlan: 34;
        lotModification: 35;
        subcontractOrder: 36;
        trackingWoWo: 37;
        shipment: 38;
        transport: 39;
        project: 40;
    }
    export type EntryTypeEnum = keyof EntryTypeEnum$Enum;
    export interface ExpirationLeadTimeUnits$Enum {
        calendarDays: 1;
        month: 2;
    }
    export type ExpirationLeadTimeUnits = keyof ExpirationLeadTimeUnits$Enum;
    export interface LabelPrinting$Enum {
        noPrint: 1;
        stockLabel: 2;
        substituteValue3: 3;
        transfertDocument: 4;
        analysisDocument: 5;
        createdContainerLabel: 6;
        stockLabelAndCreatedContainerLabel: 7;
    }
    export type LabelPrinting = keyof LabelPrinting$Enum;
    export interface LicensePlateNumberEntry$Enum {
        optional: 1;
        mandatory: 2;
    }
    export type LicensePlateNumberEntry = keyof LicensePlateNumberEntry$Enum;
    export interface LocationCategory$Enum {
        internal: 1;
        dock: 2;
        customer: 3;
        subcontract: 4;
    }
    export type LocationCategory = keyof LocationCategory$Enum;
    export interface LotManagementMode$Enum {
        notManaged: 1;
        optionalLot: 2;
        mandatoryLot: 3;
        lotAndSublot: 4;
    }
    export type LotManagementMode = keyof LotManagementMode$Enum;
    export interface MaterialCostGroup$Enum {
        materialCost1: 1;
        materialCost2: 2;
        materialCost3: 3;
        materialCost4: 4;
        materialCost5: 5;
        materialCost6: 6;
        materialCost7: 7;
        materialCost8: 8;
        materialCost9: 9;
        materialCost10: 10;
        materialCost11: 11;
        materialCost12: 12;
        materialCost13: 13;
        materialCost14: 14;
        materialCost15: 15;
        materialCost16: 16;
        materialCost17: 17;
        materialCost18: 18;
        materialCost19: 19;
        materialCost20: 20;
    }
    export type MaterialCostGroup = keyof MaterialCostGroup$Enum;
    export interface PackingSequence$Enum {
        no: 1;
        free: 2;
        newLot: 3;
    }
    export type PackingSequence = keyof PackingSequence$Enum;
    export interface PrototypeOrActiveVersion$Enum {
        no: 1;
        yesExceptOnHold: 2;
        yes: 3;
    }
    export type PrototypeOrActiveVersion = keyof PrototypeOrActiveVersion$Enum;
    export interface QualityFilter1$Enum {
        statusA: 1;
        statusQ: 2;
        statusAq: 3;
        statusR: 4;
        statusAr: 5;
        statusQr: 6;
        statusAqr: 7;
    }
    export type QualityFilter1 = keyof QualityFilter1$Enum;
    export interface ReorderingManagementMode$Enum {
        notManaged: 1;
        byMrp: 2;
        byMps: 3;
        byRop: 4;
        byPeriod: 5;
    }
    export type ReorderingManagementMode = keyof ReorderingManagementMode$Enum;
    export interface StockSearchFilter$Enum {
        none: 1;
        location: 2;
        lot: 3;
        sublot: 4;
        serial: 5;
        status: 6;
        packingUnit: 7;
        pacStkConversionFactor: 8;
        identifier1: 9;
        identifier2: 10;
        licensePlateNumber: 11;
        customField1: 12;
        customField2: 13;
    }
    export type StockSearchFilter = keyof StockSearchFilter$Enum;
    export interface StockTransactionType$Enum {
        miscellaneousReceipt: 1;
        miscellaneousIssue: 2;
        supplierReceipt: 3;
        customerDelivery: 4;
        workOrderReceipt: 5;
        workOrderIssue: 6;
        locationChange: 7;
        qualityControl: 8;
        statusChange: 9;
        intersiteTransferReceiptNotActive: 10;
        receiptReturn: 11;
        deliveryReturn: 12;
        count: 13;
        intersiteTransfer: 14;
        transferForSubcontractNotActive: 15;
        subcontractReceipt: 16;
        loanDelivery: 17;
        loanDeliveryReturn: 18;
        stockReturn: 19;
        subcontractDelivery: 20;
        resplitting: 21;
        putawayPlan: 22;
        valueChange: 23;
        serviceRequest: 24;
        replenishment: 25;
        stockChange: 26;
        internalTransferIssue: 27;
        internalTransferReceipt: 28;
        subcontractIssue: 29;
        loanReceiptNotActive: 30;
        loanReceiptReturnNotActive: 31;
        subcontractReceiptReturn: 32;
        subcontractDeliveryReturn: 33;
        analysisRequest: 34;
        stockValueAdjustment: 35;
        licensePlateNumberChange: 36;
    }
    export type StockTransactionType = keyof StockTransactionType$Enum;
    export interface StockVersionMode$Enum {
        no: 1;
        major: 2;
        majorAndMinor: 3;
    }
    export type StockVersionMode = keyof StockVersionMode$Enum;
    export interface StorageLocationCode$Enum {
        empty: 1;
        occupied: 2;
        full: 3;
    }
    export type StorageLocationCode = keyof StorageLocationCode$Enum;
    export interface TitleOfLocationForStockManagementRules$Enum {
        v0: 1;
        receipt: 2;
        stock: 3;
        picking: 4;
        workstation: 5;
        delivery: 6;
        store: 7;
        customerReturn: 8;
        returnFromReturn: 9;
        toBeDefined: 10;
        toBeDefined1: 11;
        toBeDefined2: 12;
    }
    export type TitleOfLocationForStockManagementRules = keyof TitleOfLocationForStockManagementRules$Enum;
    export interface TitleOfLocation$Enum {
        receipt: 1;
        stock: 2;
        picking: 3;
        workstation: 4;
        delivery: 5;
        store: 6;
        customerReturn: 7;
        returnFromReturn: 8;
        toBeDefined: 9;
        toBeDefined1: 10;
        toBeDefined2: 11;
    }
    export type TitleOfLocation = keyof TitleOfLocation$Enum;
    export interface TraceabilityLevel$Enum {
        byDefault: 1;
        lot: 2;
        subLot: 3;
        serialNumber: 4;
    }
    export type TraceabilityLevel = keyof TraceabilityLevel$Enum;
    export interface TraceabilityManagementMode$Enum {
        noTraceability: 1;
        detailedTraceability: 2;
        summaryTraceability: 3;
    }
    export type TraceabilityManagementMode = keyof TraceabilityManagementMode$Enum;
    export interface VersionStopped$Enum {
        no: 1;
        noUnlessException: 2;
        yes: 3;
    }
    export type VersionStopped = keyof VersionStopped$Enum;
    export interface Container extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        containerType: InternalContainerType;
        isActive: boolean;
        description: string;
        shortDescription: string;
        sizeUnit: UnitOfMeasure;
        weightUnit: UnitOfMeasure;
        tareWeight: string;
        maxWeight: string;
        length: string;
        width: string;
        height: string;
        volumeUnit: UnitOfMeasure;
        volume: string;
        usableVolume: string;
        twentyFootEquivalentUnit: integer;
        isRefrigerated: boolean;
        isInternal: boolean;
        isFreight: boolean;
        isSingleProduct: boolean;
        isSingleLot: boolean;
        labelFormat: GenericPrintReport;
    }
    export interface ContainerInput extends ClientNodeInput {
        code?: string;
        containerType?: InternalContainerType;
        isActive?: boolean | string;
        description?: string;
        shortDescription?: string;
        sizeUnit?: string;
        weightUnit?: string;
        tareWeight?: decimal | string;
        maxWeight?: decimal | string;
        length?: decimal | string;
        width?: decimal | string;
        height?: decimal | string;
        volumeUnit?: string;
        volume?: decimal | string;
        usableVolume?: decimal | string;
        twentyFootEquivalentUnit?: integer | string;
        isRefrigerated?: boolean | string;
        isInternal?: boolean | string;
        isFreight?: boolean | string;
        isSingleProduct?: boolean | string;
        isSingleLot?: boolean | string;
        labelFormat?: string;
    }
    export interface ContainerBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        containerType: InternalContainerType;
        isActive: boolean;
        description: string;
        shortDescription: string;
        sizeUnit: UnitOfMeasure;
        weightUnit: UnitOfMeasure;
        tareWeight: string;
        maxWeight: string;
        length: string;
        width: string;
        height: string;
        volumeUnit: UnitOfMeasure;
        volume: string;
        usableVolume: string;
        twentyFootEquivalentUnit: integer;
        isRefrigerated: boolean;
        isInternal: boolean;
        isFreight: boolean;
        isSingleProduct: boolean;
        isSingleLot: boolean;
        labelFormat: GenericPrintReport;
    }
    export interface Container$Lookups {
        sizeUnit: QueryOperation<UnitOfMeasure>;
        weightUnit: QueryOperation<UnitOfMeasure>;
        volumeUnit: QueryOperation<UnitOfMeasure>;
        labelFormat: QueryOperation<GenericPrintReport>;
    }
    export interface Container$Operations {
        query: QueryOperation<Container>;
        read: ReadOperation<Container>;
        aggregate: {
            read: AggregateReadOperation<Container>;
            query: AggregateQueryOperation<Container>;
        };
        lookups(dataOrId: string | { data: ContainerInput }): Container$Lookups;
        getDefaults: GetDefaultsOperation<Container>;
    }
    export interface LicensePlateNumber extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        stockSite: Site;
        warehouse: Warehouse;
        locationType: string;
        location: Location;
        container: Container;
        isActive: boolean;
        isSingleProduct: boolean;
        isSingleLot: boolean;
        firstDateOfUse: string;
        lastDateOfUse: string;
        masterLicensePlateNumber: LicensePlateNumber;
        status: ContainerStatus;
        isPrinted: boolean;
        documentEntryType: EntryTypeEnum;
        documentEntry: string;
        stock: ClientCollection<Stock>;
    }
    export interface LicensePlateNumberInput extends ClientNodeInput {
        code?: string;
        stockSite?: string;
        warehouse?: string;
        locationType?: string;
        location?: string;
        container?: string;
        isActive?: boolean | string;
        isSingleProduct?: boolean | string;
        isSingleLot?: boolean | string;
        firstDateOfUse?: string;
        lastDateOfUse?: string;
        masterLicensePlateNumber?: string;
        status?: ContainerStatus;
        isPrinted?: boolean | string;
        documentEntryType?: EntryTypeEnum;
        documentEntry?: string;
    }
    export interface LicensePlateNumberBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        stockSite: Site;
        warehouse: Warehouse;
        locationType: string;
        location: Location;
        container: Container;
        isActive: boolean;
        isSingleProduct: boolean;
        isSingleLot: boolean;
        firstDateOfUse: string;
        lastDateOfUse: string;
        masterLicensePlateNumber: LicensePlateNumber;
        status: ContainerStatus;
        isPrinted: boolean;
        documentEntryType: EntryTypeEnum;
        documentEntry: string;
        stock: ClientCollection<Stock>;
    }
    export interface LicensePlateNumber$Lookups {
        stockSite: QueryOperation<Site>;
        warehouse: QueryOperation<Warehouse>;
        location: QueryOperation<Location>;
        container: QueryOperation<Container>;
        masterLicensePlateNumber: QueryOperation<LicensePlateNumber>;
    }
    export interface LicensePlateNumber$Operations {
        query: QueryOperation<LicensePlateNumber>;
        read: ReadOperation<LicensePlateNumber>;
        aggregate: {
            read: AggregateReadOperation<LicensePlateNumber>;
            query: AggregateQueryOperation<LicensePlateNumber>;
        };
        lookups(dataOrId: string | { data: LicensePlateNumberInput }): LicensePlateNumber$Lookups;
        getDefaults: GetDefaultsOperation<LicensePlateNumber>;
    }
    export interface Location extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        code: string;
        warehouse: Warehouse;
        availability: StorageLocationCode;
        type: string;
        category: LocationCategory;
        isSingleProduct: boolean;
        isDedicated: boolean;
        authorizedSubstatus: string;
        isBlocked: boolean;
        isBeingCounted: boolean;
        stock: ClientCollection<Stock>;
    }
    export interface LocationInput extends ClientNodeInput {
        stockSite?: string;
        code?: string;
        warehouse?: string;
        availability?: StorageLocationCode;
        type?: string;
        category?: LocationCategory;
        isSingleProduct?: boolean | string;
        isDedicated?: boolean | string;
        authorizedSubstatus?: string;
        isBlocked?: boolean | string;
        isBeingCounted?: boolean | string;
    }
    export interface LocationBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        code: string;
        warehouse: Warehouse;
        availability: StorageLocationCode;
        type: string;
        category: LocationCategory;
        isSingleProduct: boolean;
        isDedicated: boolean;
        authorizedSubstatus: string;
        isBlocked: boolean;
        isBeingCounted: boolean;
        stock: ClientCollection<Stock>;
    }
    export interface Location$Lookups {
        stockSite: QueryOperation<Site>;
        warehouse: QueryOperation<Warehouse>;
    }
    export interface Location$Operations {
        query: QueryOperation<Location>;
        read: ReadOperation<Location>;
        aggregate: {
            read: AggregateReadOperation<Location>;
            query: AggregateQueryOperation<Location>;
        };
        lookups(dataOrId: string | { data: LocationInput }): Location$Lookups;
        getDefaults: GetDefaultsOperation<Location>;
    }
    export interface Lot extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        code: string;
        sublot: string;
        documentType: EntryTypeEnum;
        documentId: string;
        documentLine: integer;
        supplierLot: string;
        lotCustomField1: string;
        lotCustomField2: string;
        lotCustomField3: string;
        lotCustomField4: string;
        lotCreationDate: string;
        expirationReferenceDate: string;
        shelfLife: integer;
        expirationDate: string;
        potency: string;
        internationalUnitPotency: string;
        supplier: Supplier;
        expirationTimeUnit: ExpirationLeadTimeUnits;
        recontrolTimeUnit: ExpirationLeadTimeUnits;
        checkLeadTime: integer;
        recontrolDate: string;
        useByDateCoefficient: string;
        useByDate: string;
        controlDate: string;
        exportNumber: integer;
        majorVersion: MajorVersionStatus;
        minorVersion: string;
        stock: ClientCollection<Stock>;
    }
    export interface LotInput extends ClientNodeInput {
        product?: string;
        code?: string;
        sublot?: string;
        documentType?: EntryTypeEnum;
        documentId?: string;
        documentLine?: integer | string;
        supplierLot?: string;
        lotCustomField1?: string;
        lotCustomField2?: string;
        lotCustomField3?: decimal | string;
        lotCustomField4?: string;
        lotCreationDate?: string;
        expirationReferenceDate?: string;
        shelfLife?: integer | string;
        expirationDate?: string;
        potency?: decimal | string;
        internationalUnitPotency?: decimal | string;
        supplier?: string;
        expirationTimeUnit?: ExpirationLeadTimeUnits;
        recontrolTimeUnit?: ExpirationLeadTimeUnits;
        checkLeadTime?: integer | string;
        recontrolDate?: string;
        useByDateCoefficient?: decimal | string;
        useByDate?: string;
        controlDate?: string;
        exportNumber?: integer | string;
        majorVersion?: string;
        minorVersion?: string;
    }
    export interface LotBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        code: string;
        sublot: string;
        documentType: EntryTypeEnum;
        documentId: string;
        documentLine: integer;
        supplierLot: string;
        lotCustomField1: string;
        lotCustomField2: string;
        lotCustomField3: string;
        lotCustomField4: string;
        lotCreationDate: string;
        expirationReferenceDate: string;
        shelfLife: integer;
        expirationDate: string;
        potency: string;
        internationalUnitPotency: string;
        supplier: Supplier;
        expirationTimeUnit: ExpirationLeadTimeUnits;
        recontrolTimeUnit: ExpirationLeadTimeUnits;
        checkLeadTime: integer;
        recontrolDate: string;
        useByDateCoefficient: string;
        useByDate: string;
        controlDate: string;
        exportNumber: integer;
        majorVersion: MajorVersionStatus;
        minorVersion: string;
        stock: ClientCollection<Stock>;
    }
    export interface Lot$Lookups {
        product: QueryOperation<Product>;
        supplier: QueryOperation<Supplier>;
        majorVersion: QueryOperation<MajorVersionStatus>;
    }
    export interface Lot$Operations {
        query: QueryOperation<Lot>;
        read: ReadOperation<Lot>;
        aggregate: {
            read: AggregateReadOperation<Lot>;
            query: AggregateQueryOperation<Lot>;
        };
        lookups(dataOrId: string | { data: LotInput }): Lot$Lookups;
        getDefaults: GetDefaultsOperation<Lot>;
    }
    export interface LotsSites extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        lot: string;
        sublot: string;
        storageSite: Site;
        acceptedQuantityAStatus: string;
        qcQStatus: string;
        rejectedQuantityRStatus: string;
        averageCost: string;
        aucBaseQuantity: string;
        aucBaseAmount: string;
        mapSubConCost: string;
        invoicingElement: string;
        mapMaterialOh: string;
        mapMachineOh: string;
        mapLaborOh: string;
        mapSubConOh: string;
        mapSubConCost1: string;
        invoicingElement1: string;
        mapMaterialOh1: string;
        mapMachineOh1: string;
        mapLaborOh1: string;
        mapSubConOh1: string;
        lastReceiptDate: string;
        lastIssueDate: string;
        lastCountDate: string;
        exportNumber: integer;
        stock: ClientCollection<Stock>;
    }
    export interface LotsSitesInput extends ClientNodeInput {
        product?: string;
        lot?: string;
        sublot?: string;
        storageSite?: string;
        acceptedQuantityAStatus?: decimal | string;
        qcQStatus?: decimal | string;
        rejectedQuantityRStatus?: decimal | string;
        averageCost?: decimal | string;
        aucBaseQuantity?: decimal | string;
        aucBaseAmount?: decimal | string;
        mapSubConCost?: decimal | string;
        invoicingElement?: decimal | string;
        mapMaterialOh?: decimal | string;
        mapMachineOh?: decimal | string;
        mapLaborOh?: decimal | string;
        mapSubConOh?: decimal | string;
        mapSubConCost1?: decimal | string;
        invoicingElement1?: decimal | string;
        mapMaterialOh1?: decimal | string;
        mapMachineOh1?: decimal | string;
        mapLaborOh1?: decimal | string;
        mapSubConOh1?: decimal | string;
        lastReceiptDate?: string;
        lastIssueDate?: string;
        lastCountDate?: string;
        exportNumber?: integer | string;
        stock?: Partial<StockInput>[];
    }
    export interface LotsSitesBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        lot: string;
        sublot: string;
        storageSite: Site;
        acceptedQuantityAStatus: string;
        qcQStatus: string;
        rejectedQuantityRStatus: string;
        averageCost: string;
        aucBaseQuantity: string;
        aucBaseAmount: string;
        mapSubConCost: string;
        invoicingElement: string;
        mapMaterialOh: string;
        mapMachineOh: string;
        mapLaborOh: string;
        mapSubConOh: string;
        mapSubConCost1: string;
        invoicingElement1: string;
        mapMaterialOh1: string;
        mapMachineOh1: string;
        mapLaborOh1: string;
        mapSubConOh1: string;
        lastReceiptDate: string;
        lastIssueDate: string;
        lastCountDate: string;
        exportNumber: integer;
        stock: ClientCollection<Stock>;
    }
    export interface LotsSites$Lookups {
        product: QueryOperation<Product>;
        storageSite: QueryOperation<Site>;
    }
    export interface LotsSites$Operations {
        query: QueryOperation<LotsSites>;
        read: ReadOperation<LotsSites>;
        aggregate: {
            read: AggregateReadOperation<LotsSites>;
            query: AggregateQueryOperation<LotsSites>;
        };
        lookups(dataOrId: string | { data: LotsSitesInput }): LotsSites$Lookups;
        getDefaults: GetDefaultsOperation<LotsSites>;
    }
    export interface MajorVersionStatus extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        code: string;
        description: string;
        shortDescription: string;
        status: VersionStatus;
        startDate: string;
        endDate: string;
        isSubjectToException: boolean;
        exceptionDate: string;
        isOnHold: boolean;
        exportNumber: integer;
        minorVersions: ClientCollection<ProductVersion>;
    }
    export interface MajorVersionStatusInput extends ClientNodeInput {
        product?: string;
        code?: string;
        description?: string;
        shortDescription?: string;
        status?: VersionStatus;
        startDate?: string;
        endDate?: string;
        isSubjectToException?: boolean | string;
        exceptionDate?: string;
        isOnHold?: boolean | string;
        exportNumber?: integer | string;
    }
    export interface MajorVersionStatusBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        code: string;
        description: string;
        shortDescription: string;
        status: VersionStatus;
        startDate: string;
        endDate: string;
        isSubjectToException: boolean;
        exceptionDate: string;
        isOnHold: boolean;
        exportNumber: integer;
        minorVersions: ClientCollection<ProductVersion>;
    }
    export interface MajorVersionStatus$Lookups {
        product: QueryOperation<Product>;
    }
    export interface MajorVersionStatus$Operations {
        query: QueryOperation<MajorVersionStatus>;
        read: ReadOperation<MajorVersionStatus>;
        aggregate: {
            read: AggregateReadOperation<MajorVersionStatus>;
            query: AggregateQueryOperation<MajorVersionStatus>;
        };
        lookups(dataOrId: string | { data: MajorVersionStatusInput }): MajorVersionStatus$Lookups;
        getDefaults: GetDefaultsOperation<MajorVersionStatus>;
    }
    export interface MobileSettings extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        flowType: AdcFlowType;
        stockField1: StockSearchFilter;
        stockField2: StockSearchFilter;
        stockField3: StockSearchFilter;
        stockField4: StockSearchFilter;
        stockField5: StockSearchFilter;
        stockField6: StockSearchFilter;
        stockField7: StockSearchFilter;
        stockField8: StockSearchFilter;
    }
    export interface MobileSettingsInput extends ClientNodeInput {
        stockSite?: string;
        flowType?: AdcFlowType;
        stockField1?: StockSearchFilter;
        stockField2?: StockSearchFilter;
        stockField3?: StockSearchFilter;
        stockField4?: StockSearchFilter;
        stockField5?: StockSearchFilter;
        stockField6?: StockSearchFilter;
        stockField7?: StockSearchFilter;
        stockField8?: StockSearchFilter;
    }
    export interface MobileSettingsBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        flowType: AdcFlowType;
        stockField1: StockSearchFilter;
        stockField2: StockSearchFilter;
        stockField3: StockSearchFilter;
        stockField4: StockSearchFilter;
        stockField5: StockSearchFilter;
        stockField6: StockSearchFilter;
        stockField7: StockSearchFilter;
        stockField8: StockSearchFilter;
    }
    export interface MobileSettings$Lookups {
        stockSite: QueryOperation<Site>;
    }
    export interface MobileSettings$Operations {
        query: QueryOperation<MobileSettings>;
        read: ReadOperation<MobileSettings>;
        aggregate: {
            read: AggregateReadOperation<MobileSettings>;
            query: AggregateQueryOperation<MobileSettings>;
        };
        lookups(dataOrId: string | { data: MobileSettingsInput }): MobileSettings$Lookups;
        getDefaults: GetDefaultsOperation<MobileSettings>;
    }
    export interface ProductCategoryDefaultLocations extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        stockSite: string;
        code: string;
        locationNumber: TitleOfLocation;
        defaultLocationType: string;
        defaultLocation: string;
    }
    export interface ProductCategoryDefaultLocationsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        stockSite?: string;
        code?: string;
        locationNumber?: TitleOfLocation;
        defaultLocationType?: string;
        defaultLocation?: string;
    }
    export interface ProductCategoryDefaultLocationsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        stockSite: string;
        code: string;
        locationNumber: TitleOfLocation;
        defaultLocationType: string;
        defaultLocation: string;
    }
    export interface ProductCategoryDefaultLocations$Operations {
        query: QueryOperation<ProductCategoryDefaultLocations>;
        read: ReadOperation<ProductCategoryDefaultLocations>;
        aggregate: {
            read: AggregateReadOperation<ProductCategoryDefaultLocations>;
            query: AggregateQueryOperation<ProductCategoryDefaultLocations>;
        };
        getDefaults: GetDefaultsOperation<ProductCategoryDefaultLocations>;
    }
    export interface ProductSiteDefaultLocations extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        product: string;
        stockSite: string;
        locationNumber: TitleOfLocation;
        defaultLocationType: string;
        defaultLocation: string;
    }
    export interface ProductSiteDefaultLocationsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        product?: string;
        stockSite?: string;
        locationNumber?: TitleOfLocation;
        defaultLocationType?: string;
        defaultLocation?: string;
    }
    export interface ProductSiteDefaultLocationsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        product: string;
        stockSite: string;
        locationNumber: TitleOfLocation;
        defaultLocationType: string;
        defaultLocation: string;
    }
    export interface ProductSiteDefaultLocations$Operations {
        query: QueryOperation<ProductSiteDefaultLocations>;
        read: ReadOperation<ProductSiteDefaultLocations>;
        aggregate: {
            read: AggregateReadOperation<ProductSiteDefaultLocations>;
            query: AggregateQueryOperation<ProductSiteDefaultLocations>;
        };
        getDefaults: GetDefaultsOperation<ProductSiteDefaultLocations>;
    }
    export interface ProductSiteInternalContainers extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        product: string;
        stockSite: string;
        internalContainer: Container;
    }
    export interface ProductSiteInternalContainersInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        product?: string;
        stockSite?: string;
        internalContainer?: string;
    }
    export interface ProductSiteInternalContainersBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        product: string;
        stockSite: string;
        internalContainer: Container;
    }
    export interface ProductSiteInternalContainers$Lookups {
        internalContainer: QueryOperation<Container>;
    }
    export interface ProductSiteInternalContainers$Operations {
        query: QueryOperation<ProductSiteInternalContainers>;
        read: ReadOperation<ProductSiteInternalContainers>;
        aggregate: {
            read: AggregateReadOperation<ProductSiteInternalContainers>;
            query: AggregateQueryOperation<ProductSiteInternalContainers>;
        };
        lookups(dataOrId: string | { data: ProductSiteInternalContainersInput }): ProductSiteInternalContainers$Lookups;
        getDefaults: GetDefaultsOperation<ProductSiteInternalContainers>;
    }
    export interface SerialNumber extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        code: string;
        stockSite: Site;
        documentType: EntryTypeEnum;
        documentId: string;
        documentLine: integer;
        receiptDate: string;
        receiptSite: Site;
        receiptDocumentType: EntryTypeEnum;
        receiptDocumentId: string;
        receiptDocumentLine: integer;
        customer: Customer;
        issueDocumentType: EntryTypeEnum;
        issueDocumentId: string;
        issueDocumentLine: integer;
        issueDate: string;
        warrantyEndDate: string;
        exportNumber: integer;
        stockId: string;
        stockLine: Stock;
    }
    export interface SerialNumberInput extends ClientNodeInput {
        product?: string;
        code?: string;
        stockSite?: string;
        documentType?: EntryTypeEnum;
        documentId?: string;
        documentLine?: integer | string;
        receiptDate?: string;
        receiptSite?: string;
        receiptDocumentType?: EntryTypeEnum;
        receiptDocumentId?: string;
        receiptDocumentLine?: integer | string;
        customer?: string;
        issueDocumentType?: EntryTypeEnum;
        issueDocumentId?: string;
        issueDocumentLine?: integer | string;
        issueDate?: string;
        warrantyEndDate?: string;
        exportNumber?: integer | string;
        stockId?: decimal | string;
        stockLine?: decimal | string;
    }
    export interface SerialNumberBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        code: string;
        stockSite: Site;
        documentType: EntryTypeEnum;
        documentId: string;
        documentLine: integer;
        receiptDate: string;
        receiptSite: Site;
        receiptDocumentType: EntryTypeEnum;
        receiptDocumentId: string;
        receiptDocumentLine: integer;
        customer: Customer;
        issueDocumentType: EntryTypeEnum;
        issueDocumentId: string;
        issueDocumentLine: integer;
        issueDate: string;
        warrantyEndDate: string;
        exportNumber: integer;
        stockId: string;
        stockLine: Stock;
    }
    export interface SerialNumber$Lookups {
        product: QueryOperation<Product>;
        stockSite: QueryOperation<Site>;
        receiptSite: QueryOperation<Site>;
        customer: QueryOperation<Customer>;
        stockLine: QueryOperation<Stock>;
    }
    export interface SerialNumber$Operations {
        query: QueryOperation<SerialNumber>;
        read: ReadOperation<SerialNumber>;
        aggregate: {
            read: AggregateReadOperation<SerialNumber>;
            query: AggregateQueryOperation<SerialNumber>;
        };
        lookups(dataOrId: string | { data: SerialNumberInput }): SerialNumber$Lookups;
        getDefaults: GetDefaultsOperation<SerialNumber>;
    }
    export interface StockJournal extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        isUpdated: boolean;
        product: Product;
        effectiveDate: string;
        sequence: integer;
        index: integer;
        lot: string;
        sublot: string;
        supplierLot: string;
        location: Location;
        warehouse: Warehouse;
        serialNumber: string;
        transactionType: StockTransactionType;
        movementDescription: string;
        project: ProjectLink;
        documentType: EntryTypeEnum;
        documentId: string;
        documentLine: integer;
        documentTypeOriginal: EntryTypeEnum;
        documentIdOriginal: string;
        documentLineOriginal: integer;
        documentSequenceOriginal: integer;
        lotCustomField1: string;
        lotCustomField2: string;
        lotCustomField3: string;
        lotCustomField4: string;
        packingUnit: UnitOfMeasure;
        quantityInPackingUnit: string;
        packingUnitToStockUnitConversionFactor: string;
        quantityInStockUnit: string;
        stockUnit: UnitOfMeasure;
        expirationDate: string;
        status: StockStatus;
        potency: string;
        internationalUnitPotency: string;
        activQuantity: string;
        adjustedMovement: boolean;
        identifier1: string;
        identifier2: string;
        useByDate: string;
        majorVersion: MajorVersionStatus;
        minorVersion: string;
        startingSerialNumber: string;
        stockCustomField1: string;
        endingSerialNumber: string;
        stockCustomField2: string;
        licensePlateNumber: LicensePlateNumber;
    }
    export interface StockJournalInput extends ClientNodeInput {
        stockSite?: string;
        isUpdated?: boolean | string;
        product?: string;
        effectiveDate?: string;
        sequence?: integer | string;
        index?: integer | string;
        lot?: string;
        sublot?: string;
        supplierLot?: string;
        location?: string;
        warehouse?: string;
        serialNumber?: string;
        transactionType?: StockTransactionType;
        movementDescription?: string;
        project?: string;
        documentType?: EntryTypeEnum;
        documentId?: string;
        documentLine?: integer | string;
        documentTypeOriginal?: EntryTypeEnum;
        documentIdOriginal?: string;
        documentLineOriginal?: integer | string;
        documentSequenceOriginal?: integer | string;
        lotCustomField1?: string;
        lotCustomField2?: string;
        lotCustomField3?: decimal | string;
        lotCustomField4?: string;
        packingUnit?: string;
        quantityInPackingUnit?: decimal | string;
        packingUnitToStockUnitConversionFactor?: decimal | string;
        quantityInStockUnit?: decimal | string;
        stockUnit?: string;
        expirationDate?: string;
        status?: string;
        potency?: decimal | string;
        internationalUnitPotency?: decimal | string;
        activQuantity?: decimal | string;
        adjustedMovement?: boolean | string;
        identifier1?: string;
        identifier2?: string;
        useByDate?: string;
        majorVersion?: string;
        minorVersion?: string;
        startingSerialNumber?: string;
        stockCustomField1?: string;
        endingSerialNumber?: string;
        stockCustomField2?: string;
        licensePlateNumber?: string;
    }
    export interface StockJournalBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        isUpdated: boolean;
        product: Product;
        effectiveDate: string;
        sequence: integer;
        index: integer;
        lot: string;
        sublot: string;
        supplierLot: string;
        location: Location;
        warehouse: Warehouse;
        serialNumber: string;
        transactionType: StockTransactionType;
        movementDescription: string;
        project: ProjectLink;
        documentType: EntryTypeEnum;
        documentId: string;
        documentLine: integer;
        documentTypeOriginal: EntryTypeEnum;
        documentIdOriginal: string;
        documentLineOriginal: integer;
        documentSequenceOriginal: integer;
        lotCustomField1: string;
        lotCustomField2: string;
        lotCustomField3: string;
        lotCustomField4: string;
        packingUnit: UnitOfMeasure;
        quantityInPackingUnit: string;
        packingUnitToStockUnitConversionFactor: string;
        quantityInStockUnit: string;
        stockUnit: UnitOfMeasure;
        expirationDate: string;
        status: StockStatus;
        potency: string;
        internationalUnitPotency: string;
        activQuantity: string;
        adjustedMovement: boolean;
        identifier1: string;
        identifier2: string;
        useByDate: string;
        majorVersion: MajorVersionStatus;
        minorVersion: string;
        startingSerialNumber: string;
        stockCustomField1: string;
        endingSerialNumber: string;
        stockCustomField2: string;
        licensePlateNumber: LicensePlateNumber;
    }
    export interface StockJournal$Lookups {
        stockSite: QueryOperation<Site>;
        product: QueryOperation<Product>;
        location: QueryOperation<Location>;
        warehouse: QueryOperation<Warehouse>;
        project: QueryOperation<ProjectLink>;
        packingUnit: QueryOperation<UnitOfMeasure>;
        stockUnit: QueryOperation<UnitOfMeasure>;
        status: QueryOperation<StockStatus>;
        majorVersion: QueryOperation<MajorVersionStatus>;
        licensePlateNumber: QueryOperation<LicensePlateNumber>;
    }
    export interface StockJournal$Operations {
        query: QueryOperation<StockJournal>;
        read: ReadOperation<StockJournal>;
        aggregate: {
            read: AggregateReadOperation<StockJournal>;
            query: AggregateQueryOperation<StockJournal>;
        };
        lookups(dataOrId: string | { data: StockJournalInput }): StockJournal$Lookups;
        getDefaults: GetDefaultsOperation<StockJournal>;
    }
    export interface StockManagementRules extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        productCategory: ProductCategory;
        stockSite: Site;
        transactionType: StockTransactionType;
        stockMovementCode: MiscellaneousTable;
        locationNumber: TitleOfLocationForStockManagementRules;
        locationNumber2: TitleOfLocationForStockManagementRules;
        locationNumber3: TitleOfLocationForStockManagementRules;
        authorizedStatus: QualityFilter1;
        authorizedSubstatus: string;
        defaultStatus: string;
        formula: string;
        hasAnalysisRequest: boolean;
        lotEntry: PackingSequence;
        lotByDefault: DefaultLot;
        outputLot: LotIssueExpirationUbd;
        prototypeVersion: PrototypeOrActiveVersion;
        activeVersion: PrototypeOrActiveVersion;
        versionStopped: VersionStopped;
        isExclusiveEntryVersion: boolean;
        licensePlateNumberEntry: LicensePlateNumberEntry;
    }
    export interface StockManagementRulesInput extends ClientNodeInput {
        productCategory?: string;
        stockSite?: string;
        transactionType?: StockTransactionType;
        stockMovementCode?: string;
        locationNumber?: TitleOfLocationForStockManagementRules;
        locationNumber2?: TitleOfLocationForStockManagementRules;
        locationNumber3?: TitleOfLocationForStockManagementRules;
        authorizedStatus?: QualityFilter1;
        authorizedSubstatus?: string;
        defaultStatus?: string;
        formula?: string;
        hasAnalysisRequest?: boolean | string;
        lotEntry?: PackingSequence;
        lotByDefault?: DefaultLot;
        outputLot?: LotIssueExpirationUbd;
        prototypeVersion?: PrototypeOrActiveVersion;
        activeVersion?: PrototypeOrActiveVersion;
        versionStopped?: VersionStopped;
        isExclusiveEntryVersion?: boolean | string;
        licensePlateNumberEntry?: LicensePlateNumberEntry;
    }
    export interface StockManagementRulesBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        productCategory: ProductCategory;
        stockSite: Site;
        transactionType: StockTransactionType;
        stockMovementCode: MiscellaneousTable;
        locationNumber: TitleOfLocationForStockManagementRules;
        locationNumber2: TitleOfLocationForStockManagementRules;
        locationNumber3: TitleOfLocationForStockManagementRules;
        authorizedStatus: QualityFilter1;
        authorizedSubstatus: string;
        defaultStatus: string;
        formula: string;
        hasAnalysisRequest: boolean;
        lotEntry: PackingSequence;
        lotByDefault: DefaultLot;
        outputLot: LotIssueExpirationUbd;
        prototypeVersion: PrototypeOrActiveVersion;
        activeVersion: PrototypeOrActiveVersion;
        versionStopped: VersionStopped;
        isExclusiveEntryVersion: boolean;
        licensePlateNumberEntry: LicensePlateNumberEntry;
    }
    export interface StockManagementRules$Lookups {
        productCategory: QueryOperation<ProductCategory>;
        stockSite: QueryOperation<Site>;
        stockMovementCode: QueryOperation<MiscellaneousTable>;
    }
    export interface StockManagementRules$Operations {
        query: QueryOperation<StockManagementRules>;
        read: ReadOperation<StockManagementRules>;
        aggregate: {
            read: AggregateReadOperation<StockManagementRules>;
            query: AggregateQueryOperation<StockManagementRules>;
        };
        lookups(dataOrId: string | { data: StockManagementRulesInput }): StockManagementRules$Lookups;
        getDefaults: GetDefaultsOperation<StockManagementRules>;
    }
    export interface StockStatus extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        localizedDescription: string;
        shortDescription: string;
        localizedShortDescription: string;
        expiredQStatus: StockStatus;
        expiredRStatus: StockStatus;
    }
    export interface StockStatusInput extends ClientNodeInput {
        code?: string;
        description?: string;
        localizedDescription?: string;
        shortDescription?: string;
        localizedShortDescription?: string;
        expiredQStatus?: string;
        expiredRStatus?: string;
    }
    export interface StockStatusBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        localizedDescription: string;
        shortDescription: string;
        localizedShortDescription: string;
        expiredQStatus: StockStatus;
        expiredRStatus: StockStatus;
    }
    export interface StockStatus$Lookups {
        expiredQStatus: QueryOperation<StockStatus>;
        expiredRStatus: QueryOperation<StockStatus>;
    }
    export interface StockStatus$Operations {
        query: QueryOperation<StockStatus>;
        read: ReadOperation<StockStatus>;
        aggregate: {
            read: AggregateReadOperation<StockStatus>;
            query: AggregateQueryOperation<StockStatus>;
        };
        lookups(dataOrId: string | { data: StockStatusInput }): StockStatus$Lookups;
        getDefaults: GetDefaultsOperation<StockStatus>;
    }
    export interface Stock extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        stockId: string;
        owner: string;
        product: ProductSite;
        lot: string;
        sublot: string;
        supplierLot: string;
        identifier1: string;
        identifier2: string;
        status: StockStatus;
        location: Location;
        locationType: string;
        locationCategory: LocationCategory;
        warehouse: Warehouse;
        serialNumber: string;
        receiptDate: string;
        packingUnit: UnitOfMeasure;
        packingUnitToStockUnitConversionFactor: string;
        quantityInPackingUnit: string;
        quantityInStockUnit: string;
        activeQuantityInStockUnit: string;
        originalPackingUnit: UnitOfMeasure;
        originalQuantityInPackingUnit: string;
        originalQuantityInStockUnit: string;
        qualityAnalysisRequestId: string;
        allocatedQuantity: string;
        allocatedActiveQuantity: string;
        inProcessQuantity: string;
        inProcessActiveQuantity: string;
        editedFlag: integer;
        lastReceiptDate: string;
        lastIssueDate: string;
        lastCountDate: string;
        isBeingCounted: boolean;
        countWorksheet: string;
        exportNumber: integer;
        majorVersion: MajorVersionStatus;
        stockCustomField1: string;
        stockCustomField2: string;
        project: ProjectLink;
        licensePlateNumber: LicensePlateNumber;
        productCollection: ClientCollection<Product>;
        lotReference: Lot;
        availableQuantity: string;
    }
    export interface StockInput extends ClientNodeInput {
        stockSite?: string;
        stockId?: decimal | string;
        owner?: string;
        product?: string;
        lot?: string;
        sublot?: string;
        supplierLot?: string;
        identifier1?: string;
        identifier2?: string;
        status?: string;
        location?: string;
        locationType?: string;
        locationCategory?: LocationCategory;
        warehouse?: string;
        serialNumber?: string;
        receiptDate?: string;
        packingUnit?: string;
        packingUnitToStockUnitConversionFactor?: decimal | string;
        quantityInPackingUnit?: decimal | string;
        quantityInStockUnit?: decimal | string;
        activeQuantityInStockUnit?: decimal | string;
        originalPackingUnit?: string;
        originalQuantityInPackingUnit?: decimal | string;
        originalQuantityInStockUnit?: decimal | string;
        qualityAnalysisRequestId?: string;
        allocatedQuantity?: decimal | string;
        allocatedActiveQuantity?: decimal | string;
        inProcessQuantity?: decimal | string;
        inProcessActiveQuantity?: decimal | string;
        editedFlag?: integer | string;
        lastReceiptDate?: string;
        lastIssueDate?: string;
        lastCountDate?: string;
        isBeingCounted?: boolean | string;
        countWorksheet?: string;
        exportNumber?: integer | string;
        majorVersion?: string;
        stockCustomField1?: string;
        stockCustomField2?: string;
        project?: string;
        licensePlateNumber?: string;
        lotReference?: string;
    }
    export interface StockBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        stockId: string;
        owner: string;
        product: ProductSite;
        lot: string;
        sublot: string;
        supplierLot: string;
        identifier1: string;
        identifier2: string;
        status: StockStatus;
        location: Location;
        locationType: string;
        locationCategory: LocationCategory;
        warehouse: Warehouse;
        serialNumber: string;
        receiptDate: string;
        packingUnit: UnitOfMeasure;
        packingUnitToStockUnitConversionFactor: string;
        quantityInPackingUnit: string;
        quantityInStockUnit: string;
        activeQuantityInStockUnit: string;
        originalPackingUnit: UnitOfMeasure;
        originalQuantityInPackingUnit: string;
        originalQuantityInStockUnit: string;
        qualityAnalysisRequestId: string;
        allocatedQuantity: string;
        allocatedActiveQuantity: string;
        inProcessQuantity: string;
        inProcessActiveQuantity: string;
        editedFlag: integer;
        lastReceiptDate: string;
        lastIssueDate: string;
        lastCountDate: string;
        isBeingCounted: boolean;
        countWorksheet: string;
        exportNumber: integer;
        majorVersion: MajorVersionStatus;
        stockCustomField1: string;
        stockCustomField2: string;
        project: ProjectLink;
        licensePlateNumber: LicensePlateNumber;
        productCollection: ClientCollection<Product>;
        lotReference: Lot;
        availableQuantity: string;
    }
    export interface Stock$Lookups {
        stockSite: QueryOperation<Site>;
        product: QueryOperation<ProductSite>;
        status: QueryOperation<StockStatus>;
        location: QueryOperation<Location>;
        warehouse: QueryOperation<Warehouse>;
        packingUnit: QueryOperation<UnitOfMeasure>;
        originalPackingUnit: QueryOperation<UnitOfMeasure>;
        majorVersion: QueryOperation<MajorVersionStatus>;
        project: QueryOperation<ProjectLink>;
        licensePlateNumber: QueryOperation<LicensePlateNumber>;
        lotReference: QueryOperation<Lot>;
    }
    export interface Stock$Operations {
        query: QueryOperation<Stock>;
        read: ReadOperation<Stock>;
        aggregate: {
            read: AggregateReadOperation<Stock>;
            query: AggregateQueryOperation<Stock>;
        };
        lookups(dataOrId: string | { data: StockInput }): Stock$Lookups;
        getDefaults: GetDefaultsOperation<Stock>;
    }
    export interface Warehouse extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
        stockSite: Site;
        exportNumber: integer;
    }
    export interface WarehouseInput extends ClientNodeInput {
        code?: string;
        description?: string;
        shortDescription?: string;
        stockSite?: string;
        exportNumber?: integer | string;
    }
    export interface WarehouseBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
        stockSite: Site;
        exportNumber: integer;
    }
    export interface Warehouse$Lookups {
        stockSite: QueryOperation<Site>;
    }
    export interface Warehouse$Operations {
        query: QueryOperation<Warehouse>;
        read: ReadOperation<Warehouse>;
        aggregate: {
            read: AggregateReadOperation<Warehouse>;
            query: AggregateQueryOperation<Warehouse>;
        };
        lookups(dataOrId: string | { data: WarehouseInput }): Warehouse$Lookups;
        getDefaults: GetDefaultsOperation<Warehouse>;
    }
    export interface ProductCategoryExtension {
        lotManagementMode: LotManagementMode;
        traceabilityManagementMode: TraceabilityManagementMode;
        traceabilityLevel: TraceabilityLevel;
        reorderingManagementMode: ReorderingManagementMode;
        stockVersionMode: StockVersionMode;
        defaultLocations: ClientCollection<ProductCategoryDefaultLocations>;
    }
    export interface ProductCategoryInputExtension {
        lotManagementMode?: LotManagementMode;
        traceabilityManagementMode?: TraceabilityManagementMode;
        traceabilityLevel?: TraceabilityLevel;
        reorderingManagementMode?: ReorderingManagementMode;
        stockVersionMode?: StockVersionMode;
        defaultLocations?: Partial<ProductCategoryDefaultLocationsInput>[];
    }
    export interface ProductCategoryBindingExtension {
        lotManagementMode: LotManagementMode;
        traceabilityManagementMode: TraceabilityManagementMode;
        traceabilityLevel: TraceabilityLevel;
        reorderingManagementMode: ReorderingManagementMode;
        stockVersionMode: StockVersionMode;
        defaultLocations: ClientCollection<ProductCategoryDefaultLocationsBinding>;
    }
    export interface ProductExtension {
        stockManagementMode: StockManagement;
        lotManagementMode: LotManagementMode;
        materialCostGroup: MaterialCostGroup;
        traceabilityManagementMode: TraceabilityManagementMode;
        traceabilityLevel: TraceabilityLevel;
        expirationTimeUnit: ExpirationLeadTimeUnits;
        recontrolTimeUnit: ExpirationLeadTimeUnits;
        stockVersionMode: StockVersionMode;
    }
    export interface ProductInputExtension {
        stockManagementMode?: StockManagement;
        lotManagementMode?: LotManagementMode;
        materialCostGroup?: MaterialCostGroup;
        traceabilityManagementMode?: TraceabilityManagementMode;
        traceabilityLevel?: TraceabilityLevel;
        expirationTimeUnit?: ExpirationLeadTimeUnits;
        recontrolTimeUnit?: ExpirationLeadTimeUnits;
        stockVersionMode?: StockVersionMode;
    }
    export interface ProductBindingExtension {
        stockManagementMode: StockManagement;
        lotManagementMode: LotManagementMode;
        materialCostGroup: MaterialCostGroup;
        traceabilityManagementMode: TraceabilityManagementMode;
        traceabilityLevel: TraceabilityLevel;
        expirationTimeUnit: ExpirationLeadTimeUnits;
        recontrolTimeUnit: ExpirationLeadTimeUnits;
        stockVersionMode: StockVersionMode;
    }
    export interface ProductSiteExtension {
        reorderingManagementMode: ReorderingManagementMode;
        recontrolTimeUnit: ExpirationLeadTimeUnits;
        defaultInternalContainer: Container;
        defaultLocations: ClientCollection<ProductSiteDefaultLocations>;
        internalContainers: ClientCollection<ProductSiteInternalContainers>;
    }
    export interface ProductSiteInputExtension {
        reorderingManagementMode?: ReorderingManagementMode;
        recontrolTimeUnit?: ExpirationLeadTimeUnits;
        defaultInternalContainer?: string;
        defaultLocations?: Partial<ProductSiteDefaultLocationsInput>[];
        internalContainers?: Partial<ProductSiteInternalContainersInput>[];
    }
    export interface ProductSiteBindingExtension {
        reorderingManagementMode: ReorderingManagementMode;
        recontrolTimeUnit: ExpirationLeadTimeUnits;
        defaultInternalContainer: Container;
        defaultLocations: ClientCollection<ProductSiteDefaultLocationsBinding>;
        internalContainers: ClientCollection<ProductSiteInternalContainersBinding>;
    }
    export interface ProductSiteExtension$Lookups {
        defaultInternalContainer: QueryOperation<Container>;
    }
    export interface ProductSiteExtension$Operations {
        lookups(dataOrId: string | { data: ProductSiteInput }): ProductSiteExtension$Lookups;
    }
    export interface Package {
        '@sage/x3-stock-data/Container': Container$Operations;
        '@sage/x3-stock-data/LicensePlateNumber': LicensePlateNumber$Operations;
        '@sage/x3-stock-data/Location': Location$Operations;
        '@sage/x3-stock-data/Lot': Lot$Operations;
        '@sage/x3-stock-data/LotsSites': LotsSites$Operations;
        '@sage/x3-stock-data/MajorVersionStatus': MajorVersionStatus$Operations;
        '@sage/x3-stock-data/MobileSettings': MobileSettings$Operations;
        '@sage/x3-stock-data/ProductCategoryDefaultLocations': ProductCategoryDefaultLocations$Operations;
        '@sage/x3-stock-data/ProductSiteDefaultLocations': ProductSiteDefaultLocations$Operations;
        '@sage/x3-stock-data/ProductSiteInternalContainers': ProductSiteInternalContainers$Operations;
        '@sage/x3-stock-data/SerialNumber': SerialNumber$Operations;
        '@sage/x3-stock-data/StockJournal': StockJournal$Operations;
        '@sage/x3-stock-data/StockManagementRules': StockManagementRules$Operations;
        '@sage/x3-stock-data/StockStatus': StockStatus$Operations;
        '@sage/x3-stock-data/Stock': Stock$Operations;
        '@sage/x3-stock-data/Warehouse': Warehouse$Operations;
    }
    export interface GraphApi
        extends Package,
            SageX3MasterData$Package,
            SageX3ProjectManagementData$Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-stock-data-api' {
    export type * from '@sage/x3-stock-data-api-partial';
}
declare module '@sage/x3-master-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-stock-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-stock-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-stock-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-stock-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-stock-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type {
        ProductBindingExtension,
        ProductCategoryBindingExtension,
        ProductCategoryExtension,
        ProductCategoryInputExtension,
        ProductExtension,
        ProductInputExtension,
        ProductSiteBindingExtension,
        ProductSiteExtension,
        ProductSiteExtension$Lookups,
        ProductSiteExtension$Operations,
        ProductSiteInputExtension,
    } from '@sage/x3-stock-data-api';
    export interface ProductCategory extends ProductCategoryExtension {}
    export interface ProductCategoryBinding extends ProductCategoryBindingExtension {}
    export interface ProductCategoryInput extends ProductCategoryInputExtension {}
    export interface Product extends ProductExtension {}
    export interface ProductBinding extends ProductBindingExtension {}
    export interface ProductInput extends ProductInputExtension {}
    export interface ProductSite extends ProductSiteExtension {}
    export interface ProductSiteBinding extends ProductSiteBindingExtension {}
    export interface ProductSiteInput extends ProductSiteInputExtension {}
    export interface ProductSite$Lookups extends ProductSiteExtension$Lookups {}
    export interface ProductSite$Operations extends ProductSiteExtension$Operations {}
}
