/* eslint-disable import/no-duplicates */
declare module '@sage/x3-purchasing-data-api-partial' {
    import type {
        Package as SageX3InvoicingData$Package,
        SupplierInvoiceHeaderInput,
    } from '@sage/x3-invoicing-data-api';
    import type {
        Package as SageX3MasterData$Package,
        ProductCategoryInput,
        ProductInput,
        ShipToCustomerAddressInput,
        SupplierProductInput,
    } from '@sage/x3-master-data-api';
    import type { Package as SageX3ProjectManagementData$Package } from '@sage/x3-project-management-data-api';
    import type { Package as SageX3StockData$Package } from '@sage/x3-stock-data-api';
    import type { Package as SageX3Structure$Package } from '@sage/x3-structure-api';
    import type { MiscellaneousTable, Package as SageX3System$Package } from '@sage/x3-system-api';
    import type { Package as SageXtremX3SystemUtils$Package, SysUser } from '@sage/xtrem-x3-system-utils-api';
    import type {
        AggregateQueryOperation,
        AggregateReadOperation,
        ClientNode,
        ClientNodeInput,
        GetDefaultsOperation,
        integer,
        QueryOperation,
        ReadOperation,
    } from '@sage/xtrem-client';
    export interface Conflict$Enum {
        no: 1;
        warning: 2;
        hold: 3;
    }
    export type Conflict = keyof Conflict$Enum;
    export interface CurrencyRateSearchDate$Enum {
        orderDate: 1;
        receiptDate: 2;
        invoiceDate: 3;
    }
    export type CurrencyRateSearchDate = keyof CurrencyRateSearchDate$Enum;
    export interface DueDateCalculationBase$Enum {
        receiptDate: 1;
        invoiceDate: 2;
    }
    export type DueDateCalculationBase = keyof DueDateCalculationBase$Enum;
    export interface SupplierType$Enum {
        normal: 1;
        prospect: 2;
        miscellaneous: 3;
    }
    export type SupplierType = keyof SupplierType$Enum;
    export interface DeliveryMode extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DeliveryModeInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface DeliveryModeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface DeliveryMode$Operations {
        query: QueryOperation<DeliveryMode>;
        read: ReadOperation<DeliveryMode>;
        aggregate: {
            read: AggregateReadOperation<DeliveryMode>;
            query: AggregateQueryOperation<DeliveryMode>;
        };
        getDefaults: GetDefaultsOperation<DeliveryMode>;
    }
    export interface FreightCostStructure extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        isActive: boolean;
    }
    export interface FreightCostStructureInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        isActive?: boolean | string;
    }
    export interface FreightCostStructureBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        isActive: boolean;
    }
    export interface FreightCostStructure$Operations {
        query: QueryOperation<FreightCostStructure>;
        read: ReadOperation<FreightCostStructure>;
        aggregate: {
            read: AggregateReadOperation<FreightCostStructure>;
            query: AggregateQueryOperation<FreightCostStructure>;
        };
        getDefaults: GetDefaultsOperation<FreightCostStructure>;
    }
    export interface MatchingTolerance extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
    }
    export interface MatchingToleranceInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
    }
    export interface MatchingToleranceBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
    }
    export interface MatchingTolerance$Operations {
        query: QueryOperation<MatchingTolerance>;
        read: ReadOperation<MatchingTolerance>;
        aggregate: {
            read: AggregateReadOperation<MatchingTolerance>;
            query: AggregateQueryOperation<MatchingTolerance>;
        };
        getDefaults: GetDefaultsOperation<MatchingTolerance>;
    }
    export interface PurchaseInvoiceType extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
        purchaseInvoiceCategory: PurchaseInvoiceCategory;
        invoiceCategory: InvoiceType;
    }
    export interface PurchaseInvoiceTypeInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
        purchaseInvoiceCategory?: PurchaseInvoiceCategory;
        invoiceCategory?: InvoiceType;
    }
    export interface PurchaseInvoiceTypeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
        purchaseInvoiceCategory: PurchaseInvoiceCategory;
        invoiceCategory: InvoiceType;
    }
    export interface PurchaseInvoiceType$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface PurchaseInvoiceType$Operations {
        query: QueryOperation<PurchaseInvoiceType>;
        read: ReadOperation<PurchaseInvoiceType>;
        aggregate: {
            read: AggregateReadOperation<PurchaseInvoiceType>;
            query: AggregateQueryOperation<PurchaseInvoiceType>;
        };
        lookups(dataOrId: string | { data: PurchaseInvoiceTypeInput }): PurchaseInvoiceType$Lookups;
        getDefaults: GetDefaultsOperation<PurchaseInvoiceType>;
    }
    export interface PurchasePriceReason extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: integer;
        localizedDescription: string;
    }
    export interface PurchasePriceReasonInput extends ClientNodeInput {
        code?: integer | string;
        localizedDescription?: string;
    }
    export interface PurchasePriceReasonBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: integer;
        localizedDescription: string;
    }
    export interface PurchasePriceReason$Operations {
        query: QueryOperation<PurchasePriceReason>;
        read: ReadOperation<PurchasePriceReason>;
        aggregate: {
            read: AggregateReadOperation<PurchasePriceReason>;
            query: AggregateQueryOperation<PurchasePriceReason>;
        };
        getDefaults: GetDefaultsOperation<PurchasePriceReason>;
    }
    export interface ProductCategoryExtension {
        costStructure: FreightCostStructure;
        matchingTolerance: MatchingTolerance;
    }
    export interface ProductCategoryInputExtension {
        costStructure?: string;
        matchingTolerance?: string;
    }
    export interface ProductCategoryBindingExtension {
        costStructure: FreightCostStructure;
        matchingTolerance: MatchingTolerance;
    }
    export interface ProductCategoryExtension$Lookups {
        costStructure: QueryOperation<FreightCostStructure>;
        matchingTolerance: QueryOperation<MatchingTolerance>;
    }
    export interface ProductCategoryExtension$Operations {
        lookups(dataOrId: string | { data: ProductCategoryInput }): ProductCategoryExtension$Lookups;
    }
    export interface ProductExtension {
        costStructure: FreightCostStructure;
        matchingTolerance: MatchingTolerance;
    }
    export interface ProductInputExtension {
        costStructure?: string;
        matchingTolerance?: string;
    }
    export interface ProductBindingExtension {
        costStructure: FreightCostStructure;
        matchingTolerance: MatchingTolerance;
    }
    export interface ProductExtension$Lookups {
        costStructure: QueryOperation<FreightCostStructure>;
        matchingTolerance: QueryOperation<MatchingTolerance>;
    }
    export interface ProductExtension$Operations {
        lookups(dataOrId: string | { data: ProductInput }): ProductExtension$Lookups;
    }
    export interface ShipToCustomerAddressExtension {
        deliveryMode: DeliveryMode;
    }
    export interface ShipToCustomerAddressInputExtension {
        deliveryMode?: string;
    }
    export interface ShipToCustomerAddressBindingExtension {
        deliveryMode: DeliveryMode;
    }
    export interface ShipToCustomerAddressExtension$Lookups {
        deliveryMode: QueryOperation<DeliveryMode>;
    }
    export interface ShipToCustomerAddressExtension$Operations {
        lookups(dataOrId: string | { data: ShipToCustomerAddressInput }): ShipToCustomerAddressExtension$Lookups;
    }
    export interface SupplierExtension {
        supplierType: SupplierType;
        dueDateOrigin: DueDateCalculationBase;
        currencyRateDetermination: CurrencyRateSearchDate;
        disputeStatus: Conflict;
    }
    export interface SupplierInputExtension {
        supplierType?: SupplierType;
        dueDateOrigin?: DueDateCalculationBase;
        currencyRateDetermination?: CurrencyRateSearchDate;
        disputeStatus?: Conflict;
    }
    export interface SupplierBindingExtension {
        supplierType: SupplierType;
        dueDateOrigin: DueDateCalculationBase;
        currencyRateDetermination: CurrencyRateSearchDate;
        disputeStatus: Conflict;
    }
    export interface SupplierInvoiceHeaderExtension {
        invoiceType: PurchaseInvoiceType;
    }
    export interface SupplierInvoiceHeaderInputExtension {
        invoiceType?: string;
    }
    export interface SupplierInvoiceHeaderBindingExtension {
        invoiceType: PurchaseInvoiceType;
    }
    export interface SupplierInvoiceHeaderExtension$Lookups {
        invoiceType: QueryOperation<PurchaseInvoiceType>;
    }
    export interface SupplierInvoiceHeaderExtension$Operations {
        lookups(dataOrId: string | { data: SupplierInvoiceHeaderInput }): SupplierInvoiceHeaderExtension$Lookups;
    }
    export interface SupplierProductExtension {
        costStructure: FreightCostStructure;
        blockingManagementMode: Conflict;
        matchingTolerance: MatchingTolerance;
    }
    export interface SupplierProductInputExtension {
        costStructure?: string;
        blockingManagementMode?: Conflict;
        matchingTolerance?: string;
    }
    export interface SupplierProductBindingExtension {
        costStructure: FreightCostStructure;
        blockingManagementMode: Conflict;
        matchingTolerance: MatchingTolerance;
    }
    export interface SupplierProductExtension$Lookups {
        costStructure: QueryOperation<FreightCostStructure>;
        matchingTolerance: QueryOperation<MatchingTolerance>;
    }
    export interface SupplierProductExtension$Operations {
        lookups(dataOrId: string | { data: SupplierProductInput }): SupplierProductExtension$Lookups;
    }
    export interface Package {
        '@sage/x3-purchasing-data/DeliveryMode': DeliveryMode$Operations;
        '@sage/x3-purchasing-data/FreightCostStructure': FreightCostStructure$Operations;
        '@sage/x3-purchasing-data/MatchingTolerance': MatchingTolerance$Operations;
        '@sage/x3-purchasing-data/PurchaseInvoiceType': PurchaseInvoiceType$Operations;
        '@sage/x3-purchasing-data/PurchasePriceReason': PurchasePriceReason$Operations;
    }
    export interface GraphApi
        extends Package,
            SageX3InvoicingData$Package,
            SageX3MasterData$Package,
            SageX3ProjectManagementData$Package,
            SageX3StockData$Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-purchasing-data-api' {
    export type * from '@sage/x3-purchasing-data-api-partial';
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type {
        ProductBindingExtension,
        ProductCategoryBindingExtension,
        ProductCategoryExtension,
        ProductCategoryExtension$Lookups,
        ProductCategoryExtension$Operations,
        ProductCategoryInputExtension,
        ProductExtension,
        ProductExtension$Lookups,
        ProductExtension$Operations,
        ProductInputExtension,
        ShipToCustomerAddressBindingExtension,
        ShipToCustomerAddressExtension,
        ShipToCustomerAddressExtension$Lookups,
        ShipToCustomerAddressExtension$Operations,
        ShipToCustomerAddressInputExtension,
        SupplierBindingExtension,
        SupplierExtension,
        SupplierInputExtension,
        SupplierProductBindingExtension,
        SupplierProductExtension,
        SupplierProductExtension$Lookups,
        SupplierProductExtension$Operations,
        SupplierProductInputExtension,
    } from '@sage/x3-purchasing-data-api';
    export interface ProductCategory extends ProductCategoryExtension {}
    export interface ProductCategoryBinding extends ProductCategoryBindingExtension {}
    export interface ProductCategoryInput extends ProductCategoryInputExtension {}
    export interface ProductCategory$Lookups extends ProductCategoryExtension$Lookups {}
    export interface ProductCategory$Operations extends ProductCategoryExtension$Operations {}
    export interface Product extends ProductExtension {}
    export interface ProductBinding extends ProductBindingExtension {}
    export interface ProductInput extends ProductInputExtension {}
    export interface Product$Lookups extends ProductExtension$Lookups {}
    export interface Product$Operations extends ProductExtension$Operations {}
    export interface ShipToCustomerAddress extends ShipToCustomerAddressExtension {}
    export interface ShipToCustomerAddressBinding extends ShipToCustomerAddressBindingExtension {}
    export interface ShipToCustomerAddressInput extends ShipToCustomerAddressInputExtension {}
    export interface ShipToCustomerAddress$Lookups extends ShipToCustomerAddressExtension$Lookups {}
    export interface ShipToCustomerAddress$Operations extends ShipToCustomerAddressExtension$Operations {}
    export interface Supplier extends SupplierExtension {}
    export interface SupplierBinding extends SupplierBindingExtension {}
    export interface SupplierInput extends SupplierInputExtension {}
    export interface SupplierProduct extends SupplierProductExtension {}
    export interface SupplierProductBinding extends SupplierProductBindingExtension {}
    export interface SupplierProductInput extends SupplierProductInputExtension {}
    export interface SupplierProduct$Lookups extends SupplierProductExtension$Lookups {}
    export interface SupplierProduct$Operations extends SupplierProductExtension$Operations {}
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type {
        SupplierInvoiceHeaderBindingExtension,
        SupplierInvoiceHeaderExtension,
        SupplierInvoiceHeaderExtension$Lookups,
        SupplierInvoiceHeaderExtension$Operations,
        SupplierInvoiceHeaderInputExtension,
    } from '@sage/x3-purchasing-data-api';
    export interface SupplierInvoiceHeader extends SupplierInvoiceHeaderExtension {}
    export interface SupplierInvoiceHeaderBinding extends SupplierInvoiceHeaderBindingExtension {}
    export interface SupplierInvoiceHeaderInput extends SupplierInvoiceHeaderInputExtension {}
    export interface SupplierInvoiceHeader$Lookups extends SupplierInvoiceHeaderExtension$Lookups {}
    export interface SupplierInvoiceHeader$Operations extends SupplierInvoiceHeaderExtension$Operations {}
}
