/* eslint-disable import/no-duplicates */
declare module '@sage/x3-purchasing-sales-api-partial' {
    import type { Package as SageX3FinanceData$Package } from '@sage/x3-finance-data-api';
    import type { Package as SageX3InvoicingData$Package } from '@sage/x3-invoicing-data-api';
    import type { Package as SageX3ManufacturingData$Package } from '@sage/x3-manufacturing-data-api';
    import type { Package as SageX3MasterData$Package } from '@sage/x3-master-data-api';
    import type { Package as SageX3PhysicalFlowsData$Package } from '@sage/x3-physical-flows-data-api';
    import type { Package as SageX3ProjectManagementData$Package } from '@sage/x3-project-management-data-api';
    import type {
        Package as SageX3Purchasing$Package,
        PurchaseInvoice,
        PurchaseInvoiceInput,
        PurchaseOrder,
        PurchaseOrderLine,
        PurchaseOrderLineInput,
        PurchaseOrderQuantityLineInput,
        PurchaseReceiptLineInput,
        PurchaseReturn,
        PurchaseReturnLine,
    } from '@sage/x3-purchasing-api';
    import type { Package as SageX3PurchasingData$Package } from '@sage/x3-purchasing-data-api';
    import type {
        Package as SageX3Sales$Package,
        SalesDelivery,
        SalesDeliveryLine,
        SalesInvoice,
        SalesInvoiceInput,
        SalesOrder,
        SalesOrderLine,
        SalesOrderLineInput,
        SalesOrderQuantityLineInput,
        SalesReturnLineInput,
    } from '@sage/x3-sales-api';
    import type { Package as SageX3SalesData$Package } from '@sage/x3-sales-data-api';
    import type { Package as SageX3Stock$Package } from '@sage/x3-stock-api';
    import type { Package as SageX3StockData$Package } from '@sage/x3-stock-data-api';
    import type { Package as SageX3Structure$Package } from '@sage/x3-structure-api';
    import type { Package as SageX3System$Package } from '@sage/x3-system-api';
    import type { Package as SageXtremX3SystemUtils$Package } from '@sage/xtrem-x3-system-utils-api';
    import type { integer, QueryOperation } from '@sage/xtrem-client';
    export interface PurchaseInvoiceExtension {
        salesInvoice: SalesInvoice;
    }
    export interface PurchaseInvoiceInputExtension {
        salesInvoice?: string;
    }
    export interface PurchaseInvoiceBindingExtension {
        salesInvoice: SalesInvoice;
    }
    export interface PurchaseInvoiceExtension$Lookups {
        salesInvoice: QueryOperation<SalesInvoice>;
    }
    export interface PurchaseInvoiceExtension$Operations {
        lookups(dataOrId: string | { data: PurchaseInvoiceInput }): PurchaseInvoiceExtension$Lookups;
    }
    export interface PurchaseInvoiceLineExtension {
        salesInvoiceLineNumber: integer;
    }
    export interface PurchaseInvoiceLineInputExtension {
        salesInvoiceLineNumber?: integer | string;
    }
    export interface PurchaseInvoiceLineBindingExtension {
        salesInvoiceLineNumber: integer;
    }
    export interface PurchaseOrderExtension {
        salesOrderCategory: OrderCategory;
        partialDelivery: PartialDelivery;
    }
    export interface PurchaseOrderInputExtension {
        salesOrderCategory?: OrderCategory;
        partialDelivery?: PartialDelivery;
    }
    export interface PurchaseOrderBindingExtension {
        salesOrderCategory: OrderCategory;
        partialDelivery: PartialDelivery;
    }
    export interface PurchaseOrderLineExtension {
        salesDelivery: SalesDelivery;
        salesDeliveryLine: SalesDeliveryLine;
        salesOrder: SalesOrder;
        salesOrderLine: SalesOrderLine;
        salesOrderSequenceNumber: integer;
    }
    export interface PurchaseOrderLineInputExtension {
        salesDelivery?: string;
        salesDeliveryLine?: integer | string;
        salesOrder?: string;
        salesOrderLine?: integer | string;
        salesOrderSequenceNumber?: integer | string;
    }
    export interface PurchaseOrderLineBindingExtension {
        salesDelivery: SalesDelivery;
        salesDeliveryLine: SalesDeliveryLine;
        salesOrder: SalesOrder;
        salesOrderLine: SalesOrderLine;
        salesOrderSequenceNumber: integer;
    }
    export interface PurchaseOrderLineExtension$Lookups {
        salesDelivery: QueryOperation<SalesDelivery>;
        salesDeliveryLine: QueryOperation<SalesDeliveryLine>;
        salesOrder: QueryOperation<SalesOrder>;
        salesOrderLine: QueryOperation<SalesOrderLine>;
    }
    export interface PurchaseOrderLineExtension$Operations {
        lookups(dataOrId: string | { data: PurchaseOrderLineInput }): PurchaseOrderLineExtension$Lookups;
    }
    export interface PurchaseOrderQuantityLineExtension {
        salesOrder: SalesOrder;
        salesOrderLine: SalesOrderLine;
        salesOrderSequenceNumber: integer;
        salesDelivery: SalesDelivery;
        salesDeliveryLine: SalesDeliveryLine;
    }
    export interface PurchaseOrderQuantityLineInputExtension {
        salesOrder?: string;
        salesOrderLine?: integer | string;
        salesOrderSequenceNumber?: integer | string;
        salesDelivery?: string;
        salesDeliveryLine?: integer | string;
    }
    export interface PurchaseOrderQuantityLineBindingExtension {
        salesOrder: SalesOrder;
        salesOrderLine: SalesOrderLine;
        salesOrderSequenceNumber: integer;
        salesDelivery: SalesDelivery;
        salesDeliveryLine: SalesDeliveryLine;
    }
    export interface PurchaseOrderQuantityLineExtension$Lookups {
        salesOrder: QueryOperation<SalesOrder>;
        salesOrderLine: QueryOperation<SalesOrderLine>;
        salesDelivery: QueryOperation<SalesDelivery>;
        salesDeliveryLine: QueryOperation<SalesDeliveryLine>;
    }
    export interface PurchaseOrderQuantityLineExtension$Operations {
        lookups(
            dataOrId: string | { data: PurchaseOrderQuantityLineInput },
        ): PurchaseOrderQuantityLineExtension$Lookups;
    }
    export interface PurchaseReceiptLineExtension {
        salesDelivery: SalesDelivery;
        salesDeliveryLine: SalesDeliveryLine;
    }
    export interface PurchaseReceiptLineInputExtension {
        salesDelivery?: string;
        salesDeliveryLine?: integer | string;
    }
    export interface PurchaseReceiptLineBindingExtension {
        salesDelivery: SalesDelivery;
        salesDeliveryLine: SalesDeliveryLine;
    }
    export interface PurchaseReceiptLineExtension$Lookups {
        salesDelivery: QueryOperation<SalesDelivery>;
        salesDeliveryLine: QueryOperation<SalesDeliveryLine>;
    }
    export interface PurchaseReceiptLineExtension$Operations {
        lookups(dataOrId: string | { data: PurchaseReceiptLineInput }): PurchaseReceiptLineExtension$Lookups;
    }
    export interface SalesInvoiceExtension {
        purchaseInvoice: PurchaseInvoice;
    }
    export interface SalesInvoiceInputExtension {
        purchaseInvoice?: string;
    }
    export interface SalesInvoiceBindingExtension {
        purchaseInvoice: PurchaseInvoice;
    }
    export interface SalesInvoiceExtension$Lookups {
        purchaseInvoice: QueryOperation<PurchaseInvoice>;
    }
    export interface SalesInvoiceExtension$Operations {
        lookups(dataOrId: string | { data: SalesInvoiceInput }): SalesInvoiceExtension$Lookups;
    }
    export interface SalesInvoiceLineExtension {
        purchaseInvoiceLineNumber: integer;
    }
    export interface SalesInvoiceLineInputExtension {
        purchaseInvoiceLineNumber?: integer | string;
    }
    export interface SalesInvoiceLineBindingExtension {
        purchaseInvoiceLineNumber: integer;
    }
    export interface SalesOrderLineExtension {
        purchaseOrder: PurchaseOrder;
        purchaseOrderLine: PurchaseOrderLine;
        purchaseOrderSequenceNumber: integer;
    }
    export interface SalesOrderLineInputExtension {
        purchaseOrder?: string;
        purchaseOrderLine?: integer | string;
        purchaseOrderSequenceNumber?: integer | string;
    }
    export interface SalesOrderLineBindingExtension {
        purchaseOrder: PurchaseOrder;
        purchaseOrderLine: PurchaseOrderLine;
        purchaseOrderSequenceNumber: integer;
    }
    export interface SalesOrderLineExtension$Lookups {
        purchaseOrder: QueryOperation<PurchaseOrder>;
        purchaseOrderLine: QueryOperation<PurchaseOrderLine>;
    }
    export interface SalesOrderLineExtension$Operations {
        lookups(dataOrId: string | { data: SalesOrderLineInput }): SalesOrderLineExtension$Lookups;
    }
    export interface SalesOrderQuantityLineExtension {
        purchaseOrder: PurchaseOrder;
        purchaseOrderLine: PurchaseOrderLine;
        purchaseOrderSequenceNumber: integer;
    }
    export interface SalesOrderQuantityLineInputExtension {
        purchaseOrder?: string;
        purchaseOrderLine?: integer | string;
        purchaseOrderSequenceNumber?: integer | string;
    }
    export interface SalesOrderQuantityLineBindingExtension {
        purchaseOrder: PurchaseOrder;
        purchaseOrderLine: PurchaseOrderLine;
        purchaseOrderSequenceNumber: integer;
    }
    export interface SalesOrderQuantityLineExtension$Lookups {
        purchaseOrder: QueryOperation<PurchaseOrder>;
        purchaseOrderLine: QueryOperation<PurchaseOrderLine>;
    }
    export interface SalesOrderQuantityLineExtension$Operations {
        lookups(dataOrId: string | { data: SalesOrderQuantityLineInput }): SalesOrderQuantityLineExtension$Lookups;
    }
    export interface SalesReturnLineExtension {
        purchaseReturn: PurchaseReturn;
        purchaseReturnLine: PurchaseReturnLine;
    }
    export interface SalesReturnLineInputExtension {
        purchaseReturn?: string;
        purchaseReturnLine?: integer | string;
    }
    export interface SalesReturnLineBindingExtension {
        purchaseReturn: PurchaseReturn;
        purchaseReturnLine: PurchaseReturnLine;
    }
    export interface SalesReturnLineExtension$Lookups {
        purchaseReturn: QueryOperation<PurchaseReturn>;
        purchaseReturnLine: QueryOperation<PurchaseReturnLine>;
    }
    export interface SalesReturnLineExtension$Operations {
        lookups(dataOrId: string | { data: SalesReturnLineInput }): SalesReturnLineExtension$Lookups;
    }
    export interface Package {}
    export interface GraphApi
        extends Package,
            SageX3FinanceData$Package,
            SageX3InvoicingData$Package,
            SageX3ManufacturingData$Package,
            SageX3MasterData$Package,
            SageX3PhysicalFlowsData$Package,
            SageX3ProjectManagementData$Package,
            SageX3Purchasing$Package,
            SageX3PurchasingData$Package,
            SageX3Sales$Package,
            SageX3SalesData$Package,
            SageX3Stock$Package,
            SageX3StockData$Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-purchasing-sales-api' {
    export type * from '@sage/x3-purchasing-sales-api-partial';
}
declare module '@sage/x3-finance-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-manufacturing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-physical-flows-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-purchasing-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-purchasing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-sales-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-sales-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-purchasing-sales-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-purchasing-api-partial' {
    import type {
        PurchaseInvoiceBindingExtension,
        PurchaseInvoiceExtension,
        PurchaseInvoiceExtension$Lookups,
        PurchaseInvoiceExtension$Operations,
        PurchaseInvoiceInputExtension,
        PurchaseInvoiceLineBindingExtension,
        PurchaseInvoiceLineExtension,
        PurchaseInvoiceLineInputExtension,
        PurchaseOrderBindingExtension,
        PurchaseOrderExtension,
        PurchaseOrderInputExtension,
        PurchaseOrderLineBindingExtension,
        PurchaseOrderLineExtension,
        PurchaseOrderLineExtension$Lookups,
        PurchaseOrderLineExtension$Operations,
        PurchaseOrderLineInputExtension,
        PurchaseOrderQuantityLineBindingExtension,
        PurchaseOrderQuantityLineExtension,
        PurchaseOrderQuantityLineExtension$Lookups,
        PurchaseOrderQuantityLineExtension$Operations,
        PurchaseOrderQuantityLineInputExtension,
        PurchaseReceiptLineBindingExtension,
        PurchaseReceiptLineExtension,
        PurchaseReceiptLineExtension$Lookups,
        PurchaseReceiptLineExtension$Operations,
        PurchaseReceiptLineInputExtension,
    } from '@sage/x3-purchasing-sales-api';
    export interface PurchaseInvoice extends PurchaseInvoiceExtension {}
    export interface PurchaseInvoiceBinding extends PurchaseInvoiceBindingExtension {}
    export interface PurchaseInvoiceInput extends PurchaseInvoiceInputExtension {}
    export interface PurchaseInvoice$Lookups extends PurchaseInvoiceExtension$Lookups {}
    export interface PurchaseInvoice$Operations extends PurchaseInvoiceExtension$Operations {}
    export interface PurchaseInvoiceLine extends PurchaseInvoiceLineExtension {}
    export interface PurchaseInvoiceLineBinding extends PurchaseInvoiceLineBindingExtension {}
    export interface PurchaseInvoiceLineInput extends PurchaseInvoiceLineInputExtension {}
    export interface PurchaseOrder extends PurchaseOrderExtension {}
    export interface PurchaseOrderBinding extends PurchaseOrderBindingExtension {}
    export interface PurchaseOrderInput extends PurchaseOrderInputExtension {}
    export interface PurchaseOrderLine extends PurchaseOrderLineExtension {}
    export interface PurchaseOrderLineBinding extends PurchaseOrderLineBindingExtension {}
    export interface PurchaseOrderLineInput extends PurchaseOrderLineInputExtension {}
    export interface PurchaseOrderLine$Lookups extends PurchaseOrderLineExtension$Lookups {}
    export interface PurchaseOrderLine$Operations extends PurchaseOrderLineExtension$Operations {}
    export interface PurchaseOrderQuantityLine extends PurchaseOrderQuantityLineExtension {}
    export interface PurchaseOrderQuantityLineBinding extends PurchaseOrderQuantityLineBindingExtension {}
    export interface PurchaseOrderQuantityLineInput extends PurchaseOrderQuantityLineInputExtension {}
    export interface PurchaseOrderQuantityLine$Lookups extends PurchaseOrderQuantityLineExtension$Lookups {}
    export interface PurchaseOrderQuantityLine$Operations extends PurchaseOrderQuantityLineExtension$Operations {}
    export interface PurchaseReceiptLine extends PurchaseReceiptLineExtension {}
    export interface PurchaseReceiptLineBinding extends PurchaseReceiptLineBindingExtension {}
    export interface PurchaseReceiptLineInput extends PurchaseReceiptLineInputExtension {}
    export interface PurchaseReceiptLine$Lookups extends PurchaseReceiptLineExtension$Lookups {}
    export interface PurchaseReceiptLine$Operations extends PurchaseReceiptLineExtension$Operations {}
}
declare module '@sage/x3-sales-api-partial' {
    import type {
        SalesInvoiceBindingExtension,
        SalesInvoiceExtension,
        SalesInvoiceExtension$Lookups,
        SalesInvoiceExtension$Operations,
        SalesInvoiceInputExtension,
        SalesInvoiceLineBindingExtension,
        SalesInvoiceLineExtension,
        SalesInvoiceLineInputExtension,
        SalesOrderLineBindingExtension,
        SalesOrderLineExtension,
        SalesOrderLineExtension$Lookups,
        SalesOrderLineExtension$Operations,
        SalesOrderLineInputExtension,
        SalesOrderQuantityLineBindingExtension,
        SalesOrderQuantityLineExtension,
        SalesOrderQuantityLineExtension$Lookups,
        SalesOrderQuantityLineExtension$Operations,
        SalesOrderQuantityLineInputExtension,
        SalesReturnLineBindingExtension,
        SalesReturnLineExtension,
        SalesReturnLineExtension$Lookups,
        SalesReturnLineExtension$Operations,
        SalesReturnLineInputExtension,
    } from '@sage/x3-purchasing-sales-api';
    export interface SalesInvoice extends SalesInvoiceExtension {}
    export interface SalesInvoiceBinding extends SalesInvoiceBindingExtension {}
    export interface SalesInvoiceInput extends SalesInvoiceInputExtension {}
    export interface SalesInvoice$Lookups extends SalesInvoiceExtension$Lookups {}
    export interface SalesInvoice$Operations extends SalesInvoiceExtension$Operations {}
    export interface SalesInvoiceLine extends SalesInvoiceLineExtension {}
    export interface SalesInvoiceLineBinding extends SalesInvoiceLineBindingExtension {}
    export interface SalesInvoiceLineInput extends SalesInvoiceLineInputExtension {}
    export interface SalesOrderLine extends SalesOrderLineExtension {}
    export interface SalesOrderLineBinding extends SalesOrderLineBindingExtension {}
    export interface SalesOrderLineInput extends SalesOrderLineInputExtension {}
    export interface SalesOrderLine$Lookups extends SalesOrderLineExtension$Lookups {}
    export interface SalesOrderLine$Operations extends SalesOrderLineExtension$Operations {}
    export interface SalesOrderQuantityLine extends SalesOrderQuantityLineExtension {}
    export interface SalesOrderQuantityLineBinding extends SalesOrderQuantityLineBindingExtension {}
    export interface SalesOrderQuantityLineInput extends SalesOrderQuantityLineInputExtension {}
    export interface SalesOrderQuantityLine$Lookups extends SalesOrderQuantityLineExtension$Lookups {}
    export interface SalesOrderQuantityLine$Operations extends SalesOrderQuantityLineExtension$Operations {}
    export interface SalesReturnLine extends SalesReturnLineExtension {}
    export interface SalesReturnLineBinding extends SalesReturnLineBindingExtension {}
    export interface SalesReturnLineInput extends SalesReturnLineInputExtension {}
    export interface SalesReturnLine$Lookups extends SalesReturnLineExtension$Lookups {}
    export interface SalesReturnLine$Operations extends SalesReturnLineExtension$Operations {}
}
