/* eslint-disable import/no-duplicates */
declare module '@sage/x3-invoicing-data-api-partial' {
    import type {
        BusinessPartner,
        BusinessPartnerAddress,
        Carrier,
        Currency,
        Customer,
        CustomerAddress,
        CustomerInput,
        Incoterm,
        Package as SageX3MasterData$Package,
        ShipToCustomerAddressInput,
        Supplier,
        SupplierAddress,
    } from '@sage/x3-master-data-api';
    import type {
        Package as SageX3ProjectManagementData$Package,
        ProjectLink,
    } from '@sage/x3-project-management-data-api';
    import type { Package as SageX3StockData$Package, Warehouse } from '@sage/x3-stock-data-api';
    import type { Country, Package as SageX3Structure$Package } from '@sage/x3-structure-api';
    import type { Company, MiscellaneousTable, Package as SageX3System$Package, Site, User } from '@sage/x3-system-api';
    import type { Package as SageXtremX3SystemUtils$Package, SysUser } from '@sage/xtrem-x3-system-utils-api';
    import type {
        AggregateQueryOperation,
        AggregateReadOperation,
        ClientCollection,
        ClientNode,
        ClientNodeInput,
        decimal,
        GetDefaultsOperation,
        integer,
        QueryOperation,
        ReadOperation,
        VitalClientNode,
        VitalClientNodeInput,
    } from '@sage/xtrem-client';
    export interface CorrectionMethod$Enum {
        rectificacionIntegra: 1;
        rectificacionPorDiferencias: 2;
        rectificacionPorDescuentoPorVolumenDeOperacionesDuranteUnPeriodo: 3;
        autorizadasPorLaAgenciaTributaria: 4;
    }
    export type CorrectionMethod = keyof CorrectionMethod$Enum;
    export interface InvoiceType$Enum {
        invoice: 1;
        creditMemo: 2;
        debitNote: 3;
        creditNote: 4;
        proforma: 5;
    }
    export type InvoiceType = keyof InvoiceType$Enum;
    export interface MatchStatusEnum$Enum {
        notApplicable: 1;
        successful: 2;
        warning: 3;
        blocked: 4;
        unblocked: 5;
    }
    export type MatchStatusEnum = keyof MatchStatusEnum$Enum;
    export interface PeriodicityType$Enum {
        days: 1;
        week: 2;
        tenDayPeriod: 3;
        twoWeekPeriod: 4;
        month: 5;
    }
    export type PeriodicityType = keyof PeriodicityType$Enum;
    export interface PurchaseType$Enum {
        purchase: 1;
        fixedAsset: 2;
        services: 3;
    }
    export type PurchaseType = keyof PurchaseType$Enum;
    export interface PurchasingInvoiceStatus$Enum {
        pending: 1;
        toValidate: 2;
        validated: 3;
    }
    export type PurchasingInvoiceStatus = keyof PurchasingInvoiceStatus$Enum;
    export interface CustomerInvoiceHeaderBillToCustomerAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        addressLine: string;
    }
    export interface CustomerInvoiceHeaderBillToCustomerAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        addressLine?: string;
    }
    export interface CustomerInvoiceHeaderBillToCustomerAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        addressLine: string;
    }
    export interface CustomerInvoiceHeaderBillToCustomerAddressLines$Operations {
        query: QueryOperation<CustomerInvoiceHeaderBillToCustomerAddressLines>;
        read: ReadOperation<CustomerInvoiceHeaderBillToCustomerAddressLines>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoiceHeaderBillToCustomerAddressLines>;
            query: AggregateQueryOperation<CustomerInvoiceHeaderBillToCustomerAddressLines>;
        };
        getDefaults: GetDefaultsOperation<CustomerInvoiceHeaderBillToCustomerAddressLines>;
    }
    export interface CustomerInvoiceHeaderBillToCustomerCompanyNames extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        companyName: string;
    }
    export interface CustomerInvoiceHeaderBillToCustomerCompanyNamesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        companyName?: string;
    }
    export interface CustomerInvoiceHeaderBillToCustomerCompanyNamesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        companyName: string;
    }
    export interface CustomerInvoiceHeaderBillToCustomerCompanyNames$Operations {
        query: QueryOperation<CustomerInvoiceHeaderBillToCustomerCompanyNames>;
        read: ReadOperation<CustomerInvoiceHeaderBillToCustomerCompanyNames>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoiceHeaderBillToCustomerCompanyNames>;
            query: AggregateQueryOperation<CustomerInvoiceHeaderBillToCustomerCompanyNames>;
        };
        getDefaults: GetDefaultsOperation<CustomerInvoiceHeaderBillToCustomerCompanyNames>;
    }
    export interface CustomerInvoiceHeaderComments extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        comment: string;
    }
    export interface CustomerInvoiceHeaderCommentsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        comment?: string;
    }
    export interface CustomerInvoiceHeaderCommentsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        comment: string;
    }
    export interface CustomerInvoiceHeaderComments$Operations {
        query: QueryOperation<CustomerInvoiceHeaderComments>;
        read: ReadOperation<CustomerInvoiceHeaderComments>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoiceHeaderComments>;
            query: AggregateQueryOperation<CustomerInvoiceHeaderComments>;
        };
        getDefaults: GetDefaultsOperation<CustomerInvoiceHeaderComments>;
    }
    export interface CustomerInvoiceHeaderPayByBusinessPartnerAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        addressLine: string;
    }
    export interface CustomerInvoiceHeaderPayByBusinessPartnerAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        addressLine?: string;
    }
    export interface CustomerInvoiceHeaderPayByBusinessPartnerAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        addressLine: string;
    }
    export interface CustomerInvoiceHeaderPayByBusinessPartnerAddressLines$Operations {
        query: QueryOperation<CustomerInvoiceHeaderPayByBusinessPartnerAddressLines>;
        read: ReadOperation<CustomerInvoiceHeaderPayByBusinessPartnerAddressLines>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoiceHeaderPayByBusinessPartnerAddressLines>;
            query: AggregateQueryOperation<CustomerInvoiceHeaderPayByBusinessPartnerAddressLines>;
        };
        getDefaults: GetDefaultsOperation<CustomerInvoiceHeaderPayByBusinessPartnerAddressLines>;
    }
    export interface CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        companyName: string;
    }
    export interface CustomerInvoiceHeaderPayByBusinessPartnerCompanyNamesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        companyName?: string;
    }
    export interface CustomerInvoiceHeaderPayByBusinessPartnerCompanyNamesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        companyName: string;
    }
    export interface CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames$Operations {
        query: QueryOperation<CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames>;
        read: ReadOperation<CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames>;
            query: AggregateQueryOperation<CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames>;
        };
        getDefaults: GetDefaultsOperation<CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames>;
    }
    export interface CustomerInvoiceHeaderTaxes extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        tax: Tax;
        taxBasis: string;
        taxAmount: string;
        exemptionAmount: string;
        sageSalesTaxAmount: string;
    }
    export interface CustomerInvoiceHeaderTaxesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        tax?: string;
        taxBasis?: decimal | string;
        taxAmount?: decimal | string;
        exemptionAmount?: decimal | string;
        sageSalesTaxAmount?: decimal | string;
    }
    export interface CustomerInvoiceHeaderTaxesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        tax: Tax;
        taxBasis: string;
        taxAmount: string;
        exemptionAmount: string;
        sageSalesTaxAmount: string;
    }
    export interface CustomerInvoiceHeaderTaxes$Lookups {
        tax: QueryOperation<Tax>;
    }
    export interface CustomerInvoiceHeaderTaxes$Operations {
        query: QueryOperation<CustomerInvoiceHeaderTaxes>;
        read: ReadOperation<CustomerInvoiceHeaderTaxes>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoiceHeaderTaxes>;
            query: AggregateQueryOperation<CustomerInvoiceHeaderTaxes>;
        };
        lookups(dataOrId: string | { data: CustomerInvoiceHeaderTaxesInput }): CustomerInvoiceHeaderTaxes$Lookups;
        getDefaults: GetDefaultsOperation<CustomerInvoiceHeaderTaxes>;
    }
    export interface CustomerInvoiceHeader extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        category: InvoiceType;
        sourceModule: ModuleTable;
        billToCustomer: Customer;
        control: string;
        company: Company;
        financialSite: Site;
        accountingDate: string;
        internalNumber: integer;
        sourceDocumentDate: string;
        sourceDocument: string;
        currency: Currency;
        rateType: ExchangeRateType;
        rateDate: string;
        payByBusinessPartner: BusinessPartner;
        payByBusinessPartnerAddress: BusinessPartnerAddress;
        payByBusinessPartnerPostalCode: string;
        payByBusinessPartnerCity: string;
        payByBusinessPartnerState: string;
        payByBusinessPartnerCountry: Country;
        payByBusinessPartnerCountryName: string;
        dueDateCalculationStartDate: string;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        earlyDiscountOrLateChargeRate: string;
        taxRule: TaxRule;
        entityUserCode: MiscellaneousTable;
        isDirectInvoice: boolean;
        intrastatProcessingNumber: integer;
        status: InvoiceStatus;
        originalInvoiceNumber: string;
        debitOrCredit: integer;
        totalAmountIncludingTax: string;
        totalAmountExcludingTax: string;
        totalAmountExcludingTaxInCompanyCurrency: string;
        totalAmountIncludingTaxInCompanyCurrency: string;
        taxReferenceDate: string;
        numberOfTaxes: integer;
        billToCustomerAddress: CustomerAddress;
        billToCustomerPostalCode: string;
        billToCustomerCity: string;
        billToCustomerState: string;
        billToCustomerCountry: Country;
        billToCustomerCountryName: string;
        draftNumber: string;
        stockMovementGroup: MiscellaneousTable;
        fiscalYear: integer;
        period: integer;
        serviceStartDate: string;
        serviceEndDate: string;
        lastServiceAccountedDate: string;
        warehouse: Warehouse;
        isPrinted: boolean;
        isExternalDocument: boolean;
        earlyDiscountOrLateChargeBasis: string;
        versionControlSystemNumber: string;
        isValidatedAddress: boolean;
        priceOrAmountTaxType: PriceAmountTaxTax;
        vatDeclarationNumber: string;
        exportDeclaration: string;
        mandate: Mandate;
        recurringNumber: string;
        recurringInvoicingDate: string;
        numberOfCompanies: integer;
        cashVatTaxRule: boolean;
        derCode: string;
        field40Reason: MiscellaneousTable;
        field41Reason: MiscellaneousTable;
        originalDocumentNumber: string;
        creditMemoReferenceStartDate: string;
        creditMemoReferenceEndDate: string;
        inPaymentSlipWithReferenceNumber: string;
        cancellationStatus: integer;
        project: ProjectLink;
        correctionMethod: CorrectionMethod;
        siteIdentificationNumber: string;
        spanishInvoiceType: SpanishInvoiceType;
        billToCustomerAddressLines: ClientCollection<CustomerInvoiceHeaderBillToCustomerAddressLines>;
        billToCustomerCompanyNames: ClientCollection<CustomerInvoiceHeaderBillToCustomerCompanyNames>;
        comments: ClientCollection<CustomerInvoiceHeaderComments>;
        payByBusinessPartnerAddressLines: ClientCollection<CustomerInvoiceHeaderPayByBusinessPartnerAddressLines>;
        payByBusinessPartnerCompanyNames: ClientCollection<CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames>;
        taxes: ClientCollection<CustomerInvoiceHeaderTaxes>;
    }
    export interface CustomerInvoiceHeaderInput extends ClientNodeInput {
        id?: string;
        category?: InvoiceType;
        sourceModule?: ModuleTable;
        billToCustomer?: string;
        control?: string;
        company?: string;
        financialSite?: string;
        accountingDate?: string;
        internalNumber?: integer | string;
        sourceDocumentDate?: string;
        sourceDocument?: string;
        currency?: string;
        rateType?: ExchangeRateType;
        rateDate?: string;
        payByBusinessPartner?: string;
        payByBusinessPartnerAddress?: string;
        payByBusinessPartnerPostalCode?: string;
        payByBusinessPartnerCity?: string;
        payByBusinessPartnerState?: string;
        payByBusinessPartnerCountry?: string;
        payByBusinessPartnerCountryName?: string;
        dueDateCalculationStartDate?: string;
        paymentTerm?: string;
        earlyDiscountOrLateCharge?: string;
        earlyDiscountOrLateChargeRate?: decimal | string;
        taxRule?: string;
        entityUserCode?: string;
        isDirectInvoice?: boolean | string;
        intrastatProcessingNumber?: integer | string;
        status?: InvoiceStatus;
        originalInvoiceNumber?: string;
        debitOrCredit?: integer | string;
        totalAmountIncludingTax?: decimal | string;
        totalAmountExcludingTax?: decimal | string;
        totalAmountExcludingTaxInCompanyCurrency?: decimal | string;
        totalAmountIncludingTaxInCompanyCurrency?: decimal | string;
        taxReferenceDate?: string;
        numberOfTaxes?: integer | string;
        billToCustomerAddress?: string;
        billToCustomerPostalCode?: string;
        billToCustomerCity?: string;
        billToCustomerState?: string;
        billToCustomerCountry?: string;
        billToCustomerCountryName?: string;
        draftNumber?: string;
        stockMovementGroup?: string;
        fiscalYear?: integer | string;
        period?: integer | string;
        serviceStartDate?: string;
        serviceEndDate?: string;
        lastServiceAccountedDate?: string;
        warehouse?: string;
        isPrinted?: boolean | string;
        isExternalDocument?: boolean | string;
        earlyDiscountOrLateChargeBasis?: decimal | string;
        versionControlSystemNumber?: string;
        isValidatedAddress?: boolean | string;
        priceOrAmountTaxType?: PriceAmountTaxTax;
        vatDeclarationNumber?: string;
        exportDeclaration?: string;
        mandate?: string;
        recurringNumber?: string;
        recurringInvoicingDate?: string;
        numberOfCompanies?: integer | string;
        cashVatTaxRule?: boolean | string;
        derCode?: string;
        field40Reason?: string;
        field41Reason?: string;
        originalDocumentNumber?: string;
        creditMemoReferenceStartDate?: string;
        creditMemoReferenceEndDate?: string;
        inPaymentSlipWithReferenceNumber?: string;
        cancellationStatus?: integer | string;
        project?: string;
        correctionMethod?: CorrectionMethod;
        siteIdentificationNumber?: string;
        spanishInvoiceType?: SpanishInvoiceType;
        billToCustomerAddressLines?: Partial<CustomerInvoiceHeaderBillToCustomerAddressLinesInput>[];
        billToCustomerCompanyNames?: Partial<CustomerInvoiceHeaderBillToCustomerCompanyNamesInput>[];
        comments?: Partial<CustomerInvoiceHeaderCommentsInput>[];
        payByBusinessPartnerAddressLines?: Partial<CustomerInvoiceHeaderPayByBusinessPartnerAddressLinesInput>[];
        payByBusinessPartnerCompanyNames?: Partial<CustomerInvoiceHeaderPayByBusinessPartnerCompanyNamesInput>[];
        taxes?: Partial<CustomerInvoiceHeaderTaxesInput>[];
    }
    export interface CustomerInvoiceHeaderBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        category: InvoiceType;
        sourceModule: ModuleTable;
        billToCustomer: Customer;
        control: string;
        company: Company;
        financialSite: Site;
        accountingDate: string;
        internalNumber: integer;
        sourceDocumentDate: string;
        sourceDocument: string;
        currency: Currency;
        rateType: ExchangeRateType;
        rateDate: string;
        payByBusinessPartner: BusinessPartner;
        payByBusinessPartnerAddress: BusinessPartnerAddress;
        payByBusinessPartnerPostalCode: string;
        payByBusinessPartnerCity: string;
        payByBusinessPartnerState: string;
        payByBusinessPartnerCountry: Country;
        payByBusinessPartnerCountryName: string;
        dueDateCalculationStartDate: string;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        earlyDiscountOrLateChargeRate: string;
        taxRule: TaxRule;
        entityUserCode: MiscellaneousTable;
        isDirectInvoice: boolean;
        intrastatProcessingNumber: integer;
        status: InvoiceStatus;
        originalInvoiceNumber: string;
        debitOrCredit: integer;
        totalAmountIncludingTax: string;
        totalAmountExcludingTax: string;
        totalAmountExcludingTaxInCompanyCurrency: string;
        totalAmountIncludingTaxInCompanyCurrency: string;
        taxReferenceDate: string;
        numberOfTaxes: integer;
        billToCustomerAddress: CustomerAddress;
        billToCustomerPostalCode: string;
        billToCustomerCity: string;
        billToCustomerState: string;
        billToCustomerCountry: Country;
        billToCustomerCountryName: string;
        draftNumber: string;
        stockMovementGroup: MiscellaneousTable;
        fiscalYear: integer;
        period: integer;
        serviceStartDate: string;
        serviceEndDate: string;
        lastServiceAccountedDate: string;
        warehouse: Warehouse;
        isPrinted: boolean;
        isExternalDocument: boolean;
        earlyDiscountOrLateChargeBasis: string;
        versionControlSystemNumber: string;
        isValidatedAddress: boolean;
        priceOrAmountTaxType: PriceAmountTaxTax;
        vatDeclarationNumber: string;
        exportDeclaration: string;
        mandate: Mandate;
        recurringNumber: string;
        recurringInvoicingDate: string;
        numberOfCompanies: integer;
        cashVatTaxRule: boolean;
        derCode: string;
        field40Reason: MiscellaneousTable;
        field41Reason: MiscellaneousTable;
        originalDocumentNumber: string;
        creditMemoReferenceStartDate: string;
        creditMemoReferenceEndDate: string;
        inPaymentSlipWithReferenceNumber: string;
        cancellationStatus: integer;
        project: ProjectLink;
        correctionMethod: CorrectionMethod;
        siteIdentificationNumber: string;
        spanishInvoiceType: SpanishInvoiceType;
        billToCustomerAddressLines: ClientCollection<CustomerInvoiceHeaderBillToCustomerAddressLinesBinding>;
        billToCustomerCompanyNames: ClientCollection<CustomerInvoiceHeaderBillToCustomerCompanyNamesBinding>;
        comments: ClientCollection<CustomerInvoiceHeaderCommentsBinding>;
        payByBusinessPartnerAddressLines: ClientCollection<CustomerInvoiceHeaderPayByBusinessPartnerAddressLinesBinding>;
        payByBusinessPartnerCompanyNames: ClientCollection<CustomerInvoiceHeaderPayByBusinessPartnerCompanyNamesBinding>;
        taxes: ClientCollection<CustomerInvoiceHeaderTaxesBinding>;
    }
    export interface CustomerInvoiceHeader$Lookups {
        billToCustomer: QueryOperation<Customer>;
        company: QueryOperation<Company>;
        financialSite: QueryOperation<Site>;
        currency: QueryOperation<Currency>;
        payByBusinessPartner: QueryOperation<BusinessPartner>;
        payByBusinessPartnerAddress: QueryOperation<BusinessPartnerAddress>;
        payByBusinessPartnerCountry: QueryOperation<Country>;
        paymentTerm: QueryOperation<PaymentTerm>;
        earlyDiscountOrLateCharge: QueryOperation<EarlyDiscountLateCharge>;
        taxRule: QueryOperation<TaxRule>;
        entityUserCode: QueryOperation<MiscellaneousTable>;
        billToCustomerAddress: QueryOperation<CustomerAddress>;
        billToCustomerCountry: QueryOperation<Country>;
        stockMovementGroup: QueryOperation<MiscellaneousTable>;
        warehouse: QueryOperation<Warehouse>;
        mandate: QueryOperation<Mandate>;
        field40Reason: QueryOperation<MiscellaneousTable>;
        field41Reason: QueryOperation<MiscellaneousTable>;
        project: QueryOperation<ProjectLink>;
    }
    export interface CustomerInvoiceHeader$Operations {
        query: QueryOperation<CustomerInvoiceHeader>;
        read: ReadOperation<CustomerInvoiceHeader>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoiceHeader>;
            query: AggregateQueryOperation<CustomerInvoiceHeader>;
        };
        lookups(dataOrId: string | { data: CustomerInvoiceHeaderInput }): CustomerInvoiceHeader$Lookups;
        getDefaults: GetDefaultsOperation<CustomerInvoiceHeader>;
    }
    export interface CustomerInvoicingElements extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        percentageOrAmount: string;
        invoicingElement: SalesInvoicingElement;
    }
    export interface CustomerInvoicingElementsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        percentageOrAmount?: decimal | string;
        invoicingElement?: integer | string;
    }
    export interface CustomerInvoicingElementsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        percentageOrAmount: string;
        invoicingElement: SalesInvoicingElement;
    }
    export interface CustomerInvoicingElements$Lookups {
        invoicingElement: QueryOperation<SalesInvoicingElement>;
    }
    export interface CustomerInvoicingElements$Operations {
        query: QueryOperation<CustomerInvoicingElements>;
        read: ReadOperation<CustomerInvoicingElements>;
        aggregate: {
            read: AggregateReadOperation<CustomerInvoicingElements>;
            query: AggregateQueryOperation<CustomerInvoicingElements>;
        };
        lookups(dataOrId: string | { data: CustomerInvoicingElementsInput }): CustomerInvoicingElements$Lookups;
        getDefaults: GetDefaultsOperation<CustomerInvoicingElements>;
    }
    export interface EarlyDiscountLateCharge extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface EarlyDiscountLateChargeInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface EarlyDiscountLateChargeBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface EarlyDiscountLateCharge$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface EarlyDiscountLateCharge$Operations {
        query: QueryOperation<EarlyDiscountLateCharge>;
        read: ReadOperation<EarlyDiscountLateCharge>;
        aggregate: {
            read: AggregateReadOperation<EarlyDiscountLateCharge>;
            query: AggregateQueryOperation<EarlyDiscountLateCharge>;
        };
        lookups(dataOrId: string | { data: EarlyDiscountLateChargeInput }): EarlyDiscountLateCharge$Lookups;
        getDefaults: GetDefaultsOperation<EarlyDiscountLateCharge>;
    }
    export interface InvoicingTerm extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface InvoicingTermInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface InvoicingTermBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface InvoicingTerm$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface InvoicingTerm$Operations {
        query: QueryOperation<InvoicingTerm>;
        read: ReadOperation<InvoicingTerm>;
        aggregate: {
            read: AggregateReadOperation<InvoicingTerm>;
            query: AggregateQueryOperation<InvoicingTerm>;
        };
        lookups(dataOrId: string | { data: InvoicingTermInput }): InvoicingTerm$Lookups;
        getDefaults: GetDefaultsOperation<InvoicingTerm>;
    }
    export interface Mandate extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        code: string;
        description: string;
        customer: BusinessPartner;
    }
    export interface MandateInput extends ClientNodeInput {
        company?: string;
        code?: string;
        description?: string;
        customer?: string;
    }
    export interface MandateBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        company: Company;
        code: string;
        description: string;
        customer: BusinessPartner;
    }
    export interface Mandate$Lookups {
        company: QueryOperation<Company>;
        customer: QueryOperation<BusinessPartner>;
    }
    export interface Mandate$Operations {
        query: QueryOperation<Mandate>;
        read: ReadOperation<Mandate>;
        aggregate: {
            read: AggregateReadOperation<Mandate>;
            query: AggregateQueryOperation<Mandate>;
        };
        lookups(dataOrId: string | { data: MandateInput }): Mandate$Lookups;
        getDefaults: GetDefaultsOperation<Mandate>;
    }
    export interface PaymentMethod extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface PaymentMethodInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface PaymentMethodBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface PaymentMethod$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface PaymentMethod$Operations {
        query: QueryOperation<PaymentMethod>;
        read: ReadOperation<PaymentMethod>;
        aggregate: {
            read: AggregateReadOperation<PaymentMethod>;
            query: AggregateQueryOperation<PaymentMethod>;
        };
        lookups(dataOrId: string | { data: PaymentMethodInput }): PaymentMethod$Lookups;
        getDefaults: GetDefaultsOperation<PaymentMethod>;
    }
    export interface PaymentTerm extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        line: integer;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface PaymentTermInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        line?: integer | string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface PaymentTermBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        line: integer;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface PaymentTerm$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface PaymentTerm$Operations {
        query: QueryOperation<PaymentTerm>;
        read: ReadOperation<PaymentTerm>;
        aggregate: {
            read: AggregateReadOperation<PaymentTerm>;
            query: AggregateQueryOperation<PaymentTerm>;
        };
        lookups(dataOrId: string | { data: PaymentTermInput }): PaymentTerm$Lookups;
        getDefaults: GetDefaultsOperation<PaymentTerm>;
    }
    export interface PriceStructureLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        customerOrSupplier: SupplierCustomerType;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
        description: string;
        increaseOrDecrease: IncreaseDecrease;
        valueType: DiscountCalculationRules;
        calculationBasis: ChargeDiscountCalculation;
    }
    export interface PriceStructureLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        customerOrSupplier?: SupplierCustomerType;
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
        description?: string;
        increaseOrDecrease?: IncreaseDecrease;
        valueType?: DiscountCalculationRules;
        calculationBasis?: ChargeDiscountCalculation;
    }
    export interface PriceStructureLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        customerOrSupplier: SupplierCustomerType;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
        description: string;
        increaseOrDecrease: IncreaseDecrease;
        valueType: DiscountCalculationRules;
        calculationBasis: ChargeDiscountCalculation;
    }
    export interface PriceStructureLines$Operations {
        query: QueryOperation<PriceStructureLines>;
        read: ReadOperation<PriceStructureLines>;
        aggregate: {
            read: AggregateReadOperation<PriceStructureLines>;
            query: AggregateQueryOperation<PriceStructureLines>;
        };
        getDefaults: GetDefaultsOperation<PriceStructureLines>;
    }
    export interface PriceStructure extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        customerOrSupplier: SupplierCustomerType;
        code: string;
        alphaNumericNumber: string;
        lines: ClientCollection<PriceStructureLines>;
    }
    export interface PriceStructureInput extends ClientNodeInput {
        customerOrSupplier?: SupplierCustomerType;
        code?: string;
        alphaNumericNumber?: string;
        lines?: Partial<PriceStructureLinesInput>[];
    }
    export interface PriceStructureBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        customerOrSupplier: SupplierCustomerType;
        code: string;
        alphaNumericNumber: string;
        lines: ClientCollection<PriceStructureLinesBinding>;
    }
    export interface PriceStructure$Operations {
        query: QueryOperation<PriceStructure>;
        read: ReadOperation<PriceStructure>;
        aggregate: {
            read: AggregateReadOperation<PriceStructure>;
            query: AggregateQueryOperation<PriceStructure>;
        };
        getDefaults: GetDefaultsOperation<PriceStructure>;
    }
    export interface ProductTaxLevels extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        taxLevel: TaxLevel;
    }
    export interface ProductTaxLevelsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        taxLevel?: string;
    }
    export interface ProductTaxLevelsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        taxLevel: TaxLevel;
    }
    export interface ProductTaxLevels$Lookups {
        taxLevel: QueryOperation<TaxLevel>;
    }
    export interface ProductTaxLevels$Operations {
        query: QueryOperation<ProductTaxLevels>;
        read: ReadOperation<ProductTaxLevels>;
        aggregate: {
            read: AggregateReadOperation<ProductTaxLevels>;
            query: AggregateQueryOperation<ProductTaxLevels>;
        };
        lookups(dataOrId: string | { data: ProductTaxLevelsInput }): ProductTaxLevels$Lookups;
        getDefaults: GetDefaultsOperation<ProductTaxLevels>;
    }
    export interface PurchaseInvoicingElement extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: integer;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface PurchaseInvoicingElementInput extends ClientNodeInput {
        code?: integer | string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface PurchaseInvoicingElementBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: integer;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface PurchaseInvoicingElement$Operations {
        query: QueryOperation<PurchaseInvoicingElement>;
        read: ReadOperation<PurchaseInvoicingElement>;
        aggregate: {
            read: AggregateReadOperation<PurchaseInvoicingElement>;
            query: AggregateQueryOperation<PurchaseInvoicingElement>;
        };
        getDefaults: GetDefaultsOperation<PurchaseInvoicingElement>;
    }
    export interface SalesInvoicingElement extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: integer;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface SalesInvoicingElementInput extends ClientNodeInput {
        code?: integer | string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface SalesInvoicingElementBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: integer;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface SalesInvoicingElement$Operations {
        query: QueryOperation<SalesInvoicingElement>;
        read: ReadOperation<SalesInvoicingElement>;
        aggregate: {
            read: AggregateReadOperation<SalesInvoicingElement>;
            query: AggregateQueryOperation<SalesInvoicingElement>;
        };
        getDefaults: GetDefaultsOperation<SalesInvoicingElement>;
    }
    export interface SupplierInvoiceHeaderBillBySupplierAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        addressLine: string;
    }
    export interface SupplierInvoiceHeaderBillBySupplierAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        addressLine?: string;
    }
    export interface SupplierInvoiceHeaderBillBySupplierAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        addressLine: string;
    }
    export interface SupplierInvoiceHeaderBillBySupplierAddressLines$Operations {
        query: QueryOperation<SupplierInvoiceHeaderBillBySupplierAddressLines>;
        read: ReadOperation<SupplierInvoiceHeaderBillBySupplierAddressLines>;
        aggregate: {
            read: AggregateReadOperation<SupplierInvoiceHeaderBillBySupplierAddressLines>;
            query: AggregateQueryOperation<SupplierInvoiceHeaderBillBySupplierAddressLines>;
        };
        getDefaults: GetDefaultsOperation<SupplierInvoiceHeaderBillBySupplierAddressLines>;
    }
    export interface SupplierInvoiceHeaderBillBySupplierCompanyNames extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        companyName: string;
    }
    export interface SupplierInvoiceHeaderBillBySupplierCompanyNamesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        companyName?: string;
    }
    export interface SupplierInvoiceHeaderBillBySupplierCompanyNamesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        companyName: string;
    }
    export interface SupplierInvoiceHeaderBillBySupplierCompanyNames$Operations {
        query: QueryOperation<SupplierInvoiceHeaderBillBySupplierCompanyNames>;
        read: ReadOperation<SupplierInvoiceHeaderBillBySupplierCompanyNames>;
        aggregate: {
            read: AggregateReadOperation<SupplierInvoiceHeaderBillBySupplierCompanyNames>;
            query: AggregateQueryOperation<SupplierInvoiceHeaderBillBySupplierCompanyNames>;
        };
        getDefaults: GetDefaultsOperation<SupplierInvoiceHeaderBillBySupplierCompanyNames>;
    }
    export interface SupplierInvoiceHeaderComments extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        comment: string;
    }
    export interface SupplierInvoiceHeaderCommentsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        comment?: string;
    }
    export interface SupplierInvoiceHeaderCommentsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        comment: string;
    }
    export interface SupplierInvoiceHeaderComments$Operations {
        query: QueryOperation<SupplierInvoiceHeaderComments>;
        read: ReadOperation<SupplierInvoiceHeaderComments>;
        aggregate: {
            read: AggregateReadOperation<SupplierInvoiceHeaderComments>;
            query: AggregateQueryOperation<SupplierInvoiceHeaderComments>;
        };
        getDefaults: GetDefaultsOperation<SupplierInvoiceHeaderComments>;
    }
    export interface SupplierInvoiceHeaderPayToBusinessPartnerAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        addressLine: string;
    }
    export interface SupplierInvoiceHeaderPayToBusinessPartnerAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        addressLine?: string;
    }
    export interface SupplierInvoiceHeaderPayToBusinessPartnerAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        addressLine: string;
    }
    export interface SupplierInvoiceHeaderPayToBusinessPartnerAddressLines$Operations {
        query: QueryOperation<SupplierInvoiceHeaderPayToBusinessPartnerAddressLines>;
        read: ReadOperation<SupplierInvoiceHeaderPayToBusinessPartnerAddressLines>;
        aggregate: {
            read: AggregateReadOperation<SupplierInvoiceHeaderPayToBusinessPartnerAddressLines>;
            query: AggregateQueryOperation<SupplierInvoiceHeaderPayToBusinessPartnerAddressLines>;
        };
        getDefaults: GetDefaultsOperation<SupplierInvoiceHeaderPayToBusinessPartnerAddressLines>;
    }
    export interface SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        companyName: string;
    }
    export interface SupplierInvoiceHeaderPayToBusinessPartnerCompanyNamesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        companyName?: string;
    }
    export interface SupplierInvoiceHeaderPayToBusinessPartnerCompanyNamesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        companyName: string;
    }
    export interface SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames$Operations {
        query: QueryOperation<SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames>;
        read: ReadOperation<SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames>;
        aggregate: {
            read: AggregateReadOperation<SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames>;
            query: AggregateQueryOperation<SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames>;
        };
        getDefaults: GetDefaultsOperation<SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames>;
    }
    export interface SupplierInvoiceHeaderTaxes extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        tax: Tax;
        taxBasis: string;
        taxAmount: string;
        deductibleTax: string;
        purchaseType: PurchaseType;
    }
    export interface SupplierInvoiceHeaderTaxesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        id?: string;
        tax?: string;
        taxBasis?: decimal | string;
        taxAmount?: decimal | string;
        deductibleTax?: decimal | string;
        purchaseType?: PurchaseType;
    }
    export interface SupplierInvoiceHeaderTaxesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        id: string;
        tax: Tax;
        taxBasis: string;
        taxAmount: string;
        deductibleTax: string;
        purchaseType: PurchaseType;
    }
    export interface SupplierInvoiceHeaderTaxes$Lookups {
        tax: QueryOperation<Tax>;
    }
    export interface SupplierInvoiceHeaderTaxes$Operations {
        query: QueryOperation<SupplierInvoiceHeaderTaxes>;
        read: ReadOperation<SupplierInvoiceHeaderTaxes>;
        aggregate: {
            read: AggregateReadOperation<SupplierInvoiceHeaderTaxes>;
            query: AggregateQueryOperation<SupplierInvoiceHeaderTaxes>;
        };
        lookups(dataOrId: string | { data: SupplierInvoiceHeaderTaxesInput }): SupplierInvoiceHeaderTaxes$Lookups;
        getDefaults: GetDefaultsOperation<SupplierInvoiceHeaderTaxes>;
    }
    export interface SupplierInvoiceHeader extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        category: InvoiceType;
        purchaseInvoiceCategory: PurchaseInvoiceCategory;
        sourceModule: ModuleTable;
        billBySupplier: Supplier;
        control: string;
        company: Company;
        site: Site;
        accountingDate: string;
        internalNumber: integer;
        internalReference: string;
        sourceDocumentDate: string;
        sourceDocument: string;
        currency: Currency;
        rateType: ExchangeRateType;
        rateDate: string;
        isDAS2Submitted: boolean;
        payToBusinessPartner: BusinessPartner;
        dueDateCalculationStartDate: string;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        earlyDiscountOrLateChargeRate: string;
        taxRule: TaxRule;
        isEuropeanUnionInvoice: boolean;
        intrastatProcessingNumber: integer;
        status: PurchasingInvoiceStatus;
        paymentApproval: PaymentApprovalType;
        originalInvoiceNumber: string;
        debitOrCredit: integer;
        totalAmountIncludingTax: string;
        totalAmountExcludingTax: string;
        totalAmountIncludingTaxInCompanyCurrency: string;
        totalAmountExcludingTaxInCompanyCurrency: string;
        taxReferenceDate: string;
        numberOfTaxes: integer;
        billBySupplierAddress: SupplierAddress;
        billBySupplierPostalCode: string;
        billBySupplierCity: string;
        billBySupplierState: string;
        billBySupplierCountry: Country;
        billBySupplierCountryName: string;
        payToBusinessPartnerAddress: BusinessPartnerAddress;
        payToBusinessPartnerPostalCode: string;
        payToBusinessPartnerCity: string;
        payToBusinessPartnerState: string;
        payToBusinessPartnerCountry: Country;
        payToBusinessPartnerCountryName: string;
        incoterm: Incoterm;
        incotermTown: string;
        intrastatTransportLocation: CountryLocation;
        europeanUnionIdentification: string;
        forwardingAgent: Carrier;
        forwardingAgentAddress: SupplierAddress;
        fiscalYear: integer;
        period: integer;
        serviceStartDate: string;
        serviceEndDate: string;
        lastServiceAccountedDate: string;
        unblockUser: User;
        unblockDate: string;
        unblockAmount: string;
        matchStatus: MatchStatusEnum;
        earlyDiscountOrLateChargeBasis: string;
        priceOrAmountType: PriceAmountTaxTax;
        singleCustomsDocumentDate: string;
        singleCustomsDocumentReference: string;
        singleCustomsDocumentBusinessPartnerCode: Supplier;
        derCode: string;
        versionControlSystemNumber: string;
        priceOrAmountTaxType: PriceAmountTaxTax;
        recurringNumber: string;
        importTaxAmountNumber: string;
        recurringInvoicingDate: string;
        numberOfCompanies: integer;
        cashVatTaxRule: boolean;
        field40Reason: MiscellaneousTable;
        field41Reason: MiscellaneousTable;
        originalDocumentNumber: string;
        inPaymentSlipWithReferenceLine: string;
        bankId: string;
        project: ProjectLink;
        billBySupplierAddressLines: ClientCollection<SupplierInvoiceHeaderBillBySupplierAddressLines>;
        billBySupplierCompanyNames: ClientCollection<SupplierInvoiceHeaderBillBySupplierCompanyNames>;
        comments: ClientCollection<SupplierInvoiceHeaderComments>;
        payToBusinessPartnerAddressLines: ClientCollection<SupplierInvoiceHeaderPayToBusinessPartnerAddressLines>;
        payToBusinessPartnerCompanyNames: ClientCollection<SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames>;
        taxes: ClientCollection<SupplierInvoiceHeaderTaxes>;
    }
    export interface SupplierInvoiceHeaderInput extends ClientNodeInput {
        id?: string;
        category?: InvoiceType;
        purchaseInvoiceCategory?: PurchaseInvoiceCategory;
        sourceModule?: ModuleTable;
        billBySupplier?: string;
        control?: string;
        company?: string;
        site?: string;
        accountingDate?: string;
        internalNumber?: integer | string;
        internalReference?: string;
        sourceDocumentDate?: string;
        sourceDocument?: string;
        currency?: string;
        rateType?: ExchangeRateType;
        rateDate?: string;
        isDAS2Submitted?: boolean | string;
        payToBusinessPartner?: string;
        dueDateCalculationStartDate?: string;
        paymentTerm?: string;
        earlyDiscountOrLateCharge?: string;
        earlyDiscountOrLateChargeRate?: decimal | string;
        taxRule?: string;
        isEuropeanUnionInvoice?: boolean | string;
        intrastatProcessingNumber?: integer | string;
        status?: PurchasingInvoiceStatus;
        paymentApproval?: PaymentApprovalType;
        originalInvoiceNumber?: string;
        debitOrCredit?: integer | string;
        totalAmountIncludingTax?: decimal | string;
        totalAmountExcludingTax?: decimal | string;
        totalAmountIncludingTaxInCompanyCurrency?: decimal | string;
        totalAmountExcludingTaxInCompanyCurrency?: decimal | string;
        taxReferenceDate?: string;
        numberOfTaxes?: integer | string;
        billBySupplierAddress?: string;
        billBySupplierPostalCode?: string;
        billBySupplierCity?: string;
        billBySupplierState?: string;
        billBySupplierCountry?: string;
        billBySupplierCountryName?: string;
        payToBusinessPartnerAddress?: string;
        payToBusinessPartnerPostalCode?: string;
        payToBusinessPartnerCity?: string;
        payToBusinessPartnerState?: string;
        payToBusinessPartnerCountry?: string;
        payToBusinessPartnerCountryName?: string;
        incoterm?: string;
        incotermTown?: string;
        intrastatTransportLocation?: CountryLocation;
        europeanUnionIdentification?: string;
        forwardingAgent?: string;
        forwardingAgentAddress?: string;
        fiscalYear?: integer | string;
        period?: integer | string;
        serviceStartDate?: string;
        serviceEndDate?: string;
        lastServiceAccountedDate?: string;
        unblockUser?: string;
        unblockDate?: string;
        unblockAmount?: decimal | string;
        matchStatus?: MatchStatusEnum;
        earlyDiscountOrLateChargeBasis?: decimal | string;
        priceOrAmountType?: PriceAmountTaxTax;
        singleCustomsDocumentDate?: string;
        singleCustomsDocumentReference?: string;
        singleCustomsDocumentBusinessPartnerCode?: string;
        derCode?: string;
        versionControlSystemNumber?: string;
        priceOrAmountTaxType?: PriceAmountTaxTax;
        recurringNumber?: string;
        importTaxAmountNumber?: string;
        recurringInvoicingDate?: string;
        numberOfCompanies?: integer | string;
        cashVatTaxRule?: boolean | string;
        field40Reason?: string;
        field41Reason?: string;
        originalDocumentNumber?: string;
        inPaymentSlipWithReferenceLine?: string;
        bankId?: string;
        project?: string;
        billBySupplierAddressLines?: Partial<SupplierInvoiceHeaderBillBySupplierAddressLinesInput>[];
        billBySupplierCompanyNames?: Partial<SupplierInvoiceHeaderBillBySupplierCompanyNamesInput>[];
        comments?: Partial<SupplierInvoiceHeaderCommentsInput>[];
        payToBusinessPartnerAddressLines?: Partial<SupplierInvoiceHeaderPayToBusinessPartnerAddressLinesInput>[];
        payToBusinessPartnerCompanyNames?: Partial<SupplierInvoiceHeaderPayToBusinessPartnerCompanyNamesInput>[];
        taxes?: Partial<SupplierInvoiceHeaderTaxesInput>[];
    }
    export interface SupplierInvoiceHeaderBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        id: string;
        category: InvoiceType;
        purchaseInvoiceCategory: PurchaseInvoiceCategory;
        sourceModule: ModuleTable;
        billBySupplier: Supplier;
        control: string;
        company: Company;
        site: Site;
        accountingDate: string;
        internalNumber: integer;
        internalReference: string;
        sourceDocumentDate: string;
        sourceDocument: string;
        currency: Currency;
        rateType: ExchangeRateType;
        rateDate: string;
        isDAS2Submitted: boolean;
        payToBusinessPartner: BusinessPartner;
        dueDateCalculationStartDate: string;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        earlyDiscountOrLateChargeRate: string;
        taxRule: TaxRule;
        isEuropeanUnionInvoice: boolean;
        intrastatProcessingNumber: integer;
        status: PurchasingInvoiceStatus;
        paymentApproval: PaymentApprovalType;
        originalInvoiceNumber: string;
        debitOrCredit: integer;
        totalAmountIncludingTax: string;
        totalAmountExcludingTax: string;
        totalAmountIncludingTaxInCompanyCurrency: string;
        totalAmountExcludingTaxInCompanyCurrency: string;
        taxReferenceDate: string;
        numberOfTaxes: integer;
        billBySupplierAddress: SupplierAddress;
        billBySupplierPostalCode: string;
        billBySupplierCity: string;
        billBySupplierState: string;
        billBySupplierCountry: Country;
        billBySupplierCountryName: string;
        payToBusinessPartnerAddress: BusinessPartnerAddress;
        payToBusinessPartnerPostalCode: string;
        payToBusinessPartnerCity: string;
        payToBusinessPartnerState: string;
        payToBusinessPartnerCountry: Country;
        payToBusinessPartnerCountryName: string;
        incoterm: Incoterm;
        incotermTown: string;
        intrastatTransportLocation: CountryLocation;
        europeanUnionIdentification: string;
        forwardingAgent: Carrier;
        forwardingAgentAddress: SupplierAddress;
        fiscalYear: integer;
        period: integer;
        serviceStartDate: string;
        serviceEndDate: string;
        lastServiceAccountedDate: string;
        unblockUser: User;
        unblockDate: string;
        unblockAmount: string;
        matchStatus: MatchStatusEnum;
        earlyDiscountOrLateChargeBasis: string;
        priceOrAmountType: PriceAmountTaxTax;
        singleCustomsDocumentDate: string;
        singleCustomsDocumentReference: string;
        singleCustomsDocumentBusinessPartnerCode: Supplier;
        derCode: string;
        versionControlSystemNumber: string;
        priceOrAmountTaxType: PriceAmountTaxTax;
        recurringNumber: string;
        importTaxAmountNumber: string;
        recurringInvoicingDate: string;
        numberOfCompanies: integer;
        cashVatTaxRule: boolean;
        field40Reason: MiscellaneousTable;
        field41Reason: MiscellaneousTable;
        originalDocumentNumber: string;
        inPaymentSlipWithReferenceLine: string;
        bankId: string;
        project: ProjectLink;
        billBySupplierAddressLines: ClientCollection<SupplierInvoiceHeaderBillBySupplierAddressLinesBinding>;
        billBySupplierCompanyNames: ClientCollection<SupplierInvoiceHeaderBillBySupplierCompanyNamesBinding>;
        comments: ClientCollection<SupplierInvoiceHeaderCommentsBinding>;
        payToBusinessPartnerAddressLines: ClientCollection<SupplierInvoiceHeaderPayToBusinessPartnerAddressLinesBinding>;
        payToBusinessPartnerCompanyNames: ClientCollection<SupplierInvoiceHeaderPayToBusinessPartnerCompanyNamesBinding>;
        taxes: ClientCollection<SupplierInvoiceHeaderTaxesBinding>;
    }
    export interface SupplierInvoiceHeader$Lookups {
        billBySupplier: QueryOperation<Supplier>;
        company: QueryOperation<Company>;
        site: QueryOperation<Site>;
        currency: QueryOperation<Currency>;
        payToBusinessPartner: QueryOperation<BusinessPartner>;
        paymentTerm: QueryOperation<PaymentTerm>;
        earlyDiscountOrLateCharge: QueryOperation<EarlyDiscountLateCharge>;
        taxRule: QueryOperation<TaxRule>;
        billBySupplierAddress: QueryOperation<SupplierAddress>;
        billBySupplierCountry: QueryOperation<Country>;
        payToBusinessPartnerAddress: QueryOperation<BusinessPartnerAddress>;
        payToBusinessPartnerCountry: QueryOperation<Country>;
        incoterm: QueryOperation<Incoterm>;
        forwardingAgent: QueryOperation<Carrier>;
        forwardingAgentAddress: QueryOperation<SupplierAddress>;
        unblockUser: QueryOperation<User>;
        singleCustomsDocumentBusinessPartnerCode: QueryOperation<Supplier>;
        field40Reason: QueryOperation<MiscellaneousTable>;
        field41Reason: QueryOperation<MiscellaneousTable>;
        project: QueryOperation<ProjectLink>;
    }
    export interface SupplierInvoiceHeader$Operations {
        query: QueryOperation<SupplierInvoiceHeader>;
        read: ReadOperation<SupplierInvoiceHeader>;
        aggregate: {
            read: AggregateReadOperation<SupplierInvoiceHeader>;
            query: AggregateQueryOperation<SupplierInvoiceHeader>;
        };
        lookups(dataOrId: string | { data: SupplierInvoiceHeaderInput }): SupplierInvoiceHeader$Lookups;
        getDefaults: GetDefaultsOperation<SupplierInvoiceHeader>;
    }
    export interface TaxLevel extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface TaxLevelInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface TaxLevelBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface TaxLevel$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface TaxLevel$Operations {
        query: QueryOperation<TaxLevel>;
        read: ReadOperation<TaxLevel>;
        aggregate: {
            read: AggregateReadOperation<TaxLevel>;
            query: AggregateQueryOperation<TaxLevel>;
        };
        lookups(dataOrId: string | { data: TaxLevelInput }): TaxLevel$Lookups;
        getDefaults: GetDefaultsOperation<TaxLevel>;
    }
    export interface TaxRule extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface TaxRuleInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface TaxRuleBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface TaxRule$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface TaxRule$Operations {
        query: QueryOperation<TaxRule>;
        read: ReadOperation<TaxRule>;
        aggregate: {
            read: AggregateReadOperation<TaxRule>;
            query: AggregateQueryOperation<TaxRule>;
        };
        lookups(dataOrId: string | { data: TaxRuleInput }): TaxRule$Lookups;
        getDefaults: GetDefaultsOperation<TaxRule>;
    }
    export interface Tax extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface TaxInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface TaxBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface Tax$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface Tax$Operations {
        query: QueryOperation<Tax>;
        read: ReadOperation<Tax>;
        aggregate: {
            read: AggregateReadOperation<Tax>;
            query: AggregateQueryOperation<Tax>;
        };
        lookups(dataOrId: string | { data: TaxInput }): Tax$Lookups;
        getDefaults: GetDefaultsOperation<Tax>;
    }
    export interface CustomerExtension {
        taxRule: TaxRule;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        invoicingTerm: InvoicingTerm;
        invoicingElements: ClientCollection<CustomerInvoicingElements>;
    }
    export interface CustomerInputExtension {
        taxRule?: string;
        paymentTerm?: string;
        earlyDiscountOrLateCharge?: string;
        invoicingTerm?: string;
        invoicingElements?: Partial<CustomerInvoicingElementsInput>[];
    }
    export interface CustomerBindingExtension {
        taxRule: TaxRule;
        paymentTerm: PaymentTerm;
        earlyDiscountOrLateCharge: EarlyDiscountLateCharge;
        invoicingTerm: InvoicingTerm;
        invoicingElements: ClientCollection<CustomerInvoicingElementsBinding>;
    }
    export interface CustomerExtension$Lookups {
        taxRule: QueryOperation<TaxRule>;
        paymentTerm: QueryOperation<PaymentTerm>;
        earlyDiscountOrLateCharge: QueryOperation<EarlyDiscountLateCharge>;
        invoicingTerm: QueryOperation<InvoicingTerm>;
    }
    export interface CustomerExtension$Operations {
        lookups(dataOrId: string | { data: CustomerInput }): CustomerExtension$Lookups;
    }
    export interface ProductExtension {
        taxLevels: ClientCollection<ProductTaxLevels>;
    }
    export interface ProductInputExtension {
        taxLevels?: Partial<ProductTaxLevelsInput>[];
    }
    export interface ProductBindingExtension {
        taxLevels: ClientCollection<ProductTaxLevelsBinding>;
    }
    export interface ShipToCustomerAddressExtension {
        taxRule: TaxRule;
    }
    export interface ShipToCustomerAddressInputExtension {
        taxRule?: string;
    }
    export interface ShipToCustomerAddressBindingExtension {
        taxRule: TaxRule;
    }
    export interface ShipToCustomerAddressExtension$Lookups {
        taxRule: QueryOperation<TaxRule>;
    }
    export interface ShipToCustomerAddressExtension$Operations {
        lookups(dataOrId: string | { data: ShipToCustomerAddressInput }): ShipToCustomerAddressExtension$Lookups;
    }
    export interface Package {
        '@sage/x3-invoicing-data/CustomerInvoiceHeaderBillToCustomerAddressLines': CustomerInvoiceHeaderBillToCustomerAddressLines$Operations;
        '@sage/x3-invoicing-data/CustomerInvoiceHeaderBillToCustomerCompanyNames': CustomerInvoiceHeaderBillToCustomerCompanyNames$Operations;
        '@sage/x3-invoicing-data/CustomerInvoiceHeaderComments': CustomerInvoiceHeaderComments$Operations;
        '@sage/x3-invoicing-data/CustomerInvoiceHeaderPayByBusinessPartnerAddressLines': CustomerInvoiceHeaderPayByBusinessPartnerAddressLines$Operations;
        '@sage/x3-invoicing-data/CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames': CustomerInvoiceHeaderPayByBusinessPartnerCompanyNames$Operations;
        '@sage/x3-invoicing-data/CustomerInvoiceHeaderTaxes': CustomerInvoiceHeaderTaxes$Operations;
        '@sage/x3-invoicing-data/CustomerInvoiceHeader': CustomerInvoiceHeader$Operations;
        '@sage/x3-invoicing-data/CustomerInvoicingElements': CustomerInvoicingElements$Operations;
        '@sage/x3-invoicing-data/EarlyDiscountLateCharge': EarlyDiscountLateCharge$Operations;
        '@sage/x3-invoicing-data/InvoicingTerm': InvoicingTerm$Operations;
        '@sage/x3-invoicing-data/Mandate': Mandate$Operations;
        '@sage/x3-invoicing-data/PaymentMethod': PaymentMethod$Operations;
        '@sage/x3-invoicing-data/PaymentTerm': PaymentTerm$Operations;
        '@sage/x3-invoicing-data/PriceStructureLines': PriceStructureLines$Operations;
        '@sage/x3-invoicing-data/PriceStructure': PriceStructure$Operations;
        '@sage/x3-invoicing-data/ProductTaxLevels': ProductTaxLevels$Operations;
        '@sage/x3-invoicing-data/PurchaseInvoicingElement': PurchaseInvoicingElement$Operations;
        '@sage/x3-invoicing-data/SalesInvoicingElement': SalesInvoicingElement$Operations;
        '@sage/x3-invoicing-data/SupplierInvoiceHeaderBillBySupplierAddressLines': SupplierInvoiceHeaderBillBySupplierAddressLines$Operations;
        '@sage/x3-invoicing-data/SupplierInvoiceHeaderBillBySupplierCompanyNames': SupplierInvoiceHeaderBillBySupplierCompanyNames$Operations;
        '@sage/x3-invoicing-data/SupplierInvoiceHeaderComments': SupplierInvoiceHeaderComments$Operations;
        '@sage/x3-invoicing-data/SupplierInvoiceHeaderPayToBusinessPartnerAddressLines': SupplierInvoiceHeaderPayToBusinessPartnerAddressLines$Operations;
        '@sage/x3-invoicing-data/SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames': SupplierInvoiceHeaderPayToBusinessPartnerCompanyNames$Operations;
        '@sage/x3-invoicing-data/SupplierInvoiceHeaderTaxes': SupplierInvoiceHeaderTaxes$Operations;
        '@sage/x3-invoicing-data/SupplierInvoiceHeader': SupplierInvoiceHeader$Operations;
        '@sage/x3-invoicing-data/TaxLevel': TaxLevel$Operations;
        '@sage/x3-invoicing-data/TaxRule': TaxRule$Operations;
        '@sage/x3-invoicing-data/Tax': Tax$Operations;
    }
    export interface GraphApi
        extends Package,
            SageX3MasterData$Package,
            SageX3ProjectManagementData$Package,
            SageX3StockData$Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-invoicing-data-api' {
    export type * from '@sage/x3-invoicing-data-api-partial';
}
declare module '@sage/x3-master-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-invoicing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-invoicing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-invoicing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-invoicing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-invoicing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-invoicing-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type {
        CustomerBindingExtension,
        CustomerExtension,
        CustomerExtension$Lookups,
        CustomerExtension$Operations,
        CustomerInputExtension,
        ProductBindingExtension,
        ProductExtension,
        ProductInputExtension,
        ShipToCustomerAddressBindingExtension,
        ShipToCustomerAddressExtension,
        ShipToCustomerAddressExtension$Lookups,
        ShipToCustomerAddressExtension$Operations,
        ShipToCustomerAddressInputExtension,
    } from '@sage/x3-invoicing-data-api';
    export interface Customer extends CustomerExtension {}
    export interface CustomerBinding extends CustomerBindingExtension {}
    export interface CustomerInput extends CustomerInputExtension {}
    export interface Customer$Lookups extends CustomerExtension$Lookups {}
    export interface Customer$Operations extends CustomerExtension$Operations {}
    export interface Product extends ProductExtension {}
    export interface ProductBinding extends ProductBindingExtension {}
    export interface ProductInput extends ProductInputExtension {}
    export interface ShipToCustomerAddress extends ShipToCustomerAddressExtension {}
    export interface ShipToCustomerAddressBinding extends ShipToCustomerAddressBindingExtension {}
    export interface ShipToCustomerAddressInput extends ShipToCustomerAddressInputExtension {}
    export interface ShipToCustomerAddress$Lookups extends ShipToCustomerAddressExtension$Lookups {}
    export interface ShipToCustomerAddress$Operations extends ShipToCustomerAddressExtension$Operations {}
}
