/* eslint-disable import/no-duplicates */
declare module '@sage/x3-physical-flows-data-api-partial' {
    import type {
        Package as SageX3InvoicingData$Package,
        SupplierInvoiceHeaderInput,
    } from '@sage/x3-invoicing-data-api';
    import type { Package as SageX3MasterData$Package } from '@sage/x3-master-data-api';
    import type { Package as SageX3ProjectManagementData$Package } from '@sage/x3-project-management-data-api';
    import type { Package as SageX3StockData$Package } from '@sage/x3-stock-data-api';
    import type { Package as SageX3Structure$Package, SiteGroupings } from '@sage/x3-structure-api';
    import type { MiscellaneousTable, Package as SageX3System$Package } from '@sage/x3-system-api';
    import type { Package as SageXtremX3SystemUtils$Package, SysUser } from '@sage/xtrem-x3-system-utils-api';
    import type {
        AggregateQueryOperation,
        AggregateReadOperation,
        ClientNode,
        ClientNodeInput,
        decimal,
        GetDefaultsOperation,
        QueryOperation,
        ReadOperation,
    } from '@sage/xtrem-client';
    export interface IntrastatStatisticalRule extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
        physicalFlow: RuleFlow;
        valueStock: boolean;
        alpha1: string;
        alpha2: string;
        numeric1: string;
        numeric2: string;
        groupOfCompany: SiteGroupings;
        active: boolean;
    }
    export interface IntrastatStatisticalRuleInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
        physicalFlow?: RuleFlow;
        valueStock?: boolean | string;
        alpha1?: string;
        alpha2?: string;
        numeric1?: decimal | string;
        numeric2?: decimal | string;
        groupOfCompany?: string;
        active?: boolean | string;
    }
    export interface IntrastatStatisticalRuleBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
        physicalFlow: RuleFlow;
        valueStock: boolean;
        alpha1: string;
        alpha2: string;
        numeric1: string;
        numeric2: string;
        groupOfCompany: SiteGroupings;
        active: boolean;
    }
    export interface IntrastatStatisticalRule$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
        groupOfCompany: QueryOperation<SiteGroupings>;
    }
    export interface IntrastatStatisticalRule$Operations {
        query: QueryOperation<IntrastatStatisticalRule>;
        read: ReadOperation<IntrastatStatisticalRule>;
        aggregate: {
            read: AggregateReadOperation<IntrastatStatisticalRule>;
            query: AggregateQueryOperation<IntrastatStatisticalRule>;
        };
        lookups(dataOrId: string | { data: IntrastatStatisticalRuleInput }): IntrastatStatisticalRule$Lookups;
        getDefaults: GetDefaultsOperation<IntrastatStatisticalRule>;
    }
    export interface IntrastatTransactionNature extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
        groupOfCompany: SiteGroupings;
        valueStock: boolean;
        active: boolean;
        alpha1: string;
        alpha2: string;
        numeric1: string;
        numeric2: string;
    }
    export interface IntrastatTransactionNatureInput extends ClientNodeInput {
        code?: string;
        legislation?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
        groupOfCompany?: string;
        valueStock?: boolean | string;
        active?: boolean | string;
        alpha1?: string;
        alpha2?: string;
        numeric1?: decimal | string;
        numeric2?: decimal | string;
    }
    export interface IntrastatTransactionNatureBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        legislation: MiscellaneousTable;
        localizedDescription: string;
        localizedShortDescription: string;
        groupOfCompany: SiteGroupings;
        valueStock: boolean;
        active: boolean;
        alpha1: string;
        alpha2: string;
        numeric1: string;
        numeric2: string;
    }
    export interface IntrastatTransactionNature$Lookups {
        legislation: QueryOperation<MiscellaneousTable>;
        groupOfCompany: QueryOperation<SiteGroupings>;
    }
    export interface IntrastatTransactionNature$Operations {
        query: QueryOperation<IntrastatTransactionNature>;
        read: ReadOperation<IntrastatTransactionNature>;
        aggregate: {
            read: AggregateReadOperation<IntrastatTransactionNature>;
            query: AggregateQueryOperation<IntrastatTransactionNature>;
        };
        lookups(dataOrId: string | { data: IntrastatTransactionNatureInput }): IntrastatTransactionNature$Lookups;
        getDefaults: GetDefaultsOperation<IntrastatTransactionNature>;
    }
    export interface Packaging extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface PackagingInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface PackagingBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface Packaging$Operations {
        query: QueryOperation<Packaging>;
        read: ReadOperation<Packaging>;
        aggregate: {
            read: AggregateReadOperation<Packaging>;
            query: AggregateQueryOperation<Packaging>;
        };
        getDefaults: GetDefaultsOperation<Packaging>;
    }
    export interface SupplierInvoiceHeaderExtension {
        intrastatTransactionNature: IntrastatTransactionNature;
        intrastatStatisticalRule: IntrastatStatisticalRule;
        intrastatTransportMode: IntrastatTransportMode;
    }
    export interface SupplierInvoiceHeaderInputExtension {
        intrastatTransactionNature?: string;
        intrastatStatisticalRule?: string;
        intrastatTransportMode?: IntrastatTransportMode;
    }
    export interface SupplierInvoiceHeaderBindingExtension {
        intrastatTransactionNature: IntrastatTransactionNature;
        intrastatStatisticalRule: IntrastatStatisticalRule;
        intrastatTransportMode: IntrastatTransportMode;
    }
    export interface SupplierInvoiceHeaderExtension$Lookups {
        intrastatTransactionNature: QueryOperation<IntrastatTransactionNature>;
        intrastatStatisticalRule: QueryOperation<IntrastatStatisticalRule>;
    }
    export interface SupplierInvoiceHeaderExtension$Operations {
        lookups(dataOrId: string | { data: SupplierInvoiceHeaderInput }): SupplierInvoiceHeaderExtension$Lookups;
    }
    export interface Package {
        '@sage/x3-physical-flows-data/IntrastatStatisticalRule': IntrastatStatisticalRule$Operations;
        '@sage/x3-physical-flows-data/IntrastatTransactionNature': IntrastatTransactionNature$Operations;
        '@sage/x3-physical-flows-data/Packaging': Packaging$Operations;
    }
    export interface GraphApi
        extends Package,
            SageX3InvoicingData$Package,
            SageX3MasterData$Package,
            SageX3ProjectManagementData$Package,
            SageX3StockData$Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-physical-flows-data-api' {
    export type * from '@sage/x3-physical-flows-data-api-partial';
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-physical-flows-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-master-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-physical-flows-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-project-management-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-physical-flows-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-stock-data-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-physical-flows-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-physical-flows-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-physical-flows-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-physical-flows-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-invoicing-data-api-partial' {
    import type {
        SupplierInvoiceHeaderBindingExtension,
        SupplierInvoiceHeaderExtension,
        SupplierInvoiceHeaderExtension$Lookups,
        SupplierInvoiceHeaderExtension$Operations,
        SupplierInvoiceHeaderInputExtension,
    } from '@sage/x3-physical-flows-data-api';
    export interface SupplierInvoiceHeader extends SupplierInvoiceHeaderExtension {}
    export interface SupplierInvoiceHeaderBinding extends SupplierInvoiceHeaderBindingExtension {}
    export interface SupplierInvoiceHeaderInput extends SupplierInvoiceHeaderInputExtension {}
    export interface SupplierInvoiceHeader$Lookups extends SupplierInvoiceHeaderExtension$Lookups {}
    export interface SupplierInvoiceHeader$Operations extends SupplierInvoiceHeaderExtension$Operations {}
}
