import type { PageMetadata } from '../service/page-metadata';
import type { ExtensionLevel, Level } from './field/nested-grid/nested-grid-component-types';
import type { NestedField, NestedFieldTypes } from './nested-fields';
import type { NestedExtensionField } from './nested-fields-extensions';
import type { NestedOverrideField } from './nested-fields-overrides';
import type { ComponentKey, DecoratorProperties } from './types';
import type { Dict } from '@sage/xtrem-shared';
import type { SidebarSectionDefinition } from './table-sidebar/table-sidebar-types';
export declare const findColumnIndex: (columns: NestedField<any, NestedFieldTypes>[], match: string) => number;
export declare const insertColumn: (columns: NestedField<any, any>[], column: NestedExtensionField<any, any>, override?: boolean, onlyInsertIfFound?: boolean) => void;
/**
 * It merges the custom fields into the sidePanelLayout and returns a copy with the custom fields on it
 */
export declare const mergeIntoSidebarLayout: (sidePanelLayout: Dict<SidebarSectionDefinition>, customFields: NestedExtensionField<any, any>[]) => Dict<SidebarSectionDefinition>;
/**
 * It merges the columns defined by the base page and the columns provided by the extension.
 *  */
export declare const mergeColumnPropertyDefinitions: <T extends NestedFieldTypes = NestedFieldTypes>(currentColumns?: NestedField<any, T, any, any>[], columnExtensions?: NestedExtensionField<any, T, any, any>[]) => NestedField<any, T, any, any>[];
export declare const overrideColumnPropertyDefinitions: <T extends NestedFieldTypes = NestedFieldTypes>(currentColumns?: NestedField<any, T, any, any>[], columnOverrides?: NestedOverrideField<any, T, any, any>[]) => NestedField<any, T, any, any>[];
/** Merge the level definition of existing levels */
export declare const mergeLevelPropertyDefinition: (currentLevels?: Level<any, any>[], levelExtensions?: ExtensionLevel<any>[]) => Level<any, any>[];
export declare const overrideExtendedProperties: <T extends ComponentKey>(elementId: string, pageMetadata: PageMetadata, properties: DecoratorProperties<T>, componentType: ComponentKey) => DecoratorProperties<T>;
//# sourceMappingURL=abstract-decorator-utils.d.ts.map