import type { ComponentKey, ControlObjectConstructor, ControlObjectConstructorProps, ControlObjectInstance, DecoratorTarget, LayoutBuilder, LayoutContent, MetadataProps } from './types';
export declare class AbstractDecorator<T extends ComponentKey> {
    protected target: DecoratorTarget<T>;
    protected elementId: string;
    protected _metadataProps: MetadataProps<T>;
    protected componentType: T;
    protected _controlObjectConstructorProps: Partial<ControlObjectConstructorProps<T>>;
    protected _layout: new (target: DecoratorTarget<T>, elementId: string, props: MetadataProps<T>) => LayoutBuilder<T>;
    protected _controlObjectConstructor: ControlObjectConstructor<T>;
    protected layoutBuilder: LayoutBuilder<T>;
    protected controlObjectInstance: ControlObjectInstance<T>;
    constructor(target: DecoratorTarget<T>, elementId: string, _metadataProps: MetadataProps<T>, componentType: T, _controlObjectConstructorProps: Partial<ControlObjectConstructorProps<T>>);
    build: () => this;
    private getScreenId;
    protected readonly buildLayout: () => this;
    protected readonly buildActions: () => this;
    protected readonly buildControlObject: () => this;
    protected readonly buildMetadata: () => this;
    private readonly setTarget;
    private readonly getPageMetadata;
    private readonly setControlObject;
    protected setUiComponentProperties: () => this;
    get layout(): LayoutContent<T>;
    get controlObject(): AbstractDecorator<T>['controlObjectInstance'];
}
//# sourceMappingURL=abstract-decorator.d.ts.map