import { runAndDispatchFieldValidation } from '../service/dispatch-service';
import { focusField, isFieldDirty, isFieldInFocus, refreshField, setFieldClean, setFieldDirty, } from '../service/field-state-service';
import { getFieldValue, getUiComponentProperties, setFieldValue, setUiComponentProperties, } from '../service/transactions-service';
import { AbstractDecorator } from './abstract-decorator';
export class AbstractFieldDecorator extends AbstractDecorator {
    constructor(target, elementId, componentType, _metadataProps) {
        super(target, elementId, _metadataProps, componentType, {
            componentKey: componentType,
            getValue: getFieldValue,
            setValue: setFieldValue,
            refresh: refreshField,
            getUiComponentProperties,
            setUiComponentProperties,
            isFieldDirty,
            setFieldDirty,
            setFieldClean,
            isFieldInFocus,
            focus: focusField,
            dispatchValidation: runAndDispatchFieldValidation,
        });
        this.target = target;
        this.elementId = elementId;
        this.componentType = componentType;
        this._metadataProps = _metadataProps;
    }
    parseRawServerValue(value) {
        return value;
    }
}
//# sourceMappingURL=abstract-field-decorator.js.map