import type { AccessStatus } from '@sage/xtrem-shared';
import * as React from 'react';
import type { ReduxResponsive } from '../../../redux/state';
import type { PageArticleItem } from '../../../service/layout-service';
import { ContextType } from '../../../types';
import type { BlockProperties } from '../../control-objects';
export interface BlockComponentExternalProps {
    item: Partial<PageArticleItem>;
    screenId: string;
    contextType?: ContextType;
    availableColumns: number;
    isParentDisabled?: boolean;
    isParentHidden?: boolean;
    accessRule?: AccessStatus;
}
export interface BlockComponentProps extends BlockComponentExternalProps {
    screenType: string;
    fieldProperties: Omit<BlockProperties, 'parent'>;
    browser: ReduxResponsive;
}
export declare function BlockComponent(props: BlockComponentProps): React.ReactElement | null;
export declare const ConnectedBlockComponent: import("react-redux").ConnectedComponent<typeof BlockComponent, import("react-redux").Omit<BlockComponentProps, "contextType" | "accessRule" | "item" | "screenId" | "availableColumns" | "isParentDisabled" | "isParentHidden" | "fieldProperties" | "browser" | "screenType"> & BlockComponentExternalProps>;
//# sourceMappingURL=block-component.d.ts.map