import * as React from 'react';
import type { PageActionButtonType } from '../../control-objects';
import type { IconType } from 'carbon-react/esm/components/icon';
import type { OnTelemetryEventFunction } from '../../../redux/state';
export interface BusinessActionExternalProps {
    actionId?: string;
    screenId: string;
    defaultButtonType?: PageActionButtonType;
    buttonTypeOverride?: PageActionButtonType;
    isIconOnly?: boolean;
    onClick?: () => void;
    parentRef?: React.Ref<HTMLButtonElement>;
    size?: 'small' | 'medium';
    isSeparated?: boolean;
    alwaysTriggerFieldEvent?: boolean;
    skipWrapping?: boolean;
}
export interface BusinessActionProps extends BusinessActionExternalProps {
    isHidden?: boolean;
    isDisabled?: boolean;
    isDestructive?: boolean;
    title?: string;
    icon?: IconType;
    helperText?: string;
    buttonType?: PageActionButtonType;
    onTelemetryEvent?: OnTelemetryEventFunction;
}
export interface BusinessActionState {
    tooltipShowing: boolean;
}
export declare class BusinessAction extends React.Component<BusinessActionProps, BusinessActionState> {
    constructor(props: BusinessActionProps);
    onClick: () => void;
    setTooltipState: (tooltipShowing: boolean) => () => void;
    render(): React.ReactNode;
}
export declare const ConnectedBusinessAction: import("react-redux").ConnectedComponent<typeof BusinessAction, import("react-redux").Omit<React.ClassAttributes<BusinessAction> & BusinessActionProps, "title" | "onClick" | "buttonType" | "size" | "isHidden" | "screenId" | "helperText" | "isDisabled" | "icon" | "isDestructive" | "onTelemetryEvent" | "actionId" | "defaultButtonType" | "buttonTypeOverride" | "isIconOnly" | "parentRef" | "isSeparated" | "alwaysTriggerFieldEvent" | "skipWrapping"> & BusinessActionExternalProps>;
export default ConnectedBusinessAction;
//# sourceMappingURL=business-action.d.ts.map