import * as React from 'react';
import type { ReduxResponsive } from '../../../redux/state';
import type { PageArticleItem } from '../../../service/layout-service';
import type { ContextType } from '../../../types';
import type { NestedGridProperties } from '../../field/field-control-objects';
import type { InternalTableProperties } from '../../field/table/table-component-types';
import type { GridRowBlockDecoratorProperties } from './grid-row-block-types';
export interface GridRowBlockComponentExternalProps {
    item: Partial<PageArticleItem>;
    screenId: string;
    contextType?: ContextType;
    availableColumns: number;
    isParentDisabled?: boolean;
    /**
     * Indicates if any of the parents in the layout structure is hidden, it is required so we can cascade
     * down the hidden status and mark the hidden inputs not focusable
     * */
    isParentHidden?: boolean;
}
export interface GridRowBlockComponentProps extends GridRowBlockComponentExternalProps {
    screenType: string;
    fieldProperties: GridRowBlockDecoratorProperties;
    browser?: ReduxResponsive;
    referredTableProperties?: InternalTableProperties | NestedGridProperties;
    parentElementId: string;
}
export declare function GridRowBlockComponent(props: GridRowBlockComponentProps): React.ReactElement | null;
export declare const ConnectedGridRowBlockComponent: import("react-redux").ConnectedComponent<typeof GridRowBlockComponent, import("react-redux").Omit<GridRowBlockComponentProps, "contextType" | "item" | "screenId" | "availableColumns" | "isParentDisabled" | "isParentHidden" | "fieldProperties" | "parentElementId" | "browser" | "screenType" | "referredTableProperties"> & GridRowBlockComponentExternalProps>;
export default ConnectedGridRowBlockComponent;
//# sourceMappingURL=grid-row-block-component.d.ts.map