/**
 * @packageDocumentation
 * @module root
 * */
import type { ScreenBase } from '../../../service/screen-base';
import type { ScreenExtension } from '../../../types';
import { AbstractContainer } from '../../abstract-container';
import type { ContainerComponentProps, ContainerControlObjectConstructorProps, ParentType } from '../../types';
import { ContainerKey } from '../../types';
import type { GridRowBlockProperties } from './grid-row-block-types';
export interface IGridRowBlockControlObject extends ContainerControlObjectConstructorProps<ContainerKey.GridRowBlock> {
    parent?: ParentType<ContainerKey.GridRowBlock>;
}
/**
 * [Container]{@link AbstractContainer} that holds any number of [fields]{@link AbstractField}
 */
export declare class GridRowBlockControlObject<CT extends ScreenExtension<CT> = ScreenBase> extends AbstractContainer<CT, ContainerKey.GridRowBlock, ContainerComponentProps<ContainerKey.GridRowBlock>> {
    insertBefore?: ContainerControlObjectConstructorProps<ContainerKey.GridRowBlock>['insertBefore'];
    static readonly defaultUiProperties: Partial<GridRowBlockProperties>;
    theParentOfThisFieldNeedsToBeABlockContainer: boolean;
    constructor(properties: IGridRowBlockControlObject);
    selectedLevel?: number;
    selectedRecordId?: string;
    selectRowAndLevel(selectedRecordId: string, selectedLevel?: number): void;
}
//# sourceMappingURL=grid-row-block-control-object.d.ts.map