import type { Dict, LocalizeLocale } from '@sage/xtrem-shared';
import * as React from 'react';
import type { NodeTypeDict, ReduxResponsive, TableView } from '../../../redux/state';
import type { CollectionValue } from '../../../service/collection-data-service';
import type { TableDecoratorProperties } from '../../decorators';
import type { ValueOrCallback } from '../../../utils/types';
import type { BulkAction } from '../../control-objects';
import type { InternalTableProperties } from '../../field/table/table-component-types';
import type { PropertyValueType } from '../../field/reference/reference-types';
export interface NavigationPanelBodyItemsExternalProps {
    isFullWidthGrid?: boolean;
    screenId: string;
    setFieldProperties?: (elementId: string, properties: InternalTableProperties) => void;
}
export interface NavigationPanelBodyItemsProps extends NavigationPanelBodyItemsExternalProps {
    browser: ReduxResponsive;
    bulkActions?: BulkAction[];
    enumTypes: Dict<string[]>;
    isAutoSelectEnabled: boolean;
    isSoundDisabled?: ValueOrCallback<any, boolean>;
    locale?: LocalizeLocale;
    nodeTypes: Dict<NodeTypeDict>;
    groupByField?: PropertyValueType;
    selectedRecordId?: string | null;
    tableProperties?: TableDecoratorProperties;
    tableViews: Dict<TableView>;
    username?: string;
    value?: CollectionValue;
}
declare function NavigationPanelBodyItems({ browser, bulkActions, enumTypes, groupByField, isAutoSelectEnabled, isSoundDisabled, isFullWidthGrid, locale, nodeTypes, screenId, selectedRecordId, setFieldProperties, tableProperties, tableViews, username, value, }: NavigationPanelBodyItemsProps): React.ReactElement | null;
export declare const ConnectedNavigationPanelBodyItems: import("react-redux").ConnectedComponent<typeof NavigationPanelBodyItems, import("react-redux").Omit<NavigationPanelBodyItemsProps, "locale" | "username" | "value" | "screenId" | "nodeTypes" | "isAutoSelectEnabled" | "isSoundDisabled" | "setFieldProperties" | "browser" | "selectedRecordId" | "tableProperties" | "bulkActions" | "enumTypes" | "tableViews" | "groupByField" | "isFullWidthGrid"> & NavigationPanelBodyItemsExternalProps>;
export {};
//# sourceMappingURL=navigation-panel-body-items.d.ts.map