import * as React from 'react';
import type { ReduxResponsive } from '../../../redux/state';
import type { Page } from '../../../service/page';
import type { ScreenBase } from '../../../service/screen-base';
import type { ValueOrCallback } from '../../../utils/types';
import type { PageActionControlObject } from '../../page-action/page-action-control-object';
import type { PageNavigationPanel } from '../page/page-types';
export interface NavigationPanelExternalProps {
    screenId: string;
    selectedRecordId: string | null;
}
export interface NavigationPanelProps extends NavigationPanelExternalProps {
    browser?: ReduxResponsive;
    createAction?: ValueOrCallback<ScreenBase, PageActionControlObject | PageActionControlObject[]>;
    isNavigationPanelHidden: boolean;
    isNavigationPanelOpened: boolean;
    isNewPage: boolean;
    isRecordSelected: boolean;
    isSelectAllChecked: boolean;
    navigationPanelDefinition: PageNavigationPanel<Page>;
    selectedRecordIds: string[];
    setNavigationPanelIsHeaderHidden: (isHeaderHidden: boolean) => void;
    setNavigationPanelIsOpened: (isOpened: boolean) => void;
    title: string;
}
export declare class NavigationPanel extends React.Component<NavigationPanelProps> {
    private togglePanelButtonRef;
    componentDidMount(): void;
    componentDidUpdate(prevProps: NavigationPanelProps): void;
    private readonly isFullWidth;
    onMultiActionButtonKeyDown: (event: React.KeyboardEvent<HTMLButtonElement>) => void;
    onChevronClick: (navPanelComponentRef: React.RefObject<HTMLButtonElement>) => void;
    setChevronFocus: () => void;
    private readonly setNavigationPanelIsOpened;
    private readonly renderSplitHeaderActions;
    private readonly renderTitle;
    private readonly renderHeaderTop;
    private readonly isHeaderHidden;
    renderFullWidth: () => React.ReactNode;
    render(): React.ReactNode;
}
declare const _default: import("react-redux").ConnectedComponent<typeof NavigationPanel, import("react-redux").Omit<React.ClassAttributes<NavigationPanel> & NavigationPanelProps, "title" | "screenId" | "isSelectAllChecked" | "browser" | "selectedRecordId" | "isNavigationPanelHidden" | "isNavigationPanelOpened" | "isNewPage" | "setNavigationPanelIsOpened" | "createAction" | "isRecordSelected" | "navigationPanelDefinition" | "selectedRecordIds" | "setNavigationPanelIsHeaderHidden"> & NavigationPanelExternalProps>;
export default _default;
//# sourceMappingURL=navigation-panel-component.d.ts.map