import * as React from 'react';
import { connect } from 'react-redux';
import { ContextType } from '../../../types';
import BusinessActions from '../footer/business-actions';
export function PageFooter({ businessActions, screenId, contextType, isExtraSmallScreen, }) {
    const getClassName = () => {
        const classes = ['e-page-footer-container'];
        if (contextType) {
            classes.push(`e-page-footer-context-${contextType}`);
        }
        return classes.join(' ');
    };
    if (businessActions && businessActions.length > 0) {
        return (
        // BL: This element has to be a SPAN for tricky spacing reasons
        React.createElement("span", { className: getClassName() },
            React.createElement("div", { className: "e-page-footer" },
                React.createElement(BusinessActions, { businessActions: businessActions, contextType: contextType || ContextType.page, defaultButtonType: "secondary", key: "e-page-footer-business-actions", screenId: screenId, maxMainActions: isExtraSmallScreen ? 2 : 20 }))));
    }
    return null;
}
const mapStateToProps = (state, props) => {
    return {
        ...props,
        isExtraSmallScreen: state.browser.is.xs,
    };
};
export default connect(mapStateToProps)(PageFooter);
//# sourceMappingURL=page-footer-component.js.map