/**
 * @packageDocumentation
 * @module root
 * */
import type { ClientNode } from '@sage/xtrem-client';
import type { PageExtension } from '../../../types';
import type { PageActionControlObject } from '../../control-objects';
import type { AccessConfiguration } from '../../field/traits';
import type { BasePageDecoratorProperties, PageNavigationPanelExtension } from './page-types';
export interface PageExtensionDecoratorProperties<CT extends PageExtension<CT>, NodeType extends ClientNode = any> extends BasePageDecoratorProperties<CT> {
    /** Page that this extension extends in the following format: @sage/package-name/PageName */
    extends: string;
    /** Access binding that determines whether the extension is loaded */
    extensionAccessBinding?: AccessConfiguration;
    /** Navigation panel property overrides */
    navigationPanel?: PageNavigationPanelExtension<CT, NodeType>;
    /** Navigation panel property overrides */
    businessActions?: (this: CT) => PageActionControlObject[];
}
export declare function pageExtension<CT extends PageExtension<CT>, NodeType extends ClientNode = any>(properties: PageExtensionDecoratorProperties<CT, NodeType>): (ctor: Function) => void;
//# sourceMappingURL=page-extension-decorator.d.ts.map