import type { IconType } from 'carbon-react/esm/components/icon/icon-type';
import * as React from 'react';
import { ReadonlyFieldBaseComponent } from '../field-base-component';
import type { ButtonDecoratorProperties } from './button-types';
export declare class ButtonComponent extends ReadonlyFieldBaseComponent<ButtonDecoratorProperties, string, {
    icon?: IconType;
    buttonType?: 'primary' | 'secondary' | 'tertiary';
    isDestructive?: boolean;
    onClick?: () => void;
}> {
    getFocusableElement(element: HTMLElement): HTMLButtonElement | null;
    onClick: () => void;
    render(): React.ReactNode;
}
export declare const ConnectedButtonComponent: import("react-redux").ConnectedComponent<typeof ButtonComponent, import("react-redux").Omit<React.ClassAttributes<ButtonComponent> & import("../field-base-component-types").FieldComponentExternalProperties & import("../field-base-component-types").ReadonlyFieldComponentProperties<ButtonDecoratorProperties<import("../../../service/screen-base").ScreenBase<any, any>>, string> & {
    icon?: IconType | undefined;
    buttonType?: "primary" | "secondary" | "tertiary" | undefined;
    isDestructive?: boolean | undefined;
    onClick?: (() => void) | undefined;
} & import("../field-base-component-types").NestedFieldsAdditionalProperties, "locale" | "value" | "onFocus" | "nodeTypes" | "fieldProperties" | "isParentReadOnly" | "browser" | "pageNode" | "isInFocus"> & import("../field-base-component-types").FieldComponentExternalProperties>;
export default ConnectedButtonComponent;
//# sourceMappingURL=button-component.d.ts.map