import * as React from 'react';
import { ReadonlyFieldBaseComponent } from '../field-base-component';
import type { FieldComponentExternalProperties, ReadonlyFieldComponentProperties } from '../field-base-component-types';
import type { CalendarComponentAdditionalProps, CalendarComponentInternalProps, CalendarDecoratorProperties, CalendarState, InternalCalendarProperties } from './calendar-types';
import type { CollectionValue } from '../../../service/collection-data-service';
export declare class CalendarComponent extends ReadonlyFieldBaseComponent<InternalCalendarProperties, CollectionValue, CalendarComponentAdditionalProps & {
    fieldProperties: InternalCalendarProperties;
}, CalendarState> {
    constructor(props: CalendarComponentInternalProps);
    private readonly onFilterChange;
    private readonly saveFilters;
    private readonly onSelectView;
    private readonly getTypedEventItems;
    private readonly getEventItems;
    render(): React.ReactNode;
}
export declare const ConnectedCalendarComponent: import("react-redux").ConnectedComponent<typeof CalendarComponent, import("react-redux").Omit<React.ClassAttributes<CalendarComponent> & FieldComponentExternalProperties & ReadonlyFieldComponentProperties<CalendarDecoratorProperties<import("../../../service/screen-base").ScreenBase<any, any>, any>, CollectionValue<any>> & CalendarComponentAdditionalProps & {
    fieldProperties: InternalCalendarProperties<import("../../../service/screen-base").ScreenBase<any, any>>;
}, "locale" | "contextType" | "value" | "onFocus" | "fixedHeight" | "item" | "screenId" | "nestedReadOnlyField" | "shouldRenderLabelInNestedReadOnlyMode" | "availableColumns" | "isParentDisabled" | "isParentHidden" | "bind" | "elementId" | "nodeTypes" | "fieldProperties" | "setFieldProperties" | "isParentReadOnly" | "browser" | "pageNode" | "isInFocus" | "loading" | "selectedRecordId" | "isGreaterThanSmall"> & FieldComponentExternalProperties>;
export default ConnectedCalendarComponent;
//# sourceMappingURL=calendar-component.d.ts.map