import * as React from 'react';
import type { Filter } from '../../../service/filter-service';
import type { GraphqlCollection } from '../../types';
import type { FilterManagerField } from '../../ui/filter/filter-manager';
import { ReadonlyFieldBaseComponent } from '../field-base-component';
import type { FieldComponentExternalProperties, ReadonlyFieldComponentProperties } from '../field-base-component-types';
import type { ChartComponentProps, ChartComponentState, ChartDecoratorProperties } from './chart-types';
import type { OptionalNodePropertyType } from '../../../types';
export declare class ChartComponent extends ReadonlyFieldBaseComponent<ChartDecoratorProperties, GraphqlCollection, ChartComponentProps, ChartComponentState> {
    constructor(props: ChartComponentProps);
    onFilterChange: () => Promise<void>;
    renderChart(): React.ReactNode;
    saveFilters: (filters: Filter[]) => void;
    getFilterableFields: (node: OptionalNodePropertyType, nestedFields: ChartDecoratorProperties['chart']['series']) => FilterManagerField[];
    getNestedFields: () => FilterManagerField[];
    render(): React.ReactNode;
}
export declare const ConnectedChartComponent: import("react-redux").ConnectedComponent<typeof ChartComponent, import("react-redux").Omit<React.ClassAttributes<ChartComponent> & FieldComponentExternalProperties & ReadonlyFieldComponentProperties<ChartDecoratorProperties<import("../../../service/screen-base").ScreenBase<any, any>, any>, GraphqlCollection<import("../../types").CollectionItem>> & import("./chart-types").ChartComponentAdditionalProps, "locale" | "contextType" | "value" | "onFocus" | "fixedHeight" | "item" | "screenId" | "nestedReadOnlyField" | "shouldRenderLabelInNestedReadOnlyMode" | "availableColumns" | "isParentDisabled" | "isParentHidden" | "bind" | "elementId" | "nodeTypes" | "fieldProperties" | "setFieldProperties" | "isParentReadOnly" | "browser" | "pageNode" | "isInFocus"> & FieldComponentExternalProperties>;
export default ConnectedChartComponent;
//# sourceMappingURL=chart-component.d.ts.map