import React from 'react';
import type { CellParams } from '../../../utils/ag-grid/ag-grid-column-config';
import type { NestedDateProperties } from './date-types';
import type { LocalizeLocale } from '@sage/xtrem-shared';
import { AgGridCellEditorComponent } from '../table/table-component-types';
type EventTargetOnDateChange = {
    value: {
        formattedValue: string;
        rawValue: string;
    };
};
interface DateEditorState {
    startValue: string;
    value: string;
    isValid: boolean;
    highlightAllOnFocus: boolean;
    rawValue: string;
    locale: LocalizeLocale;
}
export default class DateCellEditor extends AgGridCellEditorComponent<CellParams<NestedDateProperties>, DateEditorState> {
    private readonly cancelBeforeStart;
    constructor(props: CellParams<NestedDateProperties>);
    componentDidMount(): void;
    handleChange(event: React.ChangeEvent<EventTargetOnDateChange>): void;
    onKeyDown(event: React.KeyboardEvent): void;
    getValue(): string;
    getFormattedDate: () => string;
    getCarbonProps: () => any;
    isCancelBeforeStart(): boolean;
    isCancelAfterEnd(): boolean;
    createInitialState(props: CellParams<NestedDateProperties>): DateEditorState;
    render(): React.ReactNode;
}
export {};
//# sourceMappingURL=date-cell-editor.d.ts.map