import * as React from 'react';
import type { DateProperties } from '../../control-objects';
import { ErrorableFieldBaseComponent } from '../field-base-component';
import type { NestedFieldsAdditionalProperties } from '../field-base-component-types';
import type { DateComponentProps } from './date-types';
export interface DateComponentState {
    internalError?: string;
    formattedValue?: string;
    rawValue?: string;
}
export declare class DateComponent extends ErrorableFieldBaseComponent<DateProperties, string, NestedFieldsAdditionalProperties, DateComponentState> {
    private readonly dateInputRef;
    constructor(props: DateComponentProps);
    private readonly onInputValueChanged;
    private readonly dispatchChange;
    UNSAFE_componentWillReceiveProps(nextProps: DateComponentProps): void;
    private readonly onBlur;
    private readonly onChange;
    private readonly onKeyDown;
    private readonly getFormattedDate;
    private readonly validate;
    render(): React.ReactNode;
}
export declare const ConnectedDateComponent: import("react-redux").ConnectedComponent<typeof DateComponent, import("react-redux").Omit<React.ClassAttributes<DateComponent> & import("../field-base-component-types").FieldComponentExternalProperties & import("../field-base-component-types").ErrorableFieldComponentProperties<DateProperties<import("../../../service/screen-base").ScreenBase<any, any>, void>, string> & NestedFieldsAdditionalProperties, "locale" | "contextType" | "value" | "onFocus" | "fixedHeight" | "item" | "screenId" | "nestedReadOnlyField" | "shouldRenderLabelInNestedReadOnlyMode" | "availableColumns" | "isParentDisabled" | "isParentHidden" | "bind" | "elementId" | "nodeTypes" | "contextNode" | "fieldProperties" | "parentElementId" | "recordContext" | "validationErrors" | "setFieldValue" | "validate" | "removeNonNestedErrors" | "setFieldProperties" | "isParentReadOnly" | "browser" | "pageNode" | "isInFocus" | "handlersArguments" | "isNested" | "columnDefinition" | "addInternalError" | "removeInternalError"> & import("../field-base-component-types").FieldComponentExternalProperties>;
export default ConnectedDateComponent;
//# sourceMappingURL=date-component.d.ts.map