import React from 'react';
import type { SelectItem } from '../../ui/select/select-component';
import type { DropdownListCellEditorProperties } from './dropdown-list-types';
import { AgGridCellEditorComponent } from '../table/table-component-types';
import { TAB, SHIFT_TAB } from '../../../utils/keyboard-event-utils';
interface DropdownListCellEditorState {
    endAction?: typeof TAB | typeof SHIFT_TAB;
    highlightAllOnFocus: boolean;
    initValue: string;
    item?: SelectItem;
}
export declare class DropdownListCellEditor extends AgGridCellEditorComponent<DropdownListCellEditorProperties, DropdownListCellEditorState> {
    private readonly inputRef;
    private isSelecting;
    constructor(props: DropdownListCellEditorProperties);
    componentDidMount(): void;
    onKeyDown: (event: React.KeyboardEvent<HTMLInputElement>) => void;
    onBlur: () => void;
    onItemSelected: (item?: SelectItem | null) => void;
    getCellWidth(): {
        width: string;
    };
    getInitState(props: DropdownListCellEditorProperties): DropdownListCellEditorState;
    getItems: () => Promise<SelectItem[]>;
    getTestId: () => string;
    getValue(): string | null;
    render(): React.ReactNode;
}
export {};
//# sourceMappingURL=dropdown-list-cell-editor.d.ts.map