import React from 'react';
import type { CollectionItem } from '../../types';
import type { SelectItem } from '../../ui/select/select-component';
import type { FilterSelectCellEditorProps } from '../select/select-types';
import { AgGridCellEditorComponent } from '../table/table-component-types';
import { SHIFT_TAB, TAB } from '../../../utils/keyboard-event-utils';
interface FilterSelectEditorState {
    id: string;
    endAction?: typeof TAB | typeof SHIFT_TAB;
    highlightAllOnFocus: boolean;
    isLookupPanelOpen: boolean;
    selectedRecord?: SelectItem;
    startValue: string;
}
export default class FilterSelectCellEditor extends AgGridCellEditorComponent<FilterSelectCellEditorProps, FilterSelectEditorState> {
    private readonly selectRef;
    private isSelecting;
    constructor(props: FilterSelectCellEditorProps);
    componentDidMount(): void;
    getItems: (filterValue: string) => Promise<SelectItem[]>;
    getValue(): string | null;
    onBlur: () => void;
    onSelected: (selectedRecord?: SelectItem | null) => void;
    isLookupDialogOpen: () => boolean;
    onLookupDialogSelectionFinished: ([collectionItem]?: CollectionItem[]) => void;
    closeLookupDialog: () => void;
    openLookupDialog: (event: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement>) => void;
    onKeyDown: (event: React.KeyboardEvent<HTMLInputElement>) => void;
    getLocalizedSuffix: () => string;
    getNewItem: (value: string) => SelectItem;
    createInitialState(props: FilterSelectCellEditorProps): FilterSelectEditorState;
    render(): React.ReactNode;
}
export {};
//# sourceMappingURL=filter-select-cell-editor.d.ts.map