import type { ClientNode } from '@sage/xtrem-client';
import * as React from 'react';
import { EditableFieldBaseComponent } from '../field-base-component';
import type { EditableFieldComponentProperties, FieldComponentExternalProperties } from '../field-base-component-types';
import type { FilterSelectComponentProps, FilterSelectState, FilterSelectDecoratorProperties } from './filter-select-types';
export declare class FilterSelectComponent<T extends ClientNode = any> extends EditableFieldBaseComponent<FilterSelectDecoratorProperties<any, T>, string, {}, FilterSelectState> {
    private readonly lookupButtonRef;
    private searchText;
    private readonly selectInputRef;
    constructor(props: FilterSelectComponentProps<T>);
    private readonly onInputValueChanged;
    private readonly getSearchTextFromValue;
    private readonly getSelectedItemFromValue;
    private readonly onChangeCallback;
    private readonly getItems;
    private readonly getSelectItemsFromNodes;
    private readonly getSelectItemFromCollectionItem;
    private readonly getLocalizedSuffix;
    private readonly getNewItem;
    private readonly isMobileLookupDialogOpen;
    private readonly isMobileSize;
    private readonly triggerOpenFilterSelectDialogEvent;
    private readonly triggerChangeEvent;
    private readonly onMobileButtonClick;
    private readonly onLookupDialogSelectionFinished;
    private readonly onLookupDialogClose;
    private readonly mobileAutoSelect;
    private readonly onMobileInputChange;
    private readonly onChange;
    private renderMobile;
    private readonly getMinLookupCharacters;
    renderDesktop(): React.ReactNode;
    render(): React.ReactNode;
}
export declare const ConnectedFilterSelectComponent: import("react-redux").ConnectedComponent<typeof FilterSelectComponent, import("react-redux").Omit<React.ClassAttributes<FilterSelectComponent<ClientNode>> & FieldComponentExternalProperties & EditableFieldComponentProperties<import("./filter-select-types").FilterSelectProperties<any, ClientNode, void>, string> & import("../field-base-component-types").NestedFieldsAdditionalProperties, "locale" | "contextType" | "value" | "onFocus" | "fixedHeight" | "item" | "screenId" | "nestedReadOnlyField" | "shouldRenderLabelInNestedReadOnlyMode" | "availableColumns" | "isParentDisabled" | "isParentHidden" | "bind" | "elementId" | "nodeTypes" | "contextNode" | "fieldProperties" | "parentElementId" | "recordContext" | "validationErrors" | "setFieldValue" | "validate" | "removeNonNestedErrors" | "setFieldProperties" | "isParentReadOnly" | "browser" | "pageNode" | "isInFocus" | "handlersArguments" | "isNested" | "columnDefinition"> & FieldComponentExternalProperties>;
export default ConnectedFilterSelectComponent;
//# sourceMappingURL=filter-select-component.d.ts.map