import * as React from 'react';
import { EditableFieldBaseComponent } from '../field-base-component';
import type { NestedFieldsAdditionalProperties } from '../field-base-component-types';
import type { BinaryValue } from '../../types';
import type { FormDesignerComponentProps, FormDesignerDecoratorProperties } from './form-designer-types';
export interface FormDesignerComponentState {
    value: string;
    headerValue: string;
    footerValue: string;
    isDirty: boolean;
}
export declare class FormDesignerComponent extends EditableFieldBaseComponent<FormDesignerDecoratorProperties, BinaryValue, NestedFieldsAdditionalProperties, FormDesignerComponentState> {
    private actionSubscription;
    constructor(props: FormDesignerComponentProps);
    componentWillReceiveProps(nextProps: Readonly<FormDesignerComponentProps>): void;
    componentWillUnmount(): void;
    private readonly onReadyEvent;
    private readonly onChange;
    private readonly onHeaderChange;
    private readonly onFooterChange;
    private readonly getObjectDetails;
    private readonly onEditorReady;
    private readonly onObjectInsert;
    private readonly getDocumentParameters;
    private readonly onDisplayToast;
    private readonly contextProvider;
    render(): React.ReactNode;
}
export declare const ConnectedFormDesignerComponent: import("react-redux").ConnectedComponent<typeof FormDesignerComponent, import("react-redux").Omit<React.ClassAttributes<FormDesignerComponent> & import("../field-base-component-types").FieldComponentExternalProperties & import("../field-base-component-types").EditableFieldComponentProperties<FormDesignerDecoratorProperties<import("../../../service/screen-base").ScreenBase<any, any>>, BinaryValue> & NestedFieldsAdditionalProperties & {
    isDirty?: boolean | undefined;
}, "locale" | "value" | "onFocus" | "nodeTypes" | "fieldProperties" | "validationErrors" | "setFieldValue" | "validate" | "removeNonNestedErrors" | "setFieldProperties" | "isParentReadOnly" | "browser" | "pageNode" | "isInFocus"> & import("../field-base-component-types").FieldComponentExternalProperties>;
export default ConnectedFormDesignerComponent;
//# sourceMappingURL=form-designer-component.d.ts.map