var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { EditableFieldControlObject } from '../../editable-field-control-object';
import { ControlObjectProperty } from '../../property-decorators/control-object-property-decorator';
import { FieldControlObjectResolvedProperty } from '../../property-decorators/control-object-resolved-property-decorator';
/**
 * [Field]{@link EditableFieldControlObject} that contains a numeric value
 */
export class NumericControlObject extends EditableFieldControlObject {
    /** Moves the browser focus to this field */
    focus() {
        this._focus();
    }
}
__decorate([
    ControlObjectProperty()
    /** Icon of the input field. It will be placed on the right side. */
], NumericControlObject.prototype, "icon", void 0);
__decorate([
    ControlObjectProperty()
    /** Color of the icon, only supported in tile containers */
], NumericControlObject.prototype, "iconColor", void 0);
__decorate([
    FieldControlObjectResolvedProperty()
    /**
     * Number of digits after the numeric field value decimal point.
     * Must be in the range 0 - 20, inclusive.
     */
], NumericControlObject.prototype, "scale", void 0);
__decorate([
    FieldControlObjectResolvedProperty()
    /** Text to be displayed inline after the field value */
], NumericControlObject.prototype, "prefix", void 0);
__decorate([
    FieldControlObjectResolvedProperty()
    /** Text to be displayed inline before the field value */
], NumericControlObject.prototype, "postfix", void 0);
__decorate([
    FieldControlObjectResolvedProperty()
    /** The maximum value allowed for the numeric field */
], NumericControlObject.prototype, "max", void 0);
__decorate([
    FieldControlObjectResolvedProperty()
    /** The minimum value allowed for the numeric field */
], NumericControlObject.prototype, "min", void 0);
__decorate([
    ControlObjectProperty()
    /** The helper text underneath the field */
], NumericControlObject.prototype, "placeholder", void 0);
__decorate([
    FieldControlObjectResolvedProperty()
], NumericControlObject.prototype, "isNotZero", void 0);
//# sourceMappingURL=numeric-control-object.js.map