import * as React from 'react';
import type { CollectionValue } from '../../../service/collection-data-service';
import type { ScreenBase } from '../../../service/screen-base';
import type { ValueOrCallbackWithFieldValue } from '../../../utils/types';
import type { NestedField, NestedFieldTypes } from '../../nested-fields';
import type { CollectionItem, FieldKey } from '../../types';
import { EditableFieldBaseComponent } from '../field-base-component';
import type { CollectionItemAction, CollectionItemActionGroup } from '../../ui/table-shared/table-dropdown-actions/table-dropdown-action-types';
import type { PodCollectionProperties } from './pod-collection-types';
import type { BaseEditableComponentProperties } from '../field-base-component-types';
import type { NodePropertyType } from '../../../types';
import type { MenuSeparatorType } from '../../container/page/page-types';
export interface PodCollectionItemProps {
    _id: string;
    elementId: string;
    screenId: string;
    podWidth: any;
    isReadOnly: boolean;
    isDisabled: boolean;
    node?: NodePropertyType;
    nestedFields: NestedField<ScreenBase, NestedFieldTypes>[];
    onPodClick: () => void;
    onPodChange: (bind: string, value: any) => Promise<void>;
    onPodRemoved: () => Promise<void>;
    onPodSelectionChange: (isSelected: boolean) => void;
    isSelected: boolean;
    canRemoveRecord: boolean;
    canSelectRecord: boolean;
    title?: NestedField<ScreenBase, NestedFieldTypes> | ValueOrCallbackWithFieldValue<any, string>;
    dropdownActions?: Array<CollectionItemAction<any> | CollectionItemActionGroup<any> | MenuSeparatorType>;
    getRowValue: () => CollectionItem;
    additionalTestId?: string;
    headerLabel?: NestedField<any, FieldKey.Label>;
}
export declare const PodCollectionItem: React.FC<PodCollectionItemProps>;
interface PodCollectionState {
    invalidRecordIds: string[];
}
export declare class PodCollectionComponent extends EditableFieldBaseComponent<PodCollectionProperties, CollectionValue, {}, PodCollectionState> {
    constructor(props: BaseEditableComponentProperties<PodCollectionProperties, CollectionValue>);
    shouldComponentUpdate(): boolean;
    private onBlockChange;
    private getRowValue;
    private getChildFields;
    private onPodAdded;
    private onPodRemoved;
    private readonly onPodClick;
    private readonly onPodSelectionChange;
    private readonly isItemSelected;
    getTooltipContent: () => React.ReactNode;
    filterErrors: () => void;
    unFilterErrors: () => void;
    render(): React.ReactNode;
}
export declare const ConnectedPodCollectionComponent: import("react-redux").ConnectedComponent<React.ComponentType<{}>, (import("react-redux").Omit<{
    children?: React.ReactNode;
}, never> | import("react-redux").Omit<React.ClassAttributes<React.Component<{}, any, any>>, never>) & import("../field-base-component-types").FieldComponentExternalProperties>;
export default ConnectedPodCollectionComponent;
//# sourceMappingURL=pod-collection-component.d.ts.map