import * as React from 'react';
import type { ScreenBase } from '../../../service/screen-base';
import type { CollectionItem } from '../../types';
import type { SelectItem } from '../../ui/select/select-component';
import { EditableFieldBaseComponent } from '../field-base-component';
import type { NestedFieldsAdditionalProperties } from '../field-base-component-types';
import type { PodDecoratorProperties } from './pod-types';
export declare class PodComponent extends EditableFieldBaseComponent<PodDecoratorProperties<ScreenBase, any>, any, NestedFieldsAdditionalProperties> {
    onChange: (collectionItem: CollectionItem | undefined, isOrganicChange: boolean) => void;
    onRemove: () => void;
    onNewPod: () => Promise<void>;
    isLookupDialogOpen: () => boolean;
    onLookupDialogSelectionFinished: ([selectedRecord]: SelectItem[]) => void;
    closeLookupDialog: () => void;
    render(): React.ReactNode;
}
export declare const ConnectedPodComponent: import("react-redux").ConnectedComponent<typeof PodComponent, import("react-redux").Omit<React.ClassAttributes<PodComponent> & import("../field-base-component-types").FieldComponentExternalProperties & import("../field-base-component-types").EditableFieldComponentProperties<PodDecoratorProperties<ScreenBase<any, any>, any>, any> & NestedFieldsAdditionalProperties, "locale" | "value" | "onFocus" | "nodeTypes" | "fieldProperties" | "validationErrors" | "setFieldValue" | "validate" | "removeNonNestedErrors" | "setFieldProperties" | "isParentReadOnly" | "browser" | "pageNode" | "isInFocus"> & import("../field-base-component-types").FieldComponentExternalProperties>;
//# sourceMappingURL=pod-component.d.ts.map