import React from 'react';
import type { CollectionItem } from '../../types';
import type { SelectItem } from '../../ui/select/select-component';
import { LOOKUP_DIALOG_INTERACTION } from '../../ui/table-shared/cell/cell-editor-utils';
import { AgGridCellEditorComponent } from '../table/table-component-types';
import type { ReferenceCellEditorProps, ReferenceCellEditorState } from './reference-types';
export default class ReferenceCellEditor extends AgGridCellEditorComponent<ReferenceCellEditorProps, ReferenceCellEditorState, CollectionItem> {
    private selectRef;
    private isSelecting;
    constructor(props: ReferenceCellEditorProps);
    componentDidMount(): void;
    componentWillUnmount(): Promise<void>;
    getItems: (filterValue: string) => Promise<SelectItem[]>;
    getValue(): CollectionItem | null;
    getWidth(): string;
    onKeyDown: (event: React.KeyboardEvent<HTMLInputElement>) => void;
    onBlur: (endAction?: typeof LOOKUP_DIALOG_INTERACTION) => () => void;
    onSelected: (endAction?: typeof LOOKUP_DIALOG_INTERACTION) => (selectedItem?: SelectItem | null) => void;
    isLookupDialogOpen: () => boolean;
    onLookupDialogSelectionFinished: ([collectionItem]?: CollectionItem[]) => void;
    closeLookupDialog: () => void;
    openLookupDialog: (event: React.MouseEvent<HTMLAnchorElement | HTMLButtonElement, MouseEvent>) => void;
    onInputChange: (value: string) => void;
    getCurrentValue: () => string;
    createInitialState(props: ReferenceCellEditorProps): ReferenceCellEditorState;
    onOpenTunnel: (isNew?: boolean) => Promise<void>;
    handleOnCreateNewItemLinkClick: () => void;
    render(): React.ReactNode;
}
//# sourceMappingURL=reference-cell-editor.d.ts.map