/**
 * @packageDocumentation
 * @module root
 * */
import { standardDecoratorImplementation, standardExtensionDecoratorImplementation, } from '../../../utils/decorator-utils';
import { AbstractFieldDecorator } from '../../abstract-field-decorator';
import { AbstractFieldLayoutBuilder } from '../../abstract-field-layout-builder';
import { ReferenceControlObject } from '../../control-objects';
import { FieldKey } from '../../types';
class ReferenceDecorator extends AbstractFieldDecorator {
    constructor() {
        super(...arguments);
        this._layout = AbstractFieldLayoutBuilder;
        this._controlObjectConstructor = ReferenceControlObject;
    }
}
/**
 * Initializes the decorated member as a [Reference]{@link ReferenceControlObject} field with the provided properties
 *
 * @param properties The properties that the [Reference]{@link ReferenceControlObject} field will be initialized with
 */
export function referenceField(properties) {
    return standardDecoratorImplementation(properties, ReferenceDecorator, FieldKey.Reference, true);
}
export function referenceFieldOverride(properties) {
    return standardExtensionDecoratorImplementation(properties);
}
//# sourceMappingURL=reference-decorator.js.map