import React from 'react';
import type { NestedSelectProperties } from '../../nested-fields-properties';
import type { SelectItem } from '../../ui/select/select-component';
import type { CellParams } from '../../../utils/ag-grid/ag-grid-column-config';
import type { SelectEditorProps, SelectEditorState } from './select-types';
import { AgGridCellEditorComponent } from '../table/table-component-types';
export declare class SelectCellEditor extends AgGridCellEditorComponent<CellParams<NestedSelectProperties>, SelectEditorState> {
    private readonly selectInputRef;
    private isSelecting;
    constructor(props: SelectEditorProps);
    componentDidMount(): void;
    getValue(): string | null;
    getInitialSelectedItem(startValue?: string): SelectItem | undefined;
    onKeyDown: (event: React.KeyboardEvent<HTMLInputElement>) => void;
    getItems: (searchText: string) => Promise<SelectItem[]>;
    onSelected: (selectedItem?: SelectItem | null) => void;
    onHighlighted: (highlightedItem?: SelectItem | null) => void;
    onBlur: () => void;
    createInitialState(props: SelectEditorProps): SelectEditorState;
    render(): React.ReactNode;
}
//# sourceMappingURL=select-cell-editor.d.ts.map