import type { Dict } from '@sage/xtrem-shared';
import type { NestedFilterSelectProperties } from '../../decorators';
import type { SelectItem } from '../../ui/select/select-component';
import type { CellParams } from '../../../utils/ag-grid/ag-grid-column-config';
import type { NestedFieldsAdditionalProperties, BaseEditableComponentProperties } from '../field-base-component-types';
import type { Changeable, ExtensionField, HasEmptyValue, HasInputValueChangeListener, HasParent, Nested, Mappable, NestedChangeable, NestedValidatable, Sizable, Validatable, HasIcon, HasOptions, HasPlaceholder, Postfixable, Prefixable, HasSound, HasOptionDetailsType } from '../traits';
import type { FieldControlObjectInstance } from '../../types';
import type { ClientNode } from '@sage/xtrem-client';
import type { ScreenBase } from '../../../service/screen-base';
import type { ChangeableOverrideDecoratorProperties } from '../../../utils/decorator-utils';
import type { BlockControlObject, TileControlObject } from '../../control-objects';
import type { EditableFieldProperties } from '../../editable-field-control-object';
import type { Extend } from '../../../service/page-extension';
import type { ScreenExtension } from '../../../types';
import type { TAB, SHIFT_TAB } from '../../../utils/keyboard-event-utils';
export interface SelectProperties<CT extends ScreenBase = ScreenBase, ContextNodeType = void> extends EditableFieldProperties<CT, ContextNodeType>, HasIcon, HasPlaceholder, HasOptions<CT>, HasSound<CT>, Postfixable<CT>, Prefixable<CT>, Sizable {
}
export interface SelectEditorProps extends CellParams<NestedSelectProperties> {
    enumOptions?: string[];
    localizedOptions?: Dict<string>;
}
export interface SelectEditorState {
    endAction?: typeof TAB | typeof SHIFT_TAB;
    highlightAllOnFocus: boolean;
    highlightedItem?: SelectItem | null;
    selectedRecord?: SelectItem;
    startValue: string;
}
export interface SelectInternalProps {
    enumOptions?: string[];
    localizedOptions?: Dict<string>;
    screenId: string;
    value?: string;
}
export interface FilterSelectCellEditorProps extends CellParams<NestedFilterSelectProperties> {
    localizedNew: string;
}
export interface SelectDecoratorProperties<CT extends ScreenBase = ScreenBase> extends Omit<SelectProperties<CT, void>, '_controlObjectType'>, Changeable<CT>, HasParent<CT, BlockControlObject<CT> | TileControlObject<CT>>, HasInputValueChangeListener<CT>, ExtensionField<CT, FieldControlObjectInstance<any>>, Validatable<CT>, Mappable<CT>, HasOptionDetailsType<CT>, HasSound<CT>, Sizable {
}
export interface NestedSelectProperties<CT extends ScreenBase = ScreenBase, ContextNodeType extends ClientNode = any> extends Omit<SelectProperties<CT, ContextNodeType>, 'bind'>, NestedChangeable<CT>, Nested<ContextNodeType>, Sizable, HasEmptyValue, HasOptionDetailsType<CT>, NestedValidatable<CT, string, ContextNodeType> {
}
export type SelectExtensionDecoratorProperties<T extends ScreenExtension<T>> = ChangeableOverrideDecoratorProperties<SelectDecoratorProperties<Extend<T>>, T>;
export type SelectAdditionalProperties = NestedFieldsAdditionalProperties & SelectInternalProps;
export type SelectComponentProps = BaseEditableComponentProperties<SelectDecoratorProperties, string, SelectAdditionalProperties>;
//# sourceMappingURL=select-types.d.ts.map