import * as React from 'react';
import { EditableFieldBaseComponent } from '../field-base-component';
import type { BaseEditableComponentProperties } from '../field-base-component-types';
import type { TextAreaDecoratorProperties } from './text-area-types';
type TextAreaComponentProps = BaseEditableComponentProperties<TextAreaDecoratorProperties, string>;
export interface TextAreaComponentState {
    value: string;
}
export declare class TextAreaComponent extends EditableFieldBaseComponent<TextAreaDecoratorProperties, string, {}, TextAreaComponentState> {
    constructor(props: TextAreaComponentProps);
    onChange: (event: React.ChangeEvent<HTMLInputElement>) => void;
    onBlur: () => void;
    onKeyDown: (event: KeyboardEvent) => void;
    UNSAFE_componentWillReceiveProps(nextProps: TextAreaComponentProps): void;
    getFocusableElement(element: HTMLElement): HTMLTextAreaElement | null;
    render(): React.ReactNode;
}
export declare const ConnectedTextAreaComponent: import("react-redux").ConnectedComponent<typeof TextAreaComponent, import("react-redux").Omit<React.ClassAttributes<TextAreaComponent> & import("../field-base-component-types").FieldComponentExternalProperties & import("../field-base-component-types").EditableFieldComponentProperties<TextAreaDecoratorProperties<import("../../../service/screen-base").ScreenBase<any, any>>, string>, "locale" | "value" | "onFocus" | "nodeTypes" | "fieldProperties" | "validationErrors" | "setFieldValue" | "validate" | "removeNonNestedErrors" | "setFieldProperties" | "isParentReadOnly" | "browser" | "pageNode" | "isInFocus"> & import("../field-base-component-types").FieldComponentExternalProperties>;
export default ConnectedTextAreaComponent;
//# sourceMappingURL=text-area-component.d.ts.map