/**
 * @packageDocumentation
 * @module root
 * */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { EditableFieldControlObject } from '../../editable-field-control-object';
import { ControlObjectProperty } from '../../property-decorators/control-object-property-decorator';
/**
 * [Field]{@link EditableFieldControlObject} that holds a multi-line text value
 */
export class TextAreaControlObject extends EditableFieldControlObject {
    /** Moves the browser focus to this field */
    focus() {
        this._focus();
    }
}
__decorate([
    ControlObjectProperty()
    /** The number of rows the text area will span */
], TextAreaControlObject.prototype, "rows", void 0);
__decorate([
    ControlObjectProperty()
    /** The minimum length of the text field value */
], TextAreaControlObject.prototype, "minLength", void 0);
__decorate([
    ControlObjectProperty()
    /**  The maximum length of the text field value  */
], TextAreaControlObject.prototype, "maxLength", void 0);
__decorate([
    ControlObjectProperty()
    /** Placeholder to be displayed in the field body */
], TextAreaControlObject.prototype, "placeholder", void 0);
__decorate([
    ControlObjectProperty()
    /** The helper text underneath the field */
], TextAreaControlObject.prototype, "helperText", void 0);
//# sourceMappingURL=text-area-control-object.js.map