import * as React from 'react';
import { EditableFieldBaseComponent } from '../field-base-component';
import type { BaseEditableComponentProperties, NestedFieldsAdditionalProperties } from '../field-base-component-types';
import type { TextDecoratorProperties } from './text-types';
type TextComponentProps = BaseEditableComponentProperties<TextDecoratorProperties, string, NestedFieldsAdditionalProperties & {
    isDirty?: boolean;
}>;
export interface TextComponentState {
    value: string;
    isDirty: boolean;
}
export declare class TextComponent extends EditableFieldBaseComponent<TextDecoratorProperties, string, NestedFieldsAdditionalProperties, TextComponentState> {
    constructor(props: TextComponentProps);
    private readonly onInputValueChanged;
    private readonly onChange;
    private readonly onBlur;
    private readonly onKeyDown;
    private readonly onKeyUp;
    private readonly onClick;
    UNSAFE_componentWillReceiveProps(nextProps: TextComponentProps): void;
    private readonly handleFocus;
    private readonly handleSelection;
    render(): React.ReactNode;
}
export declare const ConnectedTextComponent: import("react-redux").ConnectedComponent<typeof TextComponent, import("react-redux").Omit<React.ClassAttributes<TextComponent> & import("../field-base-component-types").FieldComponentExternalProperties & import("../field-base-component-types").EditableFieldComponentProperties<TextDecoratorProperties<import("../../../service/screen-base").ScreenBase<any, any>>, string> & NestedFieldsAdditionalProperties & {
    isDirty?: boolean | undefined;
}, "locale" | "value" | "onFocus" | "nodeTypes" | "fieldProperties" | "validationErrors" | "setFieldValue" | "validate" | "removeNonNestedErrors" | "setFieldProperties" | "isParentReadOnly" | "browser" | "pageNode" | "isInFocus"> & import("../field-base-component-types").FieldComponentExternalProperties>;
export default ConnectedTextComponent;
//# sourceMappingURL=text-component.d.ts.map