import type { Dict, Notification } from '@sage/xtrem-shared';
import type { integration } from '@sage/xtrem-ui';
import * as React from 'react';
import type { UserDetails } from '../service/auth-service';
import type { TenantItem } from '../service/tenants-service';
import './header.scss';
import type { ChatbotConfiguration } from '../service/chatbot-service';
export interface XtremHeaderProps extends XtremExternalHeaderProps {
    chatbotConfig: ChatbotConfiguration | null;
    chatbotEnabled: boolean;
    goHome: () => void;
    isExtraSmall: boolean;
    isNavigationOpen: boolean;
    isNotificationCenterOpen: boolean;
    loginService: string | null;
    menuItems: integration.Menu[];
    notifications: Notification[];
    path: string;
    productName: string | null;
    setChatbotOpen: (isOpen: boolean) => void;
    setNavigationOpen: (isOpen: boolean) => void;
    setNotificationCenterOpen: (isOpen: boolean) => void;
    tenantItem: TenantItem;
    translations: Dict<string>;
    user: UserDetails | null;
}
export interface XtremExternalHeaderProps {
    onUserChangeLocale: (locale: string) => void;
}
export declare function XtremHeader(props: XtremHeaderProps): React.JSX.Element;
export declare const ConnectedXtremHeader: import("react-redux").ConnectedComponent<typeof XtremHeader, import("react-redux").Omit<XtremHeaderProps, "path" | "user" | "loginService" | "isExtraSmall" | "translations" | "isNavigationOpen" | "chatbotConfig" | "chatbotEnabled" | "goHome" | "isNotificationCenterOpen" | "menuItems" | "notifications" | "productName" | "setChatbotOpen" | "setNavigationOpen" | "setNotificationCenterOpen" | "tenantItem" | "onUserChangeLocale"> & XtremExternalHeaderProps>;
//# sourceMappingURL=header.d.ts.map