/// <reference types="lodash" />
import type { integration } from '@sage/xtrem-ui';
import * as React from 'react';
export interface HeaderProps {
    pageTitle: string | null;
    pageSubtitle: string | null;
    stockSiteCode?: string;
    path: string;
    hasOpenDialog: boolean;
    hasOpenSticker: boolean;
    hasLookupDialog: boolean;
    openDialog?: integration.Menu;
    lookupDialog?: integration.Menu;
    onInternalNavigationChange: (path: string) => void;
    goHome: () => void;
    isApplicationDirty: boolean;
    preNavigationConfirmation: (() => Promise<void>) | null;
    isNavigationConfirmationPromptDisplayed: boolean;
}
export declare class Header extends React.Component<HeaderProps> {
    onLeftIconClick: () => Promise<void>;
    onRightIconClick: import("lodash").DebouncedFunc<() => void>;
    getTitle(): string | null;
    isMainPage: () => boolean;
    render(): React.ReactNode;
}
declare const _default: import("react-redux").ConnectedComponent<typeof Header, import("react-redux").Omit<React.ClassAttributes<Header> & HeaderProps, "path" | "goHome" | "onInternalNavigationChange" | "pageTitle" | "pageSubtitle" | "isApplicationDirty" | "preNavigationConfirmation" | "isNavigationConfirmationPromptDisplayed" | "stockSiteCode" | "hasOpenDialog" | "hasOpenSticker" | "hasLookupDialog" | "openDialog" | "lookupDialog">>;
export default _default;
//# sourceMappingURL=header.d.ts.map