import type { integration } from '@sage/xtrem-ui';
import * as React from 'react';
import type { EndpointOption, Profile } from '../service/profile-schema';
export interface SettingsPageProps {
    profile: Profile | null;
    menuItems: integration.Menu[];
    updateSoundDisabled: (isSoundDisabled: boolean) => void;
}
export interface SettingsPageState {
    infoMessageIgnored: boolean;
    endpointsOpen: boolean;
}
export declare class SettingsPage extends React.Component<SettingsPageProps, SettingsPageState> {
    constructor(props: SettingsPageProps);
    onInfoDismiss(): void;
    onLogout(): Promise<void>;
    getFirstName: () => string;
    getLastName: () => string;
    getNames: () => string[];
    getProfilePicture: () => string;
    getEndpoint: () => string;
    toggleEndpoints: () => void;
    selectEndpoint: (endpoint: EndpointOption) => () => Promise<void>;
    soundOnChange: (event: React.ChangeEvent<HTMLInputElement>) => void;
    render(): React.ReactNode;
}
declare const _default: import("react-redux").ConnectedComponent<typeof SettingsPage, import("react-redux").Omit<React.ClassAttributes<SettingsPage> & SettingsPageProps, "profile" | "menuItems" | "updateSoundDisabled">>;
export default _default;
//# sourceMappingURL=settings-page.d.ts.map