import * as React from 'react';
import type * as xtremRedux from '../../redux';
import type { CollectionValue } from '../../service/collection-data-service';
import type { CollectionItemAction, CollectionItemActionGroup } from '../ui/table-shared/table-dropdown-actions/table-dropdown-action-types';
import type { MenuSeparatorType } from '../container/page/page-types';
import type { ErrorHandlerFunction } from '../field/traits';
import type { AccessBindings } from '../../service/page-definition';
import type { ScreenBaseDefinition } from '../../service/screen-base-definition';
export interface TableSidebarHeaderProps {
    accessBindings: AccessBindings;
    screenDefinition: ScreenBaseDefinition;
    headerQuickActions?: Array<CollectionItemAction<any>>;
    headerDropdownActions?: Array<CollectionItemAction<any> | CollectionItemActionGroup<any> | MenuSeparatorType>;
    screenId: string;
    recordValue: any;
    elementId: string;
    recordId?: string;
    value: CollectionValue;
    isUncommitted: boolean;
    tableTitle?: string;
    sidebarGetTitle?: string | ((_id: string, recordValue?: any) => string);
    onError?: ErrorHandlerFunction<any>;
    onNextRecord: () => Promise<void>;
    onPreviousRecord: () => Promise<void>;
    hasPreviousRecord: boolean;
    hasNextRecord: boolean;
    isLoading: boolean;
}
export declare function TableSidebarHeader({ elementId, headerDropdownActions, headerQuickActions, onError, onNextRecord, onPreviousRecord: onPrevRecord, accessBindings, recordValue, screenDefinition, screenId, sidebarGetTitle, tableTitle, hasPreviousRecord, hasNextRecord, isLoading, }: TableSidebarHeaderProps): React.ReactElement | null;
export declare const mapDispatchToProps: (dispatch: xtremRedux.AppThunkDispatch) => Partial<TableSidebarHeaderProps>;
export declare const mapStateToProps: (state: xtremRedux.XtremAppState) => Partial<TableSidebarHeaderProps>;
export declare const ConnectedTableSidebarHeader: import("react-redux").ConnectedComponent<React.ComponentType<TableSidebarHeaderProps>, import("react-redux").Omit<React.ClassAttributes<React.Component<TableSidebarHeaderProps, any, any>> & TableSidebarHeaderProps, "value" | "onError" | "screenId" | "elementId" | "screenDefinition" | "recordId" | "isUncommitted" | "isLoading" | "accessBindings" | "headerQuickActions" | "headerDropdownActions" | "recordValue" | "tableTitle" | "sidebarGetTitle" | "onNextRecord" | "onPreviousRecord" | "hasPreviousRecord" | "hasNextRecord"> | import("react-redux").Omit<TableSidebarHeaderProps & {
    children?: React.ReactNode;
}, "value" | "onError" | "screenId" | "elementId" | "screenDefinition" | "recordId" | "isUncommitted" | "isLoading" | "accessBindings" | "headerQuickActions" | "headerDropdownActions" | "recordValue" | "tableTitle" | "sidebarGetTitle" | "onNextRecord" | "onPreviousRecord" | "hasPreviousRecord" | "hasNextRecord">>;
//# sourceMappingURL=table-sidebar-header.d.ts.map