import type * as xtremRedux from '../../redux';
import React from 'react';
import type { SidebarFieldBinding } from './table-sidebar-types';
import type { TableDecoratorProperties } from '../field/table/table-component-types';
import type { NodeTypeDict } from '../../redux/state';
import { FieldKey } from '../types';
import type { Dict, LocalizeLocale } from '@sage/xtrem-shared';
import type { ReduxResponsive } from '../../plugin';
import type { CollectionValue } from '../../service/collection-data-service';
import type { EditableFieldProperties } from '../editable-field-control-object';
import type { ValidationResult } from '../../service/screen-base-definition';
export interface TableSidebarNestedFieldExternalProps extends SidebarFieldBinding {
    availableColumns: number;
}
export interface TableSidebarNestedFieldProps extends TableSidebarNestedFieldExternalProps {
    fieldProperties: EditableFieldProperties;
    browser: ReduxResponsive;
    fieldType: FieldKey;
    onChange?: (bind: string, value: any) => Promise<void>;
    nodeTypes: Dict<NodeTypeDict>;
    locale: LocalizeLocale;
    screenId: string;
    elementId: string;
    recordId?: string;
    value: CollectionValue;
    isUncommitted: boolean;
    recordValue: any;
    shouldFetchDefault: boolean;
    tableProperties: TableDecoratorProperties;
    validationErrors?: ValidationResult[];
}
export declare function TableSidebarNestedField({ fieldProperties, browser, fieldType, availableColumns, onChange, locale, fieldId, screenId, elementId, recordValue, tableProperties, validationErrors, }: TableSidebarNestedFieldProps): React.ReactElement | null;
export declare const mapStateToProps: (state: xtremRedux.XtremAppState, props: TableSidebarNestedFieldExternalProps) => Partial<TableSidebarNestedFieldProps>;
export declare const ConnectedTableSidebarNestedField: import("react-redux").ConnectedComponent<React.ComponentType<TableSidebarNestedFieldProps>, (import("react-redux").Omit<React.ClassAttributes<React.Component<TableSidebarNestedFieldProps, any, any>> & TableSidebarNestedFieldProps, "locale" | "value" | "onChange" | "screenId" | "availableColumns" | "elementId" | "nodeTypes" | "fieldId" | "fieldProperties" | "recordId" | "validationErrors" | "browser" | "fieldType" | "isUncommitted" | "shouldFetchDefault" | "tableProperties" | "isNested" | "recordValue"> | import("react-redux").Omit<TableSidebarNestedFieldProps & {
    children?: React.ReactNode;
}, "locale" | "value" | "onChange" | "screenId" | "availableColumns" | "elementId" | "nodeTypes" | "fieldId" | "fieldProperties" | "recordId" | "validationErrors" | "browser" | "fieldType" | "isUncommitted" | "shouldFetchDefault" | "tableProperties" | "isNested" | "recordValue">) & TableSidebarNestedFieldExternalProps>;
//# sourceMappingURL=table-sidebar-nested-field.d.ts.map