import type { IconType } from 'carbon-react/esm/components/icon/icon-type';
import type { DecimalProps, CustomEvent } from 'carbon-react/esm/components/decimal';
import React from 'react';
import type { CarbonStyleOverrides } from '../../types';
interface Props {
    ref?: React.Ref<HTMLInputElement>;
    allowEmptyValue?: boolean;
    disabled: boolean;
    fieldHelp?: string;
    inputIcon?: IconType;
    onChange: (event: CustomEvent) => void;
    onKeyDown?: (event: React.KeyboardEvent<HTMLInputElement>) => void;
    precision?: DecimalProps['precision'];
    styleOverride?: CarbonStyleOverrides;
    validations?: any;
    value?: string;
}
interface InternalProps extends Props {
    locale: string;
}
export interface DecimalValueObject {
    rawValue: string;
    formattedValue: string;
}
export declare const UnconnectedDecimal: React.FC<InternalProps>;
export declare const Decimal: import("react-redux").ConnectedComponent<React.FC<InternalProps>, import("react-redux").Omit<InternalProps & {
    children?: React.ReactNode;
}, "locale" | "ref" | "disabled" | "value" | "onChange" | "onKeyDown" | "fieldHelp" | "inputIcon" | "allowEmptyValue" | "precision" | "styleOverride" | "validations"> & Props>;
export {};
//# sourceMappingURL=decimal-component.d.ts.map