import type { ClientNode } from '@sage/xtrem-client';
import * as React from 'react';
import type { NodeTypeDict, ReduxResponsive } from '../../redux/state';
import type { CollectionValue } from '../../service/collection-data-service';
import type { PageArticleItem } from '../../service/layout-service';
import type { ScreenBase } from '../../service/screen-base';
import type { ValidationResult } from '../../service/screen-base-definition';
import type { NodePropertyType } from '../../types';
import { ContextType } from '../../types';
import type { ValueOrCallbackWithFieldValue } from '../../utils/types';
import type { NestedField, NestedFieldTypes } from '../nested-fields';
import type { XtremActionPopoverItem } from './xtrem-action-popover';
import type { FieldKey } from '../types';
import type { Dict } from '@sage/xtrem-shared';
export interface NestedBlockProps {
    actionPopoverItems?: XtremActionPopoverItem[];
    additionalTestId?: string;
    availableColumns: number;
    baseClassName?: string;
    browser?: ReduxResponsive;
    canSelect?: boolean;
    contextNode?: NodePropertyType;
    contextType?: ContextType;
    headerLabel?: NestedField<any, FieldKey.Label>;
    hideValidationSummary?: boolean;
    info?: string;
    isCloseIconDisplayed?: boolean;
    isDisabled?: boolean;
    isHidden?: ValueOrCallbackWithFieldValue<any, boolean>;
    isReadOnly?: boolean;
    isSelected?: boolean;
    isTitleHidden?: ValueOrCallbackWithFieldValue<any, boolean>;
    item: Partial<PageArticleItem>;
    level?: number;
    nestedFields: NestedField<ScreenBase, NestedFieldTypes>[];
    nodeTypes?: Dict<NodeTypeDict>;
    noMargin?: boolean;
    onActionPopoverOpen?: () => void;
    onBlockClick?: () => void;
    onBlockRemoved?: () => void;
    onBlockSelectionChange?: (isSelected: boolean) => void;
    onChange?: (bind: string, value: any) => Promise<void>;
    parentElementId: string;
    readOnlyOverride?: (this: ScreenBase, elementId: string) => boolean | void;
    recordValue?: ClientNode;
    screenId: string;
    title?: NestedField<ScreenBase, NestedFieldTypes> | ValueOrCallbackWithFieldValue<any, string>;
    validate?: (columnName: string, value: any) => Promise<ValidationResult[]>;
    validationErrors?: ValidationResult[];
    warning?: string;
}
export interface ConnectedNestedBlockProps extends NestedBlockProps {
    recordId: string;
    value?: CollectionValue;
}
export interface NestedBlockExternalProps extends ConnectedNestedBlockProps {
    screenType: string;
}
export declare class NestedBlock extends React.Component<NestedBlockProps> {
    private readonly onChange;
    private readonly renderField;
    private readonly resolveTitle;
    private readonly getStatusIcon;
    private renderTitle;
    private readonly renderHeader;
    render(): React.ReactNode;
}
export declare const ConnectedNestedBlock: import("react-redux").ConnectedComponent<React.ComponentType<NestedBlockProps>, (import("react-redux").Omit<React.ClassAttributes<React.Component<NestedBlockProps, any, any>> & NestedBlockProps, "title" | "info" | "warning" | "contextType" | "onChange" | "isHidden" | "item" | "screenId" | "availableColumns" | "nestedFields" | "nodeTypes" | "isTitleHidden" | "isDisabled" | "isReadOnly" | "contextNode" | "level" | "parentElementId" | "canSelect" | "headerLabel" | "validationErrors" | "validate" | "browser" | "recordValue" | "isSelected" | "additionalTestId" | "actionPopoverItems" | "baseClassName" | "hideValidationSummary" | "isCloseIconDisplayed" | "noMargin" | "onActionPopoverOpen" | "onBlockClick" | "onBlockRemoved" | "onBlockSelectionChange" | "readOnlyOverride"> | import("react-redux").Omit<NestedBlockProps & {
    children?: React.ReactNode;
}, "title" | "info" | "warning" | "contextType" | "onChange" | "isHidden" | "item" | "screenId" | "availableColumns" | "nestedFields" | "nodeTypes" | "isTitleHidden" | "isDisabled" | "isReadOnly" | "contextNode" | "level" | "parentElementId" | "canSelect" | "headerLabel" | "validationErrors" | "validate" | "browser" | "recordValue" | "isSelected" | "additionalTestId" | "actionPopoverItems" | "baseClassName" | "hideValidationSummary" | "isCloseIconDisplayed" | "noMargin" | "onActionPopoverOpen" | "onBlockClick" | "onBlockRemoved" | "onBlockSelectionChange" | "readOnlyOverride">) & ConnectedNestedBlockProps>;
//# sourceMappingURL=nested-block.d.ts.map