import { COLUMN_ID_ROW_ACTIONS, COLUMN_ID_ROW_SELECTION } from '../../../../utils/ag-grid/ag-grid-column-config';
import { SHIFT_TAB } from '../../../../utils/keyboard-event-utils';
export const LOOKUP_DIALOG_INTERACTION = 'LookupDialogInteraction';
export const manageOnBlurFocus = (isSelecting, api, column, rowIndex, rowPinned, stopEditing, endAction) => {
    if (isSelecting) {
        return;
    }
    if (endAction === undefined) {
        stopEditing();
        return;
    }
    if (endAction === LOOKUP_DIALOG_INTERACTION) {
        api.stopEditing();
        setTimeout(() => {
            api.setFocusedCell(rowIndex, column, rowPinned || undefined);
        }, 50);
        return;
    }
    const currentCell = {
        column,
        rowIndex,
        rowPinned,
    };
    const navigationService = api.navigationService;
    const nextFocusedCell = navigationService.findNextCellToFocusOn(currentCell, endAction === SHIFT_TAB, true);
    const nextFocusableNonEditableCell = navigationService.findNextCellToFocusOn(currentCell, endAction === SHIFT_TAB, false);
    if (!nextFocusedCell?.column) {
        stopEditing();
        return;
    }
    let nextFocusedCellRowIndex = nextFocusedCell.getRowNode().rowIndex;
    let nextFocusedCellColKey = nextFocusedCell.column.getColId();
    // If the previous field is a select checkbox, AG-Grid doesn't detect it to be editable and keeps the focus on the current column
    if (nextFocusableNonEditableCell?.column &&
        nextFocusedCellColKey === column.getColId() &&
        nextFocusedCellRowIndex === rowIndex &&
        [COLUMN_ID_ROW_ACTIONS, COLUMN_ID_ROW_SELECTION].includes(nextFocusableNonEditableCell.column.getColId())) {
        nextFocusedCellRowIndex = nextFocusableNonEditableCell.getRowNode().rowIndex;
        nextFocusedCellColKey = nextFocusableNonEditableCell.column.getColId();
    }
    api.setFocusedCell(nextFocusedCellRowIndex, nextFocusedCellColKey, rowPinned || undefined);
    // MC: timeout needed otherwise ag-grid can throw an exception
    setTimeout(() => api.startEditingCell({
        colKey: nextFocusedCellColKey,
        rowIndex: nextFocusedCellRowIndex,
        key: 'Enter',
        rowPinned: rowPinned || undefined,
    }), 50);
};
//# sourceMappingURL=cell-editor-utils.js.map