import React from 'react';
import { TableTooltip } from '../../tooltip/tooltip';
import { getTooltipMessage } from '../../../../utils/ag-grid/ag-grid-column-config';
import { AUTO_COLUMN_ID } from '../../../../utils/table-component-utils';
export function CellWrapper({ children, textAlign = 'left', ...props }) {
    if (!props.isTree && props.data && props.data.__isGroup && props.colDef.colId !== AUTO_COLUMN_ID) {
        // group row, but not group column => value should be empty
        return null;
    }
    if (!props.isTree &&
        props.data &&
        !props.data.__isGroup &&
        props.colDef.colId === AUTO_COLUMN_ID &&
        (!props.data.__aggFunc || props.data.__aggFunc === 'day')) {
        // child rows should have an empty group column
        return null;
    }
    const message = getTooltipMessage(props);
    const hasTooltip = message !== undefined && message !== null;
    return (React.createElement("div", { className: "e-grid-error-indicator", style: {
            ...(hasTooltip && {
                display: 'flex',
                alignItems: 'center',
                justifyContent: 'space-between',
                border: '1px solid #C8384F',
            }),
            padding: textAlign === 'left' ? '0 0 0 11px' : textAlign === 'right' ? '0 11px 0 0' : '0 11px',
            textAlign,
        } },
        React.createElement("div", { style: {
                display: 'flex',
                flexDirection: 'column',
                justifyContent: 'center',
                height: '100%',
                ...(textAlign === 'right' && { order: 1 }),
            } },
            React.createElement("div", { style: {
                    minWidth: 0,
                    overflow: 'hidden',
                    textOverflow: 'ellipsis',
                    whiteSpace: 'nowrap',
                } }, children)),
        hasTooltip && React.createElement(TableTooltip, { content: message })));
}
//# sourceMappingURL=cell-wrapper.js.map