import * as React from 'react';
import type { Filter } from '../../../service/filter-service';
import type { ValidationResult } from '../../../service/screen-base-definition';
import type { OptionsMenuItem } from '../../container/page/page-types';
import type { InternalNestedGridProperties } from '../../field/nested-grid/nested-grid-control-object';
import type { InternalTableProperties, TableViewMode } from '../../field/table/table-component-types';
import type { CalendarView } from '../calendar-body/calendar-body-types';
import type { FilterManagerField } from '../filter/filter-manager';
export interface DesktopTableHeaderProps {
    columnPanelDisabled?: boolean;
    elementId: string;
    fieldProperties: InternalTableProperties | InternalNestedGridProperties;
    filterComponentFields?: FilterManagerField[];
    filtersComponentFilters?: Filter[];
    filterText?: string;
    hasCalendarView?: boolean;
    hasData?: boolean;
    hasFloatingFilters?: boolean;
    hasSearchBox?: boolean;
    isDisabled: boolean;
    isReadOnly: boolean;
    onSwitchView?: (view: TableViewMode) => void;
    onSwitchCalendarView?: (calendarView: CalendarView) => void;
    onExport?: (target: 'csv' | 'excel') => void;
    onFilterByErrors?: () => void;
    onFiltersComponentChanged?: (filters: Filter[]) => Promise<void>;
    onFocusPhantomRow?: () => void;
    onOptionsMenuItemChange?: (newOptionItem: OptionsMenuItem) => void;
    onSearchBoxValueChange?: (textValue: string) => void;
    /** Callback that is called when the toggle filter button is clicked. If undefined, the toggle button is not rendered. */
    onToggleFilters?: () => void;
    /** Callback that is called when the column settings button is clicked. If undefined, the column settings button is not rendered. */
    onOpenColumnPanel?: () => void;
    onUnsetFilterByErrors?: () => void;
    screenId: string;
    selectedCalendarView?: CalendarView;
    selectedOptionsMenuItem?: OptionsMenuItem;
    tableViewMode?: TableViewMode;
    validationErrors: ValidationResult[];
}
/**
 * This component contains the header functionality for the desktop table and nested grids. The functionality of these two components is very similar.
 * It contains the field action buttons, export button, business header actions, options menu, validation errors and the field title label.
 */
export declare const DesktopTableHeaderComponent: React.FC<DesktopTableHeaderProps>;
//# sourceMappingURL=desktop-table-header.d.ts.map