import * as React from 'react';
import type { CollectionValue } from '../../../../service/collection-data-service';
import type { NestedRecordId } from '../../../../types';
import type { XtremActionPopoverItem } from '../../xtrem-action-popover';
import type { ErrorHandlerFunction } from '../../../field/traits';
import type { CollectionPropertiesWithActions } from './table-dropdown-action-types';
import type { MenuSeparatorType } from '../../../control-objects';
import type { AccessBindings } from '../../../../service/page-definition';
export interface TableDropdownActionExternalProps {
    fieldId: string;
    isDisabled?: boolean;
    isPhantomRow?: boolean;
    phantomRowIsDirty?: boolean;
    level: number;
    recordId: NestedRecordId;
    screenId: string;
}
export interface TableDropdownActionProps extends TableDropdownActionExternalProps {
    fieldProperties: CollectionPropertiesWithActions;
    tableData: CollectionValue;
    accessBindings: AccessBindings;
    rowValue: any;
}
export declare class TableDropdownActions extends React.Component<TableDropdownActionProps> {
    isNestedGrid: () => boolean;
    calculateMenu: () => Array<XtremActionPopoverItem | MenuSeparatorType>;
    onClickMenu: (onClick?: ((this: any, recordId: string, rowItem: any, level?: number, parentIds?: string[]) => void) | undefined, onError?: ErrorHandlerFunction<any>) => void;
    renderPhantomRowRemoveButton(phantomRowIsDirty: boolean): React.ReactNode;
    render(): React.ReactNode;
}
declare const _default: import("react-redux").ConnectedComponent<typeof TableDropdownActions, import("react-redux").Omit<React.ClassAttributes<TableDropdownActions> & TableDropdownActionProps, "screenId" | "isDisabled" | "fieldId" | "fieldProperties" | "level" | "recordId" | "rowValue" | "accessBindings" | "isPhantomRow" | "tableData" | "phantomRowIsDirty"> & TableDropdownActionExternalProps>;
export default _default;
//# sourceMappingURL=table-dropdown-actions.d.ts.map