import * as React from 'react';
import type { HasGenericErrorHandler, HasIcon } from '../field/traits';
import type { MenuSeparatorType } from '../control-objects';
export interface XtremActionPopoverItem extends HasIcon, HasGenericErrorHandler<any> {
    key: string;
    title: string;
    onClick: () => void;
    isDisabled?: boolean;
    isHidden?: boolean;
    isDestructive?: boolean;
    testId?: string;
    childrenProp?: Array<XtremActionPopoverItem | MenuSeparatorType>;
}
export interface XtremActionPopoverExternalProps {
    items: Array<XtremActionPopoverItem | MenuSeparatorType>;
    onOpen?: () => void;
    isDisabled?: boolean;
    noIconSupport?: boolean;
    color?: string;
}
export interface XtremActionPopoverProps extends XtremActionPopoverExternalProps {
    isDeviceLessThanSmall: boolean;
}
export interface XtremActionPopoverState {
    isOpen: boolean;
}
export declare class XtremActionPopover extends React.Component<XtremActionPopoverProps, XtremActionPopoverState> {
    constructor(props: XtremActionPopoverProps);
    componentWillUnmount(): void;
    private readonly getVisibleMenuItems;
    private readonly onRecordClick;
    getMobileActionButton(): React.ReactNode;
    private readonly getSingleActionIconButton;
    private readonly createActionPopoverChildren;
    private readonly createActionPopoverChildrenMobile;
    private readonly toggleMobileMenu;
    private readonly itemHasNoIcon;
    renderDesktop(): React.ReactNode;
    renderMobile(): React.ReactNode;
    render(): React.ReactNode;
}
declare const _default: import("react-redux").ConnectedComponent<typeof XtremActionPopover, import("react-redux").Omit<React.ClassAttributes<XtremActionPopover> & XtremActionPopoverProps, "color" | "isDisabled" | "onOpen" | "items" | "isDeviceLessThanSmall" | "noIconSupport"> & XtremActionPopoverExternalProps>;
export default _default;
//# sourceMappingURL=xtrem-action-popover.d.ts.map