import * as React from 'react';
import { Select, Option } from 'carbon-react/esm/components/select';
import { useQueryTableCellPropertyCommand } from './use-table-cell-property-command';
import { BORDER_STYLE } from '../constants';
import { GridColumn } from '@sage/xtrem-ui-components';
export function BorderStyleSelect({ title, editor, commandName, tableUtilsPluginConstructor, isEnabled, }) {
    const { value, onChange } = useQueryTableCellPropertyCommand({
        commandName,
        editor,
        tableUtilsPluginConstructor,
    });
    const onSelectChange = React.useCallback((event) => {
        onChange(event.target.value);
    }, [onChange]);
    if (!isEnabled || !editor) {
        return null;
    }
    return (React.createElement(GridColumn, { columnSpan: 2 },
        React.createElement(Select, { name: commandName, label: title, value: value, onChange: onSelectChange }, BORDER_STYLE.map(c => (React.createElement(Option, { key: c, value: c, text: c },
            c,
            React.createElement("span", { className: "document-editor-border-style-preview", style: {
                    borderTopStyle: c,
                } })))))));
}
//# sourceMappingURL=border-style-select.js.map