import * as React from 'react';
import type { Dashboard, Dict, Locale } from '@sage/xtrem-shared';
import type { WidgetDefinition } from './widgets/abstract-widget';
export interface DashboardComponentProps {
    cloneDashboard: (dashboardId: string) => Promise<void>;
    dashboardDefinition?: Dashboard;
    deleteDashboard: (dashboardId: string) => Promise<void>;
    fetchUserDashboardDefinition: () => void;
    globalLoading: boolean;
    hasInstalledPackagesLoaded: boolean;
    loadingDashboards: boolean;
    locale: Locale;
    openDashboardEditorDialog: () => void;
    widgets: Dict<WidgetDefinition>;
}
type DIALOG_MODE_OBJ = {
    CREATE_DASHBOARD: 'CREATE_DASHBOARD';
    EDIT_DASHBOARD: 'EDIT_DASHBOARD';
    NONE: 'NONE';
};
export type DIALOG_MODE = DIALOG_MODE_OBJ[keyof DIALOG_MODE_OBJ];
export interface DashboardComponentState {
    dialogMode: DIALOG_MODE;
    startedFetching: boolean;
    verticalSpaceReady: boolean;
}
export declare class DashboardComponent extends React.Component<DashboardComponentProps, DashboardComponentState> {
    constructor(props: DashboardComponentProps);
    componentDidMount(): void;
    componentDidUpdate(): void;
    private readonly fetchDashboards;
    private readonly onCreateDialogOpen;
    private readonly onCreateDialogClose;
    private readonly onDeleteDashboard;
    private readonly onDuplicateDashboard;
    private readonly renderNoDashboards;
    private readonly renderEmptyDashboard;
    private readonly renderKebabMenu;
    private readonly getWidgets;
    private readonly renderDashboard;
    render(): React.ReactNode;
}
export declare const ConnectedDashboardComponent: import("react-redux").ConnectedComponent<typeof DashboardComponent, import("react-redux").Omit<React.ClassAttributes<DashboardComponent> & DashboardComponentProps, "locale" | "widgets" | "cloneDashboard" | "dashboardDefinition" | "deleteDashboard" | "fetchUserDashboardDefinition" | "globalLoading" | "hasInstalledPackagesLoaded" | "loadingDashboards" | "openDashboardEditorDialog">>;
export {};
//# sourceMappingURL=dashboard-component.d.ts.map