import * as React from 'react';
import type { Dashboard, Dict, Locale } from '@sage/xtrem-shared';
import type { WidgetDefinition } from './widgets/abstract-widget';
import type { WidgetPosition } from '../redux/actions/dashboard-editor-actions';
export interface DashboardEditorDialogProps {
    currentDashboardDefinition: Dashboard;
    dashboardDefinition: Dashboard;
    isDirty: boolean;
    isNavigationPanelOpened: boolean;
    isOpen?: boolean;
    isRedoDisabled: boolean;
    isUndoDisabled: boolean;
    loadingDashboards: boolean;
    locale: Locale;
    onClose: () => void;
    redoDashboardEditor: () => void;
    removeDashboardEditorWidget: (widgetId: string) => void;
    saveDashboardEditorState: () => Promise<void>;
    setNavigationPanelIsOpened: (newState: boolean) => void;
    undoDashboardEditor: () => void;
    updateDashboardEditorWidgetPositions: (widgets: WidgetPosition[]) => void;
    updateDashboardTitleInEditor: (newTitle: string) => void;
    widgets: Dict<WidgetDefinition>;
}
export declare function DashboardEditorDialog({ currentDashboardDefinition, dashboardDefinition, isDirty, isNavigationPanelOpened, isOpen, isRedoDisabled, isUndoDisabled, loadingDashboards, locale, onClose, redoDashboardEditor, removeDashboardEditorWidget, saveDashboardEditorState, setNavigationPanelIsOpened, undoDashboardEditor, updateDashboardEditorWidgetPositions, updateDashboardTitleInEditor, widgets, }: DashboardEditorDialogProps): React.ReactElement;
export declare const ConnectedDashboardEditorDialog: import("react-redux").ConnectedComponent<typeof DashboardEditorDialog, import("react-redux").Omit<DashboardEditorDialogProps, "locale" | "widgets" | "dashboardDefinition" | "loadingDashboards" | "onClose" | "isOpen" | "isNavigationPanelOpened" | "isDirty" | "currentDashboardDefinition" | "isRedoDisabled" | "isUndoDisabled" | "redoDashboardEditor" | "removeDashboardEditorWidget" | "saveDashboardEditorState" | "setNavigationPanelIsOpened" | "undoDashboardEditor" | "updateDashboardEditorWidgetPositions" | "updateDashboardTitleInEditor">>;
//# sourceMappingURL=dashboard-editor-dialog.d.ts.map