import type * as VP from '@sage/visual-process-editor';
import { BatchRequest, edgesSelector, ClientNode } from '@sage/xtrem-client';
import * as charts from './component/chart-types';
import * as containerProperties from './component/container/container-properties';
import { containers, fields, MENU_SEPARATOR, PageAction } from './component/control-objects';
import * as decoratorProperties from './component/decorator-properties';
import * as decorators from './component/decorators';
import * as fieldProperties from './component/field/field-properties';
import * as nestedFields from './component/nested-fields';
import * as nestedFieldExtensions from './component/nested-fields-extensions';
import * as nestedFieldOverrides from './component/nested-fields-overrides';
import type { PartialCollectionValueWithIds, PartialCollectionValue, PageCategory, FieldDecoratorProps } from './component/types';
import { ContainerKey, FieldKey } from './component/types';
import * as integration from './integration';
import * as plugin from './plugin';
import { localize, localizeEnumMember, formatDateToCurrentLocale, formatNumberToCurrentLocale } from './service/i18n-service';
import { PageArticleItem, PageArticleLayout } from './service/layout-service';
import { Page } from './service/page';
import { PageExtension } from './service/page-extension';
import { ValidationResult } from './service/screen-base-definition';
import type { ToastOptions, ToastType } from './service/toast-service';
import { Sticker } from './service/sticker';
import { ScreenBaseGenericType as PageNode, PageWithAccessToNodes } from './types';
import * as dialogs from './types/dialogs';
import * as widgets from './dashboard/widgets';
import * as tokens from '@sage/design-tokens/js/base/common';
import { xtremConsole as console } from './utils/console';
import { StepSequenceStatus } from './component/field/step-sequence/step-sequence-types';
import type { QueryParameters } from './utils/types';
import { GraphQLApi, ReadOnlyGraphQLApi } from './service/graphql-api';
import { RichTextEditorCapabilities } from './component/field/rich-text/rich-text-types';
import { SidebarFieldDefinition } from './component/table-sidebar/table-sidebar-types';
import { SHOULD_REFRESH_DIALOG_RESULT, TUNNEL_SEGMENTS_QUERY_PARAM } from './utils/constants';
import type { ReadonlyFieldProperties } from './component/readonly-field-control-object';
import { fetchNodeDetails } from './service/node-information-service';
declare const queryUtils: {
    BatchRequest: typeof BatchRequest;
    edgesSelector: typeof edgesSelector;
    serializeToGraphQL: (input: any) => string;
};
type PartialNode<T> = PartialCollectionValue<T>;
type PartialNodeWithId<T> = PartialCollectionValueWithIds<T>;
export { charts, ClientNode, console, ContainerKey, containerProperties, containers, decoratorProperties, decorators, dialogs, fetchNodeDetails, FieldDecoratorProps, FieldKey, fieldProperties, fields, formatDateToCurrentLocale, formatNumberToCurrentLocale, GraphQLApi, integration, localize, localizeEnumMember, MENU_SEPARATOR, nestedFieldExtensions, nestedFieldOverrides, nestedFields, Page, PageAction, PageArticleItem, PageArticleLayout, PageCategory, PageExtension, PageNode, PageWithAccessToNodes, PartialCollectionValue, PartialNode, PartialNodeWithId, plugin, QueryParameters, queryUtils, ReadonlyFieldProperties, ReadOnlyGraphQLApi, RichTextEditorCapabilities, SHOULD_REFRESH_DIALOG_RESULT, SidebarFieldDefinition, StepSequenceStatus, Sticker, ToastOptions, ToastType, tokens, TUNNEL_SEGMENTS_QUERY_PARAM, ValidationResult, VP, widgets, };
//# sourceMappingURL=index.d.ts.map