"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readSerialNumberFromStockId = void 0;
const dialogs_1 = require("@sage/x3-master-data/lib/client-functions/dialogs");
const xtrem_client_1 = require("@sage/xtrem-client");
const ui = require("@sage/xtrem-ui");
async function readSerialNumberFromStockId(pageInstance, stockId, orderBy) {
    if (stockId) {
        try {
            const serialNumber = (0, xtrem_client_1.extractEdges)(await pageInstance.$.graph
                .node('@sage/x3-stock-data/SerialNumber')
                .query(ui.queryUtils.edgesSelector({
                code: true,
            }, {
                filter: { stockId },
                orderBy: { code: orderBy },
            }))
                .execute());
            if (serialNumber[0]) {
                return serialNumber[0];
            }
        }
        catch (e) {
            await (0, dialogs_1.dialogMessage)(pageInstance, 'error', ui.localize('@sage/x3-stock/error-loading-serial-number-node', 'Error loading serial number node'), String(e));
        }
    }
    return null;
}
exports.readSerialNumberFromStockId = readSerialNumberFromStockId;
//# sourceMappingURL=read-serial-number-from-stock-id.js.map