/// <reference types="node" />
import { Application } from '@sage/xtrem-core';
import { ExpressApp } from '@sage/xtrem-shared';
import { Express, Request } from 'express';
import * as http from 'http';
export { loggers } from './loggers';
export interface DeployedXtremApp {
    expressApp: Express;
    httpServer: http.Server;
    xtremApplication: Application;
}
export declare function startGraphQl(application: Application, expressApp: ExpressApp): void;
export declare function startGraphqlService(application: Application, expressApp: ExpressApp): void;
export interface RequestWithNonce extends Request {
    nonce?: string;
}
export declare class XtremExpress implements ExpressApp {
    #private;
    private readonly application;
    private readonly app;
    private readonly routes;
    constructor(application: Application);
    private get config();
    configureHelmetApp(): void;
    addRoutes(domain: string, resolve: (express: Express) => void): void;
    startExpressApp(port: number, app: Express, description: string, encrypt?: boolean): void;
    /** Starts the internal interop app on a different port (8340 by default) */
    startInternalEndpoint(): void;
    /** Starts the metrics scraping endpoint on a different port (8250 by default) */
    startMetricsEndpoint(): void;
    start(): Promise<DeployedXtremApp>;
}
//# sourceMappingURL=index.d.ts.map