"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomerInvoiceHeaderExtension = void 0;
const sageX3InvoicingData = require("@sage/x3-invoicing-data");
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const sageX3SalesData = require("..");
const joins = {
    referenceJoins: {
        invoiceType: {
            code: 'invoiceType',
            async legislation() {
                return (await (await this.company).legislation)?.code;
            },
        },
    },
};
let CustomerInvoiceHeaderExtension = class CustomerInvoiceHeaderExtension extends xtrem_core_1.NodeExtension {
};
exports.CustomerInvoiceHeaderExtension = CustomerInvoiceHeaderExtension;
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SIVTYP',
        columnType: 'string',
        node: () => sageX3SalesData.nodes.SalesInvoiceType,
    })
], CustomerInvoiceHeaderExtension.prototype, "invoiceType", void 0);
exports.CustomerInvoiceHeaderExtension = CustomerInvoiceHeaderExtension = __decorate([
    xtrem_core_1.decorators.nodeExtension({
        extends: () => sageX3InvoicingData.nodes.CustomerInvoiceHeader,
        externalStorageManagerExtension: new xtrem_x3_gateway_1.X3StorageManagerExtension({
            joins,
        }),
    })
], CustomerInvoiceHeaderExtension);
//# sourceMappingURL=customer-invoice-header-extension.js.map