"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericPrintReportExtension = void 0;
const sageX3System = require("@sage/x3-system");
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const joins = {};
let GenericPrintReportExtension = class GenericPrintReportExtension extends xtrem_core_1.NodeExtension {
    static printReport(context, parameters) {
        return xtrem_x3_gateway_1.X3StorageManager.executeApiOperation(context, 'SCRIPT', 'GenericPrintReport', 'printReport', parameters);
    }
};
exports.GenericPrintReportExtension = GenericPrintReportExtension;
__decorate([
    xtrem_core_1.decorators.mutation({
        /* RequestNodeName: PrintReport */
        isPublished: true,
        parameters: [
            {
                name: 'parameters',
                type: 'object',
                properties: {
                    reportName: {
                        isMandatory: true,
                        type: 'string',
                    },
                    language: {
                        isMandatory: true,
                        type: 'string',
                    },
                    destination: {
                        isMandatory: true,
                        type: 'string',
                    },
                    parametersNames: {
                        isMandatory: true,
                        type: 'array',
                        item: {
                            isMandatory: true,
                            type: 'string',
                        },
                    },
                    parametersValues: {
                        isMandatory: true,
                        type: 'array',
                        item: {
                            isMandatory: true,
                            type: 'string',
                        },
                    },
                    errorCode: {
                        isMandatory: true,
                        type: 'integer',
                    },
                },
            },
        ],
        return: {
            type: 'object',
            properties: {
                errorCode: {
                    isMandatory: true,
                    type: 'integer',
                },
            },
        },
    })
], GenericPrintReportExtension, "printReport", null);
exports.GenericPrintReportExtension = GenericPrintReportExtension = __decorate([
    xtrem_core_1.decorators.nodeExtension({
        extends: () => sageX3System.nodes.GenericPrintReport,
        externalStorageManagerExtension: new xtrem_x3_gateway_1.X3StorageManagerExtension({
            joins,
        }),
    })
], GenericPrintReportExtension);
//# sourceMappingURL=generic-print-report-extension.js.map