"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpenItemExtension = void 0;
const sageX3FinanceData = require("@sage/x3-finance-data");
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const sageX3Finance = require("..");
const joins = {
    referenceJoins: {
        statementNumber: {
            id: 'statementNumber',
        },
    },
};
let OpenItemExtension = class OpenItemExtension extends xtrem_core_1.NodeExtension {
};
exports.OpenItemExtension = OpenItemExtension;
__decorate([
    xtrem_core_1.decorators.enumProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'BPRTYP',
        dataType: () => sageX3Finance.enums.businessPartnerTypeDatatype,
    })
], OpenItemExtension.prototype, "businessPartnerType", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SOINUM',
        columnType: 'string',
        node: () => sageX3Finance.nodes.StatementCreation,
    })
], OpenItemExtension.prototype, "statementNumber", void 0);
exports.OpenItemExtension = OpenItemExtension = __decorate([
    xtrem_core_1.decorators.nodeExtension({
        extends: () => sageX3FinanceData.nodes.OpenItem,
        externalStorageManagerExtension: new xtrem_x3_gateway_1.X3StorageManagerExtension({
            joins,
        }),
    })
], OpenItemExtension);
//# sourceMappingURL=open-item-extension.js.map