"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductExtension = void 0;
const sageX3MasterData = require("@sage/x3-master-data");
const sageX3System = require("@sage/x3-system");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const sageX3StockData = require("..");
const xtrem_core_1 = require("@sage/xtrem-core");
const joins = {};
let ProductExtension = class ProductExtension extends xtrem_core_1.NodeExtension {
};
exports.ProductExtension = ProductExtension;
__decorate([
    xtrem_core_1.decorators.enumProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'STOMGTCOD',
        dataType: () => sageX3MasterData.enums.stockManagementDatatype,
    })
], ProductExtension.prototype, "stockManagementMode", void 0);
__decorate([
    xtrem_core_1.decorators.enumProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'LOTMGTCOD',
        dataType: () => sageX3StockData.enums.lotManagementModeDatatype,
    })
], ProductExtension.prototype, "lotManagementMode", void 0);
__decorate([
    xtrem_core_1.decorators.enumProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'BRDCOD',
        dataType: () => sageX3StockData.enums.materialCostGroupDatatype,
    })
], ProductExtension.prototype, "materialCostGroup", void 0);
__decorate([
    xtrem_core_1.decorators.enumProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'TRKCOD',
        dataType: () => sageX3StockData.enums.traceabilityManagementModeDatatype,
    })
], ProductExtension.prototype, "traceabilityManagementMode", void 0);
__decorate([
    xtrem_core_1.decorators.enumProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'TRKLEV',
        dataType: () => sageX3StockData.enums.traceabilityLevelDatatype,
    })
], ProductExtension.prototype, "traceabilityLevel", void 0);
__decorate([
    xtrem_core_1.decorators.enumProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SHLUOM',
        dataType: () => sageX3StockData.enums.expirationLeadTimeUnitsDatatype,
    })
], ProductExtension.prototype, "expirationTimeUnit", void 0);
__decorate([
    xtrem_core_1.decorators.enumProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SHLLTIUOM',
        dataType: () => sageX3StockData.enums.expirationLeadTimeUnitsDatatype,
    })
], ProductExtension.prototype, "recontrolTimeUnit", void 0);
__decorate([
    xtrem_core_1.decorators.enumProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'ECCSTO',
        dataType: () => sageX3StockData.enums.stockVersionModeDatatype,
        serviceOptions: () => [sageX3System.serviceOptions.EccActivityCode],
    })
], ProductExtension.prototype, "stockVersionMode", void 0);
exports.ProductExtension = ProductExtension = __decorate([
    xtrem_core_1.decorators.nodeExtension({
        extends: () => sageX3MasterData.nodes.Product,
        externalStorageManagerExtension: new xtrem_x3_gateway_1.X3StorageManagerExtension({
            joins,
        }),
    })
], ProductExtension);
//# sourceMappingURL=product-extension.js.map