"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PurchaseOrderQuantityLineExtension = void 0;
const sageX3Purchasing = require("@sage/x3-purchasing");
const sageX3Sales = require("@sage/x3-sales");
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const joins = {
    referenceJoins: {
        salesOrder: {
            id: 'salesOrder',
        },
        salesOrderLine: {
            salesOrder: 'salesOrder',
            lineNumber: 'salesOrderLine',
            sequenceNumber: 'salesOrderSequenceNumber',
        },
        salesDelivery: {
            id: 'salesDelivery',
        },
        salesDeliveryLine: {
            salesDelivery: 'salesDelivery',
            lineNumber: 'salesDeliveryLine',
        },
    },
};
let PurchaseOrderQuantityLineExtension = class PurchaseOrderQuantityLineExtension extends xtrem_core_1.NodeExtension {
};
exports.PurchaseOrderQuantityLineExtension = PurchaseOrderQuantityLineExtension;
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SOHNUM',
        columnType: 'string',
        node: () => sageX3Sales.nodes.SalesOrder,
    })
], PurchaseOrderQuantityLineExtension.prototype, "salesOrder", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SOPLIN',
        columnType: 'integer',
        node: () => sageX3Sales.nodes.SalesOrderLine,
    })
], PurchaseOrderQuantityLineExtension.prototype, "salesOrderLine", void 0);
__decorate([
    xtrem_core_1.decorators.integerProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SOQSEQ',
    })
], PurchaseOrderQuantityLineExtension.prototype, "salesOrderSequenceNumber", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SDHNUM',
        columnType: 'string',
        node: () => sageX3Sales.nodes.SalesDelivery,
    })
], PurchaseOrderQuantityLineExtension.prototype, "salesDelivery", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SDDLIN',
        columnType: 'integer',
        node: () => sageX3Sales.nodes.SalesDeliveryLine,
    })
], PurchaseOrderQuantityLineExtension.prototype, "salesDeliveryLine", void 0);
exports.PurchaseOrderQuantityLineExtension = PurchaseOrderQuantityLineExtension = __decorate([
    xtrem_core_1.decorators.nodeExtension({
        extends: () => sageX3Purchasing.nodes.PurchaseOrderQuantityLine,
        externalStorageManagerExtension: new xtrem_x3_gateway_1.X3StorageManagerExtension({
            joins,
        }),
    })
], PurchaseOrderQuantityLineExtension);
//# sourceMappingURL=purchase-order-quantity-line-extension.js.map