"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaleableProductExtension = void 0;
const sageX3ProjectManagement = require("@sage/x3-project-management");
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const sageX3SalesProjectManagement = require("..");
const joins = {
    referenceJoins: {
        salesDocument: {
            id: 'salesDocument',
        },
        salesDocumentLine: {
            projectDocument: 'salesDocument',
            lineNumber: 'salesDocumentLine',
        },
    },
};
let SaleableProductExtension = class SaleableProductExtension extends xtrem_core_1.NodeExtension {
};
exports.SaleableProductExtension = SaleableProductExtension;
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'PSONUM',
        columnType: 'string',
        node: () => sageX3SalesProjectManagement.nodes.SalesDocument,
    })
], SaleableProductExtension.prototype, "salesDocument", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'PSOLIN',
        columnType: 'integer',
        node: () => sageX3SalesProjectManagement.nodes.SalesDocumentLine,
    })
], SaleableProductExtension.prototype, "salesDocumentLine", void 0);
exports.SaleableProductExtension = SaleableProductExtension = __decorate([
    xtrem_core_1.decorators.nodeExtension({
        extends: () => sageX3ProjectManagement.nodes.SaleableProduct,
        externalStorageManagerExtension: new xtrem_x3_gateway_1.X3StorageManagerExtension({
            joins,
        }),
    })
], SaleableProductExtension);
//# sourceMappingURL=saleable-product-extension.js.map