import * as sageX3FinanceData from '@sage/x3-finance-data';
import * as sageX3MasterData from '@sage/x3-master-data';
import * as sageX3System from '@sage/x3-system';
import { Node, Reference, integer, Collection } from '@sage/xtrem-core';
import * as sageX3Finance from '..';
export declare class AnalyticalBalance extends Node {
    readonly ledgerTypeNumber: Promise<sageX3MasterData.enums.GeneralLedgerTypes>;
    readonly company: Reference<sageX3System.nodes.Company>;
    readonly site: Reference<sageX3System.nodes.Site>;
    readonly fiscalYear: Promise<integer | null>;
    readonly account: Reference<sageX3FinanceData.nodes.Account | null>;
    readonly businessPartner: Reference<sageX3MasterData.nodes.BusinessPartner | null>;
    readonly dimension1: Promise<string>;
    readonly dimension2: Promise<string>;
    readonly dimension3: Promise<string>;
    readonly dimension4: Promise<string>;
    readonly dimension5: Promise<string>;
    readonly dimension6: Promise<string>;
    readonly dimension7: Promise<string>;
    readonly dimension8: Promise<string>;
    readonly dimension9: Promise<string>;
    readonly currency: Reference<sageX3MasterData.nodes.Currency>;
    readonly id: Promise<integer | null>;
    readonly ledger: Reference<sageX3FinanceData.nodes.Ledger>;
    readonly chartOfAccounts: Reference<sageX3FinanceData.nodes.ChartOfAccounts | null>;
    readonly ledgerCurrency: Reference<sageX3MasterData.nodes.Currency | null>;
    readonly amounts: Collection<sageX3Finance.nodes.AnalyticalBalanceAmounts>;
    readonly dimensionTypes: Collection<sageX3Finance.nodes.AnalyticalBalanceDimensionTypes>;
}
//# sourceMappingURL=analytical-balance.d.ts.map