import * as sageX3System from '@sage/x3-system';
import { Node, Reference, date, decimal, integer, Collection } from '@sage/xtrem-core';
import * as sageX3MasterData from '..';
export declare class BomHeader extends Node {
    readonly parentProduct: Reference<sageX3MasterData.nodes.Product>;
    readonly bomCode: Reference<sageX3MasterData.nodes.BomCodes>;
    readonly bomType: Promise<sageX3MasterData.enums.BomCodeType | null>;
    readonly description: Promise<string>;
    readonly useStatus: Promise<sageX3MasterData.enums.UseStatus | null>;
    readonly isPrototype: Promise<boolean>;
    readonly validityStartDate: Promise<date | null>;
    readonly validityEndDate: Promise<date | null>;
    readonly reviewLevel: Promise<string>;
    readonly baseQuantity: Promise<decimal | null>;
    readonly managementUnit: Promise<sageX3MasterData.enums.ManagementUnit | null>;
    readonly headerText: Promise<string>;
    readonly journalNumberConfig: Promise<string>;
    readonly accessCode: Reference<sageX3System.nodes.Access | null>;
    readonly exportNumber: Promise<integer | null>;
    readonly linkedDocuments: Promise<string>;
    readonly details: Collection<sageX3MasterData.nodes.BomDetail>;
}
//# sourceMappingURL=bom-header.d.ts.map