"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomerCashTaxRules = void 0;
const sageX3System = require("@sage/x3-system");
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const sageXtremX3SystemUtils = require("@sage/xtrem-x3-system-utils");
const sageX3MasterData = require("..");
const denormalized = { maxRepeat: 9 };
const joins = {
    referenceJoins: {
        _denormalizedParent: {
            code: 'code',
        },
    },
};
let CustomerCashTaxRules = class CustomerCashTaxRules extends xtrem_core_1.Node {
};
exports.CustomerCashTaxRules = CustomerCashTaxRules;
__decorate([
    xtrem_core_1.decorators.integerProperty({
        isPublished: true,
    })
], CustomerCashTaxRules.prototype, "denormalizedIndex", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        isPublished: true,
        isStored: true,
        isNotEmpty: true,
        columnName: 'BPCNUM',
        dataType: () => sageXtremX3SystemUtils.datatypes.genericDataTypes.textDatatype,
    })
], CustomerCashTaxRules.prototype, "code", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isStored: true,
        isVitalParent: true,
        columnType: 'string',
        node: () => sageX3MasterData.nodes.Customer,
    })
], CustomerCashTaxRules.prototype, "_denormalizedParent", void 0);
__decorate([
    xtrem_core_1.decorators.booleanProperty({
        isPublished: true,
        isStored: true,
        columnName: 'CSHVATRGM',
        serviceOptions: () => [sageX3System.serviceOptions.KpoActivityCode],
    })
], CustomerCashTaxRules.prototype, "isActive", void 0);
__decorate([
    xtrem_core_1.decorators.dateProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'VATSTRDAT',
        serviceOptions: () => [sageX3System.serviceOptions.KpoActivityCode],
    })
], CustomerCashTaxRules.prototype, "startDate", void 0);
__decorate([
    xtrem_core_1.decorators.dateProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'VATENDDAT',
        serviceOptions: () => [sageX3System.serviceOptions.KpoActivityCode],
    })
], CustomerCashTaxRules.prototype, "endDate", void 0);
exports.CustomerCashTaxRules = CustomerCashTaxRules = __decorate([
    xtrem_core_1.decorators.node({
        storage: 'external',
        tableName: 'BPCUSTOMER',
        keyPropertyNames: ['denormalizedIndex', 'code'],
        indexes: [],
        externalStorageManager: new xtrem_x3_gateway_1.X3StorageManager({
            joins,
            isDenormalized: true,
            denormalized,
        }),
        isPublished: true,
        canRead: true,
        canSearch: true,
        isVitalCollectionChild: true,
    })
], CustomerCashTaxRules);
//# sourceMappingURL=customer-cash-tax-rules.js.map