import { Node, Reference, decimal, integer } from '@sage/xtrem-core';
import * as sageX3MasterData from '..';
export declare class CustomerProduct extends Node {
    readonly product: Reference<sageX3MasterData.nodes.Product>;
    readonly customer: Reference<sageX3MasterData.nodes.BusinessPartner>;
    readonly isActive: Promise<boolean>;
    readonly customerProduct: Promise<string>;
    readonly customerProductDescription: Promise<string>;
    readonly hasSalesText: Promise<string>;
    readonly hasPickingText: Promise<string>;
    readonly salesUnit: Reference<sageX3MasterData.nodes.UnitOfMeasure>;
    readonly salesUnitToStockUnitConversion: Promise<decimal | null>;
    readonly packagingCapacity: Promise<decimal | null>;
    readonly packingUnit1: Reference<sageX3MasterData.nodes.UnitOfMeasure | null>;
    readonly packingUnit1ToSalesUnitConversion: Promise<decimal | null>;
    readonly packingUnit2: Reference<sageX3MasterData.nodes.UnitOfMeasure | null>;
    readonly packingUnit2ToSalesUnitConversion: Promise<decimal | null>;
    readonly customerUseByDateCoefficient: Promise<decimal | null>;
    readonly journalNumberConfigurator: Promise<string>;
    readonly exportNumber: Promise<integer | null>;
    readonly isVersionPreloaded: Promise<boolean>;
}
//# sourceMappingURL=customer-product.d.ts.map