import { Node, Reference, Context } from '@sage/xtrem-core';
import { DateValue } from '@sage/xtrem-date-time';
import * as sageX3System from '..';
export declare class GeneralParametersData extends Node {
    readonly code: Promise<string>;
    readonly company: Reference<sageX3System.nodes.Company | null>;
    readonly siteOrLegislationCode: Reference<sageX3System.nodes.Site | null>;
    readonly value: Promise<string>;
    readonly defaultSetOfValues: Reference<sageX3System.nodes.MiscellaneousTable | null>;
    static readParameterValueString(context: Context, parameters: {
        company: string;
        site: string;
        code: string;
    }): Promise<{
        value: string;
    }>;
    static readParameterValueDate(context: Context, parameters: {
        company: string;
        site: string;
        code: string;
    }): Promise<{
        value: DateValue;
    }>;
    static readParameterValueInteger(context: Context, parameters: {
        company: string;
        site: string;
        code: string;
    }): Promise<{
        value: number;
    }>;
}
//# sourceMappingURL=general-parameters-data.d.ts.map