"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShipToCustomerAddressCompanyNames = void 0;
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const sageXtremX3SystemUtils = require("@sage/xtrem-x3-system-utils");
const sageX3MasterData = require("..");
const denormalized = { maxRepeat: 2 };
const joins = {
    referenceJoins: {
        _denormalizedParent: {
            customer: 'customer',
            shipToAddress: 'shipToAddress',
        },
    },
};
let ShipToCustomerAddressCompanyNames = class ShipToCustomerAddressCompanyNames extends xtrem_core_1.Node {
};
exports.ShipToCustomerAddressCompanyNames = ShipToCustomerAddressCompanyNames;
__decorate([
    xtrem_core_1.decorators.integerProperty({
        isPublished: true,
    })
], ShipToCustomerAddressCompanyNames.prototype, "denormalizedIndex", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        isPublished: true,
        isStored: true,
        isNotEmpty: true,
        columnName: 'BPCNUM',
        dataType: () => sageXtremX3SystemUtils.datatypes.genericDataTypes.textDatatype,
    })
], ShipToCustomerAddressCompanyNames.prototype, "customer", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        isPublished: true,
        isStored: true,
        isNotEmpty: true,
        columnName: 'BPAADD',
        dataType: () => sageXtremX3SystemUtils.datatypes.genericDataTypes.textDatatype,
    })
], ShipToCustomerAddressCompanyNames.prototype, "shipToAddress", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isStored: true,
        isVitalParent: true,
        columnType: 'string',
        node: () => sageX3MasterData.nodes.ShipToCustomerAddress,
    })
], ShipToCustomerAddressCompanyNames.prototype, "_denormalizedParent", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        isPublished: true,
        isStored: true,
        columnName: 'BPDNAM',
        dataType: () => sageXtremX3SystemUtils.datatypes.genericDataTypes.textDatatype,
    })
], ShipToCustomerAddressCompanyNames.prototype, "companyName", void 0);
exports.ShipToCustomerAddressCompanyNames = ShipToCustomerAddressCompanyNames = __decorate([
    xtrem_core_1.decorators.node({
        storage: 'external',
        tableName: 'BPDLVCUST',
        keyPropertyNames: ['denormalizedIndex', 'customer', 'shipToAddress'],
        indexes: [],
        externalStorageManager: new xtrem_x3_gateway_1.X3StorageManager({
            joins,
            isDenormalized: true,
            denormalized,
        }),
        isPublished: true,
        canRead: true,
        canSearch: true,
        isVitalCollectionChild: true,
    })
], ShipToCustomerAddressCompanyNames);
//# sourceMappingURL=ship-to-customer-address-company-names.js.map