"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SysMiscellaneousTable = void 0;
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const x3SystemUtils = require("..");
const joins = {
    referenceJoins: {
        glossaryId: {
            glossaryId: 'glossaryId',
        },
        dependency: {
            glossaryId() {
                return 0;
            },
            code: 'dependency',
        },
        legislation: {
            glossaryId() {
                return 909;
            },
            code: 'legislation',
        },
    },
};
/** 4GL code: ATABDIV */
let SysMiscellaneousTable = class SysMiscellaneousTable extends xtrem_core_1.Node {
};
exports.SysMiscellaneousTable = SysMiscellaneousTable;
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        columnName: 'NUMTAB',
        isStored: true,
        columnType: 'integer',
        node: () => x3SystemUtils.nodes.SysMiscellaneousTables,
    })
], SysMiscellaneousTable.prototype, "glossaryId", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'CODE',
        isStored: true,
        isPublished: true,
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.textDatatype,
    })
], SysMiscellaneousTable.prototype, "code", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'LNGDES',
        isStored: true,
        isPublished: true,
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.translatableTextDatatype,
    })
], SysMiscellaneousTable.prototype, "description", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'SHODES',
        isStored: true,
        isPublished: true,
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.translatableTextDatatype,
    })
], SysMiscellaneousTable.prototype, "shortDescription", void 0);
__decorate([
    xtrem_core_1.decorators.booleanProperty({
        columnName: 'DEFVAL',
        isStored: true,
        isPublished: true,
        isNullable: true,
    })
], SysMiscellaneousTable.prototype, "defaultValue", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        columnName: 'DEPCOD',
        isStored: true,
        isPublished: true,
        columnType: 'string',
        node: () => SysMiscellaneousTable,
        isNullable: true,
    })
], SysMiscellaneousTable.prototype, "dependency", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'SOC',
        isStored: true,
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.textDatatype,
    })
], SysMiscellaneousTable.prototype, "groupOfCompany", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        columnName: 'LEG',
        isStored: true,
        columnType: 'string',
        node: () => x3SystemUtils.nodes.SysMiscellaneousTable,
        isNullable: true,
    })
], SysMiscellaneousTable.prototype, "legislation", void 0);
__decorate([
    xtrem_core_1.decorators.booleanProperty({
        columnName: 'ENAFLG',
        isStored: true,
        isNullable: true,
    })
], SysMiscellaneousTable.prototype, "activeFlag", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A1',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha1", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A2',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha2", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A3',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha3", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A4',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha4", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A5',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha5", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A6',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha6", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A7',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha7", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A8',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha8", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A9',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha9", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A10',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha10", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A11',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha11", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A12',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha12", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A13',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha13", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A14',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha14", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'A15',
        isStored: true,
        dataType: () => new xtrem_core_1.StringDataType({ maxLength: 40 }),
    })
], SysMiscellaneousTable.prototype, "alpha15", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N1',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric1", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N2',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric2", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N3',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric3", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N4',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric4", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N5',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric5", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N6',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric6", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N7',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric7", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N8',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric8", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N9',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric9", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N10',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric10", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N11',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric11", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N12',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric12", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N13',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric13", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N14',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric14", void 0);
__decorate([
    xtrem_core_1.decorators.decimalProperty({
        columnName: 'N15',
        isStored: true,
        dataType: () => new xtrem_core_1.DecimalDataType({ precision: 11, scale: 6 }),
    })
], SysMiscellaneousTable.prototype, "numeric15", void 0);
exports.SysMiscellaneousTable = SysMiscellaneousTable = __decorate([
    xtrem_core_1.decorators.node({
        tableName: 'ATABDIV',
        storage: 'external',
        externalStorageManager: new xtrem_x3_gateway_1.X3StorageManager({ joins }),
        keyPropertyNames: ['glossaryId', 'code'],
        canRead: true,
        indexes: [
            {
                orderBy: {
                    glossaryId: 1,
                    code: 1,
                },
                isUnique: true,
            },
        ],
    })
], SysMiscellaneousTable);
//# sourceMappingURL=sys-miscellaneous-table.js.map