"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SysMiscellaneousTablesColumns = void 0;
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const x3SystemUtils = require("..");
const sys_miscellaneous_tables_1 = require("./sys-miscellaneous-tables");
const denormalized = {
    minRepeat: 'zero',
    maxRepeat: 15,
};
const joins = {
    referenceJoins: {
        _denormalizedParent: {
            glossaryId: 'glossaryId',
        },
    },
    localizedStrings: {
        description1: {
            tableName: 'ATABTAB',
            columnName: 'COLDES',
            key1: ['glossaryId'],
            key2: ['denormalizedIndex'],
        },
    },
};
/** 4GL columnName: ATABTAB */
let SysMiscellaneousTablesColumns = class SysMiscellaneousTablesColumns extends xtrem_core_1.Node {
};
exports.SysMiscellaneousTablesColumns = SysMiscellaneousTablesColumns;
__decorate([
    xtrem_core_1.decorators.integerProperty({
        columnName: 'NUMTAB',
        isStored: true,
    })
], SysMiscellaneousTablesColumns.prototype, "glossaryId", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isStored: true,
        columnType: 'string',
        node: () => sys_miscellaneous_tables_1.SysMiscellaneousTables,
        isVitalParent: true,
    })
], SysMiscellaneousTablesColumns.prototype, "_denormalizedParent", void 0);
__decorate([
    xtrem_core_1.decorators.integerProperty({
        isPublished: true,
    })
], SysMiscellaneousTablesColumns.prototype, "denormalizedIndex", void 0);
__decorate([
    xtrem_core_1.decorators.enumProperty({
        columnName: 'COLTYPTYP',
        isStored: true,
        dataType: () => x3SystemUtils.enums.sysSequenceNumberTypeDataType,
        columnType: 'integer',
    })
], SysMiscellaneousTablesColumns.prototype, "columnType", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'COLDES',
        isStored: true,
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.translatableTextDatatype,
        columnType: 'string',
    })
], SysMiscellaneousTablesColumns.prototype, "description1", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'COLTYP',
        isStored: true,
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.textDatatype,
        columnType: 'string',
    })
], SysMiscellaneousTablesColumns.prototype, "dataType", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'COLSUP',
        isStored: true,
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.textDatatype,
        columnType: 'string',
    })
], SysMiscellaneousTablesColumns.prototype, "option", void 0);
exports.SysMiscellaneousTablesColumns = SysMiscellaneousTablesColumns = __decorate([
    xtrem_core_1.decorators.node({
        tableName: 'ATABTAB',
        storage: 'external',
        isPublished: true,
        canRead: true,
        canSearch: true,
        externalStorageManager: new xtrem_x3_gateway_1.X3StorageManager({ joins, isDenormalized: true, denormalized }),
        keyPropertyNames: ['glossaryId', 'denormalizedIndex'],
        isVitalCollectionChild: true,
    })
], SysMiscellaneousTablesColumns);
//# sourceMappingURL=sys-miscellaneous-tables-columns.js.map