"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SysSite = void 0;
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const x3SystemUtils = require("..");
const joins = {
    referenceJoins: {
        legalCompany: {
            code: 'legalCompany',
        },
    },
};
/** 4GL code: FACILITY */
let SysSite = class SysSite extends xtrem_core_1.Node {
};
exports.SysSite = SysSite;
__decorate([
    xtrem_core_1.decorators.stringProperty({
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.textDatatype,
        isNotEmpty: true,
        isStored: true,
        isPublished: true,
        columnName: 'FCY',
    })
], SysSite.prototype, "code", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.textDatatype,
        isStored: true,
        isPublished: true,
        columnName: 'FCYNAM',
    })
], SysSite.prototype, "name", void 0);
__decorate([
    xtrem_core_1.decorators.booleanProperty({
        isStored: true,
        isPublished: true,
        columnName: 'WRHFLG',
    })
], SysSite.prototype, "isStockSite", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        columnName: 'LEGCPY',
        isStored: true,
        columnType: 'string',
        node: () => x3SystemUtils.nodes.SysCompany,
        isPublished: true,
    })
], SysSite.prototype, "legalCompany", void 0);
exports.SysSite = SysSite = __decorate([
    xtrem_core_1.decorators.node({
        storage: 'external',
        tableName: 'FACILITY',
        keyPropertyNames: ['code'],
        externalStorageManager: new xtrem_x3_gateway_1.X3StorageManager({ joins }),
        isCached: true,
        canRead: true,
        canSearch: true,
        indexes: [
            {
                orderBy: {
                    code: 1,
                },
                isUnique: true,
            },
        ],
    })
], SysSite);
//# sourceMappingURL=sys-site.js.map