"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SysSyracusMethod = void 0;
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const x3SystemUtils = require("..");
const joins = {
    referenceJoins: {
        functionProfile: {
            profile: 'functionProfile',
        },
    },
};
/** 4GL code: ASYRMET */
let SysSyracusMethod = class SysSyracusMethod extends xtrem_core_1.Node {
};
exports.SysSyracusMethod = SysSyracusMethod;
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'CODMET',
        isStored: true,
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.textDatatype,
        isNotEmpty: true,
    })
], SysSyracusMethod.prototype, "profession", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'INTMET',
        isStored: true,
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.translatableTextDatatype,
    })
], SysSyracusMethod.prototype, "description", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        columnName: 'PRFFCT',
        isStored: true,
        node: () => x3SystemUtils.nodes.SysUserFunctionProfile,
        columnType: 'string',
    })
], SysSyracusMethod.prototype, "functionProfile", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        columnName: 'USRBI',
        isStored: true,
        serviceOptions: () => [x3SystemUtils.serviceOptions.sysBusinessIntelligenceActivityCode],
        dataType: () => x3SystemUtils.datatypes.genericDataTypes.textDatatype,
    })
], SysSyracusMethod.prototype, "biUserProfile", void 0);
exports.SysSyracusMethod = SysSyracusMethod = __decorate([
    xtrem_core_1.decorators.node({
        tableName: 'AMETUTI',
        storage: 'external',
        canRead: true,
        canSearch: true,
        externalStorageManager: new xtrem_x3_gateway_1.X3StorageManager({ joins }),
        keyPropertyNames: ['profession'],
        indexes: [
            {
                orderBy: {
                    profession: 1,
                },
                isUnique: true,
            },
        ],
    })
], SysSyracusMethod);
//# sourceMappingURL=sys-syracus-method.js.map