import { Product } from '@sage/x3-master-data-api';
import { GraphApi } from '@sage/x3-stock-api';
import { LotsSites, SerialNumber, Stock } from '@sage/x3-stock-data-api';
import { SupportServiceManagementGs1Page } from '@sage/x3-system/lib/client-functions/support-service-management-gs-1-page';
import * as ui from '@sage/xtrem-ui';
type packingUnit = {
    node: {
        unit: {
            code: string;
            numberOfDecimals: number;
        };
        packingUnitToStockUnitConversionFactor: string;
        isPackingFactorEntryAllowed: boolean;
    };
};
export declare class MobileInternalStockChangeDetails extends SupportServiceManagementGs1Page<GraphApi> {
    _packingUnits: packingUnit[];
    private _productSite;
    private _currentLine;
    private _currentOperation;
    private _stockChangeLines;
    private _selectedLocation;
    private _stockFieldSettings;
    private _stockSite;
    private _serialNumberManagementMode;
    private _selectedStockManagementRules;
    product: ui.fields.Reference<Product>;
    isLocationManaged: ui.fields.Checkbox;
    isLicensePlateNumberManaged: ui.fields.Checkbox;
    localizedDescription: ui.fields.Text;
    site: ui.fields.Text;
    nextButton: ui.PageAction;
    helperCancelButton: ui.PageAction;
    helperSelectButton: ui.PageAction;
    addSerialRange: ui.PageAction;
    mainSection: ui.containers.Section;
    detailPanelSection: ui.containers.Section;
    sectionHeader: ui.containers.Section;
    bodyBlock: ui.containers.Block;
    detailsBlock: ui.containers.Block;
    gridBlock: ui.containers.GridRowBlock;
    quantityBlock: ui.containers.Block;
    serialNumberBlock: ui.containers.Block;
    destinationBlock: ui.containers.Block;
    listSerialNumberBlock: ui.containers.Block;
    licensePlateNumber: ui.fields.Reference;
    location: ui.fields.Reference;
    lot: ui.fields.Reference<LotsSites>;
    sublot: ui.fields.Reference<LotsSites>;
    serialNumber: ui.fields.Reference<SerialNumber>;
    status: ui.fields.Select;
    packingUnit: ui.fields.Select;
    packingUnitToStockUnitConversionFactor: ui.fields.Numeric;
    identifier1: ui.fields.Text;
    identifier2: ui.fields.Text;
    stockCustomField1: ui.fields.Text;
    stockCustomField2: ui.fields.Text;
    stock: ui.fields.Table<Stock>;
    stockDetails: ui.fields.DetailList<Stock>;
    quantityToMove: ui.fields.Numeric;
    startingSerialNumber: ui.fields.Reference<SerialNumber>;
    endingSerialNumber: ui.fields.Text;
    locationDestination: ui.fields.Reference;
    statusDestination: ui.fields.Select;
    packingUnitDestination: ui.fields.Select;
    packingUnitToStockUnitConversionFactorDestination: ui.fields.Numeric;
    identifier1Destination: ui.fields.Text;
    identifier2Destination: ui.fields.Text;
    private _activeSelectButton;
    _stockId: ui.fields.Text;
    serialNumberLines: ui.fields.Table<any>;
    private _init;
    private _getSavedInputs;
    private _getProductSite;
    private _initSiteCodeField;
    private _initTechnicalProperties;
    private _onRowClick;
    private _fieldsManagement;
    private onChangeBody;
    private _lotManagement;
    private _initPackingUnitFields;
    private _miscellaneousFieldsManagement;
    private _serialNumberManagement;
    private _saveDetail;
    private _saveStockChange;
    private _getQuantityInPackingUnitOrigin;
    private _getquantityInPackingUnitRest;
    private _getStockChangeLine;
    private _getQuantityToMove;
    private _getLocationDestination;
    private _getPackingUnitToStockUnitConversionFactorDestination;
    private _getIdentifier1Destination;
    private _getIdentifier2Destination;
    private _getPackingUnitDestination;
    private _getStatusDestination;
    private _calculateEndingSerialNumber;
    private _getStockStatus;
    /**
     *
     * Technical composite data methods
     *
     */
    /**
     * Initialize ControlManagerGs1
     * @returns true when ControlManagerGs1 has usable
     */
    private _initControlManagerGs1;
}
export {};
//# sourceMappingURL=mobile-internal-stock-change-details.d.ts.map