import { GraphApi } from '@sage/x3-purchasing-api';
import { SupportServiceManagementGs1Page } from '@sage/x3-system/lib/client-functions/support-service-management-gs-1-page';
import * as ui from '@sage/xtrem-ui';
export declare const mobileApplicationGs1Key = "MobilePurchaseReceiptGs1Key";
export declare class MobilePurchaseReceipt extends SupportServiceManagementGs1Page<GraphApi> {
    private _purchaseReceiptRecordManager;
    private _purchaseSession;
    private _entryTransactionMap;
    private _productSearchCriteria1;
    private _productSearchCriteria2;
    private _purchaseShipment;
    private _purchaseShipmentLine;
    private _shipmentLines;
    private _purchaseShipmentIds;
    createButton: ui.PageAction;
    mainSection: ui.containers.Section;
    productBlock: ui.containers.Block;
    receiptBlock: ui.containers.Block;
    receiptDate: ui.fields.Date;
    stockSite: ui.fields.Label;
    transaction: ui.fields.DropdownList;
    legalCompany: ui.fields.Label;
    purchaseOrder: ui.fields.Reference;
    supplier: ui.fields.Reference;
    supplierPackingSlipLink: ui.fields.Link;
    supplierPackingSlip: ui.fields.Text;
    productSupplier: ui.fields.Reference;
    purchaseOrderLinesSupplier: ui.fields.Reference;
    receiptToCreate: ui.fields.Table<any>;
    /**
     *
     * Methods section
     *
     *
     */
    private _showWorkflowLayout;
    /**
     * Initialize ControlManagerGs1
     * @returns true when ControlManagerGs1 has usable
     */
    private _initControlManagerGs1;
    private goToDetailsPage;
    private _getLegalCompany;
    private _getEntryTransactionOptions;
    private _callCreationAPI;
    private _mapPurchaseReceipt;
    private _disablePage;
    private _getProductSearch;
    private _initTransaction;
    private _readShipmentLines;
    private _cleanShipmentLines;
}
//# sourceMappingURL=mobile-purchase-receipt.d.ts.map