"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceOption = void 0;
const lodash_1 = require("lodash");
const fsp = require("path");
class ServiceOption {
    #packageName;
    constructor(arg) {
        this.name = arg.name ?? (0, lodash_1.camelCase)(fsp.basename(arg.__filename, fsp.extname(arg.__filename)));
        this.code = arg.code;
        this.status = arg.status;
        this.description = arg.description;
        this.isSubscribable = !!arg.isSubscribable;
        this.isHidden = arg.isHidden;
        this.activates = arg.activates;
        this.isActiveByDefault = !!arg.isActiveByDefault;
    }
    setPackageName(name) {
        this.#packageName = name;
    }
    get packageName() {
        return this.#packageName;
    }
    getLocalizedTitleKey() {
        return `${this.packageName}/service_options__${(0, lodash_1.snakeCase)(this.name)}__name`;
    }
}
exports.ServiceOption = ServiceOption;
//# sourceMappingURL=service-option.js.map