import { GenericResolved, PropertyType } from '@sage/xtrem-ts-to-sql';
import { Property } from '../../properties';
import { Context, NodeFactory } from '../../runtime';
import { ConversionResult, OutputColumn, SqlConverter } from './sql-converter';
type Resolved = GenericResolved<NodeFactory, Property>;
export declare class SqlResolver {
    private static checkDateOrDatetimeType;
    private static dateAggregateFormats;
    private static castIfBoolean;
    private static aggregateSql;
    private static castFromJson;
    private static getNumericAggregateValueType;
    private static getAggregateValueType;
    static resolveAggregate(sqlConverter: SqlConverter, object: OutputColumn, name: string | undefined): OutputColumn;
    static makeColumnAlias(sql: string): string;
    static resolveCustomData(sqlConverter: SqlConverter, object: ConversionResult, name: string): Resolved;
    static resolveJson(sqlConverter: SqlConverter, object: ConversionResult, name: string): Resolved;
    static resolveRange(object: ConversionResult, name: string, type: PropertyType): Resolved;
    static resolveArray(object: ConversionResult, name: string, type: PropertyType): Resolved;
    static resolveTextStream(object: ConversionResult): Resolved;
    static resolve(sqlConverter: SqlConverter, context: Context, object: ConversionResult, name: string, rootFactory: NodeFactory): Resolved;
}
export {};
//# sourceMappingURL=sql-resolver.d.ts.map