// From file: /home/vsts/work/1/s/platform/back-end/xtrem-log/build/index.d.ts
declare module '@sage/xtrem-log/index' {
	export { clsContext, Colors, Logger, LogLevel, withClsContext } from '@sage/xtrem-log/lib/index';
	//# sourceMappingURL=index.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-log/build/lib/async-local-storage.d.ts
declare module '@sage/xtrem-log/lib/async-local-storage' {
	import { AsyncResponse } from '@sage/xtrem-shared';
	export type AnyValue = boolean | string | number | object | null | undefined | AnyValue[] | void;
	export function withClsContext<T extends AnyValue | void>(fn: () => AsyncResponse<T>, context: {}): Promise<T>;
	export function clsContext<T = any>(): T;
	//# sourceMappingURL=async-local-storage.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-log/build/lib/colors.d.ts
declare module '@sage/xtrem-log/lib/colors' {
	export abstract class Colors {
	    private static format;
	    static black(message: string): string;
	    static red(message: string): string;
	    static green(message: string): string;
	    static yellow(message: string): string;
	    static blue(message: string): string;
	    static magenta(message: string): string;
	    static cyan(message: string): string;
	    static white(message: string): string;
	    static lightGray(message: string): string;
	    static default(message: string): string;
	    static darkGray(message: string): string;
	    static lightRed(message: string): string;
	    static lightGreen(message: string): string;
	    static lightYellow(message: string): string;
	    static lightBlue(message: string): string;
	    static lightMagenta(message: string): string;
	    static lightCyan(message: string): string;
	    /** Removes all the color markers from a string */
	    static clean(message: string): string;
	}
	//# sourceMappingURL=colors.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-log/build/lib/console-transport.d.ts
declare module '@sage/xtrem-log/lib/console-transport' {
	export {};
	//# sourceMappingURL=console-transport.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-log/build/lib/index.d.ts
declare module '@sage/xtrem-log/lib/index' {
	export * from '@sage/xtrem-log/lib/async-local-storage';
	export * from '@sage/xtrem-log/lib/colors';
	export * from '@sage/xtrem-log/lib/logger';
	//# sourceMappingURL=index.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-log/build/lib/logger.d.ts
declare module '@sage/xtrem-log/lib/logger' {
	import { AnyValue, AsyncResponse, Config, LoggerErrorHandler, LoggerInterface, ProfilerCallback } from '@sage/xtrem-shared';
	export type MessageOrCallback = string | Error | (() => string | Error);
	export type MessageOrCallbackAsync = Promise<string | Error> | (() => string | Error | Promise<string | Error>);
	/** Default error handler for `logger.do`. Just rethrows */
	export const rethrow: LoggerErrorHandler<any>;
	/** We need a function for testability */
	export const getDate: () => Date;
	export class Logger implements LoggerInterface {
	    private readonly domain;
	    private static _globalLogger;
	    private static readonly _allLoggers;
	    private static readonly _allLoggersByDomain;
	    private static _nextEventId;
	    private static _startBannerDisplayed;
	    private static logsConfig;
	    private static _logAsJson?;
	    private static readonly consoleFormatter;
	    private static readonly fileFormatter;
	    private _logLevel;
	    private initialized;
	    private readonly moduleName;
	    private readonly timer;
	    private static isDisabled;
	    constructor(sourceFilename: string, domain: string);
	    private static get globalLogger();
	    private static set globalLogger(value);
	    private nopFunction;
	    /**
	     * Returns the name of the package that contains the folder.
	     * The result will be sth like sage/xtrem-core
	     * @param folder
	     */
	    private static getPackageName;
	    /** internal */
	    static get rootLogger(): Logger;
	    static reloadConfig(config: Config): void;
	    private static initGlobalLogger;
	    private initIfNeeded;
	    private static displayStartBanner;
	    private get fullDomain();
	    get logLevel(): LogLevel;
	    set logLevel(level: LogLevel);
	    /**
	     * Creates a new logger.
	     * @param sourceFilename  should be __filename
	     * @param domain
	     */
	    static getLogger(sourceFilename: string, domain: string): Logger;
	    /**
	     * Logs a message with a provided log level
	     * @param logLevel
	     * @param messageOrCallback
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    private _log;
	    /**
	     * Logs a message with a provided log level - async version
	     * @param logLevel
	     * @param messageOrCallback
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    private _logAsync;
	    /**
	     * Logs a message with a provided log level
	     * @param messageProvider
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    log(logLevel: LogLevel, messageProvider: () => string, lowThreshold?: number, highThreshold?: number): ProfilerCallback;
	    /**
	     * Logs a message with a provided log level - async version
	     * @param messageProvider
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    logAsync(logLevel: LogLevel, messageProvider: Promise<string> | (() => Promise<string>), lowThreshold?: number, highThreshold?: number): Promise<ProfilerCallback>;
	    /**
	     * Logs a message with the 'info' level (level=3)
	     * @param messageOrCallback
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    info(messageOrCallback: MessageOrCallback, lowThreshold?: number, highThreshold?: number): ProfilerCallback;
	    /**
	     * Logs a message with the 'info' level (level=3) - async version
	     * @param messageOrCallback
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    infoAsync(messageOrCallback: MessageOrCallbackAsync, lowThreshold?: number, highThreshold?: number): Promise<ProfilerCallback>;
	    /**
	     * Logs a message with the 'warn' level (level=2)
	     * @param messageOrCallback
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    warn(messageOrCallback: MessageOrCallback, lowThreshold?: number, highThreshold?: number): ProfilerCallback;
	    /**
	     * Logs a message with the 'warn' level (level=2) - async version
	     * @param messageOrCallback
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    warnAsync(messageOrCallback: MessageOrCallbackAsync, lowThreshold?: number, highThreshold?: number): Promise<ProfilerCallback>;
	    /**
	     * Logs a message with the 'debug' level (level=5)
	     * @param messageProvider
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    debug(messageProvider: () => string, lowThreshold?: number, highThreshold?: number): ProfilerCallback;
	    /**
	     * Logs a message with the 'debug' level (level=5)
	     * @param messageProvider
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    debugAsync(messageProvider: () => string | Promise<string>, lowThreshold?: number, highThreshold?: number): Promise<ProfilerCallback>;
	    /**
	     * Logs a message with the 'verbose' level (level=4)
	     * @param messageProvider
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    verbose(messageProvider: () => string, lowThreshold?: number, highThreshold?: number): ProfilerCallback;
	    /**
	     * Logs a message with the 'verbose' level (level=4) - async version
	     * @param messageProvider
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    verboseAsync(messageProvider: () => string | Promise<string>, lowThreshold?: number, highThreshold?: number): Promise<ProfilerCallback>;
	    /**
	     * Logs a message with the 'error' level (level=1)
	     * @param messageOrCallback
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    error(messageOrCallback: MessageOrCallback, lowThreshold?: number, highThreshold?: number): ProfilerCallback;
	    /**
	     * Logs a message with the 'error' level (level=1) - async version
	     * @param messageOrCallback
	     * @param lowThreshold
	     * @param highThreshold
	     */
	    errorAsync(messageOrCallback: MessageOrCallbackAsync, lowThreshold?: number, highThreshold?: number): Promise<ProfilerCallback>;
	    private getLogFunctionCallback;
	    isActive(logLevel: LogLevel): boolean;
	    private _internalLog;
	    get statistics(): {
	        count: number;
	        totalDuration: number;
	        meanDuration: number;
	        standardDeviation: number;
	    };
	    /**
	     * result = do(fn, onError);
	     *
	     * Executes `fn()` silently.
	     * But if `fn()` fails, logs the stacktrace and rethrows.
	     *
	     * `onError(err)` is an optional callback which will be invoked if `fn()` fails.
	     * By default, `onError` rethrows the error, but you can rethrow a different error, typically
	     * to mask low level details, or add some context to the error.
	     * You can also use `onError` to stop the error propagation and return a special value.
	     */
	    do<T>(fn: () => T, onError?: LoggerErrorHandler<T>): T;
	    /**
	     * Async variant of do(fn, onError)
	     */
	    doAsync<T extends AnyValue | void>(fn: () => AsyncResponse<T>, onError?: LoggerErrorHandler<T>): Promise<T>;
	    /**
	     * Logger.disable()
	     *
	     * Disables all logs.
	     * This method is called before running unit tests when logs/disabledForTests is true.
	     */
	    static disable(): void;
	    static isLogAsJson(): boolean;
	}
	//# sourceMappingURL=logger.d.ts.map
}
declare module '@sage/xtrem-log' {
	export * from '@sage/xtrem-log/index';
}
