// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/index.d.ts
declare module '@sage/xtrem-service/index' {
	export * from '@sage/xtrem-service/lib/index';
	//# sourceMappingURL=index.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/error-app.d.ts
declare module '@sage/xtrem-service/lib/error-app' {
	import { Handler, Request, Response } from 'express';
	export const unauthorized: (req: Request, res: Response) => Response;
	export const forbidden: (req: Request, res: Response) => Response;
	export const badRequest: (req: Request, res: Response) => Response;
	export const tooBusyError: (retryAfterInSeconds: number, req: Request, res: Response) => Response;
	export const notFoundApp: Handler;
	//# sourceMappingURL=error-app.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/index.d.ts
declare module '@sage/xtrem-service/lib/index' {
	/// <reference types="node" />
	import { Application } from '@sage/xtrem-core';
	import { ExpressApp } from '@sage/xtrem-shared';
	import { Express, Request } from 'express';
	import * as http from 'http';
	export { loggers } from '@sage/xtrem-service/lib/loggers';
	export interface DeployedXtremApp {
	    expressApp: Express;
	    httpServer: http.Server;
	    xtremApplication: Application;
	}
	export function startGraphQl(application: Application, expressApp: ExpressApp): void;
	export function startGraphqlService(application: Application, expressApp: ExpressApp): void;
	export interface RequestWithNonce extends Request {
	    nonce?: string;
	}
	export class XtremExpress implements ExpressApp {
	    private readonly application;
	    private readonly app;
	    private readonly routes;
	    constructor(application: Application);
	    private get config();
	    configureHelmetApp(): void;
	    addRoutes(domain: string, resolve: (express: Express) => void): void;
	    startExpressApp(port: number, app: Express, description: string, encrypt?: boolean): void;
	    /** Starts the internal interop app on a different port (8340 by default) */
	    startInternalEndpoint(): void;
	    /** Starts the metrics scraping endpoint on a different port (8250 by default) */
	    startMetricsEndpoint(): void;
	    start(): Promise<DeployedXtremApp>;
	}
	//# sourceMappingURL=index.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/logger-app.d.ts
declare module '@sage/xtrem-service/lib/logger-app' {
	import * as express from 'express';
	/**
	 * The compression middleware must be disabled in verbose and debug levels
	 * because we need the response body in clear text.
	 *
	 * @returns whether the compression middleware should be loaded or not.
	 */
	export function loggerAllowsCompress(): boolean;
	/**
	 * The request logger middleware.
	 * This middleware should be loaded first, so that we log all requests,
	 * even those which may contain invalid JSON
	 */
	export const requestLoggerApp: express.Express;
	/**
	 * The body logger middleware.
	 * This middleware must be loaded after the middleware which parses the JSON body
	 */
	export const bodyLoggerApp: express.Express;
	//# sourceMappingURL=logger-app.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/loggers.d.ts
declare module '@sage/xtrem-service/lib/loggers' {
	import { Logger } from '@sage/xtrem-core';
	export const loggers: {
	    service: Logger;
	    http: Logger;
	};
	//# sourceMappingURL=loggers.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/middlewares/auth-middleware.d.ts
declare module '@sage/xtrem-service/lib/middlewares/auth-middleware' {
	import { Handler } from 'express';
	export const authMiddleware: Handler;
	//# sourceMappingURL=auth-middleware.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/middlewares/cloudflare-middleware.d.ts
declare module '@sage/xtrem-service/lib/middlewares/cloudflare-middleware' {
	import { Handler } from 'express';
	export const cloudflareMiddleware: Handler;
	//# sourceMappingURL=cloudflare-middleware.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/middlewares/config-middleware.d.ts
declare module '@sage/xtrem-service/lib/middlewares/config-middleware' {
	import { Handler } from 'express';
	export const configMiddleware: Handler;
	//# sourceMappingURL=config-middleware.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/middlewares/csrf-middleware.d.ts
declare module '@sage/xtrem-service/lib/middlewares/csrf-middleware' {
	import { Handler } from 'express';
	export const csrfMiddleware: Handler;
	//# sourceMappingURL=csrf-middleware.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/middlewares/index.d.ts
declare module '@sage/xtrem-service/lib/middlewares/index' {
	export * from '@sage/xtrem-service/lib/middlewares/auth-middleware';
	export * from '@sage/xtrem-service/lib/middlewares/cloudflare-middleware';
	export * from '@sage/xtrem-service/lib/middlewares/config-middleware';
	export * from '@sage/xtrem-service/lib/middlewares/csrf-middleware';
	export * from '@sage/xtrem-service/lib/middlewares/standalone-config-middleware';
	export * from '@sage/xtrem-service/lib/middlewares/too-busy-middleware';
	export * from '@sage/xtrem-service/lib/middlewares/xtrem-ui-plugin-middleware';
	//# sourceMappingURL=index.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/middlewares/standalone-config-middleware.d.ts
declare module '@sage/xtrem-service/lib/middlewares/standalone-config-middleware' {
	import { Config } from '@sage/xtrem-shared';
	import { Request, Response } from 'express';
	export const standaloneConfigMiddleware: (config: Config) => (req: Request, res: Response) => void;
	//# sourceMappingURL=standalone-config-middleware.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/middlewares/too-busy-middleware.d.ts
declare module '@sage/xtrem-service/lib/middlewares/too-busy-middleware' {
	import { Express, Handler } from 'express';
	export const tooBusyMiddleware: Handler;
	export function addMakeMeBusyRoute(app: Express): void;
	//# sourceMappingURL=too-busy-middleware.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/middlewares/xtrem-ui-plugin-middleware.d.ts
declare module '@sage/xtrem-service/lib/middlewares/xtrem-ui-plugin-middleware' {
	/// <reference types="express-serve-static-core" />
	/// <reference types="compression" />
	import { Application } from '@sage/xtrem-core';
	import * as express from 'express';
	/**
	 * This middleware serves resources for UI plugins. A package may consist of a number of resources, including various
	 * images, fonts etc, therefore for plugin packages we host the entire build folder.
	 * @param application
	 */
	export const xtremUiPluginsMiddleware: (application: Application) => express.Express;
	//# sourceMappingURL=xtrem-ui-plugin-middleware.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/token-invalidation.d.ts
declare module '@sage/xtrem-service/lib/token-invalidation' {
	import { JwtClaims } from '@sage/xtrem-core';
	import { Config } from '@sage/xtrem-shared';
	export class TokenInvalidationService {
	    private static _isStarted;
	    private constructor();
	    static start(config: Config): void;
	    static stop(): void;
	    static isInvalidatedToken(accessToken: JwtClaims): boolean;
	}
	//# sourceMappingURL=token-invalidation.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/util.d.ts
declare module '@sage/xtrem-service/lib/util' {
	import { NextFunction, Request, Response } from 'express';
	export function nocache(req: Request, res: Response, next: NextFunction): void;
	/**
	 * Set a wide range of headers to prevent caching
	 * @param res the response for which to set the headers
	 * @see https://developer.mozilla.org/en-US/docs/Web/HTTP/Caching
	 * @see https://github.com/helmetjs/nocache
	 */
	export function setNoCacheHeaders(res: Response): void;
	//# sourceMappingURL=util.d.ts.map
}
// From file: /home/vsts/work/1/s/platform/back-end/xtrem-service/build/lib/xtrem-ui-app.d.ts
declare module '@sage/xtrem-service/lib/xtrem-ui-app' {
	import { NewRelicConfig } from '@sage/xtrem-shared';
	import { Response } from 'express';
	import { RequestWithNonce } from '@sage/xtrem-service/lib/index';
	export interface TemplateConfig extends Partial<NewRelicConfig> {
	    nonce?: string;
	    version?: string;
	    preferences: {
	        loadPendo: boolean;
	        loadNewRelic: boolean;
	    };
	}
	export const serveStaticXtremUi: (isProd?: boolean, newRelicConfig?: NewRelicConfig, xtremStandaloneVersion?: string, isTemplateCacheDisabled?: boolean) => (req: RequestWithNonce, res: Response) => void;
	//# sourceMappingURL=xtrem-ui-app.d.ts.map
}
declare module '@sage/xtrem-service' {
	export * from '@sage/xtrem-service/index';
}
