import { Plugin } from '@ckeditor/ckeditor5-core';
import { ButtonView } from '@ckeditor/ckeditor5-ui';
import { COMMAND_INSERT_CONDITIONAL_BLOCK } from '../../constants';
export default class ConditionalBlockUI extends Plugin {
    init() {
        const editor = this.editor;
        editor.ui.componentFactory.add(COMMAND_INSERT_CONDITIONAL_BLOCK, (locale) => {
            // The state of the button will be bound to the widget command.
            const command = editor.commands.get(COMMAND_INSERT_CONDITIONAL_BLOCK);
            // The button will be an instance of ButtonView.
            const buttonView = new ButtonView(locale);
            const { localize } = this.editor.config.get('reportEditorConfig');
            buttonView.set({
                label: localize('@sage/xtrem-document-editor/conditional-block-title', 'Conditional block'),
                withText: true,
                tooltip: true,
            });
            // Bind the state of the button to the command.
            buttonView.bind('isOn', 'isEnabled').to(command, 'value', 'isEnabled');
            // Execute the command when the button is clicked (executed).
            this.listenTo(buttonView, 'execute', () => editor.execute(COMMAND_INSERT_CONDITIONAL_BLOCK));
            return buttonView;
        });
    }
}
//# sourceMappingURL=conditional-block-ui.js.map