import type { UiComponentProperties as dirtyStateActions } from '../../component/abstract-ui-control-object';
import type { PageControlObject } from '../../component/control-objects';
import type { XtremUiPlugin } from '../../service/plugin-service';
import type { ScreenBaseDefinition } from '../../service/screen-base-definition';
import type { UserCustomization } from '../../service/user-customization';
import { WIZARD_FINISHED } from '../../utils/constants';
import type { AppAction, AppThunkDispatch } from '../action-types';
import type { ApplicationContext, XtremAppState } from '../state';
import type { Dict } from '@sage/xtrem-shared';
export declare const setPath: (path: string) => AppAction;
export declare const setComponentLoading: (screenId: string, elementId: string, isLoading: boolean) => AppAction;
export declare const setApplicationContext: (applicationContext: ApplicationContext) => AppAction;
export declare const updateUserCustomization: (screenId: string, userCustomizations: UserCustomization[]) => AppAction;
export declare const addScreenDefinition: (pageDefinition: ScreenBaseDefinition) => AppAction;
export declare const addPlugin: (pluginPackage: string, pluginDefinition: XtremUiPlugin<any, any>) => AppAction;
export declare const setScreenDefinitionReady: (screenId: string) => AppAction;
export declare const setScreenDefinitionDialogId: (screenId: string, dialogId: number, pageControlObject: PageControlObject, title: string, subtitle: string) => AppAction;
export declare const removeScreenDefinition: (screenId: string) => AppAction;
export declare const setFieldProperties: (screenId: string, elementId: string, fieldProperties: dirtyStateActions) => AppAction;
export declare const setGlobalLoading: (loaderState: boolean) => AppAction;
export declare const setUserCustomizations: (userCustomizations: Dict<Dict<any>>) => AppAction;
export declare const actionStub: () => any;
export declare const addTranslations: (locale: string, literals: Dict<string>) => AppAction;
export declare const setInitialMetaData: () => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
export declare const clearWidgetOptions: () => AppAction;
/**
 * Sets the active section in the state
 * @param screenId
 * @param activeSection the ID of the active section OR `WIZARD_FINISHED` token if the user is stepping to close the widget.
 * @param isInitialLoad
 * @returns
 */
export declare const setActiveSection: (screenId: string, activeSection: string | typeof WIZARD_FINISHED | null, isInitialLoad?: boolean) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
//# sourceMappingURL=common-actions.d.ts.map