import type { Dict } from '@sage/xtrem-shared';
import type { AbstractWidget, WidgetDefinition, WidgetOptions } from '../../dashboard/widgets/abstract-widget';
import type { LoadMoreRowsParams } from '../../service/dashboard-service';
import type { Constructible } from '../../types';
import type { AppAction, AppThunkDispatch } from '../action-types';
import type { XtremAppState } from '../state';
/**
 * Constructs the widget object depending its type. It checks if the widget is generic user configured or functional code provided, then constructs it.
 */
export declare const createWidgetObject: (widgetConstructors: Dict<Constructible<AbstractWidget>>, type: string, widgetId: string, dashboardId: string, settings?: any) => AbstractWidget;
export declare const fetchUserDashboardDefinition: () => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
export declare const setSelectedDashboard: (id: string) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
/**
 * Clone a dashboard based on its ID, then marks it automatically selected
 * @param idToClone
 * @returns
 */
export declare const cloneDashboard: (idToClone: string) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
/**
 * Creates an empty dashboard, then marks it automatically selected
 * @param idToClone
 * @returns
 */
export declare const createEmptyDashboard: () => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
export declare const deleteDashboard: (dashboardId: string) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
export declare function getNewTableData({ widgetDefinition, data }: {
    widgetDefinition: WidgetDefinition;
    data: any;
}): any;
export declare const loadWidgetData: ({ widgetId, forceRefetch, queryArgs, dataMode, }: {
    widgetId: string;
    forceRefetch?: boolean | undefined;
    queryArgs?: LoadMoreRowsParams | undefined;
    dataMode?: "SET" | "ADD" | undefined;
}) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<any[]>;
export declare const setWidgetOptions: (dashboardId: string, widgetId: string, options: WidgetOptions) => AppAction;
//# sourceMappingURL=dashboard-actions.d.ts.map