import type { Dashboard, Dict } from '@sage/xtrem-shared';
import type { CardDefinition } from '../../component/ui/card/card-component';
import * as dashboardService from '../../service/dashboard-service';
import type { PageDefinition } from '../../service/page-definition';
import type { AppAction, AppThunkDispatch } from '../action-types';
import type { NodeTypeDict, UserWidgetDefinition, XtremAppState } from '../state';
export declare const resetNextWidgetIdOnlyToBeUsedInTests: () => void;
export declare const getWidgetListCardDefinition: (dispatch: AppThunkDispatch) => CardDefinition<any>;
export declare const saveDashboardEditorState: () => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
export declare const createDashboardPageDefinition: (dispatch: AppThunkDispatch, widgets: dashboardService.XtremUiWidget[], categories: dashboardService.XtremUiWidgetCategory[], nodeTypes?: Dict<NodeTypeDict>, locale?: string) => PageDefinition;
export declare const openDashboardEditorDialog: () => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
export declare const closeDashboardEditorDialog: () => AppAction;
export declare const undoDashboardEditor: () => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => void;
export declare const redoDashboardEditor: () => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => void;
export declare const updateDashboardEditorStateWithHistory: (newDashboardDefinition: Dashboard) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => void;
export declare const removeDashboardEditorWidget: (widgetId: string) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => void;
export declare const updateDashboardTitleInEditor: (newTitle: string) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => void;
/**
 * Fetches widget source code from the server. It should be called when a new widget is added to the dashboard which has not been previously
 * loaded into the state from the server.
 *
 */
export declare const loadNewWidget: (widgetType: string, widgetId: string, dashboardId: string, settings?: any) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
export interface WidgetPosition {
    i: string;
    x: number;
    y: number;
    h: number;
    w: number;
}
export declare const updateDashboardEditorWidgetPositions: (widgets: WidgetPosition[]) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
export declare const addNewWidgetToDashboardLayout: (widgetId: string, artifactName: string, uwd?: UserWidgetDefinition) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => void;
export declare const updateWidgetSettings: (widgetId: string, settings?: any) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
export declare const addFunctionalDeveloperDefinedWidget: (widget: dashboardService.XtremUiWidget) => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
/**
 * Takes the current working copy of from the widget editor and adds it to the dashboard definition.
 * @returns
 */
export declare const finishEditingUserDefinedWidget: () => (dispatch: AppThunkDispatch, getState: () => XtremAppState) => Promise<void>;
//# sourceMappingURL=dashboard-editor-actions.d.ts.map