import { GraphQLKind, GraphQLTypes } from '../../types';
import { ActionType } from '../action-types';
export const nodeTypes = (state = {
    XtremUiWidget: {
        _id: { type: GraphQLTypes.ID, kind: GraphQLKind.Scalar },
        title: { type: GraphQLTypes.String, kind: GraphQLKind.Scalar },
        description: { type: GraphQLTypes.String, kind: GraphQLKind.Scalar },
        type: { type: GraphQLTypes.String, kind: GraphQLKind.Scalar },
        category: { type: 'XtremUiWidgetCategory', kind: GraphQLKind.Object },
    },
    XtremUiWidgetCategory: {
        _id: { type: GraphQLTypes.ID, kind: GraphQLKind.Scalar },
        title: { type: GraphQLTypes.String, kind: GraphQLKind.Scalar },
        sortValue: { type: GraphQLTypes.Int, kind: GraphQLKind.Scalar },
    },
}, action) => {
    if (action.type === ActionType.AddNodeTypes) {
        return { ...state, ...action.value };
    }
    return state;
};
//# sourceMappingURL=node-type.js.map