/**
 * @packageDocumentation
 * @module root
 * */
import type { AccessStatus } from '@sage/xtrem-shared';
import * as React from 'react';
import type { BaseControlObject } from '../component/base-control-object';
import type { FieldWrapperExternalProps } from '../component/field/field-base-component-types';
import type { ResponsiveTypes } from '../redux/state';
export interface FieldWrapperProps extends FieldWrapperExternalProps {
    fieldController: BaseControlObject<any, any>;
    browserIs?: ResponsiveTypes;
    isHidden?: boolean;
    accessRule?: AccessStatus;
    onFocus: (screenId: string, elementId: string, row: string, nestedField: string) => void;
    fixedHeight?: number;
}
/**
 * Main field type router. Depending on the field type, it renders the corresponding component to the DOM
 */
export declare class FieldWrapper extends React.Component<FieldWrapperProps> {
    /** A field is hidden if it is hidden by its `isHidden` decorator property or if the field is unavailable for
     * the current user based on the access rights computation.
     **/
    private readonly isHidden;
    private readonly renderField;
    render(): React.ReactNode;
}
declare const _default: import("react-redux").ConnectedComponent<typeof FieldWrapper, import("react-redux").Omit<React.ClassAttributes<FieldWrapper> & FieldWrapperProps, "contextType" | "onFocus" | "fieldController" | "browserIs" | "isHidden" | "accessRule" | "fixedHeight" | "item" | "screenId" | "nestedReadOnlyField" | "shouldRenderLabelInNestedReadOnlyMode" | "availableColumns" | "isParentDisabled" | "isParentHidden"> & FieldWrapperExternalProps>;
export default _default;
//# sourceMappingURL=field-wrapper.d.ts.map