import type { EditableFieldProperties } from '../component/editable-field-control-object';
import type { BaseEditableComponentProperties, NestedFieldsAdditionalProperties } from '../component/field/field-base-component-types';
import * as React from 'react';
import type { Dict } from '@sage/xtrem-shared';
import type { HasOptionType } from '../component/field/traits';
import { FieldKey } from '../component/types';
type fieldType = FieldKey.Select | FieldKey.DropdownList | FieldKey.Radio | FieldKey.MultiDropdown;
interface SelectLikeFieldWrapperExternalProps extends BaseEditableComponentProperties<EditableFieldProperties & HasOptionType, any, NestedFieldsAdditionalProperties> {
    fieldType: fieldType;
}
export interface SelectLikeFieldWrapperProps extends SelectLikeFieldWrapperExternalProps {
    localizedOptions?: Dict<string>;
    enumOptions?: string[];
}
export declare function SelectLikeFieldWrapper(props: SelectLikeFieldWrapperProps): React.ReactElement;
export declare const ConnectedSelectLikeFieldWrapper: import("react-redux").ConnectedComponent<typeof SelectLikeFieldWrapper, import("react-redux").Omit<SelectLikeFieldWrapperProps, "locale" | "contextType" | "value" | "onFocus" | "fixedHeight" | "item" | "screenId" | "nestedReadOnlyField" | "shouldRenderLabelInNestedReadOnlyMode" | "availableColumns" | "isParentDisabled" | "isParentHidden" | "bind" | "elementId" | "nodeTypes" | "contextNode" | "fieldProperties" | "parentElementId" | "recordContext" | "validationErrors" | "setFieldValue" | "validate" | "removeNonNestedErrors" | "setFieldProperties" | "isParentReadOnly" | "browser" | "pageNode" | "isInFocus" | "fieldType" | "handlersArguments" | "isNested" | "columnDefinition" | "enumOptions" | "localizedOptions"> & SelectLikeFieldWrapperExternalProps>;
export {};
//# sourceMappingURL=select-like-field-wrapper.d.ts.map