/**
 * This service updates the page definitions to include user defined custom fields, which are loaded to the product
 * from the `customFields` page metadata property
 */
import { type Dict, type MetaCustomField } from '@sage/xtrem-shared';
import type { NestedField } from '../component/nested-fields';
import type { ComponentKey } from '../component/types';
import type { NodeTypeDict } from '../redux/state';
import type { Constructible } from '../types';
import type { Page } from './page';
import type { PageMetadata } from './page-metadata';
export declare const addCustomFieldsToPageBody: (pageConstructor: Constructible<Page>, pageMetadata: PageMetadata, customFields?: MetaCustomField[]) => void;
export declare const componentsWithLookup: ComponentKey[];
export declare const addCustomColumnToNestedFields: (elementId: string, componentType: ComponentKey, columns: NestedField<any, any>[], onlyInsertIfFound: boolean, customFields?: MetaCustomField[]) => void;
export declare const getCustomFields: (elementId: string, componentType: ComponentKey, customFields?: MetaCustomField[]) => NestedField<any, any>[];
export declare const isCustomFieldReadOnly: (nodeTypes: Dict<NodeTypeDict>, pageInputNode: string, bind: string) => boolean;
//# sourceMappingURL=customization-service.d.ts.map