import type { AccessStatus, MetaCustomField } from '@sage/xtrem-shared';
export interface MetadataStringLiteralTypeEntry {
    key: string;
    content: string;
}
export interface MetadataAccessPropertyBinding {
    name: string;
    status: AccessStatus;
}
export interface MetadataAccessRightsResult {
    node: string;
    bindings: MetadataAccessPropertyBinding[];
}
export interface MetadataCustomNode {
    name: string;
    properties: MetaCustomField[];
}
export interface CustomizableNode {
    node: string;
    fullName: string;
}
export interface ExportTemplateDetails {
    id: string;
    name: string;
}
export interface ExportTemplatesByNode {
    name: string;
    exportTemplates: ExportTemplateDetails[];
}
export interface MetadataType {
    key?: string;
    content?: string;
    title?: string;
    extensions?: string[];
    plugins?: string[];
    duplicateBindings?: string[] | null;
    strings?: MetadataStringLiteralTypeEntry[];
    access?: MetadataAccessRightsResult[];
    customFields?: MetadataCustomNode[];
    customizableNodes?: CustomizableNode[];
    customizableNodesWizard?: CustomizableNode[];
    exportTemplatesByNode?: ExportTemplatesByNode[];
}
export interface MetadataResponse {
    pages?: MetadataType[];
    stickers?: MetadataType[];
    strings?: MetadataStringLiteralTypeEntry[];
}
export type ModuleEntryProperties = keyof MetadataType;
export type ArtifactType = 'pages' | 'stickers' | 'widgets' | 'strings';
//# sourceMappingURL=metadata-types.d.ts.map