/* eslint-disable import/no-duplicates */
declare module '@sage/test-extended-client-gen-app-api-partial' {
    import type {
        Address,
        Document,
        DocumentInput,
        Package as SageTestClientGenApp$Package,
    } from '@sage/test-client-gen-app-api';
    import type {
        ClientNode,
        ClientNodeInput,
        GetDefaultsOperation,
        integer,
        Operation,
        QueryOperation,
    } from '@sage/xtrem-client';
    export interface Customer extends ClientNode {
        code: string;
        name: string;
    }
    export interface CustomerInput extends ClientNodeInput {
        code?: string;
        name?: string;
    }
    export interface CustomerBinding extends ClientNode {
        code: string;
        name: string;
    }
    export interface DocumentExtension {
        extraAddress: Address;
        customer: Customer;
    }
    export interface DocumentInputExtension {
        extraAddress?: integer | string;
        customer?: integer | string;
    }
    export interface DocumentBindingExtension {
        extraAddress: Address;
        customer: Customer;
    }
    export interface DocumentExtension$Queries {
        extensionQuery: Operation<
            {
                id: string;
            },
            Document
        >;
    }
    export interface DocumentExtension$Lookups {
        extraAddress: QueryOperation<Address>;
        customer: QueryOperation<Customer>;
    }
    export interface DocumentExtension$Operations {
        queries: DocumentExtension$Queries;
        lookups(dataOrId: string | { data: DocumentInput }): DocumentExtension$Lookups;
        getDefaults: GetDefaultsOperation<Document>;
    }
    export interface Package {}
    export interface GraphApi extends Package, SageTestClientGenApp$Package {}
}
declare module '@sage/test-extended-client-gen-app-api' {
    export type * from '@sage/test-extended-client-gen-app-api-partial';
}
declare module '@sage/test-client-gen-app-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/test-extended-client-gen-app-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/test-client-gen-app-api-partial' {
    import type {
        DocumentBindingExtension,
        DocumentExtension,
        DocumentExtension$Lookups,
        DocumentExtension$Operations,
        DocumentExtension$Queries,
        DocumentInputExtension,
    } from '@sage/test-extended-client-gen-app-api';
    export interface Document extends DocumentExtension {}
    export interface DocumentBinding extends DocumentBindingExtension {}
    export interface DocumentInput extends DocumentInputExtension {}
    export interface Document$Lookups extends DocumentExtension$Lookups {}
    export interface Document$Queries extends DocumentExtension$Queries {}
    export interface Document$Operations extends DocumentExtension$Operations {}
}
