import { isDevMode } from './window';
import { get } from 'lodash';
export const getElementAccessStatus = (accessBindings, 
// TODO: handle nested access rights
elementId, elementProperties, contextNode) => {
    const accessNode = elementProperties.access?.node || contextNode;
    if (!accessNode || !accessBindings[String(accessNode)]) {
        return undefined;
    }
    const accessBind = elementProperties.access?.bind || elementProperties.bind || elementId;
    return accessBindings[String(accessNode)][accessBind] || undefined;
};
export const getElementAccessStatusWithoutId = (accessBindings, access) => {
    if (!access) {
        return 'authorized';
    }
    if (!access.bind || !access.node) {
        if (isDevMode()) {
            throw new Error('Invalid access definition, you must define both bind and node properties.');
        }
        return 'authorized';
    }
    return get(accessBindings, `${access.node}.${access.bind}`, 'unauthorized');
};
//# sourceMappingURL=access-utils.js.map