/// <reference types="react" />
/// <reference types="lodash" />
import type { Column } from '@ag-grid-community/core';
import type { ScreenBase } from '../../service/screen-base';
import type { NestedField, NestedFieldTypes } from '../../component/nested-fields';
export declare function isLeftOrRight(event: React.KeyboardEvent): boolean;
export declare function isCharNumeric(charStr: string): boolean;
export declare function isAllowedDateCharacter(charStr: string): boolean;
export declare function isValidUrl(text: string): boolean;
export declare function isKeyPressedNumeric(event: React.KeyboardEvent): boolean;
export declare function isKeyPressedDateComponent(event: React.KeyboardEvent): boolean;
export declare function isFinishedEditingPressed(event: React.KeyboardEvent): boolean;
export declare const defaultCellRendederStyles: React.CSSProperties;
export declare const defaultCellEditorStyles: React.CSSProperties;
export declare const setDefaultAgGridInputStyles: (input: HTMLInputElement) => void;
export declare const getColumnsToExport: (columns: Column[]) => Column[];
export declare const cellExportFormatter: (column: NestedField<ScreenBase, NestedFieldTypes, any>, value?: string | number | null) => string;
export interface GetRowClassRulesOptions {
    canSelect: boolean;
    openedRecordId?: string | number | null;
}
export declare const getRowClassRules: (({ canSelect, openedRecordId }: GetRowClassRulesOptions) => any) & import("lodash").MemoizedFunction;
//# sourceMappingURL=ag-grid-cell-editor-utils.d.ts.map