import type { CellClickedEvent, CellKeyDownEvent, RowClickedEvent } from '@ag-grid-community/core';
import type { NestedFieldsProperties, NestedFieldTypesWithoutTechnical } from '../../component/nested-fields';
import type { CollectionValue } from '../../service/collection-data-service';
import type { ScreenBase } from '../../service/screen-base';
import type { OnRowClickFunction } from '../../component/field/table/table-component-types';
export declare const onCellClickHandler: (screenId: string, tableElementId: string, nestedFieldProperties: NestedFieldsProperties<NestedFieldTypesWithoutTechnical, ScreenBase>, isParentFieldDisabled: boolean) => (event: CellClickedEvent) => void;
export declare const onCellValueChangedHandler: (screenId: string, tableElementId: string, nestedFieldProperties: NestedFieldsProperties<NestedFieldTypesWithoutTechnical, ScreenBase>, value: () => CollectionValue, isInLookupDialog?: boolean) => (params: any) => Promise<void>;
export declare const onCellKeyDown: (event: CellKeyDownEvent) => void;
/** Event listener, triggered when the user clicks any part of the row apart from the dropdown actions */
export declare const onRowClick: (onRowClickCallback?: OnRowClickFunction) => (event: RowClickedEvent) => void;
//# sourceMappingURL=ag-grid-event-handlers.d.ts.map