/// <reference types="lodash" />
import type { Dict, LocalizeLocale } from '@sage/xtrem-shared';
import type { NodeTypeDict, TableViewLevel, TableViewSortedColumn } from '../../redux/state';
import type { CollectionValue } from '../../service/collection-data-service';
import type { AccessBindings } from '../../service/page-definition';
import type { ScreenBase } from '../../service/screen-base';
import type { ContextType, NodePropertyType } from '../../types';
import type { ValueOrCallbackWithFieldValue } from '../types';
import type { NestedField, NestedFieldTypes } from '../../component/nested-fields';
import { FieldKey } from '../../component/types';
import type { ColumnsData, InternalTableProperties } from '../../component/field/table/table-component-types';
import type { AgGridColumnConfigWithScreenIdAndColDef } from './ag-grid-utility-types';
import type { OptionsMenuItem } from '../../component/control-objects';
export declare const shouldDisplayColumnInPanel: ((columnDefinition?: NestedField<ScreenBase, any>) => boolean) & import("lodash").MemoizedFunction;
export declare const getCellClass: (isEditable: boolean, columnId: string, columnDefinition: NestedField<ScreenBase, NestedFieldTypes>, title: string, columnDefinitionType: NestedFieldTypes) => string[];
export declare function withoutNestedTechnicalColumns(argument: ColumnsData[]): ColumnsData<Exclude<NestedFieldTypes, FieldKey.Technical>>[];
export declare const getColumns: ({ accessBindings, columnsData, contextType, currentTableView, elementId: tableElementId, enumTypes, fieldProperties, isDisabled, isFilteringDisabled, groupBy, hasFloatingFilters, isParentDisabled, isReadOnly, level, locale, lookupSelectionMode, nodeTypes, pageNode, screenId, isSortingDisabled, value, activeOptionsMenuItem, }: {
    accessBindings: AccessBindings;
    columnsData: ColumnsData[];
    contextType?: ContextType | undefined;
    currentTableView?: TableViewLevel | undefined;
    elementId: string;
    enumTypes: Dict<string[]>;
    /**
     * Ag-grid seems to cache some of these values in the column configuration, so in order to ensure that we always
     * have an up-to-date version of the properties, we pass them in as a callback
     * */
    fieldProperties: () => Omit<InternalTableProperties, 'selectedRecords'>;
    isDisabled?: boolean | undefined;
    isFilteringDisabled?: boolean | undefined;
    groupBy?: string | undefined;
    hasFloatingFilters?: boolean | undefined;
    level: number;
    locale: LocalizeLocale;
    lookupSelectionMode?: "multiple" | "single" | undefined;
    isParentDisabled: () => boolean;
    isReadOnly?: ValueOrCallbackWithFieldValue<ScreenBase<any, any>, boolean> | undefined;
    nodeTypes: Dict<NodeTypeDict>;
    pageNode?: NodePropertyType | undefined;
    screenId: string;
    isSortingDisabled?: boolean | undefined;
    customizedOrderBy?: TableViewSortedColumn[] | undefined;
    activeOptionsMenuItem?: OptionsMenuItem<any> | undefined;
    /**
     * Ag-grid seems to cache some of these values in the column configuration, so in order to ensure that we always
     * have an up-to-date version of the value, we pass them in as a callback
     * */
    value: () => CollectionValue;
}) => Promise<AgGridColumnConfigWithScreenIdAndColDef[]>;
//# sourceMappingURL=ag-grid-service.d.ts.map