import type { Dict } from '@sage/xtrem-shared';
import type { PropertyValueType } from '../component/field/reference/reference-types';
import type { NodeType, NodeTypeDict } from '../redux/state';
import { GraphQLTypes } from '../types';
/**
 * Finds a node property type details from the list of known node types by doing an deep search in the graph structure.
 * @param targetNode
 * @param targetProperty
 * @param nodeTypes
 * @returns
 */
export declare const findDeepPropertyDetails: (targetNode?: string, targetProperty?: PropertyValueType, nodeTypes?: Dict<NodeTypeDict>, forFiltering?: boolean) => NodeType | null;
/**
 * Finds a node property type from the list of known node types by doing an deep search in the graph structure
 * @param targetNode
 * @param targetProperty
 * @param nodeTypes
 * @param defaultValue optionally can be called with a defaultValue which is returned if no type definition is found
 * @returns
 */
export declare function findDeepPropertyType(targetNode: string | undefined, targetProperty: PropertyValueType | undefined, nodeTypes: Dict<NodeTypeDict>): GraphQLTypes | string | null;
export declare function findDeepPropertyType(targetNode: string | undefined, targetProperty: PropertyValueType | undefined, nodeTypes: Dict<NodeTypeDict>, defaultValue: GraphQLTypes | string, forFiltering?: boolean): GraphQLTypes | string;
export declare function findDeepPropertyType(targetNode: string | undefined, targetProperty: PropertyValueType | undefined, nodeTypes: Dict<NodeTypeDict>, defaultValue?: GraphQLTypes | string, forFiltering?: boolean): GraphQLTypes | string | null;
//# sourceMappingURL=node-utils.d.ts.map