import { getIdFieldValue } from './id-field-utils';
import { resolveByRecordValue } from './resolve-value-utils';
export function getHeaderTitles({ idFieldValue, isRecordCreationPage, objectTypePlural, objectTypeSingular, subtitle, title, }) {
    const isObjectTypeDefined = !!objectTypePlural && !!objectTypeSingular;
    if (isObjectTypeDefined) {
        if (isRecordCreationPage) {
            return { subtitle: undefined, title: objectTypeSingular };
        }
        return idFieldValue
            ? { subtitle: undefined, title: `${objectTypeSingular} ${idFieldValue}` }
            : { subtitle: undefined, title: `${objectTypePlural}` };
    }
    return { subtitle, title };
}
export const getPageTitlesFromPageDefinition = (pageDefinition, locale) => {
    const idFieldValue = getIdFieldValue(pageDefinition, locale);
    const screenId = pageDefinition.metadata.screenId;
    const pageDecoratorProps = pageDefinition.metadata.uiComponentProperties[screenId];
    return getHeaderTitles({
        title: resolveByRecordValue({
            propertyValue: pageDecoratorProps.title,
            screenId,
            rowValue: null,
            skipHexFormat: true,
        }),
        subtitle: resolveByRecordValue({
            propertyValue: pageDecoratorProps.subtitle,
            screenId,
            rowValue: null,
            skipHexFormat: true,
        }),
        idFieldValue,
        isRecordCreationPage: false,
        objectTypePlural: resolveByRecordValue({
            propertyValue: pageDecoratorProps.objectTypePlural,
            screenId,
            rowValue: null,
            skipHexFormat: true,
        }),
        objectTypeSingular: resolveByRecordValue({
            propertyValue: pageDecoratorProps.objectTypeSingular,
            screenId,
            rowValue: null,
            skipHexFormat: true,
        }),
    });
};
//# sourceMappingURL=page-utils.js.map