import type { Dict } from '@sage/xtrem-shared';
import type { PageProperties, PageNavigationPanel } from '../component/container/page/page-types';
import { AbstractUiControlObject, SectionControlObject } from '../component/control-objects';
import type { PageControlObject } from '../component/control-objects';
import type { PageDecoratorProperties, TableDecoratorProperties } from '../component/decorator-properties';
import type { SidebarSectionDefinition } from '../component/table-sidebar/table-sidebar-types';
import type { NavigationPanelState, XtremAppState } from '../redux/state';
import type { Page } from '../service/page';
import type { PageDefinition } from '../service/page-definition';
import type { ScreenBaseDefinition } from '../service/screen-base-definition';
export declare const isScreenDefinitionDirty: (screenDefinition: ScreenBaseDefinition) => boolean;
export declare const hasAnyDirtyScreenDefinitions: (state: XtremAppState) => boolean;
export declare const getPageDefinitionFromState: (screenId: string, state?: XtremAppState) => PageDefinition;
export declare const getMainPageDefinitionFromState: (state?: XtremAppState) => PageDefinition | undefined;
export declare const getPagePropertiesFromState: (screenId: string, state?: XtremAppState) => PageProperties & PageDecoratorProperties<Page>;
export declare const getPageControlObjectFromState: (screenId: string, state?: XtremAppState) => PageControlObject | null;
export declare const getPagePropertiesFromPageDefinition: (pageDefinition: PageDefinition) => PageProperties & PageDecoratorProperties<Page>;
export declare const getNavigationPanelState: (screenId: string, state?: XtremAppState) => NavigationPanelState | null;
export declare const getNavigationPanelDefinitionFromState: (screenId: string, state?: XtremAppState) => PageNavigationPanel<any> | null;
export declare const getNavigationPanelTablePropertiesFromPageDefinition: (pageDefinition: PageDefinition) => TableDecoratorProperties;
export declare const checkIfPageIsLoaded: (screenId: string, state?: XtremAppState) => void;
export declare const arePlatformLiteralsMissing: (state?: XtremAppState, locale?: string) => boolean;
export declare const getSidebarLayoutDefinitionFromState: (state?: XtremAppState) => Dict<SidebarSectionDefinition>;
export declare const getSidebarNormalFields: (state?: XtremAppState) => AbstractUiControlObject[];
export declare const getSidebarNestedFields: (state?: XtremAppState) => string[];
export declare const isSidebarDirty: (state?: XtremAppState) => boolean;
export declare const getVisibleSectionsFromPage: (screenId: string, screenDefinition?: ScreenBaseDefinition) => SectionControlObject[];
//# sourceMappingURL=state-utils.d.ts.map