import { SessionMessage } from "../types/SessionMessage";
export type OnMessageDelete = (messageId: string) => void;
export type OnMessageTrace = () => void;
export interface ChatBubbleProps {
    /** Message to display in the bubble */
    message: SessionMessage;
    /** Should the timestamp/trace/delete menu be visible */
    showMenu: boolean;
    /** Handle open/close of the menu */
    setShowMenu: (state: boolean) => void;
    /** Handle delete of the message */
    onMessageDelete: OnMessageDelete;
    /** Handle trace of the message */
    onMessageTrace: OnMessageTrace;
    /** Display bubble as a skeleton */
    isSkeleton: boolean;
}
/** Bubble containing a SessionMessage */
export declare const ChatBubble: ({ message, showMenu, setShowMenu, onMessageDelete, onMessageTrace, isSkeleton, }: ChatBubbleProps) => import("react/jsx-runtime").JSX.Element | null;
export default ChatBubble;
