/// <reference types="react" />
import { SpaceProps } from "styled-system";
export interface StyledChatButtonProps extends SpaceProps {
    /** Next in importance after primary */
    secondary?: boolean;
    /** Next in importance after secondary */
    tertiary?: boolean;
    /** Clicking will perform a dangerous/irreversible action */
    danger?: boolean;
    /** A smaller button with less padding */
    compact?: boolean;
    /** Button clicked handler */
    onClick?: () => void;
}
export interface ChatButtonProps extends StyledChatButtonProps {
    /** Content within the button */
    children?: React.ReactNode;
}
/** General purpose button */
export declare const ChatButton: ({ secondary, tertiary, danger, compact, children, ...rest }: ChatButtonProps) => import("react/jsx-runtime").JSX.Element;
export default ChatButton;
