import React from "react";
import { MaxWidthProps, MinWidthProps } from "styled-system";
type MinWidthType = Exclude<MinWidthProps["minWidth"], undefined>;
type MaxWidthType = Exclude<MaxWidthProps["maxWidth"], undefined>;
export interface ChatSideBarProps {
    /** Chat side bar is not visible */
    collapsed: boolean;
    /** Called when the sidebar is opened or collapsed */
    setCollapsed: (collapsed: boolean) => void;
    /** Minimum width in styled system values (number, px, em, etc) */
    minWidth: MinWidthType;
    /** Maximum width in styled system values (number, px, em, etc) */
    maxWidth: MaxWidthType;
    /** Content within the side bar */
    children?: React.ReactNode;
    /** Chat side bar menu */
    sidebarMenu?: React.ReactNode;
}
declare const ChatSideBar: ({ collapsed, setCollapsed, minWidth, maxWidth, children, sidebarMenu, }: ChatSideBarProps) => import("react/jsx-runtime").JSX.Element;
export default ChatSideBar;
