export interface DeleteConfirmationProps {
    /** Prompt and buttons horizontal, or prompt above buttons */
    layout: "flat" | "stacked";
    /** The prompt to receive confirmation for */
    prompt: string;
    /** Clicking the delete button will perform a dangerous/irreversible action */
    danger?: boolean;
    /** Style the cancel button as tertiary or secondary */
    cancelTertiary?: boolean;
    /** Handler for confirmed delete */
    onDelete: () => void | Promise<void>;
    /** Handler for delete cancelled */
    onCancel: () => void;
}
/** Prompt user to delete something */
export declare const DeleteConfirmation: ({ layout, prompt, danger, cancelTertiary, onDelete, onCancel, }: DeleteConfirmationProps) => import("react/jsx-runtime").JSX.Element;
export default DeleteConfirmation;
