import { AxiosError } from "axios";
import { UseMutateFunction } from "@tanstack/react-query";
import { SessionMessage, SessionMessageJson, UUIDType } from "../../types/SessionMessage";
export type ChatRequest = {
    user_id: string;
    session_id?: string;
    message: string;
    model?: string;
};
type OnChatResponse = (messages: SessionMessage[], backendSessionId: UUIDType) => void;
type OnChatError = (err: AxiosError) => void;
export declare const useBackendChatQuery: (onChatResponse: OnChatResponse, onChatError: OnChatError) => [UseMutateFunction<SessionMessageJson[], AxiosError<unknown, any>, ChatRequest, unknown>, boolean];
export default useBackendChatQuery;
