import { UseMutateFunction } from "@tanstack/react-query";
import { AxiosError } from "axios";
import { SessionMessage, UUIDType } from "../../types/SessionMessage";
interface TraceMessage {
    content: string;
    additional_kwargs: object;
    example: boolean;
}
export interface TraceStep {
    trace_step_id: UUIDType;
    trace_id: UUIDType;
    position: number;
    model: object;
    input: {
        messages: TraceMessage[];
    };
    output: {
        generations: TraceMessage[];
    };
    completion_tokens: number;
    prompt_tokens: number;
    total_tokens: number;
    created_at: Date;
}
export type OnSessionMessagesSuccess = (messages: SessionMessage[]) => void;
export declare const useBackendMessageHistory: (sessionId: string, onSuccess: OnSessionMessagesSuccess, lastSeen: Date | null, limit: number) => import("@tanstack/react-query").UseQueryResult<SessionMessage[], AxiosError<unknown, any>>;
export declare const useBackendDeleteMessage: (messageId: string, onSuccess: () => void) => [UseMutateFunction<void, AxiosError<unknown, any>, void, unknown>, boolean];
export declare const useBackendMessageTrace: (messageId: string) => import("@tanstack/react-query").UseQueryResult<TraceStep[], AxiosError<unknown, any>>;
export {};
