import { SessionMessage } from "../../types/SessionMessage";
import { SessionIdType } from "../../stores/ChatHistoryStore";
export type OnMessageSend = (message: string) => void;
declare const useCombinedChatMessages: (sessionId: SessionIdType, setSessionId: (sessionId: SessionIdType) => void, model: string, refreshSessionsIfRequired: (sid: SessionIdType) => void) => {
    combinedChatMessages: SessionMessage[];
    onMessageDelete: (messageId: string) => void;
    onMessageSend: (humanMessage: string) => void;
    loadNextMessageHistoryBatch: () => void;
    isMessageHistoryLoading: boolean;
    isMessageInFlight: boolean;
    inFlightSessionId: SessionIdType | null;
    moreMessageHistoryAvailable: boolean;
};
export default useCombinedChatMessages;
