import { BackendSettings } from "../contexts/BackendContext";
import { AxiosError } from "axios";
import { UseMutationResult } from "@tanstack/react-query";
type Method = "post" | "put" | "delete" | "patch";
interface BackendServiceParams {
    [key: string]: string;
}
interface UseBackendMutationOptions<TResponse> {
    params?: BackendServiceParams;
    onSuccess?: (data: TResponse) => void;
    onError?: (err: AxiosError) => void;
}
export declare function updateBackend<TData, TParams, TResponse>(backendSettings: BackendSettings, clientSpecific: boolean, endpoint: string, params: TParams, data: TData, method?: Method): Promise<TResponse>;
export declare function useBackendMutation<TData, TResponse>(clientSpecific: boolean, endpoint: string, mutationKeys: string[], options: UseBackendMutationOptions<TResponse>, method?: Method): UseMutationResult<TResponse, AxiosError, TData>;
export default useBackendMutation;
