export type SpeakerType = "human" | "ai";
export type TagType = "inflight";
export type UUIDType = ReturnType<typeof Crypto.prototype.randomUUID>;
export interface SessionMessageJson {
    message_id: string;
    session_id: string;
    speaker: SpeakerType;
    message: string;
    created_at: string;
}
export interface SessionMessage {
    id: UUIDType;
    speaker: SpeakerType;
    timestamp: Date;
    message?: string;
    tag?: TagType;
    data?: object;
}
